;=======================================================================================
; Code :Exemple BCF
; Project Title :
; Author : Philippe Agnisola et Nicolas Poursin
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_bcf3.bb"

Graphics3D 800,600,16,0
SetBuffer BackBuffer()

; ---------------------------------------------------
; Variable globales du nombre de FPS
; ---------------------------------------------------
Global FPS_Counter
Global FPS_CheckTime
Global FPS_CurrentFPS
Global FPS_CurrentTime

; ---------------------------------
; Innitialisation de la BCF
; ---------------------------------
BCF_InitBCF(2,3)

; ------------------
; Scene Bidon
; ------------------
Plan=CreatePlane(16)
PositionEntity Plan,0,0,0

Sol=LoadTexture(".\Medias\Floor 01.jpg")
EntityTexture Plan,Sol 

Logo=LoadMesh(".\Medias\Logo BCF 2.0.x")
PositionEntity Logo,0,5,0

Texture=LoadTexture(".\Medias\Chrome.jpg",64)
EntityTexture Logo,Texture

Camera=CreateCamera()
PositionEntity Camera,0,5,-5

Light1=CreateLight(2) :PositionEntity Light1,5,10,-5
LightColor Light1,255,150,0 : LightRange Light1,10

Light2=CreateLight(2) : PositionEntity Light2,-5,5,5
LightColor Light2,0,150,255 : LightRange Light2,10

AmbientLight 50,50,50

; -----------------------------------
; Innitialisation de la souris
; -----------------------------------
BCF_Init3DMouse(4)

; ------------------------------------
; On dfinition de l'interface
; ------------------------------------
Global MaFenetre=BCF_CreateWindow(20,20,450,500,BCF_GuiStyle,3,"BCF 3.0",True,True)

ViewPortCam1=BCF_CreateViewport( MaFenetre,10,10,150,150,0,1,-5,-25,0,0 )

Button01=BCF_CreateButton(MaFenetre,10,170,125,20,"Open Path",BCF_GuiStyle)
Button07=BCF_CreateButton(MaFenetre,10,200,125,20,"Open File",BCF_GuiStyle)
Button08=BCF_CreateButton(MaFenetre,10,230,125,20,"Msg box",BCF_GuiStyle)
Button09=BCF_CreateButton(MaFenetre,10,260,125,20,"Open Window",BCF_GuiStyle)
Button10=BCF_CreateButton(MaFenetre,259,290,180,20,"Clear List",BCF_GuiStyle)
Button11=BCF_CreateButton(MaFenetre,259,320,180,20,"Add Item",BCF_GuiStyle)

BCF_CreateButtonToolTip(Button01,"Create ToolTip :)")
BCF_CreateButtonToolTip(Button02,"I love BCF")


Button12=BCF_CreateBitmapButton(MaFenetre,20,370,".\Medias\Button 04.bmp",BCF_GuiStyle)
Button13=BCF_CreateBitmapButton(MaFenetre,200,370,".\Medias\Button 01.jpg",BCF_GuiStyle)
Button14=BCF_CreateBitmapButton(MaFenetre,320,370,".\Medias\Button 02.jpg",BCF_GuiStyle)

BCF_CreateBitmapButtonToolTip(Button12,"Create ToolTip :)")
BCF_CreateBitmapButtonToolTip(Button13,"I love BCF")

Button15=BCF_CreateBitmapButton(False,650,150,".\Medias\Button 05.bmp",0)
Button16=BCF_CreateBitmapButton(False,650,180,".\Medias\Button 05.bmp",0)
Button17=BCF_CreateBitmapButton(False,650,210,".\Medias\Button 05.bmp",0)


Button30=BCF_CreateButton(False,20,GraphicsHeight()-60,150,20,"Quit BCF 3 demo",BCF_GuiStyle)

Tmp=BCF_CreateComboBox(MaFenetre,265,10,175,100)
BCF_AddComboBoxItem(Tmp, "Test n1")
BCF_AddComboBoxItem(Tmp, "Test n2")
BCF_AddComboBoxItem(Tmp, "Test n3")
BCF_AddComboBoxItem(Tmp, "Test n4")
BCF_AddComboBoxItem(Tmp, "Test n5")

Tmp=BCF_CreateCheckbox(MaFenetre,265,50,0,"Test n6")
TmpAlpha=BCF_CreateSlIder(MaFenetre,10,290,125,20,0.0,1.0,1.0,False,"Alpha",BCF_GuiStyle,0,200,0)
Tmp=BCF_CreateInputBox(MaFenetre,265,110,"Input box",20,False)

Tmp1=BCF_CreateListBox(MaFenetre,260,145,180,142)
BCF_AddListBoxItem( Tmp1, "Listbox item n1")
BCF_AddListBoxItem( Tmp1, "Listbox item n2")
BCF_AddListBoxItem( Tmp1, "Listbox item n3")
BCF_AddListBoxItem( Tmp1, "Listbox item n4")
BCF_AddListBoxItem( Tmp1, "Listbox item n5")



Frame01=BCF_CreateFrame(MaFenetre,5,350,430,120,"3D Frame")

Toolbar=BCF_CreateWindow(520,20,95,300,BCF_GuiStyle,1,"BCF 3.0",True,True)
Icon01=BCF_CreateBitmapButton(Toolbar,5,10,".\Medias\Button 01.jpg",0)
Icon02=BCF_CreateBitmapButton(Toolbar,5,100,".\Medias\Button 02.jpg",0)
Icon03=BCF_CreateBitmapButton(Toolbar,5,190,".\Medias\Button 04.bmp",0)


image=BCF_CreateWindow(450,200,323,380,BCF_GuiStyle,1,"BCF 3.0",True,True)

Image01=BCF_CreateImage( image,10,10,300,280,".\Medias\Logo BCF 3.0.jpg" )
Image02=BCF_CreateButton(Image,10,300,300,20,"Kill image control",BCF_GuiStyle)
Image03=BCF_CreateButton(Image,10,330,300,20,"Change image",BCF_GuiStyle)

Scroll0 = BCF_CreateScrollBar( MaFenetre,10,320,125 ,20,-5,5,0.5,"Rotation",True,200,100,50 )
BCF_ChangeScrollBarValue( Scroll0 , 1)

; ---------------------
; Creating menu
; ---------------------
MyMenu01= BCF_CreateMenu( "File"  )
Item01=BCF_CreateMenuItem ( MyMenu01 , "Open")
Item02=BCF_CreateMenuItem ( MyMenu01 , "Save", False)
Item03=BCF_CreateMenuItem ( MyMenu01 , "")
Item04=BCF_CreateMenuItem ( MyMenu01 , "Delete")
Item05=BCF_CreateMenuItem ( MyMenu01 , "Rename")
Item06=BCF_CreateMenuItem ( MyMenu01 , "")

Sub01=BCF_CreateMenuItem ( MyMenu01 , "Test sub menu")
SubMEnu01 = BCF_CreateSubMenu(Sub01 )
Item09=BCF_CreateMenuItem (SubMenu01 , "Easy create menu")
Item10=BCF_CreateMenuItem (SubMenu01 , "With multi-sub menu")

Item07=BCF_CreateMenuItem ( MyMenu01 , "")
Item08=BCF_CreateMenuItem ( MyMenu01 , "Quit")

Sub02=BCF_CreateMenuItem (SubMEnu01 , "And ...")
SubMEnu02 = BCF_CreateSubMenu(Sub02 )

Item11=BCF_CreateMenuItem (SubMEnu02 , "Popup menu !")
Item12=BCF_CreateMenuItem (SubMEnu02 , "With multi-sub menu !")

MyMenu02= BCF_CreateMenu( "Edit" ,False )

MyMenu03= BCF_CreateMenu( "Prefs"  )
Item13=BCF_CreateMenuItem ( MyMenu03 , "You can :")
Item14=BCF_CreateMenuItem ( MyMenu03 , "Show / Hide Item")
Item15=BCF_CreateMenuItem ( MyMenu03 , "Disable / Enable Item")

; ----------------------------
; Create PopUp Menu
; ----------------------------
MyPopUp=BCF_CreatePopUpMenu()
Item16=BCF_CreateMenuItem ( MyPopUp , "You can have")
Item17=BCF_CreateMenuItem ( MyPopUp , "Multi pop up menu")
Item18=BCF_CreateMenuItem ( MyPopUp , "With sub menu") : SubMEnu03 = BCF_CreateSubMenu(Item18 ): Item21=BCF_CreateMenuItem ( SubMEnu03  , "I like BCF 3.0 !")
Item19=BCF_CreateMenuItem ( MyPopUp , "")
Item20=BCF_CreateMenuItem ( MyPopUp , "With separator ...")

BCF_SetPopupMenu(MyPopUp)

BCF_MsgBox("Information : during demo","Press right mouse button to activate pop up menu" ,0)


; -------------------------
; Boucle de gestion
; -------------------------
While Not KeyDown( 1 )  Or BCF_TestLastWindow()=True
	; ------------------------------
	; Tourne ta race le logo
	; ------------------------------
	TurnEntity Logo, 0,BCF_TestScrollBar#(Scroll0),0

	; -----------------------------------------------
	; Gestion de l'interface et du pop up
	; -----------------------------------------------
	If BCF_TestMenuItem( Item08 ) Then
		Exit
	EndIf 

	; --------------------------------------------------------------------------
	; On teste les boutons et on change le style du pointeur
	; --------------------------------------------------------------------------
	If BCF_TestButton(Button01)  Then
		Selecteur$=BCF_PathRequester(  )
		BCF_MsgBox("Information","Path Selected : " + Selecteur$ ,0)
	EndIf
	

	If BCF_TestButton(Button07)  Then
		Selecteur$=BCF_FileRequester( "Title","Validate","Cancel" )
		BCF_MsgBox("Information","File Selected : " + Selecteur$ ,0)
	EndIf

	If BCF_TestButton(Button08)  Then
		Reponse=BCF_MsgBox("Information","Message box  type 'Ok'",0)
		Reponse=BCF_MsgBox("Information","Message box  type 'Yes/No'",1)
		Reponse=BCF_MsgBox("Information","Message box  type 'Yes/No/Cancel'",2)
	EndIf

	If BCF_TestButton(Button09)  Then
		TmpWindow=BCF_CreateWindow(Rnd(400,600),Rnd(200),200,Rnd(100,200),BCF_GuiStyle,3,"BCF 3.0",True,True)
	EndIf

	If BCF_TestButton(Button10)  Then
		BCF_ClearListBox( Tmp1 )
	EndIf

	If BCF_TestButton(Button11)  Then
		BCF_AddListBoxItem( Tmp1, "Listbox item n"+Rnd(200))
	EndIf

	If  BCF_TestBitmapButton(Button13) Or BCF_TestBitmapButton(Button14) Then
		BCF_Init3DMouse(Rand(1,6))
	EndIf

	If BCF_TestBitmapButton(Button15) Or BCF_TestBitmapButton(Button16) Or BCF_TestBitmapButton(Button17) Then
		Reponse=BCF_MsgBox("Information","BCF Bitmap button :) with or without border, and transparency",0)
	EndIf

	If BCF_TestBitmapButton(Button12) Then
		Demande$=BCF_MsgInputBox$("Type string or number","BCF 3 ? I love !")
		Reponse=BCF_MsgBox("Information","String : "+Demande$,1)
	EndIf
	
	
	; -----------------------------------------------------------------
	; On teste le bouton 10 et on quitte si ncessaire
	; -----------------------------------------------------------------	
	If BCF_TestButton(Button30)  Then
		Exit
	EndIf

	; --------------------------------------------------------
	; On teste le bouton 01 et on efface l'image
	; --------------------------------------------------------
	If BCF_TestButton(Image02)  Then
		BCF_KillImage(Image01)
	EndIf

	; ----------------------------------------------------------
	; On teste le bouton 02 et on charge l'image
	; ----------------------------------------------------------
	If BCF_TestButton(Image03)  Then
		Selecteur$=BCF_FileRequester("","","","")

		If Selecteur$<>"" Then
			BCF_ChangeImageBitmap(Image01,Selecteur$)
		EndIf 
	EndIf

	Alpha#=BCF_TestSlIder(TmpAlpha)
	EntityAlpha Logo,Alpha#

	BCF_UpdateViewPort()
	
	RenderWorld
	UpdateWorld
	
	; -------------------------
	; Gestion de la BCF
	; -------------------------
	BCF_RenderBCF()
	
	Get_FPS()

	Flip False
Wend

; ---------------------------------
; On quitte le programme
; ---------------------------------
BCF_KillBCF()
End

; ------------------------------------
; Calcul du nombre de FPS
; ------------------------------------
Function Get_FPS()
	FPS_CurrentTime = MilliSecs()

	If FPS_CurrentTime > FPS_CheckTime Then
		FPS_CheckTime = FPS_CurrentTime + 1000
		FPS_CurrentFPS = FPS_Counter
		FPS_Counter = 0
	Else
		FPS_Counter = FPS_Counter + 1
	End If

	Color 255,255,0
	Text 10,GraphicsHeight()-50,FPS_CurrentFPS+" FPS"
End Function 