;=======================================================================================
; Code :Exemple BCF
; Project Title :
; Author : Philippe Agnisola et Nicolas Poursin
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_bcf3.bb"

Type TMovie
	Field Id
	Field WinId
	Field Movie
	Field Px
	Field Py
	Field Tx
	Field Ty
End Type

Global BCF_TMovieId

Graphics3D 640,480,32,2
SetBuffer BackBuffer()

; ---------------------------------
; Innitialisation de la BCF
; ---------------------------------
BCF_InitBCF(2,1)

Camera=CreateCamera()

; -----------------------------------
; Innitialisation de la souris
; -----------------------------------
BCF_Init3DMouse(4)

; ------------------------------------
; On dfinition de l'interface
; ------------------------------------
TmpTx=400
TmpTy=300

MaFenetre=BCF_CreateWindow(20,20,TmpTx,TmpTy,BCF_GuiStyle,1,"BCF 2.0 : Video",False,False)

Film=BCF_CreateMovie(MaFenetre,"tst.avi",0,0,TmpTx,TmpTy)

Button02=BCF_CreateButton(False,20,420,150,20,"Quitter le programme",BCF_GuiStyle)

; -------------------------
; Boucle de gestion
; -------------------------
While Not KeyDown( 1 )
	; -----------------------------------------------------------------
	; On teste le bouton 02 et on quitte si ncessaire
	; -----------------------------------------------------------------
	If BCF_TestButton(Button02)  Then
		Exit
	EndIf
	
	RenderWorld
	UpdateWorld
	
	; -------------------------
	; Gestion de la BCF
	; -------------------------
	BCF_RenderBCF()

	; -----------------------------------------------------------------------
	; Si fenetre ouverte on play le movie sinon on le ferme
	; -----------------------------------------------------------------------
	If BCF_Window( MaFenetre ) Then
		Proc_PlayMovie(MaFenetre)
	Else
		BCF_KillMovie( Film)
	EndIf
	
	Flip
Wend

; ---------------------------------
; On quitte le programme
; ---------------------------------
BCF_KillMovie(Film )
BCF_KillBCF()
End

; ----------------------------------------
; Permet d'initialiser une video
; ----------------------------------------
Function BCF_CreateMovie(WinId,Name$,Px,Py,Tx,Ty)
	BCF_TMovieId=BCF_TMovieId+1

	BCF.TMovie = New TMovie
	BCF\Id=BCF_TMovieId
	BCF\WinId=WinId
	BCF\Movie=OpenMovie(Name$)
	BCF\Px=Px
	BCF\Py=Py
	BCF\Tx=Tx
	BCF\Ty=Ty

	; ------------------------------------
	; Test pour la fenetre virtuel
	; ------------------------------------
	If WinId=False Then
		BCF\WinId = BCF_TestVirtualParent()
		BCF_IdVirtualParent = BCF\WinId
	EndIf
	
	Return BCF_TMovieId
End Function

; ------------------------------------
; Permet de jouer une video 
; ------------------------------------
Function Proc_PlayMovie(Window)
	For win.TWindow = Each TWindow
		If win\id = Window Then
			Window= Handle(win)
		EndIf
	Next
	
	ParentWindow.TWindow = Object.TWindow(Window)

	For BCF.TMovie = Each TMovie
		; ----------------------------------------------------------
		; Si le State de la fenetre est 0 (non rduite) 
		; ----------------------------------------------------------
		If BCF\WinId = ParentWindow\Id  And ParentWindow\State=0 Then

			; ----------------------
			; Synchronisation
			; ----------------------
			Repeat Until MilliSecs()-time>=100 
			time=MilliSecs() 
		
			; ----------------------------
			; Affichage de la video
			; ----------------------------
			TmpX=BCF\Px+ParentWindow\Px+2   ; 2=Bordure 3D de la gauche de la fenetre
			TmpY=BCF\Py+ParentWindow\Py+23 ; 23=Hauteur de la barre de titre
	
			If MoviePlaying(BCF\Movie)  Then
					DrawMovie BCF\Movie,TmpX,TmpY,BCF\Tx-4,BCF\Ty-26
			Else
				BCF_KillMovie(BCF\Movie )
			EndIf
		EndIf 
	Next
End Function

; ----------------------------------------
; Permet de detruire une video
; ----------------------------------------
Function BCF_KillMovie( Id )
	For BCF.TMovie = Each TMovie
		If BCF\Id = Id Then
			CloseMovie BCF\Movie
			Delete BCF
			Exit
		EndIf
	Next
End Function

