;=======================================================================================
; Code :Exemple BCF
; Project Title :
; Author : Philippe Agnisola et Nicolas Poursin
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_bcf3.bb"

Graphics3D 1024,768,0,2
SetBuffer BackBuffer()

; ---------------------------------------------------
; Variable globales du nombre de FPS
; ---------------------------------------------------
Global FPS_Counter
Global FPS_CheckTime
Global FPS_CurrentFPS
Global FPS_CurrentTime 

; ---------------------------------
; Innitialisation de la BCF
; ---------------------------------
BCF_InitBCF(2,3)

; ------------------
; Scene Bidon
; ------------------
Camera=CreateCamera()
PositionEntity Camera,0,5,-10

Light1=CreateLight(2) :PositionEntity Light1,10,10,-10
LightColor Light1,255,255,255 : LightRange Light1,10

Light2=CreateLight(2) : PositionEntity Light2,-10,10,10
LightColor Light2,255,255,255 : LightRange Light2,10

AmbientLight 50,50,50

; -----------------------------------
; Innitialisation de la souris
; -----------------------------------
BCF_Init3DMouse(4)

; ------------------------------------
; On dfinition de l'interface
; ------------------------------------
MaFenetre=BCF_CreateWindow(20,20,175,250,BCF_GuiStyle,1,"BCF 3.0",True,True)

Slider0=BCF_CreateSlIder(MaFenetre,10,50,BCF_GetWindowWIdth(MaFenetre)-24,20,-1.0,1.0,0.0,False,"Rotation X",BCF_GuiStyle,100,0,0)
Slider1=BCF_CreateSlIder(MaFenetre,10,80,BCF_GetWindowWIdth(MaFenetre)-24,20,-1.0,1.0,0.0,False,"Rotation Y",BCF_GuiStyle,0,100,0)
Slider2=BCF_CreateSlIder(MaFenetre,10,110,BCF_GetWindowWIdth(MaFenetre)-24,20,-1.0,1.0,0.0,False,"Rotation Z",BCF_GuiStyle,0,0,100)
Slider3=BCF_CreateSlIder(MaFenetre,10,140,BCF_GetWindowWIdth(MaFenetre)-24,20,0.0,10.0,1.0,False,"Taille",BCF_GuiStyle,100,100,0)

Button01=BCF_CreateButton(MaFenetre,10,20,BCF_GetWindowWIdth(MaFenetre)-24,20,"Ouvrir un fichier 3D",BCF_GuiStyle)
Button02=BCF_CreateButton(MaFenetre,10,190,BCF_GetWindowWIdth(MaFenetre)-24,20,"Rinitialiser la rotation",BCF_GuiStyle)

Button03=BCF_CreateButton(False,20,GraphicsHeight()-60,150,20,"Quitter le programme",BCF_GuiStyle)

; -------------------------
; Boucle de gestion
; -------------------------
LoadedMesh=0

While Not KeyDown( 1 )
	; ----------------------------------------------------------------
	; On teste le bouton 01 et on charge un objet 3D
	; ----------------------------------------------------------------
	If BCF_TestButton(Button01)  Then
		; -----------------------------------------------------
		; Si objet prcdement charg on le vire
		; -----------------------------------------------------
		If LoadedMesh=1 Then
			FreeEntity Objet
		EndIf
		
		; -------------------------------
		; Affichage du selecteur
		; -------------------------------
		Selecteur$=BCF_FileRequester(  )
		
		If Selecteur$<>"" And Upper(Right(Selecteur$,4))=".3DS" Or Upper(Right(Selecteur$,2))=".X" Or Upper(Right(Selecteur$,4))=".B3D" Then
			Objet=LoadMesh(Selecteur$)
			PositionEntity Objet,0,5,0
			
			LoadedMesh=1
		Else
			BCF_MsgBox("Information","Aucun fichier slctionn ! ou ce n'est pas un fichier 3DS, X, B3D" ,0)
			LoadedMesh=0
		EndIf
	EndIf
	
	; ------------------------------------------------------------------
	; On teste le bouton 02 et on rinitialise la rotation
	; ------------------------------------------------------------------
	If BCF_TestButton(Button02)  Then
		BCF_ChangeSliderValue(Slider0,0.0)
		BCF_ChangeSliderValue(Slider1,0.0)
		BCF_ChangeSliderValue(Slider2,0.0)
	EndIf
	
	; -----------------------------
	; Tourne ta race l'objet
	; -----------------------------
	RotX#=BCF_TestSlIder(Slider0)
	RotY#=BCF_TestSlIder(Slider1)
	RotZ#=BCF_TestSlIder(Slider2)
	
	Size#=BCF_TestSlIder(Slider3)
	
	; ---------------------------
	; Si l'objet est charg
	; ---------------------------
	If LoadedMesh=1 Then
		TurnEntity Objet, RotX#,RotY#,RotZ#
		ScaleEntity Objet,Size#,Size#,Size#
	EndIf

	; -----------------------------------------------------------------
	; On teste le bouton 03 et on quitte si ncessaire
	; -----------------------------------------------------------------	
	If BCF_TestButton(Button03) Then
		Exit
	EndIf
	
	RenderWorld
	UpdateWorld
	
	; -------------------------
	; Gestion de la BCF
	; -------------------------
	BCF_RenderBCF()
	Get_FPS()
	Flip
Wend

; ---------------------------------
; On quitte le programme
; ---------------------------------
BCF_KillBCF()
End

; ------------------------------------
; Calcul du nombre de FPS
; ------------------------------------
Function Get_FPS()
	FPS_CurrentTime = MilliSecs()

	If FPS_CurrentTime > FPS_CheckTime Then
		FPS_CheckTime = FPS_CurrentTime + 1000
		FPS_CurrentFPS = FPS_Counter
		FPS_Counter = 0
	Else
		FPS_Counter = FPS_Counter + 1
	End If

	Color 255,255,0
	Text 10,10,FPS_CurrentFPS
End Function 