;=======================================================================================
; Code :Exemple BCF
; Project Title :
; Author : Philippe Agnisola et Nicolas Poursin
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_bcf3.bb"

Global Rotate#

Graphics3D 640,480,0,2
SetBuffer BackBuffer()

; ---------------------------------------------------
; Variable globales du nombre de FPS
; ---------------------------------------------------
Global FPS_Counter
Global FPS_CheckTime
Global FPS_CurrentFPS
Global FPS_CurrentTime 

; ---------------------------------
; Innitialisation de la BCF
; ---------------------------------
BCF_InitBCF(2,2)

; ------------------
; Scene Bidon
; ------------------
Plan=CreatePlane(16)
PositionEntity Plan,0,0,0

Sol=LoadTexture(".\Medias\Floor 01.jpg")
EntityTexture Plan,Sol 

Logo=LoadMesh(".\Medias\Logo BCF 2.0.x")
PositionEntity Logo,0,5,0

Texture=LoadTexture(".\Medias\Chrome.jpg",64)
EntityTexture Logo,Texture

Camera=CreateCamera()
PositionEntity Camera,0,5,-5

Light1=CreateLight(2) :PositionEntity Light1,5,10,-5
LightColor Light1,255,150,0 : LightRange Light1,10

Light2=CreateLight(2) : PositionEntity Light2,-5,5,5
LightColor Light2,0,150,255 : LightRange Light2,10

AmbientLight 50,50,50

; -----------------------------------
; Innitialisation de la souris
; -----------------------------------
BCF_Init3DMouse(4)

; ------------------------------------
; On dfinition de l'interface
; ------------------------------------
MaFenetre=BCF_CreateWindow(20,20,250,50,1,1,"BCF 3.0",True,False)
BCF_CreateLabelText(Mafenetre,20,9,"Bouton droit pour voir le popup menu",1,1,0,0,0)

; -------------
; Le menu
; -------------
MyMenu01= BCF_CreateMenu( "Fichier"  )
Item01=BCF_CreateMenuItem ( MyMenu01 , "Ouvrir")
Item02=BCF_CreateMenuItem ( MyMenu01 , "Sauver", False)
Item03=BCF_CreateMenuItem ( MyMenu01 , "")
Item04=BCF_CreateMenuItem ( MyMenu01 , "Effacer")

Item05=BCF_CreateMenuItem ( MyMenu01 , "Autres ...")
SubMEnu02 = BCF_CreateSubMenu(Item05 )
SubItem01=BCF_CreateMenuItem ( SubMEnu02 , "Option n1")
SubItem02=BCF_CreateMenuItem ( SubMEnu02 , "Option n2")
SubItem03=BCF_CreateMenuItem ( SubMEnu02 , "Option n3")

Item06=BCF_CreateMenuItem ( MyMenu01 , "")
Item07=BCF_CreateMenuItem ( MyMenu01 , "Quitter ...")

; -----------------------
; Le pop up menu
; -----------------------
MyPopUp=BCF_CreatePopUpMenu()
Item16=BCF_CreateMenuItem ( MyPopUp , "You can have")
Item17=BCF_CreateMenuItem ( MyPopUp , "Multi pop up menu")
Item18=BCF_CreateMenuItem ( MyPopUp , "With sub menu") : SubMEnu03 = BCF_CreateSubMenu(Item18 ): Item21=BCF_CreateMenuItem ( SubMEnu03  , "I like BCF 3.0 !")
Item19=BCF_CreateMenuItem ( MyPopUp , "")
Item20=BCF_CreateMenuItem ( MyPopUp , "With separator ...")

BCF_SetPopupMenu(MyPopUp) ; Important pour activer vos menus

; -------------------------
; Boucle de gestion
; -------------------------
While Not KeyDown( 1 )
	; -----------------------------------------------
	; Gestion de l'interface et du pop up
	; -----------------------------------------------
	If BCF_TestMenuItem( Item20 ) Then
		Exit
	EndIf

	If BCF_TestMenuItem( SubItem01 ) Then
		Rotate#=-0.1
	EndIf

	If BCF_TestMenuItem( SubItem02 ) Then
		Rotate#=0.1
	EndIf

	If BCF_TestMenuItem( SubItem03 ) Then
		Rotate#=0
	EndIf 

	TurnEntity Logo, Rotate#,Rotate#,Rotate#

	RenderWorld
	UpdateWorld
	
	; -------------------------
	; Gestion de la BCF
	; -------------------------
	BCF_RenderBCF()
	Get_FPS()
	Flip
Wend

; ---------------------------------
; On quitte le programme
; ---------------------------------
BCF_KillBCF()
End

; ------------------------------------
; Calcul du nombre de FPS
; ------------------------------------
Function Get_FPS()
	FPS_CurrentTime = MilliSecs()

	If FPS_CurrentTime > FPS_CheckTime Then
		FPS_CheckTime = FPS_CurrentTime + 1000
		FPS_CurrentFPS = FPS_Counter
		FPS_Counter = 0
	Else
		FPS_Counter = FPS_Counter + 1
	End If

	Color 255,255,0
	Text 10,GraphicsHeight()-50,FPS_CurrentFPS
End Function 