;=======================================================================================
; Code :Exemple BCF
; Project Title :
; Author : Philippe Agnisola et Nicolas Poursin
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_bcf3.bb"
Include "Plugin_ScreenSelector.bb"

; ---------------------------------------------------
; Variable globales du nombre de FPS
; ---------------------------------------------------
Global FPS_Counter
Global FPS_CheckTime
Global FPS_CurrentFPS
Global FPS_CurrentTime

; ---------------------------------------------------------------------------------------------------------
; Innitialisation de la souris et de la BCF et affichage du requester de selection
; ---------------------------------------------------------------------------------------------------------
BCF_SelectScreenRes(1,2,"")

; ------------------
; Scene Bidon
; ------------------
Plan=CreatePlane(16)
PositionEntity Plan,0,0,0

Sol=LoadTexture(".\Medias\Floor 01.jpg")
EntityTexture Plan,Sol 

Logo=LoadMesh(".\Medias\Logo BCF 2.0.x")
PositionEntity Logo,0,5,0

Texture=LoadTexture(".\Medias\Chrome.jpg",64)
EntityTexture Logo,Texture

Camera=CreateCamera()
PositionEntity Camera,0,5,-5

Light1=CreateLight(2) :PositionEntity Light1,5,10,-5
LightColor Light1,255,150,0 : LightRange Light1,10

Light2=CreateLight(2) : PositionEntity Light2,-5,5,5
LightColor Light2,0,150,255 : LightRange Light2,10

AmbientLight 50,50,50

; --------------------------------------------------------------------------------------------
; On dfinition de l'interface apres nouvelle reinitialisation de la  BCF
; --------------------------------------------------------------------------------------------
BCF_InitBCF(2,2)
BCF_Init3DMouse(1)

Button01=BCF_CreateButton(False,20,GraphicsHeight()-60,150,20,"Quitter le programme",BCF_GuiStyle)

; -------------------------
; Boucle de gestion
; -------------------------
While Not KeyDown( 1 )
	; ------------------------------
	; Tourne ta race le logo
	; ------------------------------
	TurnEntity Logo, 0,0.3,0
	
	; -----------------------------------------------------------------
	; On teste le bouton 01 et on quitte si ncessaire
	; -----------------------------------------------------------------	
	If BCF_TestButton(Button01)  Then
		Exit
	EndIf
	
	RenderWorld
	UpdateWorld
	
	; -------------------------
	; Gestion de la BCF
	; -------------------------
	BCF_RenderBCF()
	Get_FPS()
	Flip
Wend

; ---------------------------------
; On quitte le programme
; ---------------------------------
BCF_KillBCF()
End

; ------------------------------------
; Calcul du nombre de FPS
; ------------------------------------
Function Get_FPS()
	FPS_CurrentTime = MilliSecs()

	If FPS_CurrentTime > FPS_CheckTime Then
		FPS_CheckTime = FPS_CurrentTime + 1000
		FPS_CurrentFPS = FPS_Counter
		FPS_Counter = 0
	Else
		FPS_Counter = FPS_Counter + 1
	End If

	Color 255,255,0
	Text 10,10,FPS_CurrentFPS
End Function 
