;=======================================================================================
; Code :Exemple BCF
; Project Title :
; Author : Philippe Agnisola et Nicolas Poursin
; Email :                    
; Version : 1.0.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Include "Inc_bcf3.bb"

Graphics3D 640,480,0,2
SetBuffer BackBuffer()

; ---------------------------------------------------
; Variable globales du nombre de FPS
; ---------------------------------------------------
Global FPS_Counter
Global FPS_CheckTime
Global FPS_CurrentFPS
Global FPS_CurrentTime

; ---------------------------------
; Innitialisation de la BCF
; ---------------------------------
BCF_InitBCF(2,1)

; ------------------
; Scene Bidon
; ------------------
Plan=CreatePlane(16)
PositionEntity Plan,0,0,0

Sol=LoadTexture(".\Medias\Floor 01.jpg")
EntityTexture Plan,Sol 

Logo=LoadMesh(".\Medias\Logo BCF 2.0.x")
PositionEntity Logo,0,5,0

Texture=LoadTexture(".\Medias\Chrome.jpg",64)
EntityTexture Logo,Texture

Camera=CreateCamera()
PositionEntity Camera,0,5000,0

Light1=CreateLight(2) :PositionEntity Light1,5,10,-5
LightColor Light1,255,150,0 : LightRange Light1,10

Light2=CreateLight(2) : PositionEntity Light2,-5,5,5
LightColor Light2,0,150,255 : LightRange Light2,10

AmbientLight 50,50,50

; -----------------------------------
; Innitialisation de la souris
; -----------------------------------
BCF_Init3DMouse(4)

; ------------------------------------
; On dfinition de l'interface
; ------------------------------------
WindTX=200
WindTy=200

MaFenetre1=BCF_CreateWindow(20,20,WindTX,WindTy,BCF_GuiStyle,1,"BCF 3.0 : Fentre n"+i,True,True)
ViewPortCam1=BCF_CreateViewport( MaFenetre1,2,2,WindTX-10,WindTy-32,0,1,-5,-25,0,0 )

MaFenetre2=BCF_CreateWindow(20,230,WindTX,WindTy,BCF_GuiStyle,1,"BCF 3.0 : Fentre n"+i,True,True)
ViewPortCam2=BCF_CreateViewport( MaFenetre2,2,2,WindTX-10,WindTy-32,0,10,-5,45,0,0 )

MaFenetre3=BCF_CreateWindow(230,20,WindTX,WindTy,BCF_GuiStyle,1,"BCF 3.0 : Fentre n"+i,True,True)
ViewPortCam3=BCF_CreateViewport( MaFenetre3,2,2,WindTX-10,WindTy-32,0,10,0,90,0,0 )

Button02=BCF_CreateButton(False,20,420,150,20,"Quitter le programme",BCF_GuiStyle)

; -------------------------
; Boucle de gestion
; -------------------------
GoodCam=ViewPortCam3

While Not KeyDown( 1 ) Or BCF_TestLastWindow()=True
	; ------------------------------
	; Tourne ta race le logo
	; ------------------------------
	TurnEntity Logo, 0,0.5,0

	; ----------------
	; Si activation
	; ----------------
	If BCF_WindowIsActive(MaFenetre1)=True Then
		GoodCam=ViewPortCam1
	EndIf

	If BCF_WindowIsActive(MaFenetre2)=True Then
		GoodCam=ViewPortCam2
	EndIf

	If BCF_WindowIsActive(MaFenetre3)=True Then
		GoodCam=ViewPortCam3
	EndIf

	TurnEntity GoodCam,0,0,1
	
	; -----------------------------------------------------------------
	; On teste le bouton 02 et on quitte si ncessaire
	; -----------------------------------------------------------------	
	If BCF_TestButton(Button02)=True  Then
		;BCF_KillIViewPort(ViewPortCam1)
		Exit
	EndIf

	BCF_UpdateViewPort()
	
	RenderWorld
	UpdateWorld
	
	; -------------------------
	; Gestion de la BCF
	; -------------------------
	BCF_RenderBCF()
	Get_FPS()
	
	Flip
	
Wend

; ---------------------------------
; On quitte le programme
; ---------------------------------
BCF_KillBCF()
End

; ------------------------------------
; Calcul du nombre de FPS
; ------------------------------------
Function Get_FPS()
	FPS_CurrentTime = MilliSecs()

	If FPS_CurrentTime > FPS_CheckTime Then
		FPS_CheckTime = FPS_CurrentTime + 1000
		FPS_CurrentFPS = FPS_Counter
		FPS_Counter = 0
	Else
		FPS_Counter = FPS_Counter + 1
	End If

	Color 255,255,0
	Text 10,10,FPS_CurrentFPS
End Function 