;=======================================================================================
; Code : BCF Librairie ColorSelector Plugin		
; Project Title :
; Author : V2.0 Par Philippe Agnisola	et Nicolas Poursin
; Email :                    
; Version : 1.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

Function BCF_GetColor(ColNum)
	; -----------------------------------------------------------
	; Definition de la position X et Y du requester
	; -----------------------------------------------------------
	Local HalfWidth=GraphicsWidth()/2
	Local HalfHeight=GraphicsHeight()/2

	Local RequestWidth=200
	Local RequestHeight=160
		
	Local Px=HalfWidth-(RequestWidth/2)
	Local Py=HalfHeight-(RequestHeight/2)

	Local Red=BCF_GetRed(ColNum)
	Local Green=BCF_GetGreen(ColNum)
	Local Blue=BCF_GetBlue(ColNum)

	Local ColorFenetre
	Local ColorValider
	Local ColorAnnuler

	Local SliderRouge
	Local SliderVert
	Local SliderBleu

	If BCF_Localization=1 Then
		ColorFenetre=BCF_CreateWindow(Px,Py,RequestWidth,RequestHeight,BCF_GuiStyle,3,"RVB",True,False)
		ColorValider=BCF_CreateButton(ColorFenetre,5,RequestHeight-55,70,20,"Valider",BCF_GuiStyle)
		ColorAnnuler=BCF_CreateButton(ColorFenetre,RequestWidth-80,RequestHeight-55,70,20,"Annuler",BCF_GuiStyle)

		SliderRouge=BCF_CreateSlider(ColorFenetre,5,10,100,20,0,255,Red,True,"Rouge",BCF_GuiStyle,255,0,0)
		SliderVert=BCF_CreateSlider(ColorFenetre,5,37,100,20,0,255,Green,True,"Vert",BCF_GuiStyle,0,255,0)
		SliderBleu=BCF_CreateSlider(ColorFenetre,5,65,100,20,0,255,Blue,True,"Bleu",BCF_GuiStyle,0,0,255)
	Else
		ColorFenetre=BCF_CreateWindow(Px,Py,RequestWidth,RequestHeight,BCF_GuiStyle,3,"RGB",True,False)
		ColorValider=BCF_CreateButton(ColorFenetre,5,RequestHeight-55,70,20,"Ok",BCF_GuiStyle)
		ColorAnnuler=BCF_CreateButton(ColorFenetre,RequestWidth-80,RequestHeight-55,70,20,"Cancel",BCF_GuiStyle)

		SliderRouge=BCF_CreateSlider(ColorFenetre,5,10,100,20,0,255,Red,True,"Red",BCF_GuiStyle,255,0,0)
		SliderVert=BCF_CreateSlider(ColorFenetre,5,37,100,20,0,255,Green,True,"Green",BCF_GuiStyle,0,255,0)
		SliderBleu=BCF_CreateSlider(ColorFenetre,5,65,100,20,0,255,Blue,True,"Blue",BCF_GuiStyle,0,0,255)
	EndIf

	Local BarColor=BCF_CreateGauge(ColorFenetre,113,10,79,75,10,10,False,3,Red,Green,Blue)
	
	Repeat
		; -----------------------------------
		; On teste le bouton valider
		; -----------------------------------	
		If BCF_TestButton(ColorValider)  Then
				BCF_SetColor(ColNum,BCF_TestSlider(SliderRouge),BCF_TestSlider(SliderVert),BCF_TestSlider(SliderBleu))
				Exit
		EndIf

		; ------------------------------------
		; On teste le bouton annuler
		; ------------------------------------
		If BCF_TestButton(ColorAnnuler)  Then
				Exit
		EndIf
		
		RenderWorld

		; -------------------------
		; Gestion de la BCF
		; -------------------------
		BCF_ChangeGaugeColor(BarColor,BCF_TestSlider(SliderRouge),BCF_TestSlider(SliderVert),BCF_TestSlider(SliderBleu))
		BCF_RenderBCF()
		
		Flip
	Forever

	BCF_KillWindow(ColorFenetre)
End Function