;=======================================================================================
; Code : BCF Librairie NetWorkGame Plugin		
; Project Title :
; Author : V2.0 Par Philippe Agnisola	et Nicolas Poursin
; Email :                    
; Version : 1.0
; Date :              
; Notes : Fonctionne avec l'include Inc_NetWork
;                   
;                   
;=======================================================================================

; -------------------------------------------------------------------------------------
; Fonction de creation d'un requester de selection de jeu rseau
; -------------------------------------------------------------------------------------
Function BCF_SelectNetWorkGame(TMPServerIP$="")
	Local RequestCamera=CreateCamera()
	
	; -----------------------------------------------------------
	; Definition de la position X et Y du requester
	; -----------------------------------------------------------
	Local HalfWidth=GraphicsWidth()/2
	Local HalfHeight=GraphicsHeight()/2

	Local RequestWidth=400
	Local RequestHeight=300
		
	Local Px=HalfWidth-(RequestWidth/2)
	Local Py=HalfHeight-(RequestHeight/2)

	; -----------------------------------
	; Si la langue est francaise
	; -----------------------------------
	If BCF_Localization=1 Then
		TMP_Request_Title$="Type de jeu rseau"
		TMP_Request_LaunchGame$="Crer un serveur"
		TMP_Request_JoinGame$="Rejoindre une partie"
		TMP_Request_MaxPlayer$="Nombre de joueurs max"
		TMP_Request_ServerName$="Votre nom"
		TMP_Request_ServerPort$="Votre port"
		TMP_Request_ConnectPort$="Port du serveur"	
		TMP_Request_Cancel$="Annuler ..."
		TMP_Request_ServerIP$="IP du serveur"

		TMP_Request_Problem$="Impossible de lancer le serveur ! vrifiez le port et votre connection ..."

		TMP_Connection_ErrorMsg1$="Pas de rponse du serveur !"
		TMP_Connection_ErrorMsg2$="Votre port local n'est pas disponible !"
		TMP_Connection_ErrorMsg3$="Le serveur est plein !"
		TMP_Connection_ErrorMsg4$="Votre IP est banni !"
		TMP_Connection_ErrorMsg5$="Vous avez annul la connection !"
		TMP_Connection_ErrorMsg6$="Adresse du serveur invalide !"
	EndIf
					
	; ----------------------------------
	; Si la langue est anglaise
	; ----------------------------------
	If BCF_Localization=2 Then
		TMP_Request_Title$="Network game type"
		TMP_Request_LaunchGame$="Create Server"
		TMP_Request_JoinGame$="Join Game"
		TMP_Request_MaxPlayer$="Max number of player's"
		TMP_Request_ServerName$="Your name"
		TMP_Request_ServerPort$="Your port"
		TMP_Request_ConnectPort$="Server port"	
		TMP_Request_Cancel$="Cancel ..."
		TMP_Request_ServerIP$="Server IP"

		TMP_Request_Problem$="Unable to start server ! Check the port and connection ..."

		TMP_Connection_ErrorMsg1$="Server no responding !"
		TMP_Connection_ErrorMsg2$="Your local port is occupied !"
		TMP_Connection_ErrorMsg3$="Server is full, retry later !"
		TMP_Connection_ErrorMsg4$="Your IP is banned !"
		TMP_Connection_ErrorMsg5$="Connection canceled !"
		TMP_Connection_ErrorMsg6$="Invalid server adress !"
	EndIf

	Local Number = CountHostIPs("") 
	Local LocalIP = HostIP(1) 
	Local IPaddress$ = DottedIP$(localip)

	Local Window=BCF_CreateWindow(Px,Py,RequestWidth,RequestHeight,1,2,TMP_Request_Title$+" / "+IPaddress$,True,False)

	; ------------------------------------------------
	; Interface de la section create game
 	; ------------------------------------------------
	Local Frame01=BCF_CreateFrame(Window,5,5,RequestWidth-15,105,TMP_Request_LaunchGame$)
	
	Local LaunchServer=BCF_CreateButton(Window,10,80,RequestWidth-25,20,TMP_Request_LaunchGame$)
	
	Local GameType=BCF_CreateComboBox(Window,10,17,180,100)
	BCF_AddComboBoxItem( GameType, "Deathmatch")
	BCF_SelectedComboBoxValue( GameType, "Deathmatch" )

	Local ServerName=BCF_CreateInputBox(Window,RequestWidth-106,17,"Player "+Rand (100,200),10,False)
	Local Label00 =  BCF_CreateLabelText(Window,RequestWidth-StringWidth(TMP_Request_ServerName$)-120,20,TMP_Request_ServerName$,1,1,BCF_GetRed(Bcf_Color03),BCF_GetGreen(Bcf_Color03), BCF_GetBlue(Bcf_Color03))

	Local MaxPlayer=BCF_CreateInputBox(Window,155,50,"5",3,False)
	Local Label01 =  BCF_CreateLabelText(Window,10,53,TMP_Request_MaxPlayer$,1,1,BCF_GetRed(Bcf_Color03),BCF_GetGreen(Bcf_Color03), BCF_GetBlue(Bcf_Color03))

	Local ServerPort=BCF_CreateInputBox(Window,RequestWidth-106,50,"4672",10,False)
	Local Label02 =  BCF_CreateLabelText(Window,RequestWidth-StringWidth(TMP_Request_ServerPort$)-120,53,TMP_Request_ServerPort$,1,1,BCF_GetRed(Bcf_Color03),BCF_GetGreen(Bcf_Color03), BCF_GetBlue(Bcf_Color03))

	; ---------------------------------------------
	; Interface de la section join game
 	; ---------------------------------------------
	Local Frame02=BCF_CreateFrame(Window,5,125,RequestWidth-15,105,TMP_Request_JoinGame$)

	Local JoinServer=BCF_CreateButton(Window,10,200,RequestWidth-25,20,TMP_Request_JoinGame$)

	Local Label03 =  BCF_CreateLabelText(Window,10,140,TMP_Request_ServerIP$,1,1,BCF_GetRed(Bcf_Color03),BCF_GetGreen(Bcf_Color03), BCF_GetBlue(Bcf_Color03))

	; Si pas d'ip specifie alors on prend l'ip du host
	If TMPServerIP$="" Then
		TMPServerIP$="127.0.0.1"
	EndIf
	
	Local ServerIP=BCF_CreateInputBox(Window,StringWidth(TMP_Request_ServerIP$)+25,137,TMPServerIP$,15,False)

	Local ClientName=BCF_CreateInputBox(Window,RequestWidth-106,137,"Player "+Rand (100,200),10,False)
	Local Label04 =  BCF_CreateLabelText(Window,RequestWidth-StringWidth(TMP_Request_ServerName$)-120,140,TMP_Request_ServerName$,1,1,BCF_GetRed(Bcf_Color03),BCF_GetGreen(Bcf_Color03), BCF_GetBlue(Bcf_Color03))

	Local ClientPort=BCF_CreateInputBox(Window,RequestWidth-106,170,"4660",10,False)
	Local Label05 =  BCF_CreateLabelText(Window,RequestWidth-StringWidth(TMP_Request_ServerPort$)-120,173,TMP_Request_ServerPort$,1,1,BCF_GetRed(Bcf_Color03),BCF_GetGreen(Bcf_Color03), BCF_GetBlue(Bcf_Color03))

	Local ConnectPort=BCF_CreateInputBox(Window,StringWidth(TMP_Request_ConnectPort$)+28,170,"4672",10,False)
	Local Label06 =  BCF_CreateLabelText(Window,10,173,TMP_Request_ConnectPort$,1,1,BCF_GetRed(Bcf_Color03),BCF_GetGreen(Bcf_Color03), BCF_GetBlue(Bcf_Color03))

	Local Cancel =BCF_CreateButton(Window,10, RequestHeight-50,RequestWidth-25,20,TMP_Request_Cancel$)
	
	; -------------------------
	; Boucle de gestion
 	; -------------------------
	Repeat
		; --------------------------------------------------------------------
		; On teste la Combobox et on change le type de jeu
		; --------------------------------------------------------------------
		TmpSelection$ = BCF_TestComboBox$(GameType)
		Select TmpSelection$
			Case "Deathmatch"
				Local TMP_GameType=1
		End Select
		
		; ----------------------
		; Si Create Game
		; ----------------------
		If BCF_TestButton(LaunchServer)  Then
			Local TMP_CreateGame=Proc_CreateServer(TMP_GameType,BCF_TestInputBox(MaxPlayer),BCF_TestInputBox(ServerPort), BCF_TestInputBox$(ServerName))

			If TMP_CreateGame=True 
				FreeEntity RequestCamera
				BCF_KillWindow(Window)
				Exit
			Else
				Msg=BCF_MsgBox("Information",TMP_Request_Problem$,0)
			EndIf
		EndIf

		; -------------------
		; Si Join Game
		; -------------------
		If BCF_TestButton(JoinServer)  Then
			Local TMP_JoinGame=Proc_JoinServer(BCF_TestInputBox$(ServerIP),BCF_TestInputBox(ConnectPort),BCF_TestInputBox(ClientPort),BCF_TestInputBox$(ClientName) )

			Select TMP_JoinGame
				Case True 
					FreeEntity RequestCamera
					BCF_KillWindow(Window)
					Exit
				Case BP_NOREPLY
					Msg=BCF_MsgBox("Information",TMP_Connection_ErrorMsg1$,0)
				Case BP_PORTNOTAVAILABLE
					Msg=BCF_MsgBox("Information",TMP_Connection_ErrorMsg2$,0)
				Case BP_GAMEISFULL
					Msg=BCF_MsgBox("Information",TMP_Connection_ErrorMsg3$,0)
				Case BP_IAMBANNED
					Msg=BCF_MsgBox("Information",TMP_Connection_ErrorMsg4$,0)
				Case BP_USERABORT
					Msg=BCF_MsgBox("Information",TMP_Connection_ErrorMsg5$,0)
				Case BP_INVALIDHOSTIP
					Msg=BCF_MsgBox("Information",TMP_Connection_ErrorMsg6$,0)
			End Select 
		EndIf
		
		; ------------------
		; Si annulation
		; ------------------
		If BCF_TestButton(Cancel)  Then
			FreeEntity RequestCamera
			BCF_KillWindow(Window)
			End 
		EndIf
	
		RenderWorld
		
		BCF_RenderBCF()
		Flip
	Forever
End Function
