;=======================================================================================
; Code : BCF Librairie ScreenSelector Plugin		
; Project Title :
; Author : V2.0 Par Philippe Agnisola	et Nicolas Poursin
; Email :                    
; Version : 1.0
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================

; -------------------------------------------------------------------------------------
; Fonction de creation d'un requester de selection de rsolution
; -------------------------------------------------------------------------------------
Function BCF_SelectScreenRes(GuiStyle=1,Loc=1,Background$="")
	Graphics3D 640,480,16,0
	SetBuffer BackBuffer()

	; -------------------------------
	; Initialisation de la BCF
	; -------------------------------
	BCF_InitBCF(Loc,GuiStyle)
	BCF_Init3DMouse(4)

	HalfWidth=GraphicsWidth()/2
	HalfHeight=GraphicsHeight()/2

	RequestWidth=410
	RequestHeight=300
	RequestCamera=CreateCamera()

	; ---------------------------------------
	; Chargement du background
	; --------------------------------------
	If Background$<>"" Then
		; --------------------------------------------
		; Si on travaille sur les pak, sinon
		; --------------------------------------------
		If FBK_PakInUse=1 Then 
			;TMP_Image=FBK_LoadImage(Background$)
		Else
			TMP_Image=LoadImage(Background$)
		EndIf 

		; --------------------------------------
		; On resize l'image si besoin
		; --------------------------------------
		SizeTest=ImageWidth (TMP_Image)

		If SizeTest<GraphicsWidth () Then 
			ResizeImage TMP_Image,640,480
		EndIf 
	EndIf 
		
	; -----------------------------------------------------------
	; Definition de la position X et Y du requester
	; -----------------------------------------------------------
	Px=HalfWidth-(RequestWidth/2)
	Py=HalfHeight-(RequestHeight/2)

	; -----------------------------------
	; Si la langue est francaise
	; -----------------------------------
	If BCF_Localization=1 Then
		TMP_Request_Title$="Slectionnez la rsolution"
		TMP_Request_Validate$="Valider"
		TMP_Request_Cancel$="Annuler"
		TMP_Request_Alias$="Anti-crnelage ?"
		TMP_Request_Buffer$="WBuffer (ATI) ?"
		TMP_Request_Dither$="Amliorer 16 Bits ?"
		TMP_Request_Window$="Mode fentr ?"
		TMP_Request_Error$="Rsolution non slctionne"
		TMP_Request_Res$="Rsolution de "
		TMP_Request_AlertTitle$="Alerte !"
		TMP_Request_AlertText$="Vous n'avez pas slectionn de rsolution, ou la rsolution n'est pas  disponible !"
	EndIf

	; ----------------------------------
	; Si la langue est anglaise
	; ----------------------------------
	If BCF_Localization=2 Then
		TMP_Request_Title$="Select screen resolution"
		TMP_Request_Validate$="Continue"
		TMP_Request_Cancel$="Cancel"
		TMP_Request_Alias$="Antialias ?"
		TMP_Request_Buffer$="WBuffer (ATI) ?"
		TMP_Request_Dither$="Dither 16 Bits ?"
		TMP_Request_Window$="Windowed mode ?"
		TMP_Request_Error$="Choose a resolution first"
		TMP_Request_Res$="Screen resolution "
		TMP_Request_AlertTitle$="Alert !"
		TMP_Request_AlertText$="You did not choose a resolution, or resolution not available !"
	EndIf
	
	Window=BCF_CreateWindow(Px,Py,RequestWidth,RequestHeight,BCF_GuiStyle,1,TMP_Request_Title$,True,False)
	Valider=BCF_CreateButton(Window,5,250,100,20,TMP_Request_Validate$,BCF_GuiStyle)
	Annuler=BCF_CreateButton(Window,300,250,100,20,TMP_Request_Cancel$,BCF_GuiStyle)

	Alias=BCF_CreateCheckbox(Window,270,10,0,TMP_Request_Alias$)
	Buffer=BCF_CreateCheckbox(Window,270,40,0,TMP_Request_Buffer$)
	Dithers=BCF_CreateCheckbox(Window,270,70,0,TMP_Request_Dither$)
	Windowed=BCF_CreateCheckbox(Window,270,100,0,TMP_Request_Window$)

	SelectRes =  BCF_CreateLabelText(Window,5,220,TMP_Request_Error$,1,1,BCF_GetRed(Bcf_Color03),BCF_GetGreen(Bcf_Color03), BCF_GetBlue(Bcf_Color03))
	
	Res=BCF_CreateListBox(Window,5,10,250,200)

	If GfxMode3DExists (640, 480, 16) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 640/480 16 Bits")
	EndIf

	If GfxMode3DExists (640, 480, 24) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 640/480 24 Bits")
	EndIf

	If GfxMode3DExists (640, 480, 32) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 640/480 32 Bits")
	EndIf 

	If GfxMode3DExists (800, 600, 16) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 800/600 16 Bits")
	EndIf

	If GfxMode3DExists (800, 600, 24) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 800/600 24 Bits")
	EndIf

	If GfxMode3DExists (800, 600, 32) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 800/600 32 Bits")
	EndIf 

	If GfxMode3DExists (1024, 768, 16) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1024/768 16 Bits")
	EndIf

	If GfxMode3DExists (1024, 768, 24) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1024/768 24 Bits")
	EndIf

	If GfxMode3DExists (1024, 768, 32) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1024/768 32 Bits")
	EndIf 

	If GfxMode3DExists (1280, 1024, 16) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1280/1024 16 Bits")
	EndIf

	If GfxMode3DExists (1280, 1024, 24) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1280/1024 24 Bits")
	EndIf

	If GfxMode3DExists (1280, 1024, 32) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1280/1024 32 Bits")
	EndIf
		
	If GfxMode3DExists (1600, 1200, 16) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1600/1200 16 Bits")
	EndIf

	If GfxMode3DExists (1600, 1200, 24) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1600/1200 24 Bits")
	EndIf

	If GfxMode3DExists (1600, 1200, 32) Then
		BCF_AddListBoxItem( Res, TMP_Request_Res$+" 1600/1200 32 Bits")
	EndIf 
	
	; -------------------------
	; Boucle de gestion
 	; -------------------------
	.Start
	Repeat
		; -----------------
		; Si validation
		; -----------------
		If BCF_TestButton(Valider)  Then
			Exit
		EndIf
		
		; ------------------
		; Si annulation
		; ------------------
		If BCF_TestButton(Annuler)  Then
			; -------------------------------
			; Effacer du background
			; -------------------------------
			If TMP_Image<>0 Then 
				FreeImage TMP_Image
			EndIf
	
			BCF_KillBCF()
			End
		EndIf
		
		If BCF_TestCheckbox(Alias) Then
			TmpAlias=1
		Else
			TmpAlias=0
		EndIf
		
		If BCF_TestCheckbox(Buffer) Then
			TmpBuffer=1

		Else
			TmpBuffer=0
		EndIf
		
		If BCF_TestCheckbox(Dithers) Then
			TmpDithers=1
		Else
			TmpDithers=0
		EndIf

		If BCF_TestCheckbox(Windowed) Then
			TmpWindowed=2
		Else
			TmpWindowed=1
		EndIf
		
		; ------------------------------------------------------
		; Gestion de la selection de la rsolution
		; ------------------------------------------------------
		TmpRes$ = BCF_TestListBox$(Res)
		
		; -----
		; 640
		; -----
		If TmpRes$=TMP_Request_Res$+" 640/480 16 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=1
		EndIf
		
		If TmpRes$=TMP_Request_Res$+" 640/480 24 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=2
		EndIf
		
		If TmpRes$=TMP_Request_Res$+" 640/480 32 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=3
		EndIf

		; -----
		; 800
		; -----		
		If TmpRes$=TMP_Request_Res$+" 800/600 16 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=4
		EndIf
			
		If TmpRes$=TMP_Request_Res$+" 800/600 24 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=5
		EndIf
		
		If TmpRes$=TMP_Request_Res$+" 800/600 32 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=6
		EndIf
			
		; -------
		; 1024
		; -------
		If TmpRes$=TMP_Request_Res$+" 1024/768 16 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=7
		EndIf
		
		If TmpRes$=TMP_Request_Res$+" 1024/768 24 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=8
		EndIf
		
		If TmpRes$=TMP_Request_Res$+" 1024/768 32 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=9
		EndIf

		; -------
		; 1280
		; -------
		If TmpRes$=TMP_Request_Res$+" 1280/1024 16 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=10
		EndIf
			
		If TmpRes$=TMP_Request_Res$+" 1280/1024 24 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=11
		EndIf
		
		If TmpRes$=TMP_Request_Res$+" 1280/1024 32 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=12
		EndIf
						
		; -------
		; 1600
		; -------
		If TmpRes$=TMP_Request_Res$+" 1600/1200 16 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=13
		EndIf
		
		If TmpRes$=TMP_Request_Res$+" 1600/1200 24 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=14
		EndIf

		If TmpRes$=TMP_Request_Res$+" 1600/1200 32 Bits" Then
				BCF_ChangeLabelTextLabel(SelectRes,TmpRes$ )
				SelectedRes=15
		EndIf
	
		RenderWorld

		; ----------------------------------
		; Affichage du background
		; ----------------------------------
		If TMP_Image<>0 Then 
			DrawImage TMP_Image,0,0
		EndIf
		
		BCF_RenderBCF()
		Flip
	Forever
	
	; --------------------------------------------------
	; Gestion de la rsolution selectionn
	; --------------------------------------------------
	If SelectedRes=-1 Then
		Rep=BCF_MsgBox(TMP_Request_AlertTitle$,TMP_Request_AlertText$,0)
		SelectedRes=-1
		Goto Start
	Else
		Select SelectedRes
		Case 1
			Graphics3D 640,480,16,TmpWindowed
		Case 2
			Graphics3D 640,480,24,TmpWindowed
		Case 3
			Graphics3D 640,480,32,TmpWindowed
		Case 4
			Graphics3D 800,600,16,TmpWindowed
		Case 5
			Graphics3D 800,600,24,TmpWindowed
		Case 6
			Graphics3D 800,600,32,TmpWindowed
		Case 7
			Graphics3D 1024,768,16,TmpWindowed
		Case 8
			Graphics3D 1024,768,24,TmpWindowed
		Case 9
			Graphics3D 1024,768,32,TmpWindowed
		Case 10
			Graphics3D 1280,1024,16,TmpWindowed
		Case 11
			Graphics3D 1280,1024,24,TmpWindowed
		Case 12
			Graphics3D 1280,1024,32,TmpWindowed
		Case 13
			Graphics3D 1600,1200,16,TmpWindowed
		Case 14
			Graphics3D 1600,1200,24,TmpWindowed
		Case 15
			Graphics3D 1600,1200,32,TmpWindowed
		End Select

		; ------------
		; Antialias
		; ------------
		Select TmpAlias
		Case 0
			AntiAlias False
		Case 1
			AntiAlias True
		End Select

		; -----------
		; WBuffer
		; -----------
		Select TmpBuffer
		Case 0
			WBuffer False
		Case 1
			WBuffer True
		End Select		
		
		; ---------
		; Dither
		; ---------
		Select TmpDithers
		Case 0
			Dither False
		Case 1
			Dither True
		End Select		
	EndIf
	
	; -----------------------------------------------
	; On efface la fenetre et les gadgets
	; -----------------------------------------------
	BCF_KillWindow(Window)

	; -------------------------------------
	; Effacement du background
	; -------------------------------------
	If TMP_Image<>0 Then 
		FreeImage TMP_Image
	EndIf
End Function