;=======================================================================================
; Code : BCF Librairie Ressource (GUI pour Blitz3D)		
; Project Title :
; Author : Philippe Agnisola et Nicolas Poursin (C)opyRight 2003  ! do not distribute !
; Email :                    
; Version : 3.0 Shareware
; Date :              
; Notes : 
;                   
;                   
;=======================================================================================


; -------------------------------------------
; Selection du Scheme de la GUI
; -------------------------------------------
Function BCF_InitScheme(Style)
	BCF_ColorScheme=Style
	
	Select Style
	Case 1 ; Style Bleu
		Bcf_Color00=BCF_CreateColor( 0,0,0 )		 		; Couleur noir
		Bcf_Color01=BCF_CreateColor(42,79,156 ) 			; Fond normal des gadgets
		Bcf_Color02=BCF_CreateColor(8,110,170) 			; Fond enfonce des gadgets
		Bcf_Color03=BCF_CreateColor( 255,255,255) 		; Couleur des textes
		Bcf_Color04=BCF_CreateColor( 80,170,200)		; Couleur libre pour effets
		Bcf_Color05=BCF_CreateColor( 120,181,234) 		; Couleur brillante des highlights
		Bcf_Color06=BCF_CreateColor( 20,50,100) 			; Couleur sombre des highlights
		Bcf_Color07=BCF_CreateColor( 152,162,183) 		; Couleur barre de titres
		Bcf_Color08=BCF_CreateColor( 255,255,255) 		; Couleur des textes des barres de titre
		Bcf_Color09=BCF_CreateColor(3,96,156) 			; Couleur du body des fentres
	Case 2 ; Style Gris clair
		Bcf_Color00=BCF_CreateColor( 0,0,0 )		 		; Couleur noir
		Bcf_Color01=BCF_CreateColor(188,194,212 ) 		; Fond normal des gadgets
		Bcf_Color02=BCF_CreateColor(143,148,168) 		; Fond enfonce des gadgets
		Bcf_Color03=BCF_CreateColor( 50,50,50) 			; Couleur des textes
		Bcf_Color04=BCF_CreateColor( 139,102,27)		; Couleur libre pour effets
		Bcf_Color05=BCF_CreateColor( 250,250,250) 		; Couleur brillante des highlights
		Bcf_Color06=BCF_CreateColor( 100,110,120) 		; Couleur sombre des highlights
		Bcf_Color07=BCF_CreateColor( 152,162,183) 		; Couleur barre de titres
		Bcf_Color08=BCF_CreateColor( 50,50,50) 			; Couleur des textes des barres de titre
		Bcf_Color09=BCF_CreateColor(158,164,182) 		; Couleur du body des fentres
	Case 3 ; Style Gris Fonce
		Bcf_Color00=BCF_CreateColor( 0,0,0 )		 		; Couleur noir
		Bcf_Color01=BCF_CreateColor(75,89,104 ) 			; Fond normal des gadgets
		Bcf_Color02=BCF_CreateColor(45,55,65) 			; Fond enfonce des gadgets
		Bcf_Color03=BCF_CreateColor( 255,255,255) 		; Couleur des textes
		Bcf_Color04=BCF_CreateColor( 139,102,27) 		; Couleur libre pour effets
		Bcf_Color05=BCF_CreateColor( 152,163,170) 		; Couleur brillante des highlights
		Bcf_Color06=BCF_CreateColor( 40,60,60) 			; Couleur sombre des highlights
		Bcf_Color07=BCF_CreateColor( 152,162,183) 		; Couleur barre de titres
		Bcf_Color08=BCF_CreateColor( 255,255,255) 		; Couleur des textes des barres de titre
		Bcf_Color09=BCF_CreateColor(74,87,102) 			; Couleur du body des fentres
	Default
		Bcf_Color00=BCF_CreateColor( 0,0,0 )		 		; Couleur noir
		Bcf_Color01=BCF_CreateColor(42,79,156 ) 			; Fond normal des gadgets
		Bcf_Color02=BCF_CreateColor(8,110,170) 			; Fond enfonce des gadgets
		Bcf_Color03=BCF_CreateColor( 255,255,255) 		; Couleur des textes
		Bcf_Color04=BCF_CreateColor( 0,0,0) 				; Couleur des textes sombres
		Bcf_Color05=BCF_CreateColor( 120,181,234) 		; Couleur brillante des highlights
		Bcf_Color06=BCF_CreateColor( 20,50,100) 			; Couleur sombre des highlights
		Bcf_Color07=BCF_CreateColor( 152,162,183) 		; Couleur barre de titres
		Bcf_Color08=BCF_CreateColor( 255,255,255) 		; Couleur des textes des barres de titre
		Bcf_Color09=BCF_CreateColor(3,96,156) 			; Couleur du body des fentres
	End Select

	BCF_RegenerateBCF()
End Function

; ---------------------------------------------------------------------------------
; Fonction pour lire des bitmaps sous la forme de datas raw
; ---------------------------------------------------------------------------------
Function BCF_ReadRawImage(ImageType)
	Select ImageType
	Case 0
		Return CreateImage(1,1)
	Case 1
		Restore BCF_MousePointer01
	Case 2
		Restore BCF_MousePointer02
	Case 3
		Restore BCF_MousePointer03
	Case 4
		Restore BCF_MousePointer04
	Case 5
		Restore BCF_MousePointer05
	Case 6
		Restore BCF_MousePointer06
	Case 7
		Restore BCF_MousePointer07
	Case 10
		Restore BCF_ButtonBackgroundOn_Style01
	Case 11
		Restore BCF_ButtonBackgroundOff_Style01
	Case 12
		Restore BCF_ButtonBackgroundOn_Style02
	Case 13
		Restore BCF_ButtonBackgroundOff_Style02
	Case 14
		Restore BCF_ButtonBackgroundOn_Style03
	Case 15
		Restore BCF_ButtonBackgroundOff_Style03
	Case 22
		Restore BCF_CheckBoxOn_Style01
	Case 23
		Restore BCF_CheckBoxOff_Style01
	Case 24
		Restore BCF_CheckBoxOn_Style02
	Case 25
		Restore BCF_CheckBoxOff_Style02
	Case 26
		Restore BCF_CheckBoxOn_Style03
	Case 27
		Restore BCF_CheckBoxOff_Style03
	Case 50
		Restore BCF_WindowIcon01
	Case 51
		Restore BCF_WindowIcon02
	Case 52
		Restore BCF_WindowIcon03
	Case 53
		Restore BCF_WindowIcon04
	Case 54
		Restore BCF_WindowIcon05
	Case 55
		Restore BCF_WindowIcon06
	Case 100
		Restore BCF_ReduceGadgetOn_Style01
	Case 101
		Restore BCF_ReduceGadgetOff_Style01
	Case 102
		Restore BCF_ReduceGadgetOn_Style02
	Case 103
		Restore BCF_ReduceGadgetOff_Style02
	Case 104
		Restore BCF_ReduceGadgetOn_Style03
	Case 105
		Restore BCF_ReduceGadgetOff_Style03
	Case 200
		Restore BCF_CloseGadgetOn_Style01
	Case 201
		Restore BCF_CloseGadgetOff_Style01
	Case 202
		Restore BCF_CloseGadgetOn_Style02
	Case 203
		Restore BCF_CloseGadgetOff_Style02
	Case 204
		Restore BCF_CloseGadgetOn_Style03
	Case 205
		Restore BCF_CloseGadgetOff_Style03
	Case 300
		Restore BCF_ArrowDownOn_Style01
	Case 301
		Restore BCF_ArrowDownOff_Style01
	Case 302
		Restore BCF_ArrowDownOn_Style02
	Case 303
		Restore BCF_ArrowDownOff_Style02
	Case 304
		Restore BCF_ArrowDownOn_Style03
	Case 305
		Restore BCF_ArrowDownOff_Style03
	Case 400
		Restore BCF_ArrowUpOn_Style01
	Case 401
		Restore BCF_ArrowUpOff_Style01
	Case 402
		Restore BCF_ArrowUpOn_Style02
	Case 403
		Restore BCF_ArrowUpOff_Style02
	Case 404
		Restore BCF_ArrowUpOn_Style03
	Case 405
		Restore BCF_ArrowUpOff_Style03
	Case 500
		Restore BCF_ArrowRightOn
	Case 501
		Restore BCF_ArrowRightOff
	Case 600
		Restore BCF_ArrowLeftOn
	Case 601
		Restore BCF_ArrowLeftOff
	Case 700
		Restore BCF_IconFolder
	Case 701
		Restore BCF_IconFile
	Case 702
		Restore BCF_IconPicture
	Case 703
		Restore BCF_IconHtm
	Case 704
		Restore BCF_IconSystem
	Case 705
		Restore BCF_IconText
	Case 706
		Restore BCF_IconVideo
	Case 707
		Restore BCF_IconAudio
	Case 708
		Restore BCF_IconZip
	Case 709
		Restore BCF_IconExe
	Case 800
		Restore BFF_SliderBackground_Style01
	Case 801
		Restore BFF_SliderBackground_Style02
	Case 802
		Restore BFF_SliderBackground_Style03
	Case 1000
		Restore BCF_SubMenuMark
	Case 2000
		Restore BCF_WindowTitleSelected_Style01
	Case 2001
		Restore BCF_WindowTitleUnselected_Style01
	Case 2002
		Restore BCF_WindowTitleSelected_Style02
	Case 2003
		Restore BCF_WindowTitleUnselected_Style02
	Case 2004
		Restore BCF_WindowTitleSelected_Style03
	Case 2005
		Restore BCF_WindowTitleUnselected_Style03
	Case 5000
		Restore BCF_MessageBoxIcon01
	Case 5001
		Restore BCF_MessageBoxIcon02
	Case 5002
		Restore BCF_MessageBoxIcon03
	Case 6000
		Restore BCF_FileRequesterIconHD
	Case 6001
		Restore BCF_FileRequesterIconCD
	Case 6002
		Restore BCF_FileRequesterIconRE
	Case 6003
		Restore BCF_FileRequesterIconNONE
	End Select

	; -------------------------------
	; Lecture des datas raW
	; -------------------------------
	Read imgW%
	Read imgH%
	img=CreateImage(imgW,imgH)

	SetBuffer ImageBuffer(img)
	LockBuffer ImageBuffer(img)

	For X=0 To imgW-1
		For Y=0 To imgH-1
			Read rgb%
			WritePixelFast X,Y,rgb%
		Next
	Next

	UnlockBuffer ImageBuffer(img)
	SetBuffer BackBuffer()

	Return img
End Function

; -----------------------------------------------
; Datas Raw des images de la BCF
; -----------------------------------------------
.BCF_WindowTitleSelected_Style01
Data 80
Data 21
Data $8AB0CA, $7AA7C6, $72A5C5, $6AA3C5, $62A1C5, $5C9EC5, $549DC6, $4C9AC7
Data $479AC9, $3E97CA, $1184C5, $1087C8, $148BCC, $1890D0, $1C96D5, $1F9AD9
Data $229DDC, $24A1DF, $26A4E2, $27A6E5, $36AFEA, $8AAFCA, $7AA7C6, $72A4C6
Data $6AA3C5, $62A0C4, $5C9EC6, $549CC6, $4C9AC7, $4799C9, $3D97CA, $1185C5
Data $1187C8, $158BCC, $1991D0, $1D96D5, $209ADA, $239EDD, $26A1E1, $29A5E4
Data $2AA9E8, $37B1EA, $8AAFCA, $7AA6C6, $72A3C5, $69A1C5, $62A0C4, $5C9EC5
Data $549BC6, $4C9AC8, $4799C9, $3E97C9, $1185C5, $1287C9, $168CCD, $1991D1
Data $1F97D6, $219BDA, $249FDE, $26A3E2, $29A7E6, $2BAAE9, $39B3EA, $8AAECB
Data $7AA5C5, $72A3C5, $6AA0C5, $629FC5, $5C9EC5, $549CC6, $4C9AC7, $4799C9
Data $3E97CA, $1284C5, $1187C8, $168CCC, $1A91D1, $1F97D7, $219BDB, $25A0DF
Data $28A5E3, $2AA8E7, $2DACE9, $3CB6EA, $8AADCB, $7AA5C5, $72A1C5, $6A9FC4
Data $629EC4, $5C9DC5, $539BC5, $4B99C7, $4799C9, $3E97C9, $1284C4, $1287C8
Data $168CCC, $1A91D1, $1F97D7, $239BDA, $26A0DF, $29A5E4, $2CA8E8, $2FAEE9
Data $3EB7EA, $8AADCA, $7AA4C5, $72A1C5, $6A9FC4, $629DC4, $5C9DC4, $549CC6
Data $4C99C7, $4799C9, $3E97C9, $1284C4, $1286C7, $168CCB, $1B91D1, $2097D7
Data $249BDB, $27A0E0, $2AA6E4, $2DABE8, $30AFE9, $3FB8EA, $8AACCA, $7AA4C5
Data $72A0C5, $6A9EC3, $629DC3, $5C9CC5, $549BC6, $4C99C7, $4798C7, $3F97C9
Data $1284C4, $1286C8, $158BCC, $1B90D1, $2197D6, $249CDB, $27A0DF, $2BA5E5
Data $2EABE9, $31AFE9, $41B9EA, $89ACCA, $7AA3C5, $729FC4, $6A9DC4, $629CC3
Data $5C9BC4, $549BC5, $4C98C6, $4798C8, $3E96C9, $1383C4, $1286C7, $178BCC
Data $1B91D1, $2097D6, $259BDA, $28A0DF, $2CA6E4, $2FABE9, $33AFE9, $42BBEA
Data $89ABCA, $7AA2C5, $719FC4, $699DC3, $619BC3, $5C9AC4, $549AC6, $4C99C6
Data $4798C7, $3F95C8, $1283C3, $1286C6, $178ACA, $1B8FD0, $2197D5, $259BDA
Data $2AA1DF, $2DA6E4, $2FABE9, $34B1E9, $43BBEA, $89ABC9, $7AA2C4, $719EC3
Data $699CC3, $619AC3, $5B9AC3, $549AC5, $4C98C6, $4798C7, $3F95C8, $1382C3
Data $1285C6, $178AC9, $1C90CF, $2196D6, $249BD9, $29A1DF, $2CA6E4, $31ABE9
Data $34B2E9, $44BCEA, $89ABC8, $7AA1C4, $719EC3, $699BC2, $6199C2, $5B99C3
Data $5399C4, $4C99C5, $4798C7, $3F95C7, $1283C1, $1384C4, $1889C9, $1B8FCE
Data $2296D4, $269AD8, $29A0DF, $2DA7E5, $32ACE9, $36B3E9, $45BDEA, $89AAC8
Data $7AA1C4, $719EC3, $699BC2, $6199C2, $5B98C3, $5498C4, $4C98C5, $4798C7
Data $3F95C7, $1282C1, $1384C4, $178AC8, $1C8ECD, $2196D4, $269BD9, $29A0DE
Data $2EA7E4, $32ACE9, $35B2E9, $45BEEA, $89AAC8, $79A0C4, $719DC3, $699AC2
Data $6198C1, $5B97C2, $5497C4, $4B97C5, $4797C6, $3E94C6, $1281C1, $1284C3
Data $1789C7, $1D8ECD, $2195D4, $2699D9, $2AA0DE, $2FA6E5, $32ADE9, $36B3E9
Data $47BFEA, $89A9C9, $79A0C3, $719DC2, $699AC2, $6198C1, $5B97C2, $5397C3
Data $4B97C4, $4797C6, $3F94C6, $1280C0, $1283C3, $1788C6, $1C8ECC, $2195D3
Data $2599D8, $2AA0DD, $2EA6E4, $33ACE8, $37B4E9, $47BFEA, $89A9C8, $79A0C3
Data $719CC2, $6999C1, $6197C1, $5A96C1, $5396C2, $4B96C4, $4797C5, $3E94C5
Data $1280BF, $1282C2, $1687C6, $1B8DCB, $2195D2, $269AD8, $2A9FDD, $2EA6E3
Data $33ADE9, $38B3E9, $47BFEA, $89A9C8, $799FC3, $719BC1, $6999C1, $6197C1
Data $5A96C1, $5396C2, $4B96C4, $4796C5, $3E93C5, $127FBF, $1281C1, $1686C6
Data $1B8DCB, $2193D1, $2599D6, $299FDD, $2FA6E3, $33ACE9, $38B3E9, $47C0EA
Data $89A8C7, $799FC3, $719BC2, $6998C1, $6197C1, $5A96C1, $5395C2, $4B94C3
Data $4796C4, $3E93C5, $127FBD, $1182C0, $1686C5, $1B8CCA, $2193D0, $2598D6
Data $299EDC, $2FA5E2, $33ACE9, $37B3E9, $47C0EA, $89A8C8, $799FC3, $719BC1
Data $6999C1, $6196C0, $5A95C0, $5394C1, $4B95C3, $4795C4, $3E92C4, $127EBC
Data $1281C0, $1786C4, $1B8BC9, $2092CF, $2698D6, $2A9FDC, $2EA5E3, $33ACE9
Data $37B2E9, $48BFEA, $89A8C8, $799FC2, $719BC1, $6899C0, $6196C0, $5A95C0
Data $5394C1, $4B94C2, $4795C4, $3E93C4, $127EBC, $1281BF, $1685C3, $1A8BC8
Data $2092CF, $2598D5, $2A9EDC, $2FA4E2, $33ACE8, $37B3E9, $48BFEA, $89A8C8
Data $799FC2, $719BC1, $6998C0, $6195C0, $5A95C0, $5394C0, $4B94C2, $4794C3
Data $3D92C3, $117EBB, $1180BE, $1685C3, $1B8AC8, $1F92CE, $2497D5, $2A9EDC
Data $2FA5E2, $34ADE8, $38B3E9, $48C0EA, $89A8C8, $799FC2, $719BC1, $6898C0
Data $6195C0, $5A95C0, $5294C1, $4A94C1, $4694C3, $3E92C4, $117EBC, $1280BE
Data $1584C2, $1A8AC8, $2092CE, $2598D4, $2A9DDB, $2FA5E2, $34ADE9, $37B3E9
Data $48C0EA, $89A8C7, $799FC2, $719BC1, $6898C0, $6095C0, $5A94C0, $5294C0
Data $4A93C1, $4694C3, $3E92C3, $117EBB, $1180BE, $1684C2, $1A89C7, $2090CD
Data $2598D4, $2A9EDC, $2FA4E2, $34ACE9, $38B3E9, $48C0EA, $89A8C7, $799EC2
Data $719BC1, $6998C0, $6195C0, $5A94C0, $5394C0, $4A93C1, $4694C3, $3E92C3
Data $117EBC, $117FBE, $1684C2, $1A8AC7, $2091CE, $2598D5, $2A9EDC, $2EA5E3
Data $34ACE9, $38B3E9, $48C0EA, $89A8C8, $799FC2, $719BC1, $6898C0, $6195BF
Data $5A94C0, $5293C0, $4A93C1, $4693C3, $3E92C3, $127DBB, $117FBD, $1584C1
Data $1A89C7, $2091CE, $2597D4, $299EDB, $2FA5E2, $33ACE9, $38B3E9, $48C1EA
Data $89A8C7, $799FC2, $719BC1, $6898C0, $6195C0, $5A95C0, $5293C0, $4A93C2
Data $4693C2, $3E91C3, $117DBC, $127FBE, $1684C1, $1B89C7, $2091CF, $2597D4
Data $299EDB, $2FA5E2, $34ACE9, $38B4E9, $48C1EA, $89A8C7, $799FC2, $719BC1
Data $6898C0, $6095C0, $5A94C0, $5294C0, $4A93C2, $4693C2, $3E91C3, $117DBC
Data $127FBD, $1584C1, $1A89C7, $2191CF, $2598D5, $2A9EDB, $2FA4E2, $34ADE9
Data $38B4E9, $48C1EA, $89A8C7, $799FC2, $719BC1, $6898C0, $6095BF, $5A95C0
Data $5294C0, $4A92C1, $4693C3, $3E91C3, $127DBC, $117FBD, $1584C1, $1B89C6
Data $2091CE, $2597D5, $2A9EDB, $2FA5E3, $33ACE9, $38B5E9, $48C2EA, $89A8C7
Data $799EC2, $719BC1, $6998C0, $6195BF, $5A94C0, $5293C0, $4A93C2, $4693C3
Data $3D91C3, $117DBB, $117EBD, $1683C1, $1A8AC6, $2090CD, $2597D5, $2A9FDC
Data $2FA5E4, $34ADE9, $38B5E9, $47C2EA, $89A7C7, $799EC2, $719BC1, $6898C0
Data $6095C0, $5A94C0, $5293C0, $4A93C1, $4793C3, $3D91C3, $117DBB, $117FBD
Data $1683C0, $1B89C6, $2091CE, $2597D5, $2A9FDC, $2FA6E4, $34AEE9, $38B6E9
Data $47C2EA, $89A7C7, $799EC2, $719BC1, $6897C0, $6195C0, $5A94C0, $5293C0
Data $4A92C1, $4693C2, $3D91C3, $117DBB, $107FBD, $1683C0, $1B89C7, $2091CE
Data $2597D5, $2A9FDC, $2FA6E3, $34AEE9, $38B6E9, $48C3EA, $89A7C7, $799EC2
Data $719BC1, $6998C0, $6195C0, $5A94C0, $5393C0, $4A92C2, $4693C2, $3D91C3
Data $117DBB, $117FBC, $1683C0, $1A89C7, $2091CE, $2598D6, $2A9FDD, $2FA6E4
Data $34AEE9, $38B6E9, $48C3EA, $89A7C7, $799EC2, $719BC1, $6898C0, $6195C0
Data $5A95C0, $5294C0, $4A92C2, $4693C2, $3D91C3, $117CBA, $117FBD, $1683C0
Data $1B89C7, $2092CE, $2598D4, $2A9FDD, $2FA7E5, $33AFE9, $39B6E9, $49C4EA
Data $89A7C7, $799EC2, $719BC1, $6898C0, $6095C0, $5A94C0, $5293C0, $4A92C2
Data $4693C2, $3D91C2, $117DBA, $117FBD, $1684C1, $1A8AC6, $2091CE, $2598D5
Data $2A9FDD, $2FA6E5, $34AEE9, $39B6E9, $49C4EA, $89A8C7, $799EC2, $719BC1
Data $6998C0, $6195BF, $5A94C0, $5393C0, $4A93C1, $4793C2, $3E91C3, $117DBA
Data $117FBD, $1684C1, $1A89C7, $2092CF, $2599D6, $2AA0DD, $2FA7E5, $34AFE9
Data $39B7E9, $49C4EA, $89A7C7, $799EC2, $719BC1, $6898C0, $6095C0, $5A95C0
Data $5294C0, $4A93C2, $4693C3, $3D91C3, $117DBA, $117FBE, $1583C1, $1A8AC7
Data $2092CE, $2599D6, $2AA0DE, $2FA7E6, $34B0E9, $38B8E9, $48C5EA, $89A7C7
Data $799EC2, $719BC1, $6898C0, $6095C0, $5A94C0, $5293C0, $4A92C1, $4692C3
Data $3D91C3, $117DBA, $117FBD, $1683C1, $1A8AC7, $2092CF, $2698D7, $2AA0DE
Data $30A8E6, $35B0E9, $38B8E9, $48C5EA, $89A8C7, $799EC2, $719BC1, $6898C0
Data $6196C0, $5A94C0, $5294C0, $4A93C1, $4692C2, $3D91C3, $127DBB, $1180BD
Data $1684C1, $1B8AC7, $2192CF, $259AD7, $2AA1DE, $30A7E6, $35B0E9, $39B8E9
Data $49C5EA, $89A8C7, $799EC2, $719BC1, $6898C0, $6195C0, $5A94C0, $5394C0
Data $4A93C1, $4693C2, $3D91C3, $117DBB, $117FBE, $1684C1, $1A8AC8, $2192CF
Data $2699D7, $2BA1DF, $30A8E7, $35B1E9, $39B9E9, $49C6EA, $89A8C7, $799EC2
Data $719BC1, $6998C0, $6195C0, $5A94C0, $5293C0, $4A92C1, $4693C3, $3E91C3
Data $117EBB, $117FBD, $1684C1, $1A8AC8, $2192D0, $2599D7, $2BA1DF, $30A9E8
Data $34B1E9, $38B9E9, $48C6EA, $89A8C7, $799EC2, $719BC1, $6998C0, $6195BF
Data $5994C0, $5294C0, $4A93C1, $4693C3, $3D91C3, $127DBB, $117FBD, $1584C2
Data $1B8AC8, $2192CF, $269AD8, $2BA1E0, $30A9E8, $34B2E9, $39BAE9, $49C7EA
Data $89A8C7, $799EC2, $719BC1, $6898C0, $6195C0, $5A95C0, $5294C0, $4A92C1
Data $4693C2, $3D91C3, $117DBB, $127FBD, $1584C2, $1B8AC8, $2192CF, $269AD8
Data $2BA2E0, $31A9E8, $35B2E9, $39BAE9, $49C7EA, $89A8C7, $799EC2, $719BC1
Data $6998C0, $6195C0, $5A94C0, $5293C0, $4A92C1, $4692C3, $3D91C3, $117DBB
Data $1180BD, $1684C2, $1B8BC8, $2192CF, $269AD7, $2BA2E0, $31AAE8, $35B3E9
Data $3ABAE9, $49C7EA, $89A8C7, $799EC2, $719BC1, $6898C0, $6195C0, $5A94C0
Data $5293C0, $4A92C1, $4692C3, $3D91C3, $117DBB, $117FBD, $1584C2, $1B8AC8
Data $2192D0, $269AD9, $2BA2E0, $30AAE8, $36B3E9, $39BBE9, $49C7EA, $89A8C7
Data $799EC2, $719BC1, $6897C0, $6095C0, $5A94C0, $5294C0, $4A93C1, $4693C2
Data $3D91C3, $117DBB, $117FBE, $1684C2, $1B8AC8, $2193D1, $269BD9, $2BA2E1
Data $30AAE8, $35B3E9, $3ABBE9, $49C7EA, $89A8C7, $799EC2, $719BC1, $6898C0
Data $6095C0, $5A94C0, $5293C0, $4A92C1, $4693C3, $3D91C3, $117DBB, $117FBD
Data $1684C1, $1B8BC8, $2193D1, $279BD9, $2BA3E1, $30AAE8, $35B2E9, $39BBE9
Data $49C7EA, $89A8C7, $799EC2, $719BC1, $6898C0, $6195C0, $5A94C0, $5293C0
Data $4A92C1, $4693C3, $3D91C3, $117DBB, $117FBD, $1684C2, $1B8AC8, $2193D1
Data $269BD9, $2BA3E1, $31ABE8, $35B3E9, $3ABBE9, $49C8EA, $89A8C7, $799EC2
Data $719BC1, $6898C0, $6095C0, $5A94C0, $5293C0, $4A92C1, $4693C2, $3E91C3
Data $117DBC, $117FBE, $1684C2, $1B8BC8, $2193D0, $269BD8, $2CA3E1, $31AAE9
Data $35B3E9, $39BBE9, $48C7EA, $89A8C7, $799EC2, $719BC1, $6898C0, $6095C0
Data $5A94C0, $5394C0, $4B93C1, $4793C2, $3D91C3, $117DBC, $1180BE, $1684C2
Data $1A8AC8, $2094D0, $269BD8, $2CA2E1, $31ABE8, $35B3E9, $39BAE9, $49C8EA
Data $89A8C7, $799EC2, $719AC1, $6898C0, $6095C0, $5A94C0, $5293C0, $4A92C1
Data $4693C2, $3D91C3, $117DBC, $117FBD, $1684C2, $1B8AC9, $2193D1, $269AD9
Data $2CA3E2, $31ACE8, $35B4E9, $3ABBE9, $49C8EA, $89A8C7, $799EC2, $719AC1
Data $6898C0, $6095C0, $5A94C0, $5294C0, $4A93C1, $4693C2, $3D91C3, $117DBB
Data $117FBD, $1584C2, $1A8BC8, $2193D1, $269BDA, $2BA3E2, $30ABE8, $35B3E9
Data $3ABCE9, $4AC8EA, $89A8C7, $799EC2, $719AC1, $6897C0, $6195C0, $5A94C0
Data $5393C0, $4A92C1, $4693C3, $3D91C3, $117EBC, $117FBD, $1685C2, $1B8BC9
Data $2194D2, $269CDA, $2CA3E2, $31ACE8, $35B4E9, $3ABCE9, $49C8EA, $89A8C7
Data $799EC2, $719AC1, $6897C0, $6195C0, $5A94C0, $5294C0, $4A93C1, $4693C3
Data $3D91C3, $117DBB, $1180BD, $1685C3, $1B8BC9, $2194D1, $279CDA, $2CA3E2
Data $30ACE8, $36B4E9, $39BCE9, $49C8EA, $89A8C7, $799EC2, $719AC1, $6997C0
Data $6195C0, $5A94C0, $5393C0, $4A93C1, $4693C2, $3D91C3, $117EBC, $1180BE
Data $1685C3, $1A8BC9, $2194D2, $269CDA, $2BA3E2, $30ACE9, $36B4E9, $3ABCE9
Data $49C9EA, $89A8C7, $799EC2, $719AC1, $6897C0, $6195C0, $5A94C0, $5393C0
Data $4A92C1, $4693C3, $3D91C3, $117DBB, $1180BE, $1685C3, $1B8BC9, $2194D2
Data $269CDA, $2CA4E2, $30ACE9, $36B3E9, $3ABDE9, $49C9EA, $89A8C7, $799EC2
Data $719AC1, $6997C0, $6195C0, $5A94C0, $5293C0, $4A92C1, $4693C3, $3D91C3
Data $117DBB, $1180BE, $1585C3, $1B8BC9, $2194D2, $279CDB, $2CA4E3, $30ADE9
Data $36B4E9, $3ABDE9, $49C9EA, $89A8C7, $799EC2, $719AC1, $6997C0, $6195C0
Data $5A94C0, $5293C0, $4B92C1, $4693C2, $3D91C3, $117DBB, $1180BD, $1585C3
Data $1B8BCA, $2295D2, $279CDA, $2CA4E3, $31ACE9, $36B4E9, $3ABEE9, $49C9EA
Data $89A8C7, $799EC2, $719BC1, $6897C0, $6095C0, $5A94C0, $5394C0, $4A93C1
Data $4693C2, $3E91C3, $117DBC, $1280BF, $1685C3, $1B8BC9, $2195D2, $279CDB
Data $2BA4E3, $30ADE9, $36B4E9, $3ABDE9, $49C9EA, $89A8C7, $799EC2, $719BC1
Data $6898C0, $6195C0, $5A94C0, $5293C0, $4A93C2, $4693C2, $3E92C3, $127DBB
Data $1280BE, $1685C3, $1B8CCA, $2295D3, $279CDC, $2CA5E4, $31ACE9, $37B4E9
Data $3ABEE9, $49CAEA, $89A8C7, $799EC2, $719BC1, $6898C0, $6095C0, $5A94C0
Data $5293C0, $4A93C2, $4694C3, $3E92C3, $117EBC, $1180BE, $1686C4, $1B8CCA
Data $2195D3, $279CDC, $2CA4E4, $31ADE9, $36B5E9, $3BBEE9, $49CAEA, $89A8C8
Data $799EC2, $719BC1, $6898C0, $6095C0, $5A95C0, $5293C0, $4A93C2, $4693C2
Data $3E92C3, $117EBC, $1180BE, $1685C3, $1B8CCA, $2296D4, $279DDC, $2CA4E4
Data $31ADE9, $36B5E9, $3BBEE9, $49CAEA, $89A8C8, $799FC2, $719BC1, $6898C0
Data $6095C0, $5A94C0, $5293C0, $4A93C1, $4694C3, $3E92C3, $117EBB, $1180BF
Data $1685C4, $1B8CCA, $2295D4, $279DDD, $2CA5E5, $31AEE9, $36B5E9, $3ABEE9
Data $4ACAEA, $89A8C8, $799FC2, $719BC1, $6898C0, $6095C0, $5A94C0, $5394C0
Data $4B93C1, $4694C3, $3E92C3, $117EBC, $1181BF, $1686C4, $1C8DCB, $2195D3
Data $279DDC, $2DA5E6, $32AEE9, $37B5E9, $3BBFE9, $49CAEA, $89A8C8, $799FC2
Data $719BC1, $6998C0, $6196C0, $5A95C0, $5394C1, $4A93C2, $4795C3, $3D93C3
Data $117FBD, $1281C0, $1686C4, $1C8CCB, $2296D5, $279DDC, $2CA5E5, $31AEE9
Data $36B6E9, $3BBFE9, $4ACAEA, $89A8C7, $799FC3, $719BC2, $6899C1, $6196C0
Data $5A95C0, $5395C1, $4B94C2, $4794C3, $3E92C4, $117FBC, $1281C0, $1686C6
Data $1B8DCC, $2296D4, $279EDE, $2DA6E6, $31AEE9, $35B6E9, $3ABEE9, $4ACAEA
Data $89A9C8, $799FC3, $719BC2, $6899C1, $6197C1, $5A96C1, $5394C1, $4B94C3
Data $4796C4, $3E93C4, $127FBE, $1182C1, $1786C5, $1B8DCC, $2296D6, $289FDE
Data $2DA6E6, $31AEE9, $36B6E9, $3BBFE9, $4ACAEA, $89A9C8, $799FC3, $719CC2
Data $6999C1, $6197C1, $5A96C1, $5395C2, $4B95C3, $4795C4, $3E93C4, $127FBD
Data $1182C1, $1787C6, $1C8ECC, $2297D6, $279EDE, $2DA7E6, $32AEE9, $36B6E9
Data $3ABEE9, $49CAEA, $89A9C8, $79A0C3, $719CC2, $699AC1, $6197C1, $5B96C1
Data $5395C2, $4B95C4, $4796C5, $3F93C5, $127FBF, $1181C2, $1687C7, $1C8FCD
Data $2398D7, $28A0DF, $2DA7E7, $32AFE9, $36B7E9, $3AC0E9, $49CAEA, $89AAC8
Data $79A0C4, $719DC3, $699AC2, $6198C1, $5B97C1, $5396C3, $4B96C3, $4796C5
Data $3E93C5, $1280BF, $1283C3, $1688C6, $1C8FCE, $2398D8, $289FDF, $2CA8E8
Data $31AFE9, $36B7E9, $3ABFE9, $49C9EA, $89AAC8, $7AA1C4, $719DC3, $699BC2
Data $6198C2, $5B98C2, $5397C3, $4C97C5, $4797C5, $3F93C6, $1281C0, $1284C4
Data $1788C8, $1C90CF, $2398D9, $279FE0, $2CA8E8, $31AFE9, $36B7E9, $39BFE9
Data $48CAEA, $89AAC8, $7AA1C4, $719DC3, $699BC2, $6199C2, $5B98C2, $5497C3
Data $4B97C4, $4797C5, $3F95C6, $1280C0, $1283C2, $1789C7, $1C90CF, $2298D9
Data $27A0E0, $2DA7E7, $31AFE9, $35B7E9, $3ABEE9, $48C9EA, $89ABC9, $79A2C4
Data $719EC3, $699CC3, $619AC3, $5B99C3, $5499C3, $4B98C4, $4797C6, $3E94C6
Data $1281C0, $1384C4, $1688C9, $1B90D0, $2299D8, $28A1E1, $2CA8E9, $31AFE9
Data $36B7E9, $39BEE9, $48C8EA, $89ABC9, $7AA2C5, $719EC3, $699CC3, $619AC3
Data $5C99C3, $5499C5, $4C98C6, $4797C6, $3F95C7, $1281C1, $1284C5, $178AC9
Data $1C91CF, $2399D9, $279FE0, $2CA7E7, $30AFE9, $34B6E9, $37BEE9, $46C7EA
Data $89ACCA, $7AA3C5, $729FC4, $699DC3, $619BC3, $5C9AC4, $549AC4, $4C98C5
Data $4798C7, $3E95C6, $1282C0, $1285C5, $1789C9, $1B90D1, $2299D8, $27A0E0
Data $2CA8E8, $2FAEE9, $33B5E9, $37BDE9, $45C6EA, $89ACCA, $7AA3C5, $71A0C4
Data $6A9DC3, $629CC3, $5B9CC4, $549AC5, $4C99C5, $4798C7, $3E95C6, $1281C0
Data $1385C5, $1789CA, $1B90D0, $2299D8, $27A0E0, $2BA7E8, $2EADE9, $32B4E9
Data $36BAE9, $45C5EA, $8AADCA, $7AA4C5, $71A2C4, $699EC4, $629DC4, $5C9DC4
Data $549AC5, $4C98C6, $4798C6, $3E95C6, $1282C1, $1184C5, $168ACA, $1B90D0
Data $2199D8, $269FDF, $2AA5E8, $2EADE9, $32B4E9, $34BAE9, $43C4EA, $8AADCA
Data $7AA5C5, $72A1C5, $6A9FC4, $629EC4, $5C9DC4, $539BC5, $4C98C6, $4798C7
Data $3E95C7, $1182C1, $1185C4, $168ACA, $1B90D1, $2198D8, $25A0E0, $29A6E6
Data $2DACE9, $30B4E9, $33B9E9, $42C2EA, $8AAECB, $7AA6C5, $72A2C5, $6AA0C5
Data $629FC4, $5C9EC4, $549BC5, $4C98C6, $4798C8, $3D95C8, $1182C1, $1185C5
Data $168ACA, $1B90D0, $2098D8, $249EDE, $28A6E5, $2DABE9, $2FB1E9, $32B7E9
Data $41C1EA, $8AAFCA, $7AA6C6, $72A3C5, $6AA1C4, $62A0C4, $5C9EC4, $539CC5
Data $4B99C6, $4798C7, $3E96C7, $1083C0, $1085C5, $158ACA, $1A90CF, $1F97D7
Data $239EDE, $27A3E4, $2BAAE9, $2EB1E9, $31B6E9, $3FBEEA, $8AAFCA, $7AA7C6
Data $72A4C5, $6AA2C5, $62A0C4, $5C9EC4, $549BC5, $4B99C6, $4798C7, $3D96C7
Data $1183C1, $1085C5, $148AC9, $198FCF, $1F96D6, $229DDD, $26A3E4, $2AA9E9
Data $2DAEE9, $2EB3E9, $3BBCEA, $8AAFCA, $7AA7C6, $72A5C5, $6AA3C5, $62A1C4
Data $5C9EC4, $539CC6, $4B99C6, $4798C6, $3C95C7, $0F82C1, $1084C4, $1489C9
Data $198FCF, $1D96D7, $219CDC, $25A2E2, $29A7E7, $2BADE9, $2CB1E9, $3BBAEA



.BCF_WindowTitleUnselected_Style01
Data 80
Data 21
Data $4C6492, $4B6696, $476595, $426495, $3D6395, $396195, $356096, $315F97
Data $2E5F98, $285D98, $115195, $115397, $12569A, $15599C, $165C9E, $185FA0
Data $1A60A2, $1B63A4, $1C65A5, $1D66A7, $1C65A5, $4C6492, $4B6696, $476596
Data $426495, $3D6295, $396196, $356096, $315F97, $2E5E98, $285D98, $115295
Data $115397, $13569A, $15599C, $175C9E, $185FA1, $1A61A3, $1C63A4, $1E65A6
Data $1E68A8, $1C66A5, $4C6493, $4B6696, $476495, $416395, $3D6295, $396195
Data $355F96, $315F97, $2E5E98, $285D98, $115295, $115398, $13569A, $15599C
Data $185D9F, $195FA1, $1B62A3, $1C64A5, $1E66A7, $1E68A9, $1D68A5, $4D6593
Data $4B6595, $476495, $426295, $3D6295, $396195, $356096, $315F97, $2E5E98
Data $285D98, $115195, $115397, $13569A, $16599C, $185D9F, $195FA2, $1B62A4
Data $1D65A5, $1E67A8, $1F69A9, $1F69A5, $4D6494, $4B6595, $476395, $426295
Data $3D6195, $396095, $345F95, $305E97, $2E5E98, $285D98, $115195, $115397
Data $13569A, $16599C, $185D9F, $1A5FA1, $1C62A4, $1E65A6, $1F67A8, $206BA9
Data $206AA5, $4D6494, $4B6595, $476395, $426295, $3D6095, $396095, $356096
Data $315E97, $2E5E98, $285D98, $115195, $115397, $135699, $16599C, $185D9F
Data $1B5FA2, $1D62A4, $1E66A6, $1F69A8, $216BA9, $216BA5, $4D6394, $4B6595
Data $476295, $426194, $3D6094, $396095, $355F96, $315E97, $2E5D97, $295D98
Data $115195, $115397, $13569A, $16599C, $195D9F, $1B60A2, $1D62A4, $1E65A7
Data $2069A9, $226BA9, $226CA5, $4C6394, $4B6495, $476295, $426095, $3D6094
Data $395F95, $355F95, $315D96, $2E5D97, $285C98, $125195, $115397, $14569A
Data $16599C, $185D9F, $1B5FA1, $1D62A4, $1F66A6, $2069A9, $236BA9, $236DA5
Data $4C6394, $4B6395, $466295, $416094, $3C5F94, $395F95, $355F96, $315E96
Data $2E5D97, $295C97, $115194, $115396, $145598, $16589C, $195D9E, $1B5FA1
Data $1E63A4, $1F66A6, $2069A9, $236CA9, $236DA5, $4C6493, $4B6395, $466194
Data $416094, $3C5F94, $395F94, $355F95, $315D96, $2E5D97, $295C97, $125094
Data $115296, $145598, $16599B, $195C9F, $1B5FA0, $1E63A4, $1F66A6, $2269A9
Data $236DA9, $246EA5, $4C6492, $4B6395, $466194, $415F94, $3C5E94, $395E94
Data $345E95, $315E95, $2E5D97, $295C97, $115193, $125195, $155498, $16589B
Data $1A5C9D, $1C5FA0, $1E62A4, $1F66A7, $2269A9, $256EA9, $246EA5, $4C6392
Data $4B6395, $466194, $415F94, $3C5E94, $395D94, $355D95, $315D95, $2E5D97
Data $295C97, $115093, $125195, $145597, $16579A, $195C9D, $1C5FA0, $1E62A3
Data $2066A6, $2269A9, $246DA9, $246FA5, $4C6392, $4B6295, $466094, $415F94
Data $3C5D93, $395D94, $355D95, $305D95, $2E5D96, $285B96, $115093, $115194
Data $145497, $17579A, $195C9D, $1C5EA0, $1E62A3, $2066A7, $226AA9, $256EA9
Data $256FA5, $4C6393, $4B6294, $466094, $415F94, $3C5D93, $395D94, $345D94
Data $305D95, $2E5D96, $295B96, $114F92, $115194, $145496, $16579A, $195C9D
Data $1B5EA0, $1E62A3, $2066A6, $2369A8, $256EA9, $256FA5, $4C6392, $4B6294
Data $466094, $415E93, $3C5D93, $385C93, $345C94, $305C95, $2E5D95, $285B95
Data $114F92, $115094, $135396, $165799, $195C9C, $1C5FA0, $1E62A3, $2066A5
Data $236AA9, $266EA9, $256FA5, $4C6392, $4B6294, $465F93, $415E93, $3C5D93
Data $385C93, $345C94, $305C95, $2E5C95, $285A95, $114E92, $115093, $135396
Data $165799, $195A9C, $1B5E9F, $1E62A3, $2066A5, $2369A9, $266EA9, $2570A5
Data $4C6292, $4B6294, $465F94, $415D93, $3C5D93, $385C93, $345C94, $305B94
Data $2E5C95, $285A95, $114E91, $115092, $135395, $165698, $195A9C, $1B5D9F
Data $1E61A2, $2065A5, $2369A9, $256EA9, $2570A5, $4C6292, $4B6294, $465F93
Data $415E93, $3C5C92, $385C92, $345B93, $305C94, $2E5C95, $285A95, $114E90
Data $115092, $145395, $165698, $185A9B, $1C5D9F, $1E62A2, $2065A5, $2369A9
Data $256DA9, $266FA5, $4C6292, $4B6294, $465F93, $415E92, $3C5C92, $385C92
Data $345B93, $305B94, $2E5C95, $285A95, $114E90, $115092, $135294, $165697
Data $185A9B, $1B5D9E, $1E61A2, $2065A5, $2369A8, $256EA9, $266FA5, $4C6292
Data $4B6294, $465F93, $415D92, $3C5C92, $385C92, $345B92, $305B94, $2E5B94
Data $285A94, $114E90, $114F91, $135294, $165597, $185A9B, $1B5D9E, $1E61A2
Data $2065A5, $236AA8, $266EA9, $2670A5, $4C6292, $4B6294, $465F93, $415D92
Data $3C5C92, $385C92, $335B93, $305B93, $2D5B94, $285A95, $114E90, $114F91
Data $135194, $165597, $185A9B, $1B5D9D, $1E60A2, $2065A5, $236AA9, $256EA9
Data $2670A5, $4C6292, $4B6294, $465F93, $415D92, $3C5C92, $385B92, $335B92
Data $305A93, $2D5B94, $285A94, $114E90, $114F91, $135194, $165497, $18599A
Data $1B5D9D, $1E61A2, $2065A5, $2369A9, $266EA9, $2670A5, $4C6292, $4B6194
Data $465F93, $415D92, $3C5C92, $385B92, $345B92, $305A93, $2D5B94, $285A94
Data $114E90, $114E91, $135194, $165597, $18599B, $1B5D9E, $1E61A2, $2065A5
Data $2369A9, $266EA9, $2670A5, $4C6292, $4B6294, $465F93, $415D92, $3C5C92
Data $385B92, $335A92, $305A93, $2D5A94, $285A94, $114D90, $114E91, $135193
Data $165497, $18599B, $1B5D9D, $1E61A2, $2065A5, $2369A9, $266EA9, $2671A5
Data $4C6292, $4B6294, $465F93, $415D92, $3C5C92, $385C92, $335A92, $305A94
Data $2D5A94, $285994, $114D90, $114E91, $135193, $165497, $18599B, $1B5D9D
Data $1E61A2, $2065A5, $2369A9, $266EA9, $2671A5, $4C6292, $4B6294, $465F93
Data $415D92, $3C5C92, $385B92, $335B92, $305A94, $2D5A94, $285994, $114D90
Data $114E91, $135193, $165497, $19599B, $1B5D9E, $1E61A2, $2065A5, $236AA9
Data $266EA9, $2671A5, $4C6292, $4B6294, $465F93, $415D92, $3C5C92, $385C92
Data $335B92, $305A93, $2D5A94, $285994, $114D90, $114E91, $135193, $165496
Data $18599B, $1B5D9E, $1E61A2, $2065A5, $2369A9, $266FA9, $2671A5, $4C6292
Data $4B6194, $465F93, $415D92, $3C5C92, $385B92, $335A92, $305A94, $2D5A94
Data $285994, $114D90, $114E91, $135193, $165596, $18599A, $1B5D9E, $1E62A2
Data $2065A6, $236AA9, $266FA9, $2571A5, $4C6192, $4B6194, $465F93, $415D92
Data $3C5C92, $385B92, $335A92, $305A93, $2E5A94, $285994, $114D90, $114E91
Data $135192, $165496, $18599B, $1B5D9E, $1E62A2, $2066A6, $236BA9, $266FA9
Data $2571A5, $4C6192, $4B6194, $465F93, $415D92, $3C5C92, $385B92, $335A92
Data $305A93, $2D5A94, $285994, $114D90, $114E91, $135192, $165497, $18599B
Data $1B5D9E, $1E62A2, $2066A5, $236BA9, $266FA9, $2672A5, $4C6192, $4B6194
Data $465F93, $415D92, $3C5C92, $385B92, $345A92, $305A94, $2D5A94, $285994
Data $114D90, $114E90, $135192, $165497, $18599B, $1B5D9F, $1E62A3, $2066A6
Data $236BA9, $266FA9, $2672A5, $4C6192, $4B6194, $465F93, $415D92, $3C5C92
Data $385C92, $335B92, $305A94, $2D5A94, $285994, $114D90, $114E91, $135192
Data $165497, $185A9B, $1B5D9D, $1E62A3, $2066A7, $236BA9, $266FA9, $2672A5
Data $4C6192, $4B6194, $465F93, $415D92, $3C5C92, $385B92, $335A92, $305A94
Data $2D5A94, $285994, $114D90, $114E91, $135193, $165596, $18599B, $1B5D9E
Data $1E62A3, $2066A7, $236BA9, $266FA9, $2672A5, $4C6292, $4B6194, $465F93
Data $415D92, $3C5C92, $385B92, $345A92, $305A93, $2E5A94, $285994, $114D90
Data $114E91, $135193, $165497, $185A9B, $1B5E9F, $1E62A3, $2066A7, $236BA9
Data $2670A9, $2672A5, $4C6192, $4B6194, $465F93, $415D92, $3C5C92, $385C92
Data $335B92, $305A94, $2D5A94, $285994, $114D90, $114E91, $135193, $165597
Data $185A9B, $1B5E9F, $1E62A3, $2066A7, $236CA9, $2671A9, $2673A5, $4C6192
Data $4B6194, $465F93, $415D92, $3C5C92, $385B92, $335A92, $305A93, $2D5A94
Data $285994, $114D90, $114E91, $135193, $165597, $185A9B, $1C5D9F, $1E62A3
Data $2167A7, $246CA9, $2671A9, $2673A5, $4C6292, $4B6194, $465F93, $415D92
Data $3C5C92, $385B92, $335B92, $305A93, $2D5A94, $285994, $114D90, $114F91
Data $135193, $165597, $195A9B, $1B5F9F, $1E63A3, $2166A7, $246CA9, $2671A9
Data $2673A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385B92, $345B92
Data $305A93, $2D5A94, $285994, $114D90, $114E91, $135193, $165597, $195A9B
Data $1C5E9F, $1E63A4, $2167A8, $246CA9, $2671A9, $2674A5, $4C6292, $4B6194
Data $465F93, $415D92, $3C5C92, $385B92, $335A92, $305A93, $2D5A94, $285994
Data $114E90, $114E91, $135193, $165597, $195A9C, $1B5E9F, $1E63A4, $2168A8
Data $236CA9, $2671A9, $2674A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92
Data $385B92, $335B92, $305A93, $2D5A94, $285994, $114D90, $114E91, $135194
Data $165597, $195A9B, $1C5FA0, $1E63A4, $2168A8, $236DA9, $2672A9, $2674A5
Data $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385C92, $335B92, $305A93
Data $2D5A94, $285994, $114D90, $114E91, $135194, $165597, $195A9B, $1C5FA0
Data $1E63A4, $2268A8, $246DA9, $2672A9, $2674A5, $4C6292, $4B6194, $465F93
Data $415D92, $3C5C92, $385B92, $335A92, $305A93, $2D5A94, $285994, $114D90
Data $114F91, $135194, $165697, $195A9B, $1C5F9F, $1E63A4, $2268A8, $246EA9
Data $2772A9, $2674A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385B92
Data $335A92, $305A93, $2D5A94, $285994, $114D90, $114E91, $135194, $165597
Data $195A9C, $1C5FA0, $1E63A4, $2168A8, $256EA9, $2672A9, $2675A5, $4C6292
Data $4B6194, $465F93, $415D92, $3C5C92, $385B92, $335B92, $305A93, $2D5A94
Data $285994, $114D90, $114E91, $135194, $165597, $195A9C, $1C5FA0, $1E63A4
Data $2168A8, $246EA9, $2772A9, $2674A5, $4C6292, $4B6194, $465F93, $415D92
Data $3C5C92, $385B92, $335A92, $305A93, $2D5A94, $285994, $114D90, $114E91
Data $135193, $165697, $195A9C, $1D5FA0, $1E64A4, $2168A8, $246DA9, $2672A9
Data $2674A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385B92, $335A92
Data $305A93, $2D5A94, $285994, $114D90, $114E91, $135194, $165597, $195A9C
Data $1C5FA0, $1E64A4, $2269A8, $246EA9, $2772A9, $2674A5, $4C6292, $4B6194
Data $465F93, $415D92, $3C5C92, $385B92, $335A92, $305A93, $2D5A94, $285994
Data $114D90, $114E91, $135194, $165697, $195A9C, $1C5FA0, $1F64A4, $2268A9
Data $246EA9, $2672A9, $2674A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92
Data $385B92, $345B92, $305A93, $2E5A94, $285994, $114D90, $114F91, $135194
Data $165597, $185B9C, $1C5FA0, $1F63A4, $2269A8, $246EA9, $2672A9, $2674A5
Data $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385B92, $335A92, $305A93
Data $2D5A94, $285994, $114D90, $114E91, $135194, $165598, $195A9C, $1C5FA0
Data $1F64A5, $2269A8, $246EA9, $2772A9, $2674A5, $4C6292, $4B6194, $465F93
Data $415D92, $3C5C92, $385B92, $335B92, $305A93, $2D5A94, $285994, $114D90
Data $114E91, $135194, $165697, $195A9C, $1C5FA1, $1E64A5, $2169A8, $246EA9
Data $2773A9, $2774A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385B92
Data $345A92, $305A93, $2D5A94, $285994, $114E90, $114E91, $135294, $165698
Data $195B9C, $1C60A1, $1F64A5, $2269A8, $246EA9, $2773A9, $2674A5, $4C6292
Data $4B6194, $465F93, $415D92, $3C5C92, $385B92, $335B92, $305A93, $2D5A94
Data $285994, $114D90, $114F91, $135294, $165698, $195B9C, $1D60A1, $1F64A5
Data $2169A8, $256EA9, $2673A9, $2674A5, $4C6292, $4B6194, $465F93, $415D92
Data $3C5C92, $385B92, $345A92, $305A93, $2D5A94, $285994, $114E90, $114F91
Data $135294, $165698, $195B9C, $1C60A1, $1E64A5, $2169A9, $256EA9, $2773A9
Data $2675A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385B92, $345A92
Data $305A93, $2D5A94, $285994, $114D90, $114F91, $135294, $165698, $195B9C
Data $1C60A1, $1F65A5, $2169A9, $256EA9, $2774A9, $2675A5, $4C6292, $4B6194
Data $465F93, $415D92, $3C5C92, $385B92, $335A92, $305A93, $2D5A94, $285994
Data $114D90, $114F91, $135294, $165698, $195B9C, $1D60A2, $1F65A5, $216AA9
Data $256EA9, $2774A9, $2675A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92
Data $385B92, $335A92, $305A93, $2D5A94, $285994, $114D90, $114F91, $135294
Data $165698, $1A5C9C, $1D60A1, $1F65A5, $2269A9, $256EA9, $2774A9, $2675A5
Data $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385B92, $345B92, $305A93
Data $2D5A94, $285994, $114D90, $114F92, $135294, $165698, $195C9C, $1D60A2
Data $1E65A5, $216AA9, $256EA9, $2774A9, $2675A5, $4C6292, $4B6194, $465F93
Data $415D92, $3C5C92, $385B92, $335A92, $305A94, $2D5A94, $285A94, $114D90
Data $114F91, $135294, $165698, $1A5C9D, $1D60A2, $1F65A6, $2269A9, $256EA9
Data $2774A9, $2676A5, $4C6292, $4B6194, $465F93, $415D92, $3C5C92, $385B92
Data $335A92, $305A94, $2D5B94, $285A94, $114E90, $114F91, $135395, $165698
Data $195C9D, $1D60A2, $1F65A6, $226AA9, $256FA9, $2774A9, $2676A5, $4C6292
Data $4B6194, $465F93, $415D92, $3C5C92, $385C92, $335A92, $305A94, $2D5A94
Data $285A94, $114E90, $114F91, $135294, $165698, $1A5C9D, $1D60A2, $1F65A6
Data $226AA9, $256FA9, $2774A9, $2676A5, $4C6292, $4B6294, $465F93, $415D92
Data $3C5C92, $385B92, $335A92, $305A93, $2D5B94, $285A94, $114E90, $114F92
Data $135295, $165698, $1A5C9D, $1D60A3, $1F65A7, $226BA9, $256FA9, $2774A9
Data $2776A5, $4C6292, $4B6294, $465F93, $415D92, $3C5C92, $385B92, $345B92
Data $305A93, $2D5B94, $285A94, $114E90, $115092, $135395, $165799, $195C9D
Data $1D60A2, $1F65A7, $226BA9, $256FA9, $2775A9, $2676A5, $4C6292, $4B6294
Data $465F93, $415D92, $3C5C92, $385C92, $345B93, $305A94, $2E5C94, $285A94
Data $114E91, $115092, $135395, $165699, $1A5C9E, $1D60A2, $1F65A7, $226BA9
Data $256FA9, $2775A9, $2776A5, $4C6292, $4B6294, $465F94, $415E93, $3C5C92
Data $385C92, $345C93, $305B94, $2E5B94, $285A95, $114E90, $115092, $135396
Data $16579A, $1A5C9D, $1D61A3, $1F66A7, $226BA9, $246FA9, $2774A9, $2776A5
Data $4C6392, $4B6294, $465F94, $415E93, $3C5D93, $385C93, $345B93, $305B94
Data $2E5C95, $285A95, $114E91, $115093, $145395, $16579A, $1A5C9F, $1D62A3
Data $1F66A7, $226BA9, $256FA9, $2775A9, $2776A5, $4C6392, $4B6294, $466094
Data $415E93, $3C5D93, $385C93, $345C94, $305C94, $2E5C95, $285A95, $114E91
Data $115093, $145396, $16579A, $1A5D9F, $1D61A3, $1F66A7, $226BA9, $256FA9
Data $2774A9, $2676A5, $4C6392, $4B6294, $466094, $415F93, $3C5D93, $395C93
Data $345C94, $305C95, $2E5C95, $295A95, $114E92, $115094, $135397, $16589A
Data $1A5D9F, $1D62A4, $1F66A8, $226BA9, $2570A9, $2775A9, $2676A5, $4C6392
Data $4B6295, $466094, $415F94, $3C5D93, $395D93, $345C94, $305C94, $2E5C95
Data $285A95, $114F92, $115194, $135496, $16589B, $1A5DA0, $1D62A4, $1F67A8
Data $226BA9, $2570A9, $2775A9, $2675A5, $4C6392, $4B6395, $466094, $415F94
Data $3C5D94, $395D94, $345D94, $315D95, $2E5D95, $295A96, $115092, $115195
Data $145497, $16599B, $1A5DA0, $1D62A4, $1F67A8, $226BA9, $2570A9, $2675A9
Data $2676A5, $4C6392, $4B6395, $466094, $415F94, $3C5E94, $395D94, $355D94
Data $305D95, $2E5D95, $295C96, $114F92, $115194, $145497, $16599B, $1A5DA0
Data $1D62A4, $1F66A8, $226BA9, $2470A9, $2774A9, $2675A5, $4C6393, $4B6395
Data $466194, $416094, $3C5F94, $395E94, $355E94, $305D95, $2E5D96, $285B96
Data $115092, $125195, $135498, $16599C, $1A5EA0, $1D63A4, $1F67A9, $226BA9
Data $2570A9, $2674A9, $2674A5, $4C6393, $4B6395, $466194, $416094, $3C5F94
Data $395E94, $355E95, $315D96, $2E5D96, $295C97, $115093, $115195, $145598
Data $16599B, $1A5EA0, $1D62A4, $1F66A8, $216BA9, $236FA9, $2574A9, $2574A5
Data $4C6394, $4B6495, $476295, $416094, $3C5F94, $395F95, $355F95, $315D95
Data $2E5D97, $285C96, $115092, $115295, $145498, $16599C, $1A5EA0, $1D62A4
Data $1F67A8, $206BA9, $236FA9, $2574A9, $2473A5, $4C6394, $4B6495, $466295
Data $426094, $3D6094, $396095, $355F95, $315E95, $2E5D97, $285C96, $115092
Data $125295, $145498, $16599C, $1A5EA0, $1D62A4, $1E66A8, $206AA9, $226EA9
Data $2572A9, $2472A5, $4D6494, $4B6595, $466395, $416195, $3D6095, $396095
Data $355F95, $315D96, $2E5D96, $285C96, $115093, $115195, $135598, $16599C
Data $195EA0, $1C62A4, $1E65A8, $206AA9, $226EA9, $2372A9, $2371A5, $4D6494
Data $4B6595, $476395, $426295, $3D6195, $396095, $345F95, $315D96, $2E5D97
Data $285C97, $115093, $115295, $135598, $16599C, $195DA0, $1B62A4, $1E66A7
Data $1F69A9, $216EA9, $2371A9, $2370A5, $4D6594, $4B6695, $476395, $426295
Data $3D6295, $396195, $355F95, $315D96, $2E5D97, $285C97, $115093, $115295
Data $135598, $16599C, $185DA0, $1B61A3, $1D66A7, $1F69A9, $206CA9, $2270A9
Data $2270A5, $4D6593, $4B6696, $476495, $426395, $3D6295, $396195, $346095
Data $305E96, $2E5D97, $285C97, $115192, $115295, $135598, $16599B, $185D9F
Data $1A61A3, $1D64A6, $1E68A9, $206CA9, $226FA9, $216EA5, $4D6593, $4B6696
Data $476595, $426395, $3D6295, $396195, $355F95, $305E96, $2E5D97, $285C97
Data $115193, $115295, $125598, $15589B, $185C9F, $1A60A3, $1C64A6, $1E68A9
Data $1F6BA9, $206EA9, $1E6DA5, $4D6593, $4B6696, $476595, $426495, $3D6395
Data $396195, $346096, $305E96, $2E5D96, $275C97, $105093, $115195, $125498
Data $15589B, $175C9F, $1960A2, $1B63A5, $1E66A8, $1E6AA9, $1F6CA9, $1E6CA5


.BCF_WindowTitleSelected_Style02
Data 80
Data 21
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5
Data $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF
Data $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6
Data $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7
Data $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF
Data $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE
Data $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9
Data $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF
Data $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0
Data $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3
Data $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD
Data $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE
Data $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE
Data $B7BECF, $B8BDCF, $BAC0CF, $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0
Data $A7AEC0, $A7AEC0, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8
Data $BEC3D6, $BEC4D3, $BBC1D0, $B9BFCE, $B7BECE, $B7BECF, $B8BDCF, $BAC0CF
Data $AFB6C7, $A4ABBD, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A7AEC0, $A6ADBF
Data $A6ADBF, $A5ACBE, $8C93A5, $F6F6F9, $C6CCD8, $BEC3D6, $BEC4D3, $BBC1D0
Data $B9BFCE, $B6BECE, $B6BCCE, $B7BCCE, $B9BFCE, $AFB6C7, $A5ADBF, $A7AEC0
Data $A7AEC0, $A6ADBF, $A6ADBF, $A6ADBF, $A6ADBF, $A6ADBF, $A5ACBE, $8C93A5



.BCF_WindowTitleUnselected_Style02
Data 80
Data 21
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697083, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697083, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697083, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697083, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697083, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697083, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697083
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697083, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697083, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697083, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697083, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697083, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697083, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697083, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E
Data $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082
Data $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD
Data $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E
Data $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4
Data $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5
Data $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D
Data $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC
Data $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E
Data $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5
Data $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD
Data $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E
Data $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1
Data $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD, $8D94A5, $82899B
Data $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D, $848B9D, $838A9C
Data $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC
Data $959CAD, $969BAD, $989EAD, $8D94A5, $82899B, $858C9E, $858C9E, $858C9E
Data $858C9E, $858C9E, $848B9D, $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6
Data $9CA1B4, $9CA2B1, $999FAE, $979DAC, $959CAC, $959CAD, $969BAD, $989EAD
Data $8D94A5, $82899B, $858C9E, $858C9E, $858C9E, $858C9E, $858C9E, $848B9D
Data $848B9D, $838A9C, $697082, $D1D1D5, $A4AAB6, $9CA1B4, $9CA2B1, $999FAE
Data $979DAC, $949CAC, $949AAC, $959AAC, $979DAC, $8D94A5, $838B9D, $858C9E
Data $858C9E, $848B9D, $848B9D, $848B9D, $848B9D, $848B9D, $838A9C, $696F82


.BCF_WindowTitleSelected_Style03
Data 80
Data 21
Data $67788C, $69798A, $69798A, $69798A, $69798A, $69798A, $69798A, $69798A
Data $69798A, $69798A, $69798A, $69798A, $69798A, $69798A, $69798A, $69798A
Data $69798A, $69798A, $69798A, $69798A, $67788C, $69798A, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $69798A, $69798A, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $69798A, $69798A
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $69798A, $69798A, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $69798A, $69798A, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $69798A, $69798A, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $69798A, $69798A, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $69798A
Data $69798A, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $69798A, $69798A, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $69798A, $69798A, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $69798A, $69798A
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $69798A, $69798A, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $69798A, $69798A, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $69798A, $69798A, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $69798A, $69798A, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $69798A
Data $69798A, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $69798A, $69798A, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $69798A, $687889, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $69798A, $687889
Data $6A7887, $6A7887, $6A7887, $6A7887, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $69798A, $687889, $6A7887, $6A7887, $6A7887
Data $6A7887, $6A7887, $6A7887, $6B7987, $6B7987, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $69798A, $687889, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887
Data $6A7887, $6A7887, $6A7887, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $6B7988, $6B7988, $6B7988, $69798A, $687888, $6A7887
Data $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887
Data $6A7887, $6B7988, $6B7987, $6B7988, $6B7988, $6B7988, $6B7988, $6B7988
Data $6B7988, $6B7988, $69798A, $677788, $697786, $697786, $6A7887, $6A7886
Data $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887
Data $6A7887, $6A7887, $6A7887, $6A7887, $6B7988, $6B7988, $6B7988, $69798A
Data $677788, $697786, $697786, $6A7886, $697786, $6A7886, $6A7887, $6A7887
Data $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887
Data $6A7887, $6A7887, $6A7887, $6B7987, $697989, $677787, $697786, $687685
Data $697786, $697786, $697786, $697786, $697786, $697786, $6A7887, $6A7887
Data $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887
Data $6A7887, $687889, $667687, $697785, $687685, $687685, $697785, $697786
Data $697786, $697786, $697786, $6A7887, $6A7886, $6A7887, $6A7886, $697786
Data $6A7886, $6A7887, $6A7887, $6A7887, $6A7887, $6A7887, $687889, $667686
Data $687684, $687684, $687685, $687685, $687685, $697785, $697786, $697786
Data $697786, $697786, $697786, $697786, $697786, $697786, $697786, $6A7887
Data $6A7886, $6A7887, $6A7887, $687889, $657586, $677584, $677584, $687685
Data $687685, $687685, $687685, $687685, $687685, $697786, $697786, $687686
Data $697786, $697785, $697786, $697786, $697786, $697786, $697786, $6A7887
Data $687889, $647485, $677584, $667483, $687685, $677584, $687684, $687685
Data $687685, $687685, $687685, $687685, $687684, $687685, $687685, $697785
Data $687685, $697785, $697786, $697786, $697786, $677788, $647484, $677583
Data $667482, $677584, $677583, $677584, $677584, $677584, $687684, $687685
Data $687685, $687684, $687685, $687685, $677585, $687685, $687685, $697786
Data $697786, $697786, $667688, $637384, $667483, $657382, $677583, $667483
Data $677583, $677583, $667483, $677584, $677584, $677583, $677584, $677584
Data $677584, $677584, $677584, $687684, $697785, $687685, $687685, $667687
Data $627282, $647281, $647281, $667483, $677582, $667482, $667483, $667483
Data $677583, $667483, $667483, $667483, $667483, $677584, $677583, $677583
Data $677584, $687685, $687685, $687685, $667686, $627182, $637180, $647280
Data $657381, $647281, $647281, $657381, $657382, $657382, $667482, $667483
Data $657382, $667482, $667483, $667483, $667483, $677584, $687685, $697785
Data $697785, $667686, $617081, $637180, $62707F, $647280, $647280, $647281
Data $647281, $647280, $657382, $667482, $657381, $657382, $667482, $667483
Data $667483, $667483, $677584, $677584, $687685, $677584, $637385, $617081
Data $637180, $62707E, $657382, $667483, $657381, $657381, $657381, $667483
Data $667483, $657381, $657382, $667482, $667482, $667483, $667483, $667483
Data $667483, $677584, $677583, $637383, $606F80, $64727F, $62707E, $657382
Data $667482, $647281, $657381, $647281, $647281, $657381, $647280, $647280
Data $647280, $647281, $647281, $657381, $657382, $657382, $667483, $677583
Data $637383, $617080, $647280, $62707E, $637180, $627080, $616F7E, $616F7E
Data $62707E, $62707F, $62707F, $62707E, $62707E, $62707E, $62707E, $63717E
Data $62707F, $63717F, $647281, $657382, $667482, $637384, $627282, $657382
Data $616F7D, $616F7C, $5F6D7C, $5F6D7B, $5F6D7B, $5F6D7C, $606E7C, $616F7D
Data $606E7D, $606E7D, $606E7C, $616F7D, $606E7D, $616F7D, $62707E, $637180
Data $647281, $657381, $637384, $617080, $62707E, $5F6D7B, $5E6C7A, $5D6B79
Data $5D6B79, $5D6B79, $5D6B7A, $5E6C7A, $5E6C7A, $5E6C7B, $5F6D7B, $5F6D7B
Data $5E6C7B, $5F6D7C, $5F6D7C, $616F7D, $62707F, $63717F, $647280, $627282
Data $5E6D7D, $606E7C, $5D6B79, $5B6977, $5C6A78, $5C6A78, $5C6A78, $5C6A78
Data $5D6B79, $5C6A79, $5E6C79, $5E6C7A, $5E6C7A, $5E6C7B, $5E6C7A, $5F6D7B
Data $606E7C, $616F7C, $616F7D, $616F7D, $606F7F, $5B6A7B, $5D6B79, $5A6876
Data $5A6876, $5B6977, $5B6977, $5B6977, $5B6977, $5C6A78, $5B6978, $5C6A79
Data $5D6B79, $5D6B79, $5D6B79, $5D6B79, $5D6B7A, $5E6C7A, $5F6D7B, $5F6D7B
Data $5F6D7C, $5E6D7E, $586878, $596774, $596775, $5A6876, $596775, $596775
Data $5A6876, $5A6876, $5A6876, $5A6877, $5B6977, $5B6977, $5B6977, $5C6A77
Data $5B6977, $5C6A78, $5D6B79, $5D6B7A, $5E6C7A, $5E6C7B, $5D6C7D, $566676
Data $576573, $586673, $576573, $586673, $586673, $586674, $586674, $586674
Data $596775, $596775, $596775, $596775, $5A6876, $5A6876, $5B6977, $5C6A78
Data $5C6A78, $5D6B79, $5D6B79, $5C6B7D, $556575, $566472, $566471, $566472
Data $566471, $566472, $566472, $576573, $576573, $576573, $586674, $586674
Data $586674, $596775, $596775, $5B6977, $5B6977, $5B6977, $5C6A78, $5C6A78
Data $5B6A7B, $546474, $546270, $546270, $546271, $546270, $546270, $556371
Data $556371, $566472, $566472, $566473, $586673, $586674, $586674, $586674
Data $596775, $5A6876, $596776, $5A6876, $5B6977, $596879, $526271, $53616F
Data $53616F, $546270, $53616F, $53616F, $556370, $556371, $556371, $556371
Data $576572, $576573, $576573, $576573, $576573, $586674, $586674, $596775
Data $596775, $5A6876, $5A697A, $516170, $52606E, $53616E, $53616E, $52606E
Data $53616F, $556370, $556371, $556371, $556371, $566472, $566472, $566472
Data $566472, $576573, $576573, $576573, $596775, $596775, $5A6876, $5C6B7C
Data $4F5F6F, $52606D, $52606D, $515F6C, $52606E, $53616F, $546270, $556370
Data $546270, $556370, $556371, $546270, $556371, $566472, $576573, $566472
Data $576573, $596775, $5A6877, $5D6B79, $5C6B7C, $50606F, $515F6C, $505E6C
Data $515F6D, $52606D, $52606E, $53616F, $53616F, $54626F, $54626F, $546270
Data $556371, $566472, $566472, $556371, $576572, $5A6875, $5C6A78, $5D6B78
Data $5D6B79, $596879, $4F5F6F, $4F5D6B, $505E6B, $515F6D, $52606D, $52606E
Data $52606E, $52606E, $53616E, $54626F, $53616F, $556371, $546270, $556371
Data $566472, $596775, $5C6A78, $5D6B78, $5A6876, $586674, $566676, $4E5E6E
Data $4F5D6B, $505E6B, $52606D, $52606D, $52606E, $52606D, $52606E, $53616E
Data $54626F, $53616F, $53616F, $54626F, $576572, $5A6875, $5A6876, $5B6976
Data $576573, $566472, $576573, $5B6A7B, $4E5E6E, $505E6B, $515F6C, $53616E
Data $52606E, $52606D, $52606D, $52606E, $54626F, $54626F, $52606D, $53616F
Data $576572, $5A6875, $596775, $576572, $556371, $556371, $586674, $5E6C79
Data $637382, $4E5E6D, $505E6B, $515F6C, $52606D, $52606D, $515F6D, $52606E
Data $52606E, $52606E, $52606D, $53616E, $576572, $586674, $576572, $556371
Data $556370, $556370, $586674, $5D6B79, $63717F, $627282, $4F5F6E, $505E6C
Data $515F6C, $515F6D, $52606E, $53616E, $52606E, $52606E, $52606E, $54626F
Data $576572, $596774, $586673, $556370, $556371, $566472, $586675, $5C6A77
Data $606E7C, $616F7D, $5B6A7B, $4F5F6E, $515F6B, $515F6D, $53616E, $52606D
Data $53616E, $53616E, $53616E, $54626F, $576572, $586674, $576572, $556371
Data $546270, $566472, $5B6976, $5C6A78, $5E6C7A, $5E6C79, $5B6976, $5B6A7B
Data $50606F, $52606D, $52606E, $53616E, $52606D, $52606D, $53616E, $546270
Data $566472, $586674, $586673, $556371, $53616F, $566471, $586674, $5D6B78
Data $5E6C79, $5C6A78, $5B6977, $5D6B79, $637383, $506070, $53616F, $53616E
Data $52606D, $53616E, $53616E, $556370, $576572, $576573, $586673, $566471
Data $54626F, $556370, $586673, $5A6875, $5E6C79, $5E6C7A, $5D6B79, $62707E
Data $677583, $687888, $516170, $53616E, $53616E, $52606E, $52606E, $54626F
Data $566471, $586673, $586673, $566471, $53616F, $54626F, $576572, $586674
Data $5B6976, $5E6C7A, $62707E, $657381, $6B7986, $6D7B89, $687888, $526271
Data $53616E, $53616E, $53616E, $54626F, $566471, $576572, $576572, $556371
Data $546270, $54626F, $556370, $586673, $5A6875, $5D6B79, $64727F, $697784
Data $6F7D8A, $717F8D, $6E7C8B, $697988, $526271, $53616F, $52606E, $54626F
Data $566472, $586673, $576572, $556371, $556370, $53616F, $556370, $586674
Data $5D6B78, $62707D, $687683, $6D7B89, $717F8D, $72808E, $707E8B, $6F7D8A
Data $6B7B8B, $546473, $52606D, $53616E, $556370, $576572, $586673, $566472
Data $556371, $556370, $54626F, $596774, $5F6D7A, $647280, $6B7987, $717F8D
Data $73818F, $758390, $717F8E, $6A7886, $697785, $687888, $516170, $52606D
Data $54626F, $586673, $586673, $546270, $556371, $566471, $546270, $586673
Data $616F7C, $687683, $6E7C89, $73818E, $758390, $758391, $758390, $717F8C
Data $6B7986, $667481, $606F7E, $516170, $54626F, $566471, $566471, $556370
Data $556371, $586673, $596774, $596773, $5F6D79, $697784, $717F8C, $74828F
Data $768491, $768491, $768491, $768491, $72808D, $6C7A87, $64727F, $5D6C7C
Data $526272, $54626F, $556371, $576571, $586673, $5D6B78, $616F7C, $616F7C
Data $64727F, $6A7885, $717F8D, $768491, $768491, $768491, $768491, $768491
Data $768491, $72808D, $697785, $63717F, $61707F, $536372, $556370, $576572
Data $5D6B78, $62707D, $667481, $6B7987, $6E7C89, $72808D, $758390, $768491
Data $778592, $768491, $758390, $758390, $74828F, $768491, $73818E, $6B7986
Data $657380, $627281, $536372, $5C6A77, $62707D, $63717E, $63717F, $657380
Data $6D7B88, $748290, $758391, $758390, $768491, $768491, $758390, $768491
Data $758390, $74828F, $75838F, $72808E, $6E7C89, $677582, $637382, $5B6A7A
Data $616F7C, $62707D, $606E7B, $606E7B, $667482, $707E8B, $758391, $758391
Data $768491, $758390, $768491, $758390, $758390, $758390, $74828F, $73818E
Data $6F7D8A, $697783, $606E7C, $5D6C7D, $606F7E, $5E6C79, $5A6875, $5D6B78
Data $657380, $6E7C89, $768491, $778592, $768491, $768491, $748290, $758391
Data $758390, $74828F, $758390, $73818F, $6C7A87, $64727F, $5E6C79, $566471
Data $50606F, $586877, $566471, $5F6D7A, $6A7885, $717F8C, $74828F, $72808D
Data $73818E, $758390, $758390, $768491, $758391, $748290, $74828F, $758390
Data $6E7C8A, $616F7C, $566471, $52606D, $505E6B, $4C5B6A, $566675, $5E6C79
Data $6B7986, $72808D, $72808D, $6F7D8A, $6E7C89, $6E7C89, $707E8B, $717F8C
Data $717F8C, $6E7C89, $6E7C89, $74828F, $707E8A, $64727F, $5B6976, $515F6C
Data $4D5B67, $4C5A67, $4D5C6B, $606F7E, $6A7885, $6F7D8A, $6D7B88, $697784
Data $677582, $6A7885, $6A7885, $6A7885, $697784, $667481, $606E7B, $677582
Data $717F8C, $657380, $586673, $53616E, $505E6B, $4C5A67, $4B5966, $4E5E6D
Data $61707F, $667481, $657380, $64727F, $64727F, $657380, $687683, $687683
Data $657381, $616F7D, $5C6A77, $5B6976, $697784, $697784, $596775, $53616E
Data $515F6C, $505E6B, $4F5D6A, $4D5B68, $4F5F6E, $5B6A7A, $5C6A77, $5C6A77
Data $606E7B, $62707D, $657380, $657380, $64727F, $5F6D7A, $5B6976, $596774
Data $5D6B78, $6C7A87, $606E7B, $52606D, $52606D, $52606D, $515F6C, $4F5D6B
Data $4E5C69, $4F5F6E, $566675, $596774, $596774, $5D6B78, $62707D, $63717E
Data $5F6D7A, $5B6977, $5A6875, $596775, $586673, $5F6D7A, $6A7885, $596774
Data $505E6B, $53616E, $52606D, $505E6B, $4F5D6B, $4F5D6A, $4E5E6D, $566675
Data $5A6875, $5D6B78, $5F6D7A, $5F6D7A, $5C6A77, $596774, $576572, $5A6875
Data $5B6977, $566471, $5C6A77, $657380, $556370, $515F6C, $515F6C, $515F6C
Data $4F5D6A, $4F5D69, $4E5C69, $4E5E6D, $596878, $5D6B78, $5D6B78, $5E6C79
Data $596774, $596774, $586673, $576572, $596774, $576573, $53616E, $5E6C79
Data $62707D, $54626F, $515F6C, $505E6B, $505E6B, $4F5D6A, $4E5C69, $4D5B68
Data $4E5D6C, $5D6C7C, $5E6C79, $5B6976, $596774, $596774, $596774, $566471
Data $596774, $586673, $566471, $5C6A77, $667481, $5E6C79, $505E6B, $515F6C
Data $52606D, $4F5D6A, $505E6B, $4E5C69, $4E5C69, $4D5C6B, $5D6C7C, $5D6B78
Data $5C6A77, $5D6B78, $5E6C79, $606E7B, $606E7B, $5D6B78, $5B6976, $5F6D7A
Data $667481, $62707D, $556370, $505E6B, $52606D, $505E6B, $505E6B, $505E6B
Data $4D5B68, $4D5B68, $4C5B6A, $5D6E80, $5F6E7E, $627282, $657585, $667686
Data $677787, $637383, $5E6E7E, $607080, $667686, $627282, $576777, $506070
Data $516171, $516171, $4F5F6F, $506070, $4D5D6D, $4C5C6C, $4C5B6B, $4D5E70


.BCF_WindowTitleUnselected_Style03
Data 80
Data 21
Data $26364A, $283748, $283749, $283749, $283749, $283749, $283749, $283749
Data $283749, $283749, $283749, $283749, $283749, $283749, $283749, $283749
Data $283749, $283749, $283749, $283748, $26364A, $283748, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $283748, $283748, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $283748, $283748
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $283748, $283748, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $283748, $283748, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $283748, $283748, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $283748, $283748, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $283748
Data $283748, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $283748, $283748, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $283748, $283748, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $283748, $283748
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $283748, $283748, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $283748, $283748, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $283748, $283748, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $283748, $283748, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $283748
Data $283748, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $283748, $283748, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $283748, $273647, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $283748, $273647
Data $293746, $293746, $293746, $293746, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $283748, $273647, $293746, $293746, $293746
Data $293746, $293746, $293746, $2A3846, $2A3846, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $283748, $273647, $293746, $293746, $293746, $293746, $293746, $293746
Data $293746, $293746, $293746, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $2A3847, $2A3847, $2A3847, $283748, $273646, $293746
Data $293746, $293746, $293746, $293746, $293746, $293746, $293746, $293746
Data $293746, $2A3847, $2A3846, $2A3847, $2A3847, $2A3847, $2A3847, $2A3847
Data $2A3847, $2A3847, $283748, $263546, $283645, $283645, $293746, $293745
Data $293746, $293746, $293746, $293746, $293746, $293746, $293746, $293746
Data $293746, $293746, $293746, $293746, $2A3847, $2A3847, $2A3847, $283748
Data $263546, $283645, $283645, $293745, $283645, $293745, $293746, $293746
Data $293746, $293746, $293746, $293746, $293746, $293746, $293746, $293746
Data $293746, $293746, $293746, $2A3846, $283747, $263545, $283645, $273544
Data $283645, $283645, $283645, $283645, $283645, $283645, $293746, $293746
Data $293746, $293746, $293746, $293746, $293746, $293746, $293746, $293746
Data $293746, $273647, $253445, $283644, $273544, $273544, $283644, $283645
Data $283645, $283645, $283645, $293746, $293745, $293746, $293745, $283645
Data $293745, $293746, $293746, $293746, $293746, $293746, $273647, $253444
Data $273543, $273543, $273544, $273544, $273544, $283644, $283645, $283645
Data $283645, $283645, $283645, $283645, $283645, $283645, $283645, $293746
Data $293745, $293746, $293746, $273647, $243344, $263443, $263443, $273544
Data $273544, $273544, $273544, $273544, $273544, $283645, $283645, $273545
Data $283645, $283644, $283645, $283645, $283645, $283645, $283645, $293746
Data $273647, $233244, $263443, $253342, $273544, $263443, $273543, $273544
Data $273544, $273544, $273544, $273544, $273543, $273544, $273544, $283644
Data $273544, $283644, $283645, $283645, $283645, $263546, $233243, $263442
Data $253341, $263443, $263442, $263443, $263443, $263443, $273543, $273544
Data $273544, $273543, $273544, $273544, $263444, $273544, $273544, $283645
Data $283645, $283645, $253446, $223143, $253342, $243241, $263442, $253342
Data $263442, $263442, $253342, $263443, $263443, $263442, $263443, $263443
Data $263443, $263443, $263443, $273543, $283644, $273544, $273544, $253445
Data $213041, $233140, $233140, $253342, $263441, $253341, $253342, $253342
Data $263442, $253342, $253342, $253342, $253342, $263443, $263442, $263442
Data $263443, $273544, $273544, $273544, $253444, $202F41, $22303F, $23313F
Data $243240, $233140, $233140, $243240, $243241, $243241, $253341, $253342
Data $243241, $253341, $253342, $253342, $253342, $263443, $273544, $283644
Data $283644, $253444, $1F2E40, $22303F, $212F3E, $23313F, $23313F, $233140
Data $233140, $23313F, $243241, $253341, $243240, $243241, $253341, $253342
Data $253342, $253342, $263443, $263443, $273544, $263443, $223144, $1F2E40
Data $22303F, $212F3D, $243241, $253342, $243240, $243240, $243240, $253342
Data $253342, $243240, $243241, $253341, $253341, $253342, $253342, $253342
Data $253342, $263443, $263442, $223142, $1E2E3F, $23313E, $212F3D, $243241
Data $253341, $233140, $243240, $233140, $233140, $243240, $23313F, $23313F
Data $23313F, $233140, $233140, $243240, $243241, $243241, $253342, $263442
Data $223142, $1F2E3F, $23313F, $212F3D, $22303F, $212F3F, $202E3D, $202E3D
Data $212F3D, $212F3E, $212F3E, $212F3D, $212F3D, $212F3D, $212F3D, $22303D
Data $212F3E, $22303E, $233140, $243241, $253341, $223143, $213041, $243241
Data $202E3C, $202E3B, $1E2C3B, $1E2C3A, $1E2C3A, $1E2C3B, $1F2D3B, $202E3C
Data $1F2D3C, $1F2D3C, $1F2D3B, $202E3C, $1F2D3C, $202E3C, $212F3D, $22303F
Data $233140, $243240, $223143, $1F2E3F, $212F3D, $1E2C3A, $1D2B39, $1C2A38
Data $1C2A38, $1C2A38, $1C2A39, $1D2B39, $1D2B39, $1D2B3A, $1E2C3A, $1E2C3A
Data $1D2B3A, $1E2C3B, $1E2C3B, $202E3C, $212F3E, $22303E, $23313F, $213041
Data $1D2C3C, $1F2D3B, $1C2A38, $1A2836, $1B2937, $1B2937, $1B2937, $1B2937
Data $1C2A38, $1B2938, $1D2B38, $1D2B39, $1D2B39, $1D2B3A, $1D2B39, $1E2C3A
Data $1F2D3B, $202E3B, $202E3C, $202E3C, $1E2E3E, $1A2939, $1C2A38, $192735
Data $192735, $1A2836, $1A2836, $1A2836, $1A2836, $1B2937, $1A2837, $1B2938
Data $1C2A38, $1C2A38, $1C2A38, $1C2A38, $1C2A39, $1D2B39, $1E2C3A, $1E2C3A
Data $1E2C3B, $1D2C3D, $172636, $182633, $182634, $192735, $182634, $182634
Data $192735, $192735, $192735, $192736, $1A2836, $1A2836, $1A2836, $1B2936
Data $1A2836, $1B2937, $1C2A38, $1C2A39, $1D2B39, $1D2B3A, $1C2B3B, $152434
Data $162432, $172532, $162432, $172532, $172532, $172533, $172533, $172533
Data $182634, $182634, $182634, $182634, $192735, $192735, $1A2836, $1B2937
Data $1B2937, $1C2A38, $1C2A38, $1B2A3B, $142333, $152331, $152330, $152331
Data $152330, $152331, $152331, $162432, $162432, $162432, $172533, $172533
Data $172533, $182634, $182634, $1A2836, $1A2836, $1A2836, $1B2937, $1B2937
Data $1A2939, $132232, $13212F, $13212F, $132130, $13212F, $13212F, $142230
Data $142230, $152331, $152331, $152332, $172532, $172533, $172533, $172533
Data $182634, $192735, $182635, $192735, $1A2836, $182737, $11202F, $12202E
Data $12202E, $13212F, $12202E, $12202E, $14222F, $142230, $142230, $142230
Data $162431, $162432, $162432, $162432, $162432, $172533, $172533, $182634
Data $182634, $192735, $192838, $101F2F, $111F2D, $12202D, $12202D, $111F2D
Data $12202E, $14222F, $142230, $142230, $142230, $152331, $152331, $152331
Data $152331, $162432, $162432, $162432, $182634, $182634, $192735, $1B2A3A
Data $0E1D2E, $111F2C, $111F2C, $101E2B, $111F2D, $12202E, $13212F, $14222F
Data $13212F, $14222F, $142230, $13212F, $142230, $152331, $162432, $152331
Data $162432, $182634, $192736, $1C2A38, $1B2A3A, $0F1E2E, $101E2B, $0F1D2B
Data $101E2C, $111F2C, $111F2D, $12202E, $12202E, $13212E, $13212E, $13212F
Data $142230, $152331, $152331, $142230, $162431, $192734, $1B2937, $1C2A37
Data $1C2A38, $182737, $0E1D2E, $0E1C2A, $0F1D2A, $101E2C, $111F2C, $111F2D
Data $111F2D, $111F2D, $12202D, $13212E, $12202E, $142230, $13212F, $142230
Data $152331, $182634, $1B2937, $1C2A37, $192735, $172533, $152434, $0D1C2D
Data $0E1C2A, $0F1D2A, $111F2C, $111F2C, $111F2D, $111F2C, $111F2D, $12202D
Data $13212E, $12202E, $12202E, $13212E, $162431, $192734, $192735, $1A2835
Data $162432, $152331, $162432, $1A2939, $0D1C2D, $0F1D2A, $101E2B, $12202D
Data $111F2D, $111F2C, $111F2C, $111F2D, $13212E, $13212E, $111F2C, $12202E
Data $162431, $192734, $182634, $162431, $142230, $142230, $172533, $1D2B38
Data $223141, $0D1C2C, $0F1D2A, $101E2B, $111F2C, $111F2C, $101E2C, $111F2D
Data $111F2D, $111F2D, $111F2C, $12202D, $162431, $172533, $162431, $142230
Data $14222F, $14222F, $172533, $1C2A38, $22303E, $213041, $0E1D2D, $0F1D2B
Data $101E2B, $101E2C, $111F2D, $12202D, $111F2D, $111F2D, $111F2D, $13212E
Data $162431, $182633, $172532, $14222F, $142230, $152331, $172534, $1B2936
Data $1F2D3B, $202E3C, $1A2939, $0E1D2D, $101E2A, $101E2C, $12202D, $111F2C
Data $12202D, $12202D, $12202D, $13212E, $162431, $172533, $162431, $142230
Data $13212F, $152331, $1A2835, $1B2937, $1D2B39, $1D2B38, $1A2835, $1A2939
Data $0F1E2E, $111F2C, $111F2D, $12202D, $111F2C, $111F2C, $12202D, $13212F
Data $152331, $172533, $172532, $142230, $12202E, $152330, $172533, $1C2A37
Data $1D2B38, $1B2937, $1A2836, $1C2A38, $223142, $0F1E2F, $12202E, $12202D
Data $111F2C, $12202D, $12202D, $14222F, $162431, $162432, $172532, $152330
Data $13212E, $14222F, $172532, $192734, $1D2B38, $1D2B39, $1C2A38, $212F3D
Data $263442, $273646, $101F2F, $12202D, $12202D, $111F2D, $111F2D, $13212E
Data $152330, $172532, $172532, $152330, $12202E, $13212E, $162431, $172533
Data $1A2835, $1D2B39, $212F3D, $243240, $2A3845, $2C3A48, $273646, $11202F
Data $12202D, $12202D, $12202D, $13212E, $152330, $162431, $162431, $142230
Data $13212F, $13212E, $14222F, $172532, $192734, $1C2A38, $23313E, $283643
Data $2E3C49, $303E4C, $2D3B4A, $283746, $11202F, $12202E, $111F2D, $13212E
Data $152331, $172532, $162431, $142230, $14222F, $12202E, $14222F, $172533
Data $1C2A37, $212F3C, $273542, $2C3A48, $303E4C, $313F4D, $2F3D4A, $2E3C49
Data $2A3949, $132231, $111F2C, $12202D, $14222F, $162431, $172532, $152331
Data $142230, $14222F, $13212E, $182633, $1E2C39, $23313F, $2A3846, $303E4C
Data $32404E, $34424F, $303E4D, $293745, $283644, $273646, $101F2F, $111F2C
Data $13212E, $172532, $172532, $13212F, $142230, $152330, $13212F, $172532
Data $202E3B, $273542, $2D3B48, $32404D, $34424F, $344250, $34424F, $303E4B
Data $2A3845, $253340, $1E2E3D, $101F2F, $13212E, $152330, $152330, $14222F
Data $142230, $172532, $182633, $182632, $1E2C38, $283643, $303E4B, $33414E
Data $354350, $354350, $354350, $354350, $313F4C, $2B3946, $23313E, $1C2B3A
Data $112030, $13212E, $142230, $162430, $172532, $1C2A37, $202E3B, $202E3B
Data $23313E, $293744, $303E4C, $354350, $354350, $354350, $354350, $354350
Data $354350, $313F4C, $283644, $22303E, $1F2E3E, $122130, $14222F, $162431
Data $1C2A37, $212F3C, $253340, $2A3846, $2D3B48, $313F4C, $34424F, $354350
Data $364451, $354350, $34424F, $34424F, $33414E, $354350, $32404D, $2A3845
Data $24323F, $213040, $122130, $1B2936, $212F3C, $22303D, $22303E, $24323F
Data $2C3A47, $33414F, $344250, $34424F, $354350, $354350, $34424F, $354350
Data $34424F, $33414E, $34424E, $313F4D, $2D3B48, $263441, $223141, $1A2938
Data $202E3B, $212F3C, $1F2D3A, $1F2D3A, $253341, $2F3D4A, $344250, $344250
Data $354350, $34424F, $354350, $34424F, $34424F, $34424F, $33414E, $32404D
Data $2E3C49, $283642, $1F2D3B, $1C2B3B, $1E2E3D, $1D2B38, $192734, $1C2A37
Data $24323F, $2D3B48, $354350, $364451, $354350, $354350, $33414F, $344250
Data $34424F, $33414E, $34424F, $32404E, $2B3946, $23313E, $1D2B38, $152330
Data $0F1E2E, $172635, $152330, $1E2C39, $293744, $303E4B, $33414E, $313F4C
Data $32404D, $34424F, $34424F, $354350, $344250, $33414F, $33414E, $34424F
Data $2D3B49, $202E3B, $152330, $111F2C, $0F1D2A, $0A1A29, $152433, $1D2B38
Data $2A3845, $313F4C, $313F4C, $2E3C49, $2D3B48, $2D3B48, $2F3D4A, $303E4B
Data $303E4B, $2D3B48, $2D3B48, $33414E, $2F3D49, $23313E, $1A2835, $101E2B
Data $0C1A26, $0B1926, $0B1A2A, $1E2E3D, $293744, $2E3C49, $2C3A47, $283643
Data $263441, $293744, $293744, $293744, $283643, $253340, $1F2D3A, $263441
Data $303E4B, $24323F, $172532, $12202D, $0F1D2A, $0B1926, $0A1825, $0D1C2C
Data $1F2E3E, $253340, $24323F, $23313E, $23313E, $24323F, $273542, $273542
Data $243240, $202E3C, $1B2936, $1A2835, $283643, $283643, $182634, $12202D
Data $101E2B, $0F1D2A, $0E1C29, $0C1A27, $0E1D2D, $1A2938, $1B2936, $1B2936
Data $1F2D3A, $212F3C, $24323F, $24323F, $23313E, $1E2C39, $1A2835, $182633
Data $1C2A37, $2B3946, $1F2D3A, $111F2C, $111F2C, $111F2C, $101E2B, $0E1C2A
Data $0D1B28, $0E1D2D, $152433, $182633, $182633, $1C2A37, $212F3C, $22303D
Data $1E2C39, $1A2836, $192734, $182634, $172532, $1E2C39, $293744, $182633
Data $0F1D2A, $12202D, $111F2C, $0F1D2A, $0E1C2A, $0E1C29, $0D1C2C, $152433
Data $192734, $1C2A37, $1E2C39, $1E2C39, $1B2936, $182633, $162431, $192734
Data $1A2836, $152330, $1B2936, $24323F, $14222F, $101E2B, $101E2B, $101E2B
Data $0E1C29, $0E1C28, $0D1B28, $0D1C2C, $182736, $1C2A37, $1C2A37, $1D2B38
Data $182633, $182633, $172532, $162431, $182633, $162432, $12202D, $1D2B38
Data $212F3C, $13212E, $101E2B, $0F1D2A, $0F1D2A, $0E1C29, $0D1B28, $0C1A27
Data $0C1B2B, $1C2B3A, $1D2B38, $1A2835, $182633, $182633, $182633, $152330
Data $182633, $172532, $152330, $1B2936, $253340, $1D2B38, $0F1D2A, $101E2B
Data $111F2C, $0E1C29, $0F1D2A, $0D1B28, $0D1B28, $0B1A2A, $1C2B3A, $1C2A37
Data $1B2936, $1C2A37, $1D2B38, $1F2D3A, $1F2D3A, $1C2A37, $1A2835, $1E2C39
Data $253340, $212F3C, $14222F, $0F1D2A, $111F2C, $0F1D2A, $0F1D2A, $0F1D2A
Data $0C1A27, $0C1A27, $0A1A29, $1C2C3E, $1D2D3C, $213040, $243343, $253444
Data $263545, $223141, $1D2C3C, $1F2E3E, $253444, $213040, $162535, $0F1E2E
Data $101F2F, $101F2F, $0E1D2D, $0F1E2E, $0C1C2B, $0B1B2A, $0A1A29, $0C1C2E


.BCF_ButtonBackgroundOn_Style01
Data 80
Data 35
Data $7097B4, $6C96B3, $6693B2, $6192B1, $5C91B1, $588FB1, $528EB1, $4E8DB1
Data $4B8BB1, $468AB1, $4289B2, $3C88B2, $3886B3, $3586B4, $3286B5, $3085B6
Data $177BB4, $0070B1, $0070B2, $0074B5, $0076B7, $0279BA, $047CBC, $0680BF
Data $0983C2, $0A85C4, $0C87C6, $0E89C8, $0F8BCA, $108ECC, $128FCD, $1291CF
Data $1392D1, $1495D4, $1494D5, $7096B4, $6C95B3, $6693B2, $6191B2, $5C90B2
Data $588FB1, $528EB0, $4E8CB0, $4B8BB1, $468AB2, $4288B2, $3C87B2, $3886B3
Data $3585B4, $3285B5, $2F85B6, $177CB4, $0071B1, $0070B2, $0074B5, $0076B7
Data $0379BA, $057DBC, $0780BF, $0A83C2, $0B85C5, $0D88C7, $0F8AC9, $118CCB
Data $138ECE, $1490CF, $1693D2, $1695D4, $1797D5, $1696D5, $7096B4, $6C95B3
Data $6692B2, $6190B1, $5C8EB1, $578DB1, $528DB1, $4E8CB0, $4B8BB0, $4689B1
Data $4288B2, $3C86B3, $3886B4, $3586B5, $3285B5, $3085B5, $177CB3, $0071B1
Data $0070B3, $0074B6, $0177B8, $037ABB, $057DBD, $0981C0, $0C84C3, $0D86C5
Data $0E89C8, $108BCA, $118DCC, $1390CF, $1492D1, $1694D4, $1796D5, $1899D5
Data $1898D5, $7095B5, $6C94B3, $6691B1, $6190B1, $5C8EB1, $588DB1, $528BB1
Data $4E8BB1, $4B8BB1, $468AB1, $4288B2, $3C87B2, $3886B3, $3585B4, $3285B5
Data $2F85B6, $187BB4, $0070B1, $0070B2, $0074B5, $0177B7, $047ABA, $067DBD
Data $0981C1, $0C84C4, $0C86C6, $0F89C9, $118CCB, $138FCD, $1592D0, $1593D2
Data $1796D4, $1998D5, $1B9BD5, $1A9BD5, $7094B5, $6C93B3, $6691B1, $618FB1
Data $5C8CB1, $588BB0, $528AB0, $4E8AB0, $4B8AB1, $4689B1, $4187B1, $3B86B2
Data $3785B3, $3585B4, $3285B5, $2F85B6, $187BB3, $0070B0, $0070B2, $0074B5
Data $0177B7, $047ABA, $067DBD, $0981C1, $0C84C4, $0E86C5, $1089C8, $128CCB
Data $148FCE, $1692D1, $1793D3, $1996D5, $1B9AD5, $1D9DD5, $1C9CD5, $7094B4
Data $6C93B2, $6690B1, $618EB1, $5C8CB1, $588BB0, $528AB0, $4E89B0, $4B89B0
Data $4689B0, $4288B2, $3C87B2, $3885B3, $3585B4, $3285B5, $2F85B6, $187BB3
Data $0070B0, $006FB1, $0073B4, $0177B6, $047AB9, $077DBD, $0A81C1, $0D84C4
Data $0F86C6, $1189C9, $138CCC, $158FCE, $1793D1, $1896D3, $1A99D5, $1C9BD5
Data $1E9ED5, $1D9ED5, $7093B4, $6C92B2, $6690B1, $618EB1, $5C8BB1, $588AAF
Data $5289AF, $4E89AF, $4B88B0, $4688B1, $4287B2, $3C86B3, $3885B3, $3584B3
Data $3284B3, $3085B5, $187BB3, $0070B0, $006FB2, $0073B5, $0076B7, $0379BA
Data $077CBD, $0B80C0, $0E84C3, $0F87C6, $118AC9, $138CCB, $158FCE, $1892D2
Data $1996D4, $1B99D5, $1D9BD5, $209FD5, $1F9FD5, $6F93B4, $6B92B2, $668FB1
Data $618DB0, $5C8AB0, $5889B0, $5288B0, $4E88AF, $4B87AF, $4687B0, $4287B1
Data $3C86B1, $3884B2, $3584B3, $3284B4, $2F84B5, $187AB3, $006FB0, $006FB1
Data $0073B4, $0276B7, $0579BA, $077DBD, $0A81C0, $0D84C3, $1086C5, $1289C8
Data $148CCB, $168FCE, $1993D1, $1A96D4, $1D99D6, $1F9BD5, $21A0D5, $20A1D5
Data $6F92B4, $6C91B2, $668EB1, $618CB0, $5B8AB0, $5789AF, $5188AF, $4D87AF
Data $4A86AF, $4686B0, $4286B2, $3C86B2, $3885B2, $3585B2, $3284B3, $3083B4
Data $1879B2, $006FAF, $006FB0, $0073B3, $0275B5, $0578B8, $077BBC, $0A80BF
Data $0E84C2, $1086C5, $1389C8, $168DCB, $1890CE, $1993D1, $1A96D4, $1D99D6
Data $209DD5, $22A1D5, $21A1D5, $6F92B3, $6C91B1, $668EB0, $618CAF, $5B89AF
Data $5788AF, $5187AF, $4D86AF, $4A86AF, $4586AF, $4286B1, $3C85B2, $3884B2
Data $3584B3, $3284B3, $3083B4, $1979B2, $006EAF, $006EB0, $0072B3, $0275B4
Data $0578B7, $087CBB, $0B80BF, $0E83C3, $0F86C4, $128AC7, $158DCB, $1790CE
Data $1993D1, $1C96D4, $1E9AD6, $209ED5, $23A2D5, $22A2D5, $6F92B2, $6C90B1
Data $668DB0, $618BAF, $5B89AF, $5788AE, $5186AE, $4D85AE, $4A85AE, $4585AF
Data $4185B0, $3C85B0, $3885B1, $3585B2, $3284B3, $3083B4, $1879B0, $006FAD
Data $006EAE, $0071B1, $0374B4, $0577B7, $077BBA, $0B7FBE, $0F83C1, $1185C3
Data $1388C7, $158CCB, $1790CF, $1A94D2, $1D97D4, $209BD5, $229FD5, $24A3D5
Data $23A3D5, $6F91B2, $6C90B1, $668DB0, $618BAF, $5B89AF, $5788AE, $5186AE
Data $4D85AE, $4A84AE, $4584AF, $4284B0, $3C84B0, $3884B1, $3584B2, $3284B3
Data $3083B4, $1879B0, $006EAD, $006DAE, $0071B1, $0275B3, $0578B6, $087AB9
Data $0B7FBD, $0E83C1, $1186C4, $1389C7, $158CCA, $1890CD, $1B94D1, $1D97D4
Data $1F9AD6, $219ED5, $24A3D5, $23A4D5, $6F91B2, $6B8FB1, $658CB0, $608AAF
Data $5B88AF, $5787AE, $5185AD, $4D84AD, $4A83AD, $4583AE, $4283B0, $3C83B1
Data $3783B1, $3583B2, $3283B2, $2F82B2, $1878B0, $006DAD, $006DAD, $0071B0
Data $0274B2, $0677B5, $097AB9, $0B7EBD, $0E82C1, $1184C4, $1488C7, $168CCA
Data $198FCE, $1C94D2, $1D97D4, $1F9CD5, $229FD5, $26A4D5, $26A5D5, $6F90B3
Data $6B8FB1, $658CAF, $608AAE, $5B88AE, $5787AE, $5185AE, $4D84AD, $4A83AD
Data $4583AE, $4183AF, $3B83AF, $3783B0, $3583B1, $3283B2, $3082B3, $1878AF
Data $006CAC, $006CAD, $0070B0, $0273B1, $0576B4, $087AB8, $0B7EBC, $0E82C0
Data $1084C3, $1388C6, $168CC9, $1890CD, $1B93D1, $1E96D3, $219BD5, $23A0D5
Data $26A5D5, $26A5D5, $6F90B2, $6B8FB0, $658CAF, $608AAE, $5B87AE, $5786AD
Data $5184AD, $4D83AD, $4982AD, $4482AD, $4182AE, $3B82AF, $3782B0, $3583B1
Data $3283B1, $2F82B2, $1878AE, $006CAB, $006BAC, $006FAF, $0172B1, $0475B4
Data $0779B7, $0A7EBB, $0E82C0, $1185C3, $1488C6, $168BC9, $188FCC, $1B94D1
Data $1E97D4, $219CD6, $249FD5, $27A4D5, $26A4D5, $6F90B2, $6B8EB0, $658BAF
Data $6088AE, $5B86AD, $5785AD, $5184AD, $4D83AD, $4982AD, $4482AD, $4182AE
Data $3B82AF, $3782B0, $3582B1, $3282B1, $2F81B2, $1877AE, $006BAB, $006AAB
Data $006EAE, $0171B1, $0475B4, $0779B7, $0B7DBA, $0E80BE, $1084C1, $1387C5
Data $158BC9, $188FCD, $1C93D1, $1E97D4, $219BD6, $249FD5, $27A5D5, $26A5D5
Data $6F8FB1, $6B8EB0, $658BAF, $6089AE, $5B86AE, $5784AD, $5183AD, $4D83AD
Data $4982AD, $4482AD, $4181AE, $3B80AE, $3780AF, $3581B0, $3282B0, $2F81B2
Data $1877AE, $006BA9, $006BAA, $006FAD, $0171B0, $0474B3, $0778B6, $0B7CB9
Data $0E80BD, $1083C1, $1386C5, $158AC8, $188ECB, $1C93D0, $1E96D4, $219BD6
Data $239FD5, $26A5D5, $26A5D5, $6F8FB2, $6B8EB0, $658BAF, $6089AE, $5B86AD
Data $5786AD, $5184AD, $4D82AC, $4981AC, $4481AC, $4180AD, $3B80AE, $3781AF
Data $3581B0, $3281B0, $2F80B1, $1876AD, $006AA8, $006AA9, $006EAD, $0271AF
Data $0574B2, $0777B5, $0A7BB8, $0D7FBD, $1183C0, $1487C5, $168BC8, $188ECC
Data $1B93D1, $1E96D4, $219AD6, $239ED5, $27A4D5, $27A4D5, $6F8FB2, $6B8EB0
Data $658BAE, $6089AD, $5B86AD, $5686AC, $5184AC, $4D82AC, $4981AC, $4481AC
Data $4180AD, $3B80AD, $3780AE, $3581AF, $3281B0, $2F81B1, $1876AD, $006AA8
Data $006AA9, $006EAC, $0170AE, $0473B1, $0677B4, $097BB8, $0D80BC, $1083C0
Data $1387C4, $168AC8, $198DCC, $1C92D0, $1E96D3, $219BD5, $239FD5, $27A4D5
Data $27A4D5, $6F8FB2, $6B8EB0, $658BAE, $6089AD, $5B86AD, $5785AC, $5182AC
Data $4D81AC, $4981AC, $4481AC, $4180AC, $3B80AD, $3780AE, $3580AF, $3280AF
Data $2F80B0, $1776AC, $006AA7, $0069A8, $006DAB, $0170AE, $0473B1, $0776B4
Data $097BB7, $0C7FBC, $0F82BF, $1386C4, $168AC8, $198ECC, $1C93D0, $1F97D3
Data $229CD5, $249FD5, $27A5D5, $27A5D5, $6F8FB2, $6B8EB0, $658BAE, $6089AD
Data $5B86AD, $5685AC, $5182AC, $4D81AC, $4981AC, $4481AC, $4080AD, $3A80AD
Data $3680AD, $3480AE, $3180B0, $2F80B1, $1776AD, $006AA8, $0069A8, $006DAB
Data $006FAD, $0372B0, $0676B4, $097BB7, $0D80BB, $1083BE, $1386C3, $1689C7
Data $198DCB, $1C93D0, $1F97D4, $219CD6, $239FD5, $27A5D5, $27A5D5, $6F8FB1
Data $6B8EAF, $658BAE, $6089AD, $5B86AD, $5685AC, $5083AC, $4C81AC, $4980AC
Data $4480AC, $4080AC, $3A80AC, $367FAD, $3480AE, $3180AF, $2F80B0, $1776AC
Data $006AA7, $0069A8, $006DAB, $016FAD, $0472B0, $0675B3, $0979B6, $0D7EBB
Data $1082BE, $1387C3, $168AC8, $198DCB, $1C92D0, $1F96D4, $229BD6, $249FD5
Data $27A5D5, $27A5D5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5785AC
Data $5183AC, $4D81AC, $4980AC, $4480AC, $4180AC, $3B80AC, $367FAD, $3480AE
Data $3180AF, $2F80B0, $1776AC, $006AA8, $0069A8, $006CAB, $016FAD, $0472B0
Data $0676B3, $097AB7, $0D7FBC, $1082BF, $1387C4, $168AC8, $188ECC, $1B93D1
Data $1F96D4, $229BD6, $249FD5, $27A5D5, $27A5D5, $6F8FB2, $6B8EB0, $658BAE
Data $6089AD, $5B86AD, $5685AC, $5183AB, $4D81AB, $4980AC, $4480AC, $407FAC
Data $3A7FAC, $367FAD, $347FAE, $317FAF, $2F80B0, $1875AC, $0069A7, $0068A7
Data $006CAA, $006FAC, $0372AF, $0675B3, $097AB7, $0D7FBB, $1082BF, $1386C3
Data $158AC7, $188ECB, $1C93D0, $1E96D4, $219BD6, $249FD5, $27A6D5, $27A6D5
Data $6F8FB1, $6B8EAF, $658BAE, $6089AD, $5B86AD, $5685AC, $5182AC, $4D81AC
Data $4981AC, $4481AC, $407FAC, $3A7FAD, $367FAE, $347FAE, $317FAE, $2F7FAF
Data $1775AC, $0069A8, $0068A8, $006CAB, $016FAC, $0472AF, $0775B3, $0A7AB8
Data $0D7FBC, $1082BF, $1386C3, $158AC7, $188ECB, $1C93D0, $1F96D4, $229BD6
Data $24A0D5, $27A6D5, $27A6D5, $6F8FB1, $6B8EAF, $658BAE, $6089AD, $5B86AD
Data $5685AC, $5083AC, $4C81AC, $4980AC, $4480AC, $4080AC, $3A80AD, $367FAE
Data $347FAE, $317FAE, $2F7FAF, $1775AC, $0069A8, $0068A8, $006CAA, $006FAC
Data $0372AF, $0675B3, $0A79B8, $0E7FBD, $1082C0, $1387C3, $168AC7, $198DCB
Data $1C92D0, $1F97D4, $229CD6, $24A0D5, $27A6D5, $27A6D5, $6F8FB1, $6B8EAF
Data $658BAE, $6089AD, $5B86AD, $5685AC, $5082AB, $4C81AB, $4981AC, $4481AC
Data $4080AC, $3A7FAC, $367EAD, $347FAE, $317FAF, $2F7FB0, $1875AC, $0069A8
Data $0068A8, $006CAA, $006FAC, $0372AF, $0775B2, $0A7AB6, $0D7FBC, $1082BF
Data $1386C4, $168AC7, $198ECC, $1C93D1, $1E96D4, $219CD6, $24A1D5, $27A7D5
Data $27A7D5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5785AC, $5183AB
Data $4D81AB, $4980AC, $4480AC, $407FAC, $3A7FAD, $367FAE, $347FAF, $317FAF
Data $2E7FB0, $1775AC, $0069A7, $0068A7, $006BAA, $016EAC, $0472AF, $0676B2
Data $0979B6, $0D7EBB, $1081BF, $1386C4, $168BC8, $198ECD, $1C93D2, $1F97D4
Data $229CD6, $24A1D5, $27A7D5, $26A7D5, $6F8FB1, $6B8DAF, $658AAE, $6088AD
Data $5B86AD, $5685AC, $5083AC, $4C81AC, $4980AC, $4480AC, $407FAC, $3A7FAC
Data $367FAD, $357FAE, $327FAF, $2F7FB0, $1775AC, $0069A7, $0068A7, $006CAA
Data $016EAB, $0471AE, $0775B2, $0A7AB7, $0D7FBC, $1081BF, $1386C4, $168BC8
Data $198FCD, $1C94D2, $1F98D4, $229DD6, $24A2D5, $27A7D5, $26A7D5, $6F8FB1
Data $6B8DAF, $658AAE, $6088AD, $5B86AD, $5684AC, $5182AC, $4D81AC, $4980AC
Data $4480AC, $407FAC, $3A7EAC, $367EAD, $347FAE, $317FAE, $2E7FB0, $1775AC
Data $0069A7, $0068A7, $006CAA, $016EAB, $0471AF, $0775B3, $0A7AB7, $0D7FBC
Data $1081BF, $1386C4, $168BC8, $198FCC, $1C94D1, $1F98D4, $229DD6, $24A2D5
Data $27A8D5, $27A8D5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5785AC
Data $5183AC, $4D81AC, $4980AC, $4480AC, $417FAC, $3B7EAD, $367EAE, $347FAE
Data $317FAE, $2E7FB0, $1775AC, $0069A7, $0068A7, $006CA9, $016EAB, $0471AF
Data $0675B3, $097AB7, $0D7FBC, $1082C0, $1387C5, $168BC9, $198FCD, $1C94D1
Data $1F98D4, $229DD6, $24A2D5, $27A8D5, $27A8D5, $6F8FB1, $6B8DAF, $658AAE
Data $6088AD, $5B86AD, $5685AC, $5182AC, $4D81AC, $4981AC, $4481AC, $4080AC
Data $3A7FAD, $367EAE, $347FAE, $317FAE, $2E7FB0, $1774AB, $0068A6, $0068A7
Data $006CAA, $016EAB, $0471AF, $0775B3, $0A7AB7, $0D80BB, $1083BE, $1387C4
Data $168BC9, $198FCE, $1C95D2, $1E99D5, $219ED5, $25A2D5, $28A9D5, $28A9D5
Data $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5685AC, $5083AC, $4C81AC
Data $4980AC, $4480AC, $407FAC, $3A7EAD, $367EAE, $347FAE, $317FAE, $2E7FAF
Data $1775AB, $0069A6, $0068A7, $006CAA, $016FAC, $0472AF, $0676B2, $097AB6
Data $0D7FBC, $1082BF, $1387C4, $168BC9, $198FCE, $1C94D2, $1F98D5, $229DD5
Data $25A2D5, $28A9D5, $28A9D5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD
Data $5785AC, $5183AB, $4D81AB, $4980AC, $4480AC, $417FAC, $3B7FAC, $367FAD
Data $347FAE, $327FAE, $307FB0, $1775AB, $0069A6, $0068A7, $006CAA, $016FAC
Data $0472AF, $0675B3, $097AB8, $0D80BD, $1083C0, $1388C5, $168CC9, $1990CE
Data $1C95D2, $1F99D5, $229ED5, $25A3D5, $28A9D5, $28A9D5, $6F8FB1, $6B8DAF
Data $658AAE, $6088AD, $5B86AD, $5685AC, $5082AC, $4C81AC, $4981AC, $4481AC
Data $4080AC, $3A7FAD, $367FAE, $347FAF, $317FAF, $2E7FB0, $1775AB, $0069A6
Data $0068A7, $006CAB, $006EAC, $0372AF, $0676B3, $097BB7, $0D80BC, $1083C0
Data $1388C5, $168CCA, $1990CF, $1C95D3, $1F9AD5, $229FD5, $24A4D5, $27AAD5
Data $27AAD5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5685AC, $5083AC
Data $4C81AC, $4980AC, $4480AC, $407FAC, $3A7EAC, $367EAD, $347EAE, $317EAF
Data $2E7FB0, $1775AB, $0069A6, $0068A7, $006CAA, $016EAC, $0472AF, $0676B3
Data $097BB7, $0D80BD, $1182C1, $1487C6, $168CCA, $1991CF, $1D96D3, $209AD5
Data $229FD5, $24A4D5, $27AAD5, $27AAD5, $6F8FB1, $6B8DAF, $658AAE, $6088AD
Data $5B86AD, $5685AC, $5183AC, $4D82AC, $4981AC, $4480AC, $4080AC, $3A80AC
Data $367FAD, $347EAE, $317EAE, $2E7FB0, $1775AC, $0069A7, $0069A7, $006DAA
Data $016FAC, $0472AF, $0776B3, $0B7AB7, $0E80BD, $1084C1, $1389C6, $168DCA
Data $1990CF, $1D95D3, $209AD5, $239FD5, $25A4D5, $28AAD5, $28AAD5, $6F8FB1
Data $6B8DAF, $658AAE, $6088AD, $5B86AD, $5685AC, $5183AC, $4D81AC, $4980AC
Data $4480AC, $4180AC, $3B80AC, $367FAD, $347FAE, $317FAE, $2E7FB0, $1775AC
Data $0069A7, $0068A8, $006CAB, $016FAC, $0472B0, $0676B4, $0A7BB8, $0E80BD
Data $1183C1, $1488C6, $178DCB, $1A91D0, $1D96D4, $209BD5, $23A0D5, $25A5D5
Data $28ABD5, $28ABD5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5785AC
Data $5183AC, $4D81AC, $4980AC, $4480AC, $407FAC, $3A7EAC, $367EAD, $347FAE
Data $317FAF, $2F7FB0, $1775AC, $006AA7, $0069A7, $006CAA, $016FAC, $0472B0
Data $0676B4, $0A7BB9, $0E80BE, $1083C1, $1388C6, $178DCB, $1A92D1, $1D97D5
Data $1F9BD5, $22A0D5, $24A5D5, $27ABD5, $27ABD5, $6F8FB1, $6B8DAF, $658AAE
Data $6088AD, $5B86AD, $5785AC, $5283AB, $4D81AB, $4880AC, $4380AC, $4080AC
Data $3A80AC, $367FAD, $347FAE, $317FAF, $2E7FB0, $1775AC, $0069A7, $0068A7
Data $006CAA, $006FAD, $0372B0, $0776B4, $0B7AB8, $0E80BD, $1184C2, $1489C8
Data $178DCC, $1A91D1, $1D97D5, $1F9CD5, $22A1D5, $25A6D5, $28ACD5, $28ACD5
Data $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5685AC, $5182AC, $4D81AC
Data $4981AC, $4481AC, $4080AC, $3A7FAC, $367EAD, $347FAE, $317FAE, $2E7FB0
Data $1775AC, $0069A7, $0068A7, $006CAA, $006FAD, $0372B0, $0776B4, $0B7AB8
Data $0E80BD, $1184C2, $148AC8, $178ECC, $1B92D1, $1E97D5, $209CD5, $23A1D5
Data $25A6D5, $28ACD5, $28ACD5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD
Data $5785AC, $5183AC, $4D81AC, $4980AC, $4480AC, $407FAC, $3A7EAC, $367EAD
Data $347EAE, $317EAF, $2E7FB0, $1775AC, $0069A7, $0069A7, $006DAA, $016FAD
Data $0473B0, $0777B4, $0A7BB8, $0E80BD, $1184C1, $1489C7, $178ECC, $1B92D1
Data $1E98D5, $209DD5, $23A2D5, $26A6D5, $29ACD5, $28ACD5, $6F8FB1, $6B8DAF
Data $658AAE, $6088AD, $5B86AD, $5685AC, $5183AC, $4D81AC, $4980AC, $4480AC
Data $407FAC, $3A7EAC, $367EAD, $347EAE, $317EAF, $2E7FB0, $1775AC, $0069A7
Data $0068A7, $006CAA, $006FAD, $0372B0, $0776B4, $0B7AB8, $0E80BE, $1184C3
Data $1489C8, $178ECC, $1A92D1, $1D98D5, $219DD5, $23A2D5, $25A7D5, $28ADD5
Data $28ADD5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5684AC, $5082AC
Data $4C81AC, $4980AC, $4480AC, $4080AC, $3A80AC, $367FAD, $347FAE, $317FAE
Data $2E7FB0, $1775AC, $0069A7, $0068A8, $006CAB, $016FAD, $0472B0, $0776B4
Data $0A7BB9, $0E81BF, $1185C3, $148AC9, $178ECD, $1A92D2, $1D98D5, $209DD5
Data $23A2D5, $26A7D5, $29ADD5, $28ADD5, $6F8FB1, $6B8DAF, $658AAE, $6088AD
Data $5B86AD, $5685AC, $5083AC, $4C81AC, $4980AC, $4480AC, $407FAC, $3A7EAC
Data $367EAD, $347FAE, $317FAF, $2E7FB0, $1775AC, $0069A7, $0068A7, $006CAA
Data $016FAC, $0473B0, $0777B4, $0A7BB9, $0E81BF, $1285C3, $158BC9, $178FCD
Data $1A93D2, $1D98D5, $209CD5, $23A2D5, $25A7D5, $28ADD5, $28ADD5, $6F8FB1
Data $6B8DAF, $658AAE, $6088AD, $5B86AD, $5685AC, $5183AC, $4D81AC, $4980AC
Data $4480AC, $407FAC, $3A7EAC, $367EAD, $347FAE, $317FAF, $2E7FB0, $1775AC
Data $0069A7, $0068A7, $006CAA, $016FAD, $0472B0, $0776B4, $0A7BB9, $0E81BF
Data $1185C3, $148AC9, $178FCD, $1B94D2, $1E99D5, $209DD5, $23A2D5, $26A7D5
Data $29AED5, $28AED5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5685AC
Data $5083AC, $4C81AC, $4980AC, $4480AC, $407FAC, $3A7EAC, $367EAD, $347FAE
Data $317FAE, $2F7FB0, $1775AC, $0069A8, $0068A8, $006CAB, $016FAD, $0473B0
Data $0777B4, $0A7BB8, $0E81BE, $1185C2, $158BC8, $188FCD, $1B93D3, $1E98D6
Data $209DD5, $23A2D5, $25A7D5, $28ADD5, $27ADD5, $6F8FB1, $6B8DAF, $658AAE
Data $6088AD, $5B86AD, $5685AC, $5083AC, $4C81AC, $4980AC, $4480AC, $4180AC
Data $3B80AC, $377FAD, $357FAE, $327FAE, $2F7FB0, $1775AC, $0069A8, $0069A8
Data $006DAB, $016FAD, $0472B0, $0676B4, $097CB8, $0D82BE, $1185C2, $158AC8
Data $188ECD, $1B93D2, $1E99D5, $209DD5, $23A2D5, $25A6D5, $28ADD5, $28AED5
Data $6F8FB1, $6B8DAF, $658AAE, $6087AD, $5B85AD, $5685AC, $5083AC, $4C81AC
Data $4980AC, $4480AC, $407FAC, $3A7EAC, $367EAD, $347FAE, $317FAE, $2E7FB0
Data $1775AC, $0069A8, $0068A8, $006CAA, $016FAD, $0472B1, $0776B5, $0A7BB9
Data $0E81BF, $1184C3, $158AC9, $188FCE, $1B94D2, $1E9AD5, $209ED5, $23A3D5
Data $26A7D5, $29AED5, $28AED5, $6F8FB1, $6B8DAF, $658AAE, $6087AD, $5B85AD
Data $5685AC, $5083AC, $4C81AC, $4980AC, $4480AC, $4080AC, $3A80AC, $367FAD
Data $347FAE, $317FAE, $2E7FB0, $1775AC, $0069A7, $0068A7, $006CAA, $006FAD
Data $0373B0, $0677B4, $0A7BB9, $0E81BF, $1185C4, $148ACA, $178FCE, $1A94D2
Data $1D99D5, $209DD5, $23A3D5, $26A8D5, $29AED5, $28AED5, $6F8FB1, $6B8DAF
Data $658AAE, $6088AD, $5B85AD, $5684AC, $5182AC, $4D81AC, $4980AC, $4480AC
Data $417FAC, $3B7EAC, $367EAD, $347FAE, $317FAF, $2E7FB0, $1775AC, $006AA8
Data $0069A8, $006CAA, $016FAD, $0473B1, $0777B5, $0A7CBA, $0E82C0, $1186C4
Data $158BCA, $188FCE, $1B94D2, $1E9AD5, $209ED5, $23A3D5, $26A8D5, $29AED5
Data $28AED5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B85AD, $5684AC, $5182AC
Data $4D81AC, $4980AC, $4480AC, $4080AC, $3A80AC, $367FAD, $347FAE, $317FAF
Data $2E7FB0, $1775AC, $0069A7, $0069A7, $006DAA, $0170AE, $0473B1, $0777B5
Data $0A7CB9, $0E82BF, $1286C4, $158BCA, $188FCE, $1A94D2, $1D9AD5, $219ED5
Data $23A3D5, $25A8D5, $28AED5, $28AED5, $6F8FB1, $6B8DAF, $658AAE, $6088AD
Data $5B85AD, $5784AC, $5182AC, $4D81AC, $4980AC, $4480AC, $417FAC, $3B7FAC
Data $367FAD, $347FAE, $317FAE, $2E7FB0, $1775AC, $006AA8, $0069A8, $006DAB
Data $0170AE, $0473B1, $0677B5, $0A7CBA, $0E82C0, $1186C4, $148BCA, $178FCE
Data $1A94D3, $1D9AD6, $219ED5, $24A3D5, $26A8D5, $29AFD5, $28AFD5, $6F8FB1
Data $6B8DAF, $658AAE, $6088AD, $5B85AD, $5684AC, $5182AC, $4D81AC, $4980AC
Data $4480AC, $417FAC, $3B7EAC, $367EAD, $347FAE, $317FAF, $2E7FB0, $1775AC
Data $0069A7, $0069A8, $006DAB, $0170AE, $0473B1, $0777B5, $0A7CBA, $0E82C0
Data $1186C4, $158BCA, $1890CE, $1A95D3, $1D9AD6, $219DD5, $24A3D5, $26A9D5
Data $29AFD5, $28AFD5, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B85AD, $5784AC
Data $5182AC, $4D81AC, $4980AC, $4480AC, $407FAC, $3A7EAC, $367EAD, $347FAE
Data $317FAF, $2E7FB0, $1775AC, $0069A7, $0069A8, $006DAB, $0070AE, $0373B1
Data $0777B5, $0A7CBA, $0E82C0, $1286C5, $158BCB, $1890CF, $1A95D3, $1D9BD6
Data $219ED5, $24A4D5, $26A9D5, $29AFD5, $28AFD6, $6F8FB1, $6B8DAF, $658AAE
Data $6088AD, $5B85AD, $5784AC, $5182AC, $4D81AC, $4980AC, $4480AC, $407FAC
Data $3B7EAC, $377EAD, $347FAE, $317FAE, $2E7FB0, $1775AC, $0069A7, $0069A7
Data $006DAA, $0070AD, $0373B2, $0777B6, $0B7DBA, $0F83C0, $1286C4, $158BCA
Data $1890CF, $1B95D3, $1E9AD6, $219ED5, $24A4D5, $26AAD5, $29B0D5, $28AFD6
Data $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD, $5684AC, $5082AC, $4C81AC
Data $4980AC, $4480AC, $4180AC, $3B80AC, $367FAD, $347FAE, $317FAE, $2F7FB0
Data $1775AC, $0069A8, $0069A9, $006DAC, $0170AE, $0473B1, $0777B5, $0A7DBA
Data $0E83C0, $1286C5, $158BCB, $1790CF, $1A95D3, $1D9BD6, $219ED5, $24A4D5
Data $26A9D5, $29AFD5, $28AFD6, $6F8FB1, $6B8DAF, $658AAE, $6088AD, $5B86AD
Data $5685AC, $5183AC, $4D81AC, $4980AC, $4480AC, $407FAC, $3A7FAD, $367FAE
Data $347FAE, $317FAE, $2F80B0, $1875AC, $0069A7, $0069A8, $006DAB, $0170AE
Data $0474B2, $0778B6, $0B7DBB, $0F83C1, $1286C6, $158CCC, $1891D0, $1B95D4
Data $1E9AD5, $229ED5, $25A4D5, $26AAD5, $29B0D5, $28B0D6, $6F8FB1, $6B8DAF
Data $658AAE, $6088AD, $5B86AD, $5685AC, $5083AC, $4C81AC, $4980AC, $4480AC
Data $407FAC, $3A7FAD, $367FAE, $3480AF, $3180AF, $2F80B0, $1776AC, $006AA8
Data $0069A8, $006DAB, $0171AF, $0474B2, $0778B6, $0A7DBB, $0E83C1, $1286C6
Data $158BCC, $1890D0, $1B95D4, $1E9BD5, $219FD5, $24A5D5, $27AAD5, $29B0D5
Data $28B0D6, $6F8FB2, $6B8DB0, $658AAE, $6088AD, $5B86AD, $5685AC, $5082AC
Data $4C81AC, $4981AC, $4481AC, $407FAC, $3A7FAD, $367FAE, $347FAE, $317FAE
Data $2F80AF, $1776AC, $006AA8, $0069A8, $006DAB, $0170AE, $0474B2, $0778B6
Data $0B7EBC, $0F84C2, $1287C6, $158CCC, $1890D0, $1B95D4, $1E9BD5, $219FD5
Data $24A5D5, $27AAD5, $29B0D5, $28B0D6, $6F8FB2, $6B8EB0, $658BAE, $6089AD
Data $5B86AD, $5685AC, $5083AC, $4C81AC, $4980AC, $4480AC, $407FAC, $3A7FAC
Data $367FAD, $3480AE, $3180AF, $2F80B0, $1776AC, $006AA7, $0069A8, $006DAC
Data $0170AF, $0474B2, $0778B6, $0B7DBC, $0F83C2, $1287C7, $158CCD, $1891D1
Data $1B96D4, $1E9CD5, $219FD5, $24A5D5, $26AAD5, $29B0D5, $29B0D6, $6F8FB2
Data $6B8EB0, $658BAE, $6089AD, $5B86AD, $5685AC, $5083AC, $4C81AC, $4980AC
Data $4480AC, $4180AC, $3B80AC, $377FAD, $3480AE, $3180AF, $2F80B0, $1776AC
Data $006AA8, $006AA9, $006EAC, $0171AF, $0575B3, $0879B7, $0B7DBB, $0E83C1
Data $1287C6, $168CCD, $1991D2, $1C96D5, $1F9CD5, $229FD5, $25A5D5, $27ABD5
Data $29B1D5, $28B0D6, $6F8FB2, $6B8EB0, $658BAE, $6089AD, $5B86AD, $5785AC
Data $5183AC, $4D82AC, $4981AC, $4481AC, $4180AD, $3B7FAD, $367FAE, $3580AF
Data $3281AF, $2F81B0, $1677AC, $006BA9, $006AAA, $006EAD, $0171AF, $0474B2
Data $0878B7, $0C7EBD, $0F84C3, $1287C6, $158CCC, $1891D1, $1B96D4, $1E9CD5
Data $21A0D5, $24A6D5, $27ABD5, $2AB1D5, $29B0D6, $6F8FB1, $6B8EB0, $658BAF
Data $6089AE, $5B86AE, $5686AD, $5184AC, $4D82AC, $4981AC, $4481AC, $4181AD
Data $3B81AD, $3780AE, $3580AF, $3280AF, $3080B1, $1776AD, $006BA8, $006AA9
Data $006EAD, $0171B1, $0475B4, $0779B8, $0B7EBC, $0F84C2, $1288C8, $168DCE
Data $1992D2, $1B97D4, $1E9CD5, $20A0D5, $23A5D5, $26AAD5, $29B0D5, $29B0D6
Data $6F90B2, $6B8EB0, $658BAF, $6088AE, $5B86AE, $5685AD, $5184AD, $4D83AD
Data $4982AD, $4482AD, $4180AD, $3B80AE, $3780AF, $3582B0, $3282B0, $2F81B1
Data $1877AD, $006BAA, $006BAB, $006FAE, $0271B0, $0575B3, $0779B8, $0B7EBE
Data $1084C4, $1389C8, $168ECE, $1992D2, $1B96D4, $1E9CD5, $21A0D5, $24A6D5
Data $27ABD5, $2AB1D5, $29B0D6, $6F90B2, $6B8EB0, $658BAF, $6089AE, $5B87AE
Data $5786AD, $5184AD, $4D83AD, $4982AD, $4482AD, $4181AE, $3B81AE, $3781AF
Data $3581B0, $3281B0, $2F81B1, $1877AD, $006BA9, $006BAA, $006FAE, $0272B1
Data $0576B4, $087AB8, $0B7FBE, $0F85C4, $1288C8, $168ECE, $1993D2, $1C97D4
Data $1F9CD5, $21A0D5, $24A5D5, $26AAD5, $29B0D5, $28B0D6, $6F90B2, $6B8FB0
Data $658CAF, $608AAE, $5B87AE, $5787AD, $5185AD, $4D83AD, $4A82AD, $4582AD
Data $4181AE, $3B81AF, $3781B0, $3582B1, $3282B1, $3081B2, $1877AE, $006BAB
Data $006AAC, $006EAF, $0171B2, $0476B5, $087BB9, $0C80BF, $1086C5, $138AC9
Data $168FCF, $1993D3, $1C97D5, $1F9DD5, $21A1D5, $24A7D5, $26ACD5, $29B1D5
Data $28B0D6, $6F91B2, $6B8FB1, $658CB0, $608AAF, $5B88AF, $5787AE, $5185AD
Data $4D84AD, $4A83AD, $4583AD, $4182AF, $3B82AF, $3782AF, $3582B0, $3282B1
Data $2F81B2, $1877AE, $006CAB, $006CAD, $0070B0, $0173B1, $0477B5, $087BBA
Data $0C80C0, $1086C6, $1389C9, $168FCF, $1894D4, $1B98D5, $1E9DD5, $21A1D5
Data $24A7D5, $26ABD5, $29B0D5, $28B0D6, $6F91B2, $6C90B1, $668DB0, $618BAF
Data $5B88AF, $5788AE, $5186AE, $4D84AE, $4A84AE, $4584AE, $4183AF, $3C83B0
Data $3883B1, $3583B1, $3283B1, $3081B2, $1877AF, $006DAC, $006DAE, $0071B1
Data $0273B3, $0577B6, $087CBB, $0C81C1, $1086C7, $1289CA, $158FD0, $1894D4
Data $1B98D5, $1E9DD5, $21A1D5, $23A6D5, $25ABD5, $28B0D5, $27B0D6, $6F91B2
Data $6C90B1, $668DB0, $618BAF, $5B88AF, $5787AE, $5186AE, $4D85AE, $4A84AE
Data $4584AE, $4283AF, $3C83AF, $3783B0, $3583B1, $3283B1, $3083B2, $1878B0
Data $006CAC, $006CAC, $0070AF, $0273B1, $0578B6, $087CBB, $0B80C1, $0F86C7
Data $128ACA, $168FCF, $1993D3, $1B97D5, $1E9DD5, $20A1D5, $23A6D5, $26AAD5
Data $28AFD5, $27AFD6, $6F92B3, $6B91B1, $658EB0, $608CAF, $5B89AF, $5788AF
Data $5187AF, $4D86AF, $4A85AF, $4585AF, $4285AF, $3C85AF, $3784B0, $3584B1
Data $3283B2, $2F82B3, $1878AF, $006DAC, $006DAD, $0071B1, $0173B4, $0477B8
Data $077CBC, $0B81C0, $1087C6, $138BCB, $1690D1, $1894D5, $1B98D6, $1E9DD5
Data $21A1D5, $23A6D5, $25AAD5, $28AFD5, $27AED6, $6F92B3, $6C91B2, $668EB1
Data $618CB0, $5B89AF, $5788AF, $5187AF, $4D86AF, $4A85AF, $4685AF, $4285B1
Data $3C85B2, $3884B2, $3584B2, $3283B2, $3083B3, $1879B0, $006DAD, $006DAF
Data $0071B2, $0274B4, $0579B7, $087DBB, $0C82C1, $1087C7, $1289CA, $158ECF
Data $1893D3, $1A98D5, $1D9DD5, $1FA0D5, $21A5D5, $23AAD5, $25AED5, $24ADD6
Data $6F93B4, $6B92B2, $668FB1, $628DB0, $5C8AB0, $5789AF, $5188AF, $4D87AF
Data $4A86B0, $4686B0, $4286B0, $3C85B0, $3884B1, $3584B2, $3284B3, $2F83B3
Data $1879AF, $006EAC, $006EAE, $0072B2, $0274B4, $0578B8, $077CBD, $0B81C1
Data $0F87C6, $128ACA, $158FD0, $1894D4, $1A97D5, $1C9CD5, $1E9FD5, $21A5D5
Data $23A9D5, $25ADD5, $23ABD6, $6F93B4, $6C92B2, $668FB1, $618DB0, $5B8BB0
Data $588AAF, $5388AF, $4E88AF, $4A88AF, $4588B0, $4286B1, $3C85B1, $3885B1
Data $3585B2, $3284B3, $2F83B3, $1878AF, $006DAC, $006EAE, $0072B2, $0274B5
Data $0478B8, $077CBC, $0B81C0, $0F87C6, $128ACA, $158FD0, $1793D4, $1996D5
Data $1B9BD5, $1D9ED5, $20A3D5, $22A6D5, $24ABD5, $23AAD5, $7094B4, $6C93B2
Data $6690B1, $618FB0, $5B8DB0, $578BB0, $5289B0, $4E89B0, $4B89B0, $4689B0
Data $4287B1, $3C85B2, $3884B2, $3584B2, $3284B2, $2F83B2, $1879B0, $006EAD
Data $006DAF, $0071B2, $0175B5, $0478B8, $077CBC, $0A81C1, $0E87C6, $118AC9
Data $148DCF, $1691D4, $1896D5, $1B9BD5, $1D9ED5, $1FA3D5, $20A6D5, $22AAD5
Data $21A9D5, $7094B4, $6C93B2, $6691B1, $618FB1, $5C8CB1, $588BB0, $528AB0
Data $4E8AB0, $4B8AB0, $4689B0, $4188B1, $3C86B1, $3884B2, $3584B3, $3284B3
Data $3083B4, $1779B0, $006EAD, $006EAE, $0072B1, $0175B4, $0478B9, $077CBD
Data $0B80C1, $0E86C6, $108ACA, $138FCF, $1592D2, $1795D4, $1A9AD5, $1B9ED5
Data $1DA2D5, $1FA5D5, $21A8D5, $20A7D5, $7095B5, $6C94B3, $6692B1, $6190B1
Data $5C8DB1, $588CB1, $528BB1, $4E8BB0, $4B8BB0, $4689B0, $4288B1, $3C85B1
Data $3884B2, $3584B3, $3284B4, $2F83B5, $1779B1, $006EAD, $006EAE, $0072B2
Data $0175B5, $0478B8, $077CBC, $0A81C1, $0D86C6, $0F88C9, $128DCD, $1492D1
Data $1795D4, $1A98D5, $1B9CD5, $1CA0D5, $1EA3D5, $20A7D5, $1FA6D5, $7096B4
Data $6C95B3, $6692B2, $6190B1, $5C8EB1, $588DB0, $528DB0, $4E8CB0, $4B8BB0
Data $468AB0, $4189B1, $3B87B1, $3785B2, $3584B3, $3284B3, $3084B4, $177AB0
Data $006FAC, $006EAE, $0072B2, $0075B5, $0378B8, $067CBB, $0980BF, $0C85C5
Data $0E89C8, $118CCD, $138FD0, $1593D3, $1898D5, $199CD5, $1B9FD5, $1DA2D5
Data $1EA5D5, $1DA3D5, $7096B4, $6C95B3, $6693B2, $6191B1, $5C8FB1, $588EB1
Data $528DB1, $4E8CB0, $4B8BB0, $4689B0, $4288B1, $3C86B1, $3785B2, $3584B3
Data $3284B3, $2F84B4, $177AB0, $006FAD, $006EAF, $0072B2, $0075B4, $0278B7
Data $057BBB, $097FBF, $0C84C4, $0D87C7, $108CCC, $128FD0, $1493D4, $1796D5
Data $1999D5, $1A9CD5, $1A9FD5, $1BA2D5, $19A1D5, $7096B4, $6C95B3, $6693B2
Data $6192B1, $5C91B1, $588FB1, $528EB1, $4E8DB0, $4B8BB0, $4689B0, $4189B2
Data $3B87B2, $3785B2, $3584B2, $3284B2, $2E83B3, $1579B1, $006EAD, $006DAE
Data $0071B1, $0074B4, $0277B7, $057BBB, $077FC0, $0A84C4, $0C87C7, $0F8BCB
Data $118ECE, $1391D1, $1694D4, $1798D5, $179BD5, $189DD5, $1AA0D5, $199FD5



.BCF_ButtonBackgroundOff_Style01
Data 80
Data 35
Data $446B89, $406A87, $3A6786, $356685, $306585, $2C6385, $266285, $226185
Data $1F5F85, $1A5E85, $165D86, $105C86, $0C5A87, $095A88, $065A89, $04598A
Data $004F88, $004485, $004486, $004889, $004A8B, $004D8E, $005090, $005493
Data $005796, $005998, $005B9A, $005D9C, $005F9E, $0062A0, $0063A1, $0065A3
Data $0066A5, $0069A8, $0167A9, $446A88, $406987, $3A6786, $356586, $306486
Data $2C6385, $266284, $226084, $1F5F85, $1A5E86, $165C86, $105B86, $0C5A87
Data $095988, $065989, $03598A, $005088, $004585, $004486, $004889, $004A8B
Data $004D8E, $005190, $005493, $005796, $005999, $005C9B, $005E9D, $00609F
Data $0062A2, $0064A3, $0067A6, $0069A8, $006BA9, $0069A9, $446A89, $406987
Data $3A6686, $356485, $306285, $2B6185, $266185, $226084, $1F5F84, $1A5D85
Data $165C86, $105A87, $0C5A88, $095A89, $065989, $045989, $005087, $004585
Data $004487, $00488A, $004B8C, $004E8F, $005191, $005594, $005897, $005A99
Data $005D9C, $005F9E, $0061A0, $0064A3, $0066A5, $0068A8, $006AA9, $006DA9
Data $006BA9, $446989, $406887, $3A6585, $356485, $306285, $2C6185, $265F85
Data $225F85, $1F5F85, $1A5E85, $165C86, $105B86, $0C5A87, $095988, $065989
Data $03598A, $004F88, $004485, $004486, $004889, $004B8B, $004E8E, $005191
Data $005595, $005898, $005A9A, $005D9D, $00609F, $0063A1, $0066A4, $0067A6
Data $006AA8, $006CA9, $006FA9, $006EA9, $446889, $406787, $3A6585, $356385
Data $306085, $2C5F84, $265E84, $225E84, $1F5E85, $1A5D85, $155B85, $0F5A86
Data $0B5987, $095988, $065989, $03598A, $004F87, $004484, $004486, $004889
Data $004B8B, $004E8E, $005191, $005595, $005898, $005A99, $005D9C, $00609F
Data $0063A2, $0066A5, $0067A7, $006AA9, $006EA9, $0071A9, $006FAA, $446889
Data $406786, $3A6485, $356285, $306085, $2C5F84, $265E84, $225D84, $1F5D84
Data $1A5D84, $165C86, $105B86, $0C5987, $095988, $065989, $03598A, $004F87
Data $004484, $004385, $004788, $004B8A, $004E8D, $005191, $005595, $005898
Data $005A9A, $005D9D, $0060A0, $0063A2, $0067A5, $006AA7, $006DA9, $006FA9
Data $0072A9, $0071AA, $446789, $406686, $3A6485, $356285, $305F85, $2C5E83
Data $265D83, $225D83, $1F5C84, $1A5C85, $165B86, $105A87, $0C5987, $095887
Data $065887, $045989, $004F87, $004484, $004386, $004789, $004A8B, $004D8E
Data $005091, $005494, $005897, $005B9A, $005E9D, $00609F, $0063A2, $0066A6
Data $006AA8, $006DA9, $006FA9, $0073A9, $0072AA, $436789, $3F6686, $3A6385
Data $356184, $305E84, $2C5D84, $265C84, $225C83, $1F5B83, $1A5B84, $165B85
Data $105A85, $0C5886, $095887, $065888, $035889, $004E87, $004384, $004385
Data $004788, $004A8B, $004D8E, $005191, $005594, $005897, $005A99, $005D9C
Data $00609F, $0063A2, $0067A5, $006AA8, $006DAA, $006FA9, $0074A9, $0074AA
Data $436689, $406586, $3A6285, $356084, $2F5E84, $2B5D83, $255C83, $215B83
Data $1E5A83, $1A5A84, $165A86, $105A86, $0C5986, $095986, $065887, $045788
Data $004D86, $004383, $004384, $004787, $004989, $004C8C, $004F90, $005493
Data $005896, $005A99, $005D9C, $00619F, $0064A2, $0067A5, $006AA8, $006DAA
Data $0071A9, $0075A9, $0074AA, $436688, $406585, $3A6284, $356083, $2F5D83
Data $2B5C83, $255B83, $215A83, $1E5A83, $195A83, $165A85, $105986, $0C5886
Data $095887, $065887, $045788, $004D86, $004283, $004284, $004687, $004988
Data $004C8B, $00508F, $005493, $005797, $005A98, $005E9B, $00619F, $0064A2
Data $0067A5, $006AA8, $006EAA, $0072A9, $0076A9, $0075AA, $436687, $406485
Data $3A6184, $355F83, $2F5D83, $2B5C82, $255A82, $215982, $1E5982, $195983
Data $155984, $105984, $0C5985, $095986, $065887, $045788, $004D84, $004381
Data $004282, $004585, $004888, $004B8B, $004F8E, $005392, $005795, $005997
Data $005C9B, $00609F, $0064A3, $0068A6, $006BA8, $006FA9, $0073A9, $0077A9
Data $0075AA, $436587, $406485, $3A6184, $355F83, $2F5D83, $2B5C82, $255A82
Data $215982, $1E5882, $195883, $165884, $105884, $0C5885, $095886, $065887
Data $045788, $004D84, $004281, $004182, $004585, $004987, $004C8A, $004E8D
Data $005391, $005795, $005A98, $005D9B, $00609E, $0064A1, $0068A5, $006BA8
Data $006EAA, $0072A9, $0077A9, $0076AA, $436587, $3F6385, $396084, $345E83
Data $2F5C83, $2B5B82, $255981, $215881, $1E5781, $195782, $165784, $105785
Data $0B5785, $095786, $065786, $035686, $004C84, $004181, $004181, $004584
Data $004886, $004B89, $004E8D, $005291, $005695, $005898, $005C9B, $00609E
Data $0063A2, $0068A6, $006BA8, $0070A9, $0073A9, $0078A9, $0077AA, $436488
Data $3F6385, $396083, $345E82, $2F5C82, $2B5B82, $255982, $215881, $1E5781
Data $195782, $155783, $0F5783, $0B5784, $095785, $065786, $045687, $004C83
Data $004080, $004081, $004484, $004785, $004A88, $004E8C, $005290, $005694
Data $005897, $005C9A, $00609D, $0064A1, $0067A5, $006AA7, $006FA9, $0074A9
Data $0079A9, $0077AA, $436487, $3F6384, $396083, $345E82, $2F5B82, $2B5A81
Data $255881, $215781, $1D5681, $185681, $155682, $0F5683, $0B5684, $095785
Data $065785, $035686, $004C82, $00407F, $003F80, $004383, $004685, $004988
Data $004D8B, $00528F, $005694, $005997, $005C9A, $005F9D, $0063A0, $0068A5
Data $006BA8, $0070AA, $0073A9, $0078A9, $0077AA, $436487, $3F6284, $395F83
Data $345C82, $2F5A81, $2B5981, $255881, $215781, $1D5681, $185681, $155682
Data $0F5683, $0B5684, $095685, $065685, $035586, $004B82, $003F7F, $003E7F
Data $004282, $004585, $004988, $004D8B, $00518E, $005492, $005895, $005B99
Data $005F9D, $0063A1, $0067A5, $006BA8, $006FAA, $0073A9, $0079A9, $0078AA
Data $436386, $3F6284, $395F83, $345D82, $2F5A82, $2B5881, $255781, $215781
Data $1D5681, $185681, $155582, $0F5482, $0B5483, $095584, $065684, $035586
Data $004B82, $003F7D, $003F7E, $004381, $004584, $004887, $004C8A, $00508D
Data $005491, $005795, $005A99, $005E9C, $00629F, $0067A4, $006AA8, $006FAA
Data $0073A9, $0079A9, $0078AA, $436387, $3F6284, $395F83, $345D82, $2F5A81
Data $2B5A81, $255881, $215680, $1D5580, $185580, $155481, $0F5482, $0B5583
Data $095584, $065584, $035485, $004A81, $003E7C, $003E7D, $004281, $004583
Data $004886, $004B89, $004F8C, $005391, $005794, $005B99, $005F9C, $0062A0
Data $0067A5, $006AA8, $006EAA, $0072A9, $0078A9, $0077AA, $436387, $3F6284
Data $395F82, $345D81, $2F5A81, $2A5A80, $255880, $215680, $1D5580, $185580
Data $155481, $0F5481, $0B5482, $095583, $065584, $035585, $004A81, $003E7C
Data $003E7D, $004280, $004482, $004785, $004B88, $004F8C, $005490, $005794
Data $005B98, $005E9C, $0061A0, $0066A4, $006AA7, $006FA9, $0073A9, $0078A9
Data $0077A9, $436387, $3F6284, $395F82, $345D81, $2F5A81, $2B5980, $255680
Data $215580, $1D5580, $185580, $155480, $0F5481, $0B5482, $095483, $065483
Data $035484, $004A80, $003E7B, $003D7C, $00417F, $004482, $004785, $004A88
Data $004F8B, $005390, $005693, $005A98, $005E9C, $0062A0, $0067A4, $006BA7
Data $0070A9, $0073A9, $0079A9, $0078A9, $436387, $3F6284, $395F82, $345D81
Data $2F5A81, $2A5980, $255680, $215580, $1D5580, $185580, $145481, $0E5481
Data $0A5481, $085482, $055484, $035485, $004A81, $003E7C, $003D7C, $00417F
Data $004381, $004684, $004A88, $004F8B, $00548F, $005792, $005A97, $005D9B
Data $00619F, $0067A4, $006BA8, $0070AA, $0073A9, $0079A9, $0078A9, $436386
Data $3F6283, $395F82, $345D81, $2F5A81, $2A5980, $245780, $205580, $1D5480
Data $185480, $145480, $0E5480, $0A5381, $085482, $055483, $035484, $004A80
Data $003E7B, $003D7C, $00417F, $004381, $004684, $004987, $004D8A, $00528F
Data $005692, $005B97, $005E9C, $00619F, $0066A4, $006AA8, $006FAA, $0073A9
Data $0079A9, $0078A9, $436386, $3F6183, $395E82, $345C81, $2F5A81, $2B5980
Data $255780, $215580, $1D5480, $185480, $155480, $0F5480, $0A5381, $085482
Data $055483, $035484, $004A80, $003E7C, $003D7C, $00407F, $004381, $004684
Data $004A87, $004E8B, $005390, $005693, $005B98, $005E9C, $0062A0, $0067A5
Data $006AA8, $006FAA, $0073A9, $0079A9, $0078AA, $436387, $3F6284, $395F82
Data $345D81, $2F5A81, $2A5980, $25577F, $21557F, $1D5480, $185480, $145380
Data $0E5380, $0A5381, $085382, $055383, $035484, $004980, $003D7B, $003C7B
Data $00407E, $004380, $004683, $004987, $004E8B, $00538F, $005693, $005A97
Data $005E9B, $00629F, $0067A4, $006AA8, $006FAA, $0073A9, $007AA9, $0079A9
Data $436386, $3F6283, $395F82, $345D81, $2F5A81, $2A5980, $255680, $215580
Data $1D5580, $185580, $145380, $0E5381, $0A5382, $085382, $055382, $035383
Data $004980, $003D7C, $003C7C, $00407F, $004380, $004683, $004987, $004E8C
Data $005390, $005693, $005A97, $005E9B, $00629F, $0067A4, $006AA8, $006FAA
Data $0074A9, $007AA9, $0079A9, $436386, $3F6283, $395F82, $345D81, $2F5A81
Data $2A5980, $245780, $205580, $1D5480, $185480, $145480, $0E5481, $0A5382
Data $085382, $055382, $035383, $004980, $003D7C, $003C7C, $00407E, $004380
Data $004683, $004987, $004D8C, $005391, $005694, $005B97, $005E9B, $00619F
Data $0066A4, $006BA8, $0070AA, $0074A9, $007AA9, $0079A9, $436386, $3F6283
Data $395F82, $345D81, $2F5A81, $2A5980, $24567F, $20557F, $1D5580, $185580
Data $145480, $0E5380, $0A5281, $085382, $055383, $035384, $004980, $003D7C
Data $003C7C, $00407E, $004380, $004683, $004986, $004E8A, $005390, $005693
Data $005A98, $005E9B, $0062A0, $0067A5, $006AA8, $0070AA, $0075A9, $007BA9
Data $007AAA, $436386, $3F6183, $395E82, $345C81, $2F5A81, $2B5980, $25577F
Data $21557F, $1D5480, $185480, $145380, $0E5381, $0A5382, $085383, $055383
Data $025384, $004980, $003D7B, $003C7B, $003F7E, $004280, $004683, $004A86
Data $004D8A, $00528F, $005593, $005A98, $005F9C, $0062A1, $0067A6, $006BA8
Data $0070AA, $0075A9, $007BA9, $007AAA, $436286, $3F6183, $395E82, $345C81
Data $2F5A81, $2A5980, $245780, $205580, $1D5480, $185480, $145380, $0E5380
Data $0A5381, $095382, $065383, $035384, $004980, $003D7B, $003C7B, $00407E
Data $00427F, $004582, $004986, $004E8B, $005390, $005593, $005A98, $005F9C
Data $0063A1, $0068A6, $006CA8, $0071AA, $0076A9, $007BA9, $007AAA, $436286
Data $3F6183, $395E82, $345C81, $2F5A81, $2A5880, $255680, $215580, $1D5480
Data $185480, $145380, $0E5280, $0A5281, $085382, $055382, $025384, $004980
Data $003D7B, $003C7B, $00407E, $00427F, $004583, $004987, $004E8B, $005390
Data $005593, $005A98, $005F9C, $0063A0, $0068A5, $006CA8, $0071AA, $0076A9
Data $007CA9, $007BAA, $436286, $3F6183, $395E82, $345C81, $2F5A81, $2B5980
Data $255780, $215580, $1D5480, $185480, $155380, $0F5281, $0A5282, $085382
Data $055382, $025384, $004980, $003D7B, $003C7B, $00407D, $00427F, $004583
Data $004987, $004E8B, $005390, $005694, $005B99, $005F9D, $0063A1, $0068A5
Data $006CA8, $0071AA, $0076A9, $007CA9, $007BAA, $436286, $3F6183, $395E82
Data $345C81, $2F5A81, $2A5980, $255680, $215580, $1D5580, $185580, $145480
Data $0E5381, $0A5282, $085382, $055382, $025384, $00487F, $003C7A, $003C7B
Data $00407E, $00427F, $004583, $004987, $004E8B, $00548F, $005792, $005B98
Data $005F9D, $0063A2, $0069A6, $006DA9, $0072A9, $0076A9, $007DA9, $007CAA
Data $436286, $3F6183, $395E82, $345C81, $2F5A81, $2A5980, $245780, $205580
Data $1D5480, $185480, $145380, $0E5281, $0A5282, $085382, $055382, $025383
Data $00497F, $003D7A, $003C7B, $00407E, $004380, $004683, $004A86, $004E8A
Data $005390, $005693, $005B98, $005F9D, $0063A2, $0068A6, $006CA9, $0071A9
Data $0076A9, $007DA9, $007CAA, $436386, $3F6183, $395E82, $345C81, $2F5A81
Data $2B5980, $25577F, $21557F, $1D5480, $185480, $155380, $0F5380, $0A5381
Data $085382, $065382, $045384, $00497F, $003D7A, $003C7B, $00407E, $004380
Data $004683, $004987, $004E8C, $005491, $005794, $005C99, $00609D, $0064A2
Data $0069A6, $006DA9, $0072A9, $0077A9, $007DA9, $007CAA, $436286, $3F6183
Data $395E82, $345C81, $2F5A81, $2A5980, $245680, $205580, $1D5580, $185580
Data $145480, $0E5381, $0A5382, $085383, $055383, $025384, $00497F, $003D7A
Data $003C7B, $00407F, $004280, $004683, $004A87, $004F8B, $005490, $005794
Data $005C99, $00609E, $0064A3, $0069A7, $006EA9, $0073A9, $0078A9, $007EA9
Data $007DAA, $436286, $3F6183, $395E82, $345C81, $2F5A81, $2A5980, $245780
Data $205580, $1D5480, $185480, $145380, $0E5280, $0A5281, $085282, $055283
Data $025384, $00497F, $003D7A, $003C7B, $00407E, $004280, $004683, $004A87
Data $004F8B, $005491, $005695, $005B9A, $00609E, $0065A3, $006AA7, $006EA9
Data $0073A9, $0078A9, $007EA9, $007DAA, $436386, $3F6183, $395E82, $345C81
Data $2F5A81, $2A5980, $255780, $215680, $1D5580, $185480, $145480, $0E5480
Data $0A5381, $085282, $055282, $025384, $004980, $003D7B, $003D7B, $00417E
Data $004380, $004683, $004A87, $004E8B, $005491, $005895, $005D9A, $00619E
Data $0064A3, $0069A7, $006EA9, $0073A9, $0078A9, $007EA9, $007DAA, $436386
Data $3F6183, $395E82, $345C81, $2F5A81, $2A5980, $255780, $215580, $1D5480
Data $185480, $155480, $0F5480, $0A5381, $085382, $055382, $025384, $004980
Data $003D7B, $003C7C, $00407F, $004380, $004684, $004A88, $004F8C, $005491
Data $005795, $005C9A, $00619F, $0065A4, $006AA8, $006FA9, $0074A9, $0079A9
Data $007FA9, $007EAA, $436386, $3F6183, $395E82, $345C81, $2F5A81, $2B5980
Data $255780, $215580, $1D5480, $185480, $145380, $0E5280, $0A5281, $085382
Data $055383, $035384, $004980, $003E7B, $003D7B, $00407E, $004380, $004684
Data $004A88, $004F8D, $005492, $005795, $005C9A, $00619F, $0066A5, $006BA9
Data $006FA9, $0074A9, $0079A9, $007FA9, $007EAA, $436386, $3F6183, $395E82
Data $345C81, $2F5A81, $2B5980, $26577F, $21557F, $1C5480, $175480, $145480
Data $0E5480, $0A5381, $085382, $055383, $025384, $004980, $003D7B, $003C7B
Data $00407E, $004381, $004684, $004A88, $004E8C, $005491, $005896, $005D9C
Data $0061A0, $0065A5, $006BA9, $0070A9, $0075A9, $007AA9, $0080A9, $007FAA
Data $436386, $3F6183, $395E82, $345C81, $2F5A81, $2A5980, $255680, $215580
Data $1D5580, $185580, $145480, $0E5380, $0A5281, $085382, $055382, $025384
Data $004980, $003D7B, $003C7B, $00407E, $004381, $004684, $004A88, $004E8C
Data $005491, $005896, $005E9C, $0062A0, $0066A5, $006BA9, $0070A9, $0075A9
Data $007AA9, $0080A9, $007FAA, $436386, $3F6183, $395E82, $345C81, $2F5A81
Data $2B5980, $255780, $215580, $1D5480, $185480, $145380, $0E5280, $0A5281
Data $085282, $055283, $025384, $004980, $003D7B, $003D7B, $00417E, $004381
Data $004784, $004B88, $004F8C, $005491, $005895, $005D9B, $0062A0, $0066A5
Data $006CA9, $0071A9, $0076A9, $007AA9, $0080A9, $007FAA, $436386, $3F6183
Data $395E82, $345C81, $2F5A81, $2A5980, $255780, $215580, $1D5480, $185480
Data $145380, $0E5280, $0A5281, $085282, $055283, $025384, $004980, $003D7B
Data $003C7B, $00407E, $004381, $004684, $004A88, $004E8C, $005492, $005897
Data $005D9C, $0062A0, $0066A5, $006CA9, $0071A9, $0076A9, $007BA9, $0081A9
Data $0080AA, $436386, $3F6183, $395E82, $345C81, $2F5A81, $2A5880, $245680
Data $205580, $1D5480, $185480, $145480, $0E5480, $0A5381, $085382, $055382
Data $025384, $004980, $003D7B, $003C7C, $00407F, $004381, $004684, $004A88
Data $004F8D, $005593, $005997, $005E9D, $0062A1, $0066A6, $006CA9, $0071A9
Data $0076A9, $007BA9, $0081A9, $0080AA, $436386, $3F6183, $395E82, $345C81
Data $2F5A81, $2A5980, $245780, $205580, $1D5480, $185480, $145380, $0E5280
Data $0A5281, $085382, $055383, $025384, $004980, $003D7B, $003C7B, $00407E
Data $004380, $004784, $004B88, $004F8D, $005593, $005997, $005F9D, $0063A1
Data $0067A6, $006CA9, $0070A9, $0076A9, $007BA9, $0081A9, $0080AA, $436386
Data $3F6183, $395E82, $345C81, $2F5A81, $2A5980, $255780, $215580, $1D5480
Data $185480, $145380, $0E5280, $0A5281, $085382, $055383, $025384, $004980
Data $003D7B, $003C7B, $00407E, $004381, $004684, $004A88, $004F8D, $005593
Data $005997, $005E9D, $0063A1, $0068A6, $006DA9, $0071A9, $0076A9, $007BA9
Data $0082A9, $0081AA, $436386, $3F6183, $395E82, $345C81, $2F5A81, $2A5980
Data $245780, $205580, $1D5480, $185480, $145380, $0E5280, $0A5281, $085382
Data $055382, $035384, $004980, $003D7C, $003C7C, $00407F, $004381, $004784
Data $004B88, $004F8C, $005592, $005996, $005F9C, $0063A1, $0067A7, $006CAA
Data $0071A9, $0076A9, $007BA9, $0081A9, $0080AA, $436386, $3F6183, $395E82
Data $345C81, $2F5A81, $2A5980, $245780, $205580, $1D5480, $185480, $155480
Data $0F5480, $0B5381, $095382, $065382, $035384, $004980, $003D7C, $003D7C
Data $00417F, $004381, $004684, $004A88, $00508C, $005692, $005996, $005E9C
Data $0062A1, $0067A6, $006DA9, $0071A9, $0076A9, $007AA9, $0081A9, $0081AA
Data $436386, $3F6183, $395E82, $345B81, $2F5981, $2A5980, $245780, $205580
Data $1D5480, $185480, $145380, $0E5280, $0A5281, $085382, $055382, $025384
Data $004980, $003D7C, $003C7C, $00407E, $004381, $004685, $004A89, $004F8D
Data $005593, $005897, $005E9D, $0063A2, $0068A6, $006EA9, $0072A9, $0077A9
Data $007BA9, $0082A9, $0081AA, $436386, $3F6183, $395E82, $345B81, $2F5981
Data $2A5980, $245780, $205580, $1D5480, $185480, $145480, $0E5480, $0A5381
Data $085382, $055382, $025384, $004980, $003D7B, $003C7B, $00407E, $004381
Data $004784, $004B88, $004F8D, $005593, $005998, $005E9E, $0063A2, $0068A6
Data $006DA9, $0071A9, $0077A9, $007CA9, $0082A9, $0081AA, $436386, $3F6183
Data $395E82, $345C81, $2F5981, $2A5880, $255680, $215580, $1D5480, $185480
Data $155380, $0F5280, $0A5281, $085382, $055383, $025384, $004980, $003E7C
Data $003D7C, $00407E, $004381, $004785, $004B89, $00508E, $005694, $005A98
Data $005F9E, $0063A2, $0068A6, $006EA9, $0072A9, $0077A9, $007CA9, $0082A9
Data $0081AA, $436386, $3F6183, $395E82, $345C81, $2F5981, $2A5880, $255680
Data $215580, $1D5480, $185480, $145480, $0E5480, $0A5381, $085382, $055383
Data $025384, $004980, $003D7B, $003D7B, $00417E, $004482, $004785, $004B89
Data $00508D, $005693, $005A98, $005F9E, $0063A2, $0068A6, $006EA9, $0072A9
Data $0077A9, $007CA9, $0082A9, $0081AA, $436386, $3F6183, $395E82, $345C81
Data $2F5981, $2B5880, $255680, $215580, $1D5480, $185480, $155380, $0F5380
Data $0A5381, $085382, $055382, $025384, $004980, $003E7C, $003D7C, $00417F
Data $004482, $004785, $004B89, $00508E, $005694, $005A98, $005F9E, $0063A2
Data $0068A7, $006EAA, $0072A9, $0077A9, $007CA9, $0083A9, $0082AA, $436386
Data $3F6183, $395E82, $345C81, $2F5981, $2A5880, $255680, $215580, $1D5480
Data $185480, $155380, $0F5280, $0A5281, $085382, $055383, $025384, $004980
Data $003D7B, $003D7C, $00417F, $004482, $004785, $004B89, $00508E, $005694
Data $005A98, $005F9E, $0064A2, $0069A7, $006EAA, $0071A9, $0077A9, $007DA9
Data $0083A9, $0082AA, $436386, $3F6183, $395E82, $345C81, $2F5981, $2B5880
Data $255680, $215580, $1D5480, $185480, $145380, $0E5280, $0A5281, $085382
Data $055383, $025384, $004980, $003D7B, $003D7C, $00417F, $004482, $004785
Data $004B89, $00508E, $005694, $005A99, $005F9F, $0064A3, $0069A7, $006FAA
Data $0072A9, $0078A9, $007DA9, $0083A9, $0082AA, $436386, $3F6183, $395E82
Data $345C81, $2F5981, $2B5880, $255680, $215580, $1D5480, $185480, $145380
Data $0F5280, $0B5281, $085382, $055382, $025384, $004980, $003D7B, $003D7B
Data $00417E, $004481, $004786, $004B8A, $00518E, $005794, $005A98, $005F9E
Data $0064A3, $0069A7, $006EAA, $0072A9, $0078A9, $007EA9, $0084A9, $0082AA
Data $436386, $3F6183, $395E82, $345C81, $2F5A81, $2A5880, $245680, $205580
Data $1D5480, $185480, $155480, $0F5480, $0A5381, $085382, $055382, $035384
Data $004980, $003D7C, $003D7D, $004180, $004482, $004785, $004B89, $00518E
Data $005794, $005A99, $005F9F, $0064A3, $0069A7, $006FAA, $0072A9, $0078A9
Data $007DA9, $0083A9, $0082AA, $436386, $3F6183, $395E82, $345C81, $2F5A81
Data $2A5980, $255780, $215580, $1D5480, $185480, $145380, $0E5381, $0A5382
Data $085382, $055382, $035484, $004980, $003D7B, $003D7C, $00417F, $004482
Data $004886, $004C8A, $00518F, $005795, $005A9A, $0060A0, $0065A4, $0069A8
Data $006EA9, $0072A9, $0078A9, $007EA9, $0084A9, $0083AA, $436386, $3F6183
Data $395E82, $345C81, $2F5A81, $2A5980, $245780, $205580, $1D5480, $185480
Data $145380, $0E5381, $0A5382, $085483, $055483, $035484, $004A80, $003E7C
Data $003D7C, $00417F, $004583, $004886, $004C8A, $00518F, $005795, $005A9A
Data $005FA0, $0064A4, $0069A8, $006FA9, $0073A9, $0079A9, $007EA9, $0084A9
Data $0083AA, $436387, $3F6184, $395E82, $345C81, $2F5A81, $2A5980, $245680
Data $205580, $1D5580, $185580, $145380, $0E5381, $0A5382, $085382, $055382
Data $035483, $004A80, $003E7C, $003D7C, $00417F, $004482, $004886, $004C8A
Data $005290, $005896, $005B9A, $0060A0, $0064A4, $0069A8, $006FA9, $0073A9
Data $0079A9, $007EA9, $0084A9, $0083AA, $436387, $3F6284, $395F82, $345D81
Data $2F5A81, $2A5980, $245780, $205580, $1D5480, $185480, $145380, $0E5380
Data $0A5381, $085482, $055483, $035484, $004A80, $003E7B, $003D7C, $004180
Data $004483, $004886, $004C8A, $005190, $005796, $005B9B, $0060A1, $0065A5
Data $006AA8, $0070A9, $0073A9, $0079A9, $007EA9, $0084A9, $0083AA, $436387
Data $3F6284, $395F82, $345D81, $2F5A81, $2A5980, $245780, $205580, $1D5480
Data $185480, $155480, $0F5480, $0B5381, $085482, $055483, $035484, $004A80
Data $003E7C, $003E7D, $004280, $004583, $004987, $004D8B, $00518F, $005795
Data $005B9A, $0060A1, $0065A6, $006AA9, $0070A9, $0073A9, $0079A9, $007FA9
Data $0085A9, $0083AA, $436387, $3F6284, $395F82, $345D81, $2F5A81, $2B5980
Data $255780, $215680, $1D5580, $185580, $155481, $0F5381, $0A5382, $095483
Data $065583, $035584, $004B80, $003F7D, $003E7E, $004281, $004583, $004886
Data $004C8B, $005291, $005897, $005B9A, $0060A0, $0065A5, $006AA8, $0070A9
Data $0074A9, $007AA9, $007FA9, $0085A9, $0083AA, $436386, $3F6284, $395F83
Data $345D82, $2F5A82, $2A5A81, $255880, $215680, $1D5580, $185580, $155581
Data $0F5581, $0B5482, $095483, $065483, $045485, $004A81, $003F7C, $003E7D
Data $004281, $004585, $004988, $004D8C, $005290, $005896, $005C9C, $0061A2
Data $0066A6, $006BA8, $0070A9, $0074A9, $0079A9, $007EA9, $0084A9, $0083AA
Data $436487, $3F6284, $395F83, $345C82, $2F5A82, $2A5981, $255881, $215781
Data $1D5681, $185681, $155481, $0F5482, $0B5483, $095684, $065684, $035585
Data $004B81, $003F7E, $003F7F, $004382, $004584, $004987, $004D8C, $005292
Data $005898, $005D9C, $0062A2, $0066A6, $006AA8, $0070A9, $0074A9, $007AA9
Data $007FA9, $0085A9, $0083AA, $436487, $3F6284, $395F83, $345D82, $2F5B82
Data $2B5A81, $255881, $215781, $1D5681, $185681, $155582, $0F5582, $0B5583
Data $095584, $065584, $035585, $004B81, $003F7D, $003F7E, $004382, $004685
Data $004A88, $004E8C, $005392, $005998, $005C9C, $0062A2, $0067A6, $006BA8
Data $0070A9, $0074A9, $0079A9, $007EA9, $0084A9, $0083AA, $436487, $3F6384
Data $396083, $345E82, $2F5B82, $2B5B81, $255981, $215781, $1E5681, $195681
Data $155582, $0F5583, $0B5584, $095685, $065685, $045586, $004B82, $003F7F
Data $003E80, $004283, $004586, $004A89, $004F8D, $005493, $005A99, $005E9D
Data $0063A3, $0067A7, $006BA9, $0071A9, $0075A9, $007BA9, $0080A9, $0085A9
Data $0083AA, $436587, $3F6385, $396084, $345E83, $2F5C83, $2B5B82, $255981
Data $215881, $1E5781, $195781, $155683, $0F5683, $0B5683, $095684, $065685
Data $035586, $004B82, $00407F, $004081, $004484, $004785, $004B89, $004F8E
Data $005494, $005A9A, $005D9D, $0063A3, $0068A8, $006CA9, $0071A9, $0075A9
Data $007BA9, $007FA9, $0084A9, $0082AA, $436587, $406485, $3A6184, $355F83
Data $2F5C83, $2B5C82, $255A82, $215882, $1E5882, $195882, $155783, $105784
Data $0C5785, $095785, $065785, $045586, $004B83, $004180, $004182, $004585
Data $004787, $004B8A, $00508F, $005595, $005A9B, $005D9E, $0063A4, $0068A8
Data $006CA9, $0071A9, $0075A9, $007AA9, $007FA9, $0084A9, $0083AA, $436587
Data $406485, $3A6184, $355F83, $2F5C83, $2B5B82, $255A82, $215982, $1E5882
Data $195882, $165783, $105783, $0B5784, $095785, $065785, $045786, $004C84
Data $004080, $004080, $004483, $004785, $004C8A, $00508F, $005495, $005A9B
Data $005E9E, $0063A3, $0067A7, $006BA9, $0071A9, $0075A9, $007AA9, $007EA9
Data $0083A9, $0082AA, $436688, $3F6585, $396284, $346083, $2F5D83, $2B5C83
Data $255B83, $215A83, $1E5983, $195983, $165983, $105983, $0B5884, $095885
Data $065786, $035687, $004C83, $004180, $004181, $004585, $004788, $004B8C
Data $005090, $005594, $005B9A, $005F9F, $0064A5, $0068A9, $006CAA, $0071A9
Data $0075A9, $007AA9, $007EA9, $0083A9, $0081AA, $436688, $406586, $3A6285
Data $356084, $2F5D83, $2B5C83, $255B83, $215A83, $1E5983, $1A5983, $165985
Data $105986, $0C5886, $095886, $065786, $045787, $004D84, $004181, $004183
Data $004586, $004888, $004D8B, $00518F, $005695, $005B9B, $005D9E, $0062A3
Data $0067A7, $006CA9, $0071A9, $0074A9, $0079A9, $007EA9, $0082A9, $0080AA
Data $436789, $3F6686, $3A6385, $366184, $305E84, $2B5D83, $255C83, $215B83
Data $1E5A84, $1A5A84, $165A84, $105984, $0C5885, $095886, $065887, $035787
Data $004D83, $004280, $004282, $004686, $004888, $004C8C, $005091, $005595
Data $005B9A, $005E9E, $0063A4, $0068A8, $006BA9, $0070A9, $0073A9, $0079A9
Data $007DA9, $0081A9, $007EAA, $436789, $406686, $3A6385, $356184, $2F5F84
Data $2C5E83, $275C83, $225C83, $1E5C83, $195C84, $165A85, $105985, $0C5985
Data $095986, $065887, $035787, $004C83, $004180, $004282, $004686, $004889
Data $004C8C, $005090, $005594, $005B9A, $005E9E, $0063A4, $0067A8, $006AA9
Data $006FA9, $0072A9, $0077A9, $007AA9, $007FA9, $007DAA, $446889, $406786
Data $3A6485, $356384, $2F6184, $2B5F84, $265D84, $225D84, $1F5D84, $1A5D84
Data $165B85, $105986, $0C5886, $095886, $065886, $035786, $004D84, $004281
Data $004183, $004586, $004989, $004C8C, $005090, $005595, $005B9A, $005E9D
Data $0061A3, $0065A8, $006AA9, $006FA9, $0072A9, $0077A9, $007AA9, $007EA9
Data $007CAA, $446889, $406786, $3A6585, $356385, $306085, $2C5F84, $265E84
Data $225E84, $1F5E84, $1A5D84, $155C85, $105A85, $0C5886, $095887, $065887
Data $045788, $004D84, $004281, $004282, $004685, $004988, $004C8D, $005091
Data $005495, $005A9A, $005E9E, $0063A3, $0066A6, $0069A8, $006EA9, $0072A9
Data $0076A9, $0079A9, $007CA9, $007AAA, $446989, $406887, $3A6685, $356485
Data $306185, $2C6085, $265F85, $225F84, $1F5F84, $1A5D84, $165C85, $105985
Data $0C5886, $095887, $065888, $035789, $004D85, $004281, $004282, $004686
Data $004989, $004C8C, $005090, $005595, $005A9A, $005C9D, $0061A1, $0066A5
Data $0069A8, $006CA9, $0070A9, $0074A9, $0077A9, $007BA9, $0079AA, $446A89
Data $406987, $3A6686, $356485, $306285, $2C6184, $266184, $226084, $1F5F84
Data $1A5E84, $155D85, $0F5B85, $0B5986, $095887, $065887, $045888, $004E84
Data $004380, $004282, $004686, $004989, $004C8C, $00508F, $005493, $005999
Data $005D9C, $0060A1, $0063A4, $0067A7, $006CA9, $0070A9, $0073A9, $0076A9
Data $0079A9, $0076AA, $446A88, $406987, $3A6786, $356585, $306385, $2C6285
Data $266185, $226084, $1F5F84, $1A5D84, $165C85, $105A85, $0B5986, $095887
Data $065887, $035888, $004E84, $004381, $004283, $004686, $004988, $004C8B
Data $004F8F, $005393, $005898, $005B9B, $0060A0, $0063A4, $0067A8, $006AA9
Data $006DA9, $0070A9, $0073A9, $0076A9, $0074A9, $446B89, $406987, $3A6786
Data $356685, $306585, $2C6385, $266285, $226184, $1F5F84, $1A5D84, $155D86
Data $0F5B86, $0B5986, $095886, $065886, $025787, $004D85, $004281, $004182
Data $004585, $004888, $004B8B, $004F8F, $005394, $005898, $005B9B, $005F9F
Data $0062A2, $0065A5, $0068A8, $006CA9, $006FA9, $0071A9, $0074A9, $0173A9


.BCF_ButtonBackgroundOn_Style02
Data 80
Data 35
Data $E9EFEF, $E4E9EB, $D7DBE0, $C9CBD6, $BFC2D0, $B9BFCD, $B8C0CD, $B5BECD
Data $B4BBCD, $B2B8CA, $B2B8C8, $B4BAC8, $B5BBC9, $B5BBC9, $B5BBC9, $B6B9CA
Data $B7BBCC, $B4BACA, $AAAFC1, $A0A5B8, $9EA4B7, $9FA6B8, $9FA6B9, $9FA6B9
Data $9FA6B9, $9FA6B9, $A0A7BA, $A0A7BA, $9FA6B9, $9FA4B8, $A1A6BA, $A8AFC1
Data $B6BECE, $C2CAD8, $C6CEDB, $E9EFEF, $E4E9EB, $D7DBE0, $C9CBD6, $BFC2D0
Data $B9BFCD, $B8C0CD, $B5BECD, $B4BBCD, $B2B8CA, $B2B8C8, $B4BAC8, $B5BBC9
Data $B5BBC9, $B5BBC9, $B6B9CA, $B7BBCC, $B4BACA, $AAAFC1, $A0A5B8, $9EA4B7
Data $9FA6B8, $9FA6B9, $9FA6B9, $9FA6B9, $9FA6B9, $A0A7BA, $A0A7BA, $9FA6B9
Data $9FA4B8, $A1A6BA, $A8AFC1, $B6BECE, $C2CAD8, $C6CEDB, $E9EFEF, $E4E9EB
Data $D7DBE0, $C9CBD6, $BFC2D0, $B9BFCD, $B8C0CD, $B5BECD, $B4BBCD, $B2B8CA
Data $B2B8C8, $B4BAC8, $B5BBC9, $B5BBC9, $B5BBC9, $B6B9CA, $B7BBCC, $B4BACA
Data $AAAFC1, $A0A5B8, $9EA4B7, $9FA6B8, $9FA6B9, $9FA6B9, $9FA6B9, $9FA6B9
Data $A0A7BA, $A0A7BA, $9FA6B9, $9FA4B8, $A1A6BA, $A8AFC1, $B6BECE, $C2CAD8
Data $C6CEDB, $E9EEEF, $E5E8EB, $D8DBDF, $C9CBD5, $BFC1CF, $BABECD, $B9BFCE
Data $B5BDCE, $B4BACD, $B4B8CB, $B4B9C8, $B5B9C9, $B5BAC9, $B5BAC9, $B5BAC9
Data $B5B9CA, $B6BCCC, $B4BACA, $AAAEC0, $A0A4B7, $9EA5B7, $9FA7B9, $9FA7BA
Data $9FA6BA, $9FA6BA, $9FA6BA, $A0A6BA, $9FA6BA, $9FA6BA, $9FA4B8, $A1A6BA
Data $A9AFC1, $B7BDCE, $C3C9D8, $C6CDDB, $E9EEED, $E5E8E9, $D8DBDF, $C9CBD5
Data $BFC0CF, $BABECD, $B9BFCE, $B5BCCE, $B4B9CD, $B5B8CB, $B6B9CA, $B6B9C9
Data $B5B9C9, $B5B9C9, $B5B9C9, $B5B9CA, $B6BCCC, $B4BACA, $A9AEC0, $9FA4B7
Data $9EA5B7, $9FA7B9, $9FA7BA, $9FA6BA, $9FA6BA, $9FA6BA, $9EA6BA, $9FA6BA
Data $9FA6BA, $9FA4B8, $A1A6BA, $A9AFC1, $B7BDCE, $C3C9D8, $C6CDDB, $E9EDEC
Data $E5E8E8, $D9DBDF, $CACBD5, $BEC0CE, $B9BECD, $B9C0CE, $B6BBCD, $B5B8CC
Data $B7B9CD, $B7BACB, $B7B9CA, $B6B8C9, $B6B8C9, $B6B8C9, $B4BACA, $B6BDCC
Data $B4BBCB, $A8AEC0, $9EA4B6, $9EA6B8, $A0A8BA, $9FA7BB, $9EA6BB, $9EA6BB
Data $9EA6BB, $9DA5BA, $9EA6BA, $9FA7BB, $9FA5B9, $A1A7BB, $A9AFC2, $B7BDCE
Data $C3C9D8, $C7CDDA, $E9EDEC, $E5E8E8, $DADBDF, $CBCBD5, $BEC0CE, $B9BECD
Data $B9C0CE, $B6BBCD, $B5B8CC, $B8B9CE, $B9BACD, $B7B9CA, $B6B7C9, $B6B8C9
Data $B6B8C9, $B4BACA, $B6BDCC, $B4BBCB, $A8AEC0, $9EA4B6, $9EA6B8, $A0A8BA
Data $9FA7BB, $9EA6BB, $9EA6BB, $9EA6BB, $9DA5BA, $9EA6BB, $9FA7BC, $9FA5B9
Data $A1A7BB, $A9AFC2, $B8BDCE, $C4C9D8, $C7CDDA, $E9EDEC, $E5E8E8, $DADBDF
Data $CBCBD5, $BEC0CE, $BABECD, $B9C0CE, $B6BBCC, $B5B7CC, $B8B9CE, $B9BACD
Data $B7B8CA, $B6B6C8, $B6B7C9, $B6B8C9, $B4BACA, $B6BDCC, $B4BBCB, $A7AEC0
Data $9DA4B6, $9EA6B8, $A0A8BB, $9FA7BB, $9EA6BB, $9EA6BB, $9EA6BB, $9DA5BA
Data $9EA6BB, $9FA7BC, $9FA5B9, $A1A7BB, $AAAFC2, $B8BDCE, $C4C9D8, $C7CDDA
Data $E9EDED, $E5E8E9, $DADBE0, $CBCBD5, $BEC0CE, $BABECC, $BAC0CE, $B7BBCB
Data $B6B7CB, $B8B9CE, $B9BACD, $B7B8CA, $B6B6C9, $B6B7C9, $B6B8C9, $B4BACA
Data $B6BDCD, $B4BBCC, $A7AFC1, $9DA5B7, $9EA6B9, $A0A8BC, $9FA7BC, $9EA6BB
Data $9EA6BB, $9EA6BB, $9EA6BA, $9EA6BB, $9FA7BC, $9FA5BA, $A1A7BB, $AAB0C2
Data $B8BECD, $C4CAD7, $C7CDD9, $E9EDED, $E5E8EA, $D9DBE0, $CACBD5, $BEC0CE
Data $BABECC, $BBBFCD, $B8BBCB, $B6B7CB, $B7B9CD, $B7BACC, $B7B8CA, $B6B7C9
Data $B6B7C9, $B6B8C9, $B4BACA, $B6BDCD, $B4BBCC, $A7AFC1, $9DA5B7, $9EA6B9
Data $A0A8BC, $9FA7BC, $9EA6BB, $9EA6BB, $9EA6BB, $9EA6BA, $9EA6BA, $9FA7BB
Data $9FA5BA, $A1A7BB, $AAB0C2, $B7BECD, $C3CAD7, $C7CDD9, $E9EDEE, $E5E8EB
Data $D9DCE1, $C9CCD6, $BEC1CF, $BABECC, $BBBFCC, $B8BBCA, $B6B8CA, $B6BACB
Data $B6BACA, $B6B9C9, $B6B8C8, $B6B8C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C1, $9EA6B8, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $9FA7BA, $9FA7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BECC, $C3CAD6
Data $C6CED8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD6, $BEC1CF, $BABECC, $BBBECB
Data $B8BBCA, $B6B9CA, $B4BACB, $B4BACA, $B6B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C1, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $9FA7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BECC, $C3CAD6, $C6CED8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8
Data $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA
Data $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA
Data $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA
Data $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1
Data $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF
Data $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8
Data $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA
Data $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA
Data $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB
Data $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA
Data $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6
Data $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA
Data $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8
Data $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA
Data $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA
Data $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA
Data $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1
Data $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF
Data $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8
Data $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA
Data $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA
Data $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB
Data $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA
Data $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6
Data $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA
Data $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8
Data $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA
Data $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA
Data $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA
Data $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1
Data $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF
Data $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8
Data $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA
Data $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA
Data $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB
Data $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA
Data $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6
Data $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA
Data $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8
Data $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA
Data $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA
Data $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA
Data $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1
Data $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF
Data $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8
Data $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA
Data $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA
Data $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB
Data $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA
Data $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6
Data $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA
Data $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8
Data $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA
Data $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA
Data $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA
Data $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1
Data $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF
Data $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8
Data $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA
Data $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA
Data $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB
Data $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA
Data $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6
Data $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA
Data $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8
Data $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA
Data $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA
Data $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA
Data $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1
Data $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF
Data $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8
Data $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA
Data $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA
Data $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB
Data $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA
Data $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6
Data $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA
Data $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8
Data $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA
Data $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA
Data $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA
Data $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1
Data $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF
Data $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8
Data $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA
Data $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA
Data $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB
Data $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA
Data $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6
Data $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA
Data $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8
Data $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA
Data $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA
Data $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA
Data $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1
Data $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF
Data $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8
Data $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA
Data $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA
Data $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB
Data $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA
Data $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC
Data $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA
Data $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6
Data $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA
Data $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8
Data $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB
Data $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB
Data $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7
Data $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9
Data $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9
Data $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA
Data $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE
Data $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA
Data $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC
Data $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA
Data $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC
Data $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2, $C9CCD7, $BEC1CF, $BABECC
Data $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA, $B5B9C9, $B6B9C8, $B6B9C8
Data $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2, $9EA6B9, $9DA5BA, $9FA7BC
Data $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA, $A0A7BA, $9FA7BA, $9EA5BA
Data $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8, $E9EDEE, $E5E8EB, $D9DCE2
Data $C9CCD7, $BEC1CF, $BABECC, $BBBECA, $B9BBCA, $B6B9CA, $B4BACA, $B4BACA
Data $B5B9C9, $B6B9C8, $B6B9C8, $B6B9C8, $B4BACA, $B5BCCC, $B3BACC, $A8B0C2
Data $9EA6B9, $9DA5BA, $9FA7BC, $9FA7BB, $9FA7BA, $9FA7BA, $9FA7BA, $A0A7BA
Data $A0A7BA, $9FA7BA, $9EA5BA, $A0A7BB, $A9B0C1, $B7BFCC, $C3CBD6, $C6CFD8

.BCF_ButtonBackgroundOff_Style02
Data 80
Data 35
Data $C6CCCC, $C1C6C8, $B4B8BD, $A6A8B3, $9C9FAD, $969CAA, $959DAA, $929BAA
Data $9198AA, $8F95A7, $8F95A5, $9197A5, $9298A6, $9298A6, $9298A6, $9396A7
Data $9498A9, $9197A7, $878C9E, $7D8295, $7B8194, $7C8395, $7C8396, $7C8396
Data $7C8396, $7C8396, $7D8497, $7D8497, $7C8396, $7C8195, $7E8397, $858C9E
Data $939BAB, $9FA7B5, $A3ABB8, $C6CCCC, $C1C6C8, $B4B8BD, $A6A8B3, $9C9FAD
Data $969CAA, $959DAA, $929BAA, $9198AA, $8F95A7, $8F95A5, $9197A5, $9298A6
Data $9298A6, $9298A6, $9396A7, $9498A9, $9197A7, $878C9E, $7D8295, $7B8194
Data $7C8395, $7C8396, $7C8396, $7C8396, $7C8396, $7D8497, $7D8497, $7C8396
Data $7C8195, $7E8397, $858C9E, $939BAB, $9FA7B5, $A3ABB8, $C6CCCC, $C1C6C8
Data $B4B8BD, $A6A8B3, $9C9FAD, $969CAA, $959DAA, $929BAA, $9198AA, $8F95A7
Data $8F95A5, $9197A5, $9298A6, $9298A6, $9298A6, $9396A7, $9498A9, $9197A7
Data $878C9E, $7D8295, $7B8194, $7C8395, $7C8396, $7C8396, $7C8396, $7C8396
Data $7D8497, $7D8497, $7C8396, $7C8195, $7E8397, $858C9E, $939BAB, $9FA7B5
Data $A3ABB8, $C6CBCC, $C2C5C8, $B5B8BC, $A6A8B2, $9C9EAC, $979BAA, $969CAB
Data $929AAB, $9197AA, $9195A8, $9196A5, $9296A6, $9297A6, $9297A6, $9297A6
Data $9296A7, $9399A9, $9197A7, $878B9D, $7D8194, $7B8294, $7C8496, $7C8497
Data $7C8397, $7C8397, $7C8397, $7D8397, $7C8397, $7C8397, $7C8195, $7E8397
Data $868C9E, $949AAB, $A0A6B5, $A3AAB8, $C6CBCA, $C2C5C6, $B5B8BC, $A6A8B2
Data $9C9DAC, $979BAA, $969CAB, $9299AB, $9196AA, $9295A8, $9396A7, $9396A6
Data $9296A6, $9296A6, $9296A6, $9296A7, $9399A9, $9197A7, $868B9D, $7C8194
Data $7B8294, $7C8496, $7C8497, $7C8397, $7C8397, $7C8397, $7B8397, $7C8397
Data $7C8397, $7C8195, $7E8397, $868C9E, $949AAB, $A0A6B5, $A3AAB8, $C6CAC9
Data $C2C5C5, $B6B8BC, $A7A8B2, $9B9DAB, $969BAA, $969DAB, $9398AA, $9295A9
Data $9496AA, $9497A8, $9496A7, $9395A6, $9395A6, $9395A6, $9197A7, $939AA9
Data $9198A8, $858B9D, $7B8193, $7B8395, $7D8597, $7C8498, $7B8398, $7B8398
Data $7B8398, $7A8297, $7B8397, $7C8498, $7C8296, $7E8498, $868C9F, $949AAB
Data $A0A6B5, $A4AAB7, $C6CAC9, $C2C5C5, $B7B8BC, $A8A8B2, $9B9DAB, $969BAA
Data $969DAB, $9398AA, $9295A9, $9596AB, $9697AA, $9496A7, $9394A6, $9395A6
Data $9395A6, $9197A7, $939AA9, $9198A8, $858B9D, $7B8193, $7B8395, $7D8597
Data $7C8498, $7B8398, $7B8398, $7B8398, $7A8297, $7B8398, $7C8499, $7C8296
Data $7E8498, $868C9F, $959AAB, $A1A6B5, $A4AAB7, $C6CAC9, $C2C5C5, $B7B8BC
Data $A8A8B2, $9B9DAB, $979BAA, $969DAB, $9398A9, $9294A9, $9596AB, $9697AA
Data $9495A7, $9393A5, $9394A6, $9395A6, $9197A7, $939AA9, $9198A8, $848B9D
Data $7A8193, $7B8395, $7D8598, $7C8498, $7B8398, $7B8398, $7B8398, $7A8297
Data $7B8398, $7C8499, $7C8296, $7E8498, $878C9F, $959AAB, $A1A6B5, $A4AAB7
Data $C6CACA, $C2C5C6, $B7B8BD, $A8A8B2, $9B9DAB, $979BA9, $979DAB, $9498A8
Data $9394A8, $9596AB, $9697AA, $9495A7, $9393A6, $9394A6, $9395A6, $9197A7
Data $939AAA, $9198A9, $848C9E, $7A8294, $7B8396, $7D8599, $7C8499, $7B8398
Data $7B8398, $7B8398, $7B8397, $7B8398, $7C8499, $7C8297, $7E8498, $878D9F
Data $959BAA, $A1A7B4, $A4AAB6, $C6CACA, $C2C5C7, $B6B8BD, $A7A8B2, $9B9DAB
Data $979BA9, $989CAA, $9598A8, $9394A8, $9496AA, $9497A9, $9495A7, $9394A6
Data $9394A6, $9395A6, $9197A7, $939AAA, $9198A9, $848C9E, $7A8294, $7B8396
Data $7D8599, $7C8499, $7B8398, $7B8398, $7B8398, $7B8397, $7B8397, $7C8498
Data $7C8297, $7E8498, $878D9F, $949BAA, $A0A7B4, $A4AAB6, $C6CACB, $C2C5C8
Data $B6B9BE, $A6A9B3, $9B9EAC, $979BA9, $989CA9, $9598A7, $9395A7, $9397A8
Data $9397A7, $9396A6, $9395A5, $9395A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9E, $7B8395, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7C8497, $7C8497, $7C8497, $7B8297, $7D8498, $868D9E, $949BA9, $A0A7B3
Data $A3ABB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B3, $9B9EAC, $979BA9, $989BA8
Data $9598A7, $9396A7, $9197A8, $9197A7, $9396A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9E, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7C8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949BA9, $A0A7B3, $A3ABB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5
Data $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7
Data $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7
Data $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497
Data $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E
Data $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC
Data $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5
Data $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297
Data $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497
Data $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8
Data $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7
Data $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3
Data $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7
Data $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5
Data $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7
Data $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7
Data $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497
Data $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E
Data $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC
Data $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5
Data $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297
Data $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497
Data $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8
Data $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7
Data $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3
Data $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7
Data $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5
Data $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7
Data $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7
Data $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497
Data $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E
Data $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC
Data $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5
Data $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297
Data $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497
Data $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8
Data $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7
Data $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3
Data $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7
Data $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5
Data $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7
Data $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7
Data $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497
Data $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E
Data $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC
Data $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5
Data $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297
Data $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497
Data $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8
Data $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7
Data $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3
Data $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7
Data $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5
Data $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7
Data $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7
Data $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497
Data $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E
Data $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC
Data $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5
Data $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297
Data $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497
Data $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8
Data $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7
Data $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3
Data $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7
Data $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5
Data $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7
Data $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7
Data $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497
Data $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E
Data $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC
Data $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5
Data $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297
Data $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497
Data $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8
Data $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7
Data $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3
Data $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7
Data $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5
Data $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7
Data $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7
Data $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497
Data $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E
Data $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC
Data $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5
Data $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297
Data $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497
Data $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8
Data $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7
Data $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3
Data $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7
Data $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5
Data $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7
Data $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7
Data $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497
Data $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E
Data $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC
Data $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5
Data $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297
Data $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497
Data $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8
Data $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7
Data $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9
Data $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497
Data $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3
Data $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7
Data $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5
Data $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498
Data $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498
Data $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4
Data $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6
Data $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396
Data $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497
Data $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB
Data $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7
Data $9197A7, $9197A7, $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9
Data $9097A9, $858D9F, $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497
Data $7C8497, $7D8497, $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9
Data $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF, $A6A9B4, $9B9EAC, $979BA9
Data $989BA7, $9698A7, $9396A7, $9197A7, $9197A7, $9296A6, $9396A5, $9396A5
Data $9396A5, $9197A7, $9299A9, $9097A9, $858D9F, $7B8396, $7A8297, $7C8499
Data $7C8498, $7C8497, $7C8497, $7C8497, $7D8497, $7D8497, $7C8497, $7B8297
Data $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5, $C6CACB, $C2C5C8, $B6B9BF
Data $A6A9B4, $9B9EAC, $979BA9, $989BA7, $9698A7, $9396A7, $9197A7, $9197A7
Data $9296A6, $9396A5, $9396A5, $9396A5, $9197A7, $9299A9, $9097A9, $858D9F
Data $7B8396, $7A8297, $7C8499, $7C8498, $7C8497, $7C8497, $7C8497, $7D8497
Data $7D8497, $7C8497, $7B8297, $7D8498, $868D9E, $949CA9, $A0A8B3, $A3ACB5

.BCF_ButtonBackgroundOn_Style03
Data 80
Data 35
Data $647180, $63717F, $63707E, $626F7E, $626E7C, $606D7B, $5F6C7A, $5E6B79
Data $5D6A77, $5C6976, $5B6774, $5A6673, $596571, $586470, $56626F, $55616C
Data $545F6A, $535D69, $515C67, $505B65, $505964, $4E5862, $4D5761, $4C555F
Data $4B545D, $4A535C, $48525B, $475059, $464F58, $454E57, $454D56, $444C55
Data $434B53, $424B53, $424A52, $647180, $63707F, $63707F, $626F7D, $616E7D
Data $606D7B, $606C7A, $5F6B79, $5E6977, $5D6976, $5C6774, $5A6673, $596471
Data $586370, $57626E, $55616C, $545F6A, $535E69, $525C67, $515B66, $505964
Data $4E5862, $4D5761, $4B555F, $4A545E, $49525C, $48515A, $485059, $474F58
Data $464E57, $444D56, $444C54, $434B53, $424A53, $424A52, $647180, $63717F
Data $636F7F, $626F7D, $626E7D, $606D7C, $5F6C7A, $5F6B79, $5D6A77, $5D6876
Data $5B6774, $5A6673, $5A6572, $586370, $57616E, $55616C, $545F6B, $535E69
Data $515C68, $505B66, $4F5964, $4E5862, $4D5661, $4B555F, $4B545D, $4A535C
Data $48515B, $485159, $464F58, $464E57, $454D55, $444C54, $444B53, $434A52
Data $424A52, $647180, $63707F, $63707E, $626F7D, $626E7D, $616D7B, $606C7A
Data $5F6B79, $5E6A77, $5C6876, $5C6775, $5B6673, $596571, $57636F, $56626E
Data $56616D, $555F6A, $535D69, $525C67, $505B65, $505964, $4E5862, $4C5761
Data $4C555F, $4B535E, $49535C, $49515B, $48515A, $464F57, $464E57, $444D56
Data $444C55, $434B54, $424B53, $424A52, $647180, $64707F, $636F7F, $626F7D
Data $616E7C, $606D7B, $5F6C7A, $5F6B79, $5D6977, $5C6976, $5C6775, $5A6673
Data $596571, $586370, $57626E, $56616C, $555F6A, $535E69, $525D68, $515B66
Data $505964, $4E5762, $4D5661, $4C555F, $4A545D, $49535C, $49515B, $475059
Data $474F58, $464E56, $454D56, $444C54, $434B54, $434B53, $424A52, $647180
Data $64707F, $62707E, $626F7E, $626E7D, $616D7C, $606C7A, $5E6B78, $5E6A78
Data $5C6976, $5B6774, $5A6673, $596571, $58646F, $57626E, $55616D, $545F6A
Data $535E69, $525C67, $505A65, $4F5964, $4E5762, $4D5761, $4C555F, $4B545E
Data $4A525C, $48515A, $475059, $464F57, $464E57, $454D55, $444D55, $434C53
Data $434A53, $424A52, $647180, $64717F, $63707E, $626F7E, $626E7C, $616D7C
Data $5F6B7A, $5E6A78, $5E6A77, $5C6876, $5B6775, $5A6673, $596471, $586370
Data $57626E, $56606C, $545F6A, $535D69, $525C67, $505A66, $505964, $4E5763
Data $4D5761, $4C555F, $4B535E, $49535C, $49515B, $47505A, $464F58, $454E57
Data $444D55, $444D55, $434B54, $434A53, $424A52, $647180, $637080, $63707F
Data $626F7D, $616E7C, $606D7B, $5F6C7A, $5E6B79, $5E6A78, $5C6876, $5C6774
Data $5B6673, $596572, $58636F, $56616E, $55606D, $545F6A, $535D69, $515C68
Data $515B65, $4F5964, $4E5862, $4D5760, $4B555F, $4A545D, $49535C, $48515A
Data $485059, $464F58, $454E57, $444D56, $434C55, $444C53, $434B53, $424A52
Data $647180, $64707F, $636F7E, $626F7D, $616E7C, $606D7B, $606C7A, $5F6B79
Data $5E6A77, $5C6976, $5C6775, $5A6573, $596572, $576370, $56626E, $56606C
Data $545F6B, $535D69, $525D67, $505B65, $4F5964, $4E5862, $4C5660, $4C555F
Data $4A545D, $49535C, $48515A, $475059, $464F58, $464E57, $444D56, $444C55
Data $434C53, $434A53, $424A52, $647180, $637180, $626F7E, $636E7D, $616E7D
Data $616D7B, $606C7A, $5F6A79, $5E6A77, $5C6976, $5B6774, $5A6673, $596572
Data $58636F, $57626E, $56606D, $545F6B, $535D69, $525C67, $515B66, $4F5964
Data $4E5863, $4D5661, $4C555F, $4A545E, $49525C, $49515A, $475059, $464F58
Data $464E56, $454D56, $434C54, $434C54, $424A52, $424A52, $647180, $63707F
Data $63707E, $626F7E, $616E7C, $616D7B, $5F6C7A, $5E6B79, $5E6A77, $5D6876
Data $5C6774, $5A6673, $596471, $586370, $57616E, $55606D, $545F6B, $535E69
Data $525C67, $515B66, $505964, $4E5862, $4D5761, $4C565F, $4B535E, $4A525C
Data $48525B, $475059, $474F58, $454E57, $444D55, $444C55, $434B54, $424A53
Data $424A52, $647180, $63717F, $63707E, $626F7D, $616E7C, $606D7B, $606C7A
Data $5F6B79, $5E6A77, $5D6976, $5B6774, $5A6673, $596571, $576370, $56626E
Data $55606D, $545F6B, $535D69, $525C67, $505A66, $505963, $4E5863, $4D5760
Data $4C5560, $4A545D, $49535C, $49515B, $475059, $474F58, $464E56, $454D56
Data $444C55, $434C54, $424B52, $424A52, $647180, $647080, $63707F, $626F7E
Data $616E7C, $616D7C, $5F6C7A, $5E6B78, $5E6A77, $5C6976, $5C6775, $5A6673
Data $596471, $58636F, $56626E, $56616D, $545E6A, $535D69, $525C68, $505B65
Data $505964, $4E5862, $4D5760, $4B555F, $4A545D, $49525C, $49515B, $485059
Data $474F58, $454E57, $454E55, $444C54, $434C53, $424B53, $424A52, $647180
Data $64707F, $62707E, $626F7D, $616E7C, $616D7B, $5F6C7A, $5E6A78, $5E6978
Data $5C6876, $5C6774, $5A6673, $596471, $58636F, $56626E, $56616C, $545F6B
Data $535D69, $525C67, $505B66, $4F5964, $4E5862, $4D5761, $4C555F, $4A545E
Data $4A525C, $49515A, $485059, $474F58, $454E57, $444D55, $444C54, $434C54
Data $424A53, $424A52, $647180, $63707F, $62707F, $636F7D, $616E7C, $606D7B
Data $606C7A, $5E6B78, $5E6A78, $5C6976, $5C6774, $5B6573, $596571, $58636F
Data $57616F, $55606C, $545F6B, $535D69, $525C67, $515A66, $4F5A64, $4E5762
Data $4D5761, $4C555F, $4A545E, $49535C, $49515B, $485059, $474F58, $464E57
Data $444D56, $444C55, $444C54, $434B52, $424A52, $647180, $63717F, $62707F
Data $626F7E, $616E7C, $606D7B, $5F6C7A, $5F6B78, $5D6A77, $5D6976, $5C6774
Data $5A6672, $596571, $586370, $57626E, $55616C, $545E6A, $535E69, $525C67
Data $515B66, $4F5A63, $4E5863, $4D5660, $4C555F, $4A545E, $49535C, $48515A
Data $485159, $464F58, $454E57, $454D56, $444D55, $434B54, $434B53, $424A52
Data $647180, $63707F, $63707E, $626F7D, $616E7C, $606D7C, $606C7A, $5F6B79
Data $5E6977, $5D6876, $5B6774, $5A6673, $596471, $586470, $57626E, $55606C
Data $555F6B, $535E69, $515C67, $505A65, $4F5964, $4E5862, $4D5761, $4B555F
Data $4A535E, $4A525C, $49515A, $475059, $464F58, $454E57, $454D55, $434C55
Data $434C53, $424B53, $424A52, $647180, $637180, $636F7E, $626F7D, $626E7C
Data $616D7C, $5F6C7A, $5F6B79, $5E6978, $5D6876, $5B6875, $5B6673, $5A6571
Data $586470, $57626E, $56606D, $545F6B, $535D69, $525C68, $515B66, $505964
Data $4E5863, $4D5661, $4C555F, $4A545E, $49525C, $48515B, $47505A, $464F58
Data $464E57, $454D56, $444C54, $444B54, $424B53, $424A52, $647180, $64707F
Data $636F7E, $626F7E, $626E7C, $616D7B, $606C7A, $5F6B78, $5E6978, $5D6876
Data $5B6775, $5A6673, $5A6471, $586370, $56626E, $55616C, $545F6B, $535D69
Data $525C67, $515B65, $4F5963, $4E5862, $4C5661, $4C565F, $4A545E, $49525C
Data $48525B, $475059, $464F58, $454E57, $454D55, $444D54, $434C54, $434B53
Data $424A52, $647180, $637180, $63707F, $626E7E, $616E7C, $616D7B, $606C7A
Data $5F6A79, $5D6A77, $5C6876, $5C6774, $5A6673, $596571, $586370, $56626E
Data $55606C, $545E6B, $535E69, $525C67, $515A66, $505964, $4E5862, $4D5760
Data $4C555F, $4B545E, $4A525C, $48515B, $485059, $474F58, $464E56, $454D56
Data $444C55, $434C54, $434A53, $424A52, $647180, $63707F, $63707F, $626F7E
Data $616E7C, $616D7C, $5F6C7A, $5F6B78, $5E6A77, $5D6876, $5C6774, $5A6673
Data $5A6572, $586370, $56626E, $55616C, $545F6A, $535E69, $525C68, $515B66
Data $4F5964, $4E5862, $4D5760, $4C555F, $4A535D, $49535C, $49515A, $485059
Data $464F58, $454E56, $454D55, $434C55, $444B54, $424B53, $424A52, $647180
Data $64707F, $63707E, $626F7D, $626E7D, $606D7B, $606C7A, $5E6B78, $5D6A77
Data $5D6876, $5B6874, $5A6673, $596472, $586370, $57626E, $56606C, $545F6A
Data $535E69, $525D68, $515A65, $4F5964, $4E5863, $4D5760, $4C555F, $4A545D
Data $49535C, $49525B, $47505A, $474F58, $454E57, $444D55, $444C54, $434B54
Data $434A53, $424A52, $647180, $63717F, $636F7F, $626F7E, $626E7C, $606D7C
Data $606C7B, $5E6A79, $5D6A78, $5C6976, $5B6775, $5A6673, $596472, $58636F
Data $57616E, $56616D, $545F6B, $535D69, $515C67, $505B66, $4F5964, $4E5862
Data $4D5761, $4C555F, $4A545E, $4A535C, $49515A, $475059, $464F58, $454E57
Data $454D55, $444C54, $434B53, $424B52, $424A52, $647180, $64717F, $63707E
Data $626F7D, $616E7C, $606D7C, $5F6C7A, $5E6A79, $5E6A78, $5D6976, $5B6775
Data $5A6673, $596471, $586370, $57626E, $56606C, $555F6A, $535E69, $525C68
Data $515B65, $505964, $4E5863, $4D5661, $4C555F, $4B545E, $49525C, $48525A
Data $475059, $464F58, $464E57, $454D56, $444C55, $434B53, $434A53, $424A52
Data $647180, $64707F, $63707F, $626F7D, $616E7C, $606D7C, $5F6C7A, $5F6B78
Data $5D6978, $5C6976, $5B6874, $5A6673, $596572, $586370, $57626E, $55606C
Data $555F6B, $535D69, $525C67, $515B66, $505964, $4E5862, $4C5661, $4C555F
Data $4B545E, $4A535C, $48515A, $475059, $464F58, $454E57, $444D55, $444C55
Data $434C54, $434B52, $424A52, $647180, $647180, $63707F, $626F7D, $626E7C
Data $616D7C, $5F6C7A, $5F6B78, $5E6977, $5D6876, $5C6874, $5A6673, $596571
Data $586370, $57626E, $56606D, $555F6A, $535D69, $525C67, $515B65, $4F5964
Data $4E5862, $4D5761, $4B555F, $4A545E, $4A525C, $48515B, $475059, $474F58
Data $464E57, $444D56, $444C54, $444C54, $424A53, $424A52, $647180, $63707F
Data $63707E, $626F7D, $626E7D, $616D7B, $606C7A, $5F6B79, $5E6A77, $5D6976
Data $5B6875, $5A6673, $596472, $586370, $57626E, $55606D, $555F6B, $535D69
Data $525C67, $505A65, $4F5964, $4E5862, $4C5761, $4C555F, $4A545D, $49525C
Data $48525B, $47505A, $474F58, $454E57, $444D55, $444C54, $434B53, $424B53
Data $424A52, $647180, $63707F, $63707E, $626F7D, $616E7D, $616D7B, $606B7A
Data $5F6B79, $5D6A77, $5D6976, $5B6774, $5A6673, $596471, $58636F, $56626E
Data $56606D, $555F6A, $535E69, $515C68, $515B65, $4F5964, $4E5862, $4D5760
Data $4C555F, $4A535D, $49535C, $49525A, $47505A, $464F58, $464E57, $454D56
Data $444C55, $434B53, $434A53, $424A52, $647180, $64707F, $63707F, $626F7D
Data $616E7D, $616D7C, $606C7A, $5E6B79, $5D6A77, $5D6976, $5B6774, $5B6573
Data $596572, $586470, $56626E, $56606C, $545F6B, $535E69, $525C67, $515B66
Data $4F5964, $4E5762, $4D5660, $4B5660, $4B545E, $49525C, $49515A, $475059
Data $474F58, $464E57, $444D55, $444C54, $444C54, $424B53, $424A52, $647180
Data $63707F, $62707F, $626F7D, $616E7D, $606D7C, $606C7A, $5F6A79, $5E6A78
Data $5C6876, $5C6774, $5A6673, $596472, $586370, $56626E, $55616C, $545F6B
Data $535E69, $525C67, $505B65, $4F5964, $4E5862, $4D5761, $4C5560, $4B535D
Data $49535C, $48515B, $485059, $464F57, $454E57, $454D55, $444C54, $434C53
Data $424A52, $424A52, $647180, $64707F, $636F7E, $626F7D, $616E7C, $616D7B
Data $606C7A, $5F6B79, $5E6A78, $5D6876, $5B6775, $5A6573, $596472, $58636F
Data $56626E, $55606C, $545F6B, $535D69, $525C68, $515B66, $4F5964, $4E5862
Data $4D5761, $4B5660, $4A535D, $49525C, $49515A, $485059, $474F58, $464E57
Data $454D55, $444C55, $434C53, $434B53, $424A52, $647180, $63707F, $636F7E
Data $626F7D, $616E7D, $606D7B, $606C7A, $5F6B78, $5E6978, $5D6976, $5C6875
Data $5A6673, $596471, $586370, $57626E, $56606D, $545F6B, $535E69, $525C68
Data $505A66, $4F5964, $4E5862, $4D5661, $4C555F, $4B545D, $49525C, $48515A
Data $485159, $465058, $464E57, $454D55, $444D54, $444B54, $424B52, $424A52
Data $647180, $63707F, $63707F, $626E7D, $616E7D, $606D7C, $606C7A, $5E6B79
Data $5D6A77, $5D6876, $5C6775, $5B6673, $5A6471, $586370, $57616E, $55606C
Data $555F6A, $535D69, $525C68, $515B65, $4F5964, $4E5862, $4D5760, $4C565F
Data $4A535D, $49525C, $48515B, $47505A, $464F58, $464E56, $444D55, $444C55
Data $434B54, $424A52, $424A52, $647180, $63707F, $62707E, $636F7E, $616E7D
Data $606D7B, $5F6C7A, $5F6A79, $5E6A78, $5C6976, $5B6774, $5A6673, $5A6472
Data $586370, $56626E, $56606C, $545F6B, $535E69, $515C68, $515B66, $4F5A64
Data $4E5763, $4D5661, $4C555F, $4A535E, $4A535C, $48515B, $47505A, $464F58
Data $464E57, $444D56, $444C54, $434B54, $434A52, $424A52, $647180, $63707F
Data $636F7F, $636F7E, $626E7C, $606D7B, $606C7B, $5F6B79, $5E6A77, $5D6876
Data $5B6774, $5B6673, $596471, $586370, $57626F, $55606C, $545F6B, $535E69
Data $525C68, $515A65, $4F5A64, $4E5863, $4D5661, $4C555F, $4B545D, $49525C
Data $49525B, $485059, $464F58, $464E57, $454D55, $444C55, $434C54, $424B52
Data $424A52, $647180, $63717F, $636F7E, $626F7E, $616E7D, $616D7B, $606C7A
Data $5F6B78, $5E6A77, $5C6976, $5B6774, $5A6673, $596572, $586370, $57626E
Data $55606C, $545F6B, $535E69, $525D67, $515B66, $4F5964, $4E5862, $4D5761
Data $4C555F, $4B545E, $4A535D, $48525A, $475059, $464F58, $464E57, $444D56
Data $444C54, $434B54, $424B53, $424A52, $647180, $64717F, $63707F, $626F7D
Data $626E7C, $616D7B, $606C7A, $5F6A78, $5D6A78, $5C6876, $5B6774, $5A6673
Data $596571, $58636F, $57626E, $56606D, $545F6B, $535E69, $515C68, $505A66
Data $505964, $4E5763, $4D5661, $4C555F, $4B545D, $4A525C, $48515A, $475059
Data $464F58, $464E57, $444D56, $444C54, $434C54, $434B53, $424A52, $647180
Data $63707F, $63707F, $626F7E, $616E7C, $606D7B, $606C7A, $5E6A79, $5D6977
Data $5D6876, $5C6774, $5A6673, $5A6571, $58636F, $57626E, $56606D, $555F6B
Data $535E69, $525C68, $505B65, $4F5964, $4E5862, $4D5760, $4B555F, $4A545E
Data $49525C, $48515B, $485059, $475058, $464E57, $454D56, $444C54, $434B54
Data $424A53, $424A52, $647180, $637080, $63707F, $626F7D, $616E7C, $606D7C
Data $606C7A, $5F6A78, $5D6977, $5C6876, $5B6774, $5A6673, $596572, $58636F
Data $57626E, $56606C, $545F6B, $535E69, $525C67, $505B66, $505A64, $4E5863
Data $4D5660, $4C555F, $4A535E, $4A525C, $49515B, $475059, $464F58, $454E57
Data $444D56, $444C54, $434B54, $434A53, $424A52, $647180, $63707F, $636F7F
Data $626F7E, $616E7D, $606D7B, $5F6C7A, $5E6B79, $5E6977, $5C6976, $5C6774
Data $5A6673, $596571, $58636F, $57626E, $55606C, $545F6B, $535D69, $515C68
Data $505B66, $505964, $4E5863, $4D5761, $4C5560, $4B545E, $4A535C, $48515B
Data $48505A, $474F58, $454E57, $454D55, $444C54, $434B54, $424A53, $424A52
Data $647180, $64707F, $636F7E, $626E7D, $616E7D, $616D7B, $5F6C7A, $5F6B79
Data $5E6978, $5D6976, $5C6775, $5A6573, $596471, $58646F, $57626E, $55606D
Data $545F6A, $535D69, $525C67, $505B66, $4F5964, $4E5862, $4D5761, $4C555F
Data $4B545D, $49535C, $49525A, $475059, $464F58, $464E57, $444D56, $444D54
Data $434B54, $434B53, $424A52, $647180, $64717F, $63707E, $626F7D, $626E7C
Data $616D7B, $606C7A, $5F6B78, $5E6A78, $5D6976, $5B6775, $5B6673, $596471
Data $58636F, $57626E, $55616D, $545F6B, $535E69, $515C68, $515B65, $4F5964
Data $4E5862, $4D5661, $4C555F, $4B545D, $49525C, $48515B, $475159, $474F58
Data $464E57, $454D56, $444C54, $434C53, $424A52, $424A52, $647180, $637180
Data $636F7E, $626F7E, $616E7C, $606D7C, $5F6C7B, $5F6B79, $5D6A77, $5D6876
Data $5B6775, $5B6673, $596571, $586370, $57626F, $55616D, $545F6B, $535D69
Data $525C68, $505B65, $4F5963, $4F5862, $4D5661, $4C565F, $4B535D, $49525C
Data $48515B, $485059, $464F58, $454E57, $454D56, $444C54, $434C54, $434B53
Data $424A52, $647180, $63707F, $63707F, $626E7E, $616E7D, $616D7C, $5F6C7A
Data $5F6B79, $5E6978, $5D6876, $5C6774, $5A6573, $596571, $586470, $57626E
Data $55606C, $545F6B, $535E69, $525C68, $515B65, $505964, $4E5862, $4D5760
Data $4C555F, $4B545D, $49525C, $48515B, $475059, $465058, $464E57, $444D55
Data $444C55, $434B53, $434B53, $424A52, $647180, $64717F, $63707E, $626F7E
Data $616E7C, $616D7B, $606C7A, $5F6B79, $5E6977, $5C6976, $5C6874, $5A6673
Data $5A6571, $586370, $57626E, $55616C, $545F6B, $535E69, $515C67, $515B66
Data $4F5964, $4E5862, $4D5761, $4C555F, $4B545D, $49525C, $49525B, $47505A
Data $464F58, $454E57, $444D55, $444C54, $434B54, $424B52, $424A52, $647180
Data $647180, $636F7E, $626F7D, $626E7C, $606D7B, $606C7A, $5F6B78, $5E6A77
Data $5D6976, $5C6774, $5B6673, $596571, $576370, $56626E, $56606D, $545F6B
Data $535E69, $515C67, $505B66, $505A64, $4F5862, $4D5660, $4C555F, $4B545D
Data $49535C, $48515B, $475059, $464F58, $464E56, $444D55, $444D54, $434B54
Data $434A53, $424A52, $647180, $647080, $63707E, $626F7E, $626E7D, $606D7C
Data $606C7A, $5F6B79, $5D6A78, $5C6876, $5C6774, $5B6673, $596572, $586470
Data $57616E, $56616C, $545F6A, $535D69, $525C68, $505A66, $4F5964, $4F5862
Data $4D5660, $4B555F, $4A535D, $4A525C, $48515A, $475059, $464F58, $464E57
Data $444D56, $444C54, $434B54, $434A53, $424A52, $647180, $64717F, $636F7F
Data $626E7E, $616E7D, $606D7B, $606C7A, $5E6A78, $5E6A77, $5C6876, $5B6875
Data $5A6673, $596571, $58636F, $57626E, $56616D, $545F6B, $535E69, $525C67
Data $505B65, $505964, $4E5862, $4D5761, $4B565F, $4A545D, $49525D, $48515A
Data $48505A, $465058, $464E56, $454D56, $444C54, $444C54, $434B53, $424A52
Data $647180, $64717F, $63707F, $626F7E, $616E7D, $606D7B, $606C7A, $5E6B79
Data $5D6977, $5D6876, $5C6774, $5B6673, $596571, $586370, $57616E, $55616D
Data $545F6A, $535D69, $515C67, $505B65, $4F5A64, $4E5763, $4D5661, $4C5560
Data $4A545D, $4A535C, $49525B, $485159, $464F58, $464E57, $454D55, $434C55
Data $434C54, $434A53, $424A52, $647180, $637180, $63707E, $626F7D, $616E7C
Data $606D7C, $606C7A, $5E6B79, $5D6A78, $5D6876, $5C6774, $5A6673, $596471
Data $586470, $57626E, $56616C, $545F6A, $535E69, $525D67, $515B66, $4F5A64
Data $4E5862, $4D5760, $4C555F, $4A545E, $49535C, $49525A, $475059, $464F58
Data $464E57, $454D56, $444C55, $434C53, $424A53, $424A52, $647180, $63707F
Data $636F7F, $626F7D, $626E7C, $616D7C, $606C7A, $5F6B79, $5E6977, $5C6876
Data $5B6774, $5A6673, $596572, $586370, $57616E, $56606D, $545F6B, $535E69
Data $525C67, $515B65, $4F5964, $4E5862, $4D5761, $4C565F, $4A535E, $4A525C
Data $48525B, $475059, $464F58, $464E56, $444D56, $444D54, $434C53, $424A52
Data $424A52, $647180, $64707F, $636F7E, $636F7E, $616E7C, $616D7C, $606C7A
Data $5F6B79, $5D6978, $5D6876, $5C6774, $5A6673, $596472, $586370, $57626E
Data $56606C, $545F6B, $535D69, $525C67, $515B66, $505964, $4E5862, $4D5661
Data $4C5560, $4B545D, $4A525C, $48515A, $48505A, $474F58, $454E56, $454D56
Data $444C54, $434C54, $424A53, $424A52, $647180, $637080, $62707F, $636F7D
Data $616E7C, $616D7B, $606C7A, $5F6B78, $5E6A78, $5D6976, $5B6774, $5A6673
Data $596471, $58636F, $56616E, $55616C, $545F6A, $535D69, $525C68, $515B66
Data $4F5964, $4E5862, $4C5761, $4C555F, $4B545E, $49535C, $49525B, $485059
Data $474F58, $454E56, $454D56, $444C55, $434B54, $434A52, $424A52, $647180
Data $63717F, $62707E, $626F7D, $626E7D, $606D7B, $606C7A, $5F6B79, $5D6A78
Data $5D6876, $5C6775, $5A6673, $596472, $586370, $57626E, $55606D, $545F6A
Data $535D69, $525C67, $515A65, $505964, $4E5862, $4D5761, $4C565F, $4A545D
Data $4A535C, $48515B, $475059, $474F58, $454E57, $454D55, $444C55, $434C54
Data $434A53, $424A52, $647180, $63717F, $62707E, $626F7D, $626E7C, $606D7C
Data $5F6C7A, $5F6B79, $5E6A78, $5D6876, $5C6774, $5A6673, $596571, $58636F
Data $57616E, $55616C, $545E6B, $535E69, $525C67, $505A65, $4F5964, $4F5862
Data $4D5661, $4B5560, $4A545E, $49525C, $49515B, $475059, $464F58, $454E56
Data $444D55, $444D55, $434B54, $434B53, $424A52, $647180, $637080, $636F7E
Data $626F7D, $626E7D, $616D7B, $606B7B, $5E6B79, $5E6A77, $5D6876, $5B6775
Data $5B6673, $596571, $586370, $57616F, $56606C, $555F6A, $535D69, $525C67
Data $505B66, $4F5964, $4E5863, $4D5661, $4C555F, $4B545D, $49525C, $48515A
Data $475159, $464F58, $454E57, $454D55, $444C54, $434B54, $424A53, $424A52
Data $647180, $637080, $63707E, $636F7E, $616E7C, $606D7C, $606C7A, $5F6B79
Data $5E6A77, $5D6876, $5B6775, $5B6673, $596472, $58636F, $57616E, $55606C
Data $545F6B, $535D69, $525C68, $515B65, $505964, $4E5862, $4D5661, $4B555F
Data $4A545E, $49535C, $49515B, $485059, $474F58, $454E56, $454D56, $444D55
Data $434C53, $424B53, $424A52, $647180, $63707F, $636F7F, $626F7D, $616E7C
Data $616D7B, $606C7A, $5E6B78, $5D6A78, $5D6876, $5B6775, $5A6673, $596471
Data $586370, $57616E, $56606C, $545F6A, $535D69, $525C68, $515A66, $4F5964
Data $4E5863, $4D5760, $4C555F, $4A535E, $4A535C, $48525A, $47505A, $465058
Data $464E57, $454D56, $444C55, $434C53, $434A52, $424A52, $647180, $64707F
Data $63707E, $626F7E, $616E7C, $616D7B, $5F6C7A, $5F6B78, $5E6A77, $5D6876
Data $5B6774, $5A6673, $596471, $586470, $57626E, $55606C, $555F6B, $535E69
Data $525C67, $505A66, $505964, $4F5863, $4D5761, $4C555F, $4B545D, $4A525D
Data $48515B, $47515A, $474F58, $454E56, $444D56, $444C55, $434C54, $434B53
Data $424A52, $647180, $647080, $63707F, $636F7D, $626E7D, $616D7B, $606C7A
Data $5E6B78, $5E6A77, $5D6876, $5C6774, $5A6673, $596572, $58636F, $57626F
Data $56616C, $555F6A, $535D69, $525C67, $515A66, $505964, $4E5863, $4D5760
Data $4C555F, $4B535D, $4A535C, $48515B, $475059, $474F58, $464E57, $444D56
Data $434C55, $434B54, $434B53, $424A52, $647180, $637080, $63707E, $626F7D
Data $626E7C, $606D7B, $5F6C7B, $5E6B79, $5E6977, $5C6976, $5C6774, $5A6673
Data $5A6472, $57646F, $56616E, $55606C, $555F6B, $535E69, $525C68, $505B66
Data $4F5964, $4E5763, $4C5660, $4C555F, $4A545D, $4A525C, $48515A, $475159
Data $464F58, $464E57, $454D55, $444C54, $434B54, $424B53, $424A52, $647180
Data $63717F, $636F7F, $626F7D, $616D7D, $606D7B, $5F6C7A, $5F6B79, $5E6A78
Data $5C6876, $5B6774, $5A6673, $596472, $586370, $57626E, $56616D, $545F6B
Data $535D69, $525C67, $515B65, $505964, $4E5762, $4D5761, $4C5560, $4B545D
Data $49535C, $48515A, $485059, $474F58, $454E57, $444D56, $444C54, $444B53
Data $424A53, $424A52, $647180, $64707F, $62707E, $626F7D, $616D7C, $606D7C
Data $606C7A, $5F6B79, $5D6A77, $5D6976, $5C6774, $5A6573, $596571, $586370
Data $57616E, $56606C, $545F6A, $535D69, $525C67, $515A66, $505964, $4E5862
Data $4C5761, $4C555F, $4A545E, $4A525C, $48515A, $47505A, $464F58, $454E56
Data $454D55, $444C55, $434C54, $424B52, $424A52, $647180, $63707F, $626F7E
Data $626E7D, $616E7C, $606D7C, $606C7A, $5F6B79, $5D6978, $5C6876, $5C6875
Data $5A6673, $596471, $586370, $57626E, $56616C, $545F6A, $535E69, $525C67
Data $505B66, $4F5A64, $4F5862, $4D5661, $4C555F, $4A545E, $49525C, $48515A
Data $475059, $474F58, $454E57, $454D56, $444C54, $434C54, $424B53, $424A52
Data $647180, $64717F, $63707E, $626F7E, $616E7D, $616D7C, $5F6C7A, $5E6B79
Data $5E6978, $5D6875, $5B6774, $5B6673, $596471, $586370, $56626E, $56616C
Data $555F6A, $535E69, $525C68, $505B66, $4F5964, $4E5762, $4D5761, $4B555F
Data $4B535D, $49525C, $49515B, $475059, $464F58, $454E57, $444D55, $444C55
Data $434B53, $424A53, $424A52, $647180, $63717F, $63707E, $626F7E, $626E7C
Data $616D7B, $5F6C7A, $5F6B78, $5D6978, $5D6976, $5C6774, $5A6573, $596472
Data $586370, $57626F, $56606C, $545F6B, $535D69, $525D67, $505B66, $505964
Data $4E5863, $4C5661, $4B555F, $4A545E, $4A525C, $48525A, $475059, $465058
Data $464E57, $444D56, $444C54, $434C53, $434B53, $424A52, $647180, $64717F
Data $636F7F, $626F7D, $616E7D, $606D7B, $606C7A, $5E6B79, $5E6977, $5C6876
Data $5B6774, $5B6673, $596472, $586370, $57626E, $55616D, $545F6B, $535D69
Data $515C67, $505B65, $4F5A64, $4E5862, $4D5661, $4B555F, $4B545D, $49525C
Data $48525A, $485059, $464F58, $464E57, $454D56, $444D54, $434C54, $434A53
Data $424A52, $647180, $63717F, $636F7F, $636F7E, $616E7C, $616D7C, $5F6B7A
Data $5F6B79, $5E6977, $5C6876, $5B6774, $5A6573, $596472, $58636F, $57626E
Data $55606C, $545F6B, $535E69, $525D67, $505B65, $4F5A64, $4E5863, $4D5761
Data $4C565F, $4A545D, $49525C, $48515B, $47505A, $464F58, $454E57, $444D56
Data $444C54, $434C53, $434A53, $424A52, $647180, $64707F, $636F7E, $626E7E
Data $616E7C, $616D7B, $606C7A, $5F6B79, $5E6977, $5C6876, $5B6774, $5A6673
Data $596471, $586370, $56626E, $55606C, $545F6A, $535D69, $525C67, $505B65
Data $4F5A64, $4E5862, $4D5661, $4B555F, $4A545D, $49525C, $48525B, $475159
Data $474F58, $464E57, $454D56, $444C55, $434B53, $434A53, $424A52, $647180
Data $64707F, $62707E, $626F7D, $626E7D, $616D7C, $606C7A, $5F6B79, $5E6A77
Data $5D6876, $5C6775, $5B6673, $596571, $58636F, $57626E, $56616C, $545F6B
Data $535E69, $525C67, $505B66, $4F5964, $4E5863, $4D5661, $4B555F, $4B545E
Data $49525C, $49515A, $47505A, $474F58, $454E57, $454D55, $444C54, $444B53
Data $424A53, $424A52, $647180, $64707F, $626F7F, $626F7E, $616D7C, $606D7B
Data $606C7A, $5E6B78, $5E6A78, $5C6976, $5B6774, $5B6673, $596471, $58636F
Data $56626E, $55606D, $545F6B, $535D69, $525C67, $515A66, $4F5964, $4E5862
Data $4D5660, $4C555F, $4B545E, $49535C, $48525B, $475159, $474F58, $454E56
Data $444D55, $444C54, $434C54, $434A52, $424A52, $647180, $63707F, $63707E
Data $626F7E, $616E7D, $606D7B, $606C7A, $5F6B79, $5E6A77, $5D6976, $5C6775
Data $5A6673, $596571, $58636F, $57616E, $56616C, $545F6B, $535E69, $525D67
Data $505B66, $505A64, $4E5762, $4D5661, $4C555F, $4A545E, $49525D, $48515B
Data $475059, $464F58, $454E57, $454D55, $444D55, $434B53, $424B53, $424A52
Data $647180, $63717F, $626F7E, $626F7E, $616E7D, $616D7B, $606C7A, $5F6B79
Data $5D6A78, $5D6976, $5B6774, $5A6673, $596571, $586370, $57626F, $56606D
Data $555E6B, $535D69, $525C67, $515A65, $4F5964, $4E5862, $4C5661, $4C565F
Data $4A545D, $4A535C, $48515B, $47515A, $464F58, $464E56, $454D56, $444C55
Data $434B54, $424A53, $424A52, $647180, $647080, $63707F, $626F7D, $616E7D
Data $616D7B, $606C7A, $5F6B79, $5E6A77, $5C6976, $5B6774, $5A6572, $596571
Data $586370, $57626E, $55606C, $545F6A, $535E69, $525C67, $515A66, $4F5963
Data $4E5862, $4C5661, $4C555F, $4B545E, $4A525C, $48515A, $475059, $474F58
Data $464E56, $454D56, $444D55, $434B53, $434B53, $424A52, $647180, $64707F
Data $63707F, $626F7D, $616E7C, $606D7B, $606C7B, $5F6B78, $5D6A78, $5C6876
Data $5C6874, $5A6673, $596471, $586470, $57616E, $55616C, $555F6B, $535E69
Data $525C67, $515B66, $4F5964, $4E5862, $4D5660, $4B555F, $4B545E, $4A535C
Data $49515B, $485159, $464F58, $454E56, $454D56, $444C55, $434C53, $434B53
Data $424A52, $647180, $64717F, $636F7E, $626F7E, $626E7D, $606D7B, $606C7A
Data $5F6B79, $5E6977, $5D6876, $5B6774, $5A6673, $596472, $58636F, $57626E
Data $55606D, $555F6B, $535E69, $525C68, $515B66, $4F5A64, $4E5862, $4D5660
Data $4C5560, $4A545D, $49535C, $49515B, $47505A, $464F58, $464E57, $454D56
Data $444D54, $434C54, $424B53, $424A52, $647180, $647180, $63707E, $626F7E
Data $616E7D, $606D7B, $606C7A, $5E6B79, $5D6A78, $5C6876, $5C6775, $5A6673
Data $596572, $586370, $57626E, $56616D, $555F6B, $535D69, $525C67, $505B66
Data $505964, $4E5862, $4D5661, $4C555F, $4A545D, $4A525C, $49515B, $47505A
Data $475058, $454E57, $454D56, $444C55, $434C53, $434A53, $424A52, $647180
Data $64707F, $636F7F, $626F7D, $616D7D, $606D7B, $5F6C7A, $5F6B79, $5D6A77
Data $5C6875, $5B6874, $5A6673, $596472, $586370, $57626E, $56606C, $545F6B
Data $535D69, $525C68, $505B66, $4F5963, $4E5762, $4D5661, $4C555F, $4B545E
Data $4A525C, $49525B, $475059, $474F58, $464E57, $444D55, $444C54, $444C53
Data $434B52, $424A52, $647180, $63707F, $63707F, $626F7D, $616D7C, $606D7B
Data $5F6C7A, $5E6B79, $5E6A78, $5C6976, $5C6774, $5B6672, $596572, $586370
Data $57626E, $56606C, $545F6B, $535D69, $525C67, $515B66, $4F5964, $4E5862
Data $4D5661, $4B555F, $4B545D, $49525C, $49515B, $47505A, $464F58, $464E57
Data $454D55, $444C55, $434C54, $424B53, $424A52, $647180, $63707F, $636F7E
Data $626F7D, $616E7C, $606D7B, $606C7A, $5F6B79, $5D6A77, $5D6876, $5C6775
Data $5A6673, $596472, $58646F, $57626E, $55606C, $545F6A, $535E69, $525C68
Data $515A65, $4F5A64, $4E5862, $4D5761, $4C5560, $4B545D, $49525C, $49515A
Data $475059, $474F58, $454E57, $454D56, $434C54, $434B54, $434A52, $424A52


.BCF_ButtonBackgroundOff_Style03
Data 80
Data 35
Data $394655, $384654, $384553, $374453, $374351, $354250, $34414F, $33404E
Data $323F4C, $313E4B, $303C49, $2F3B48, $2E3A46, $2D3945, $2B3744, $2A3641
Data $29343F, $28323E, $26313C, $25303A, $252E39, $232D37, $222C36, $212A34
Data $202932, $1F2831, $1D2730, $1C252E, $1B242D, $1A232C, $1A222B, $19212A
Data $182028, $172028, $171F27, $394655, $384554, $384554, $374452, $364352
Data $354250, $35414F, $34404E, $333E4C, $323E4B, $313C49, $2F3B48, $2E3946
Data $2D3845, $2C3743, $2A3641, $29343F, $28333E, $27313C, $26303B, $252E39
Data $232D37, $222C36, $202A34, $1F2933, $1E2731, $1D262F, $1D252E, $1C242D
Data $1B232C, $19222B, $192129, $182028, $171F28, $171F27, $394655, $384654
Data $384454, $374452, $374352, $354251, $34414F, $34404E, $323F4C, $323D4B
Data $303C49, $2F3B48, $2F3A47, $2D3845, $2C3643, $2A3641, $293440, $28333E
Data $26313D, $25303B, $242E39, $232D37, $222B36, $202A34, $202932, $1F2831
Data $1D2630, $1D262E, $1B242D, $1B232C, $1A222A, $192129, $192028, $181F27
Data $171F27, $394655, $384554, $384553, $374452, $374352, $364250, $35414F
Data $34404E, $333F4C, $313D4B, $313C4A, $303B48, $2E3A46, $2C3844, $2B3743
Data $2B3642, $2A343F, $28323E, $27313C, $25303A, $252E39, $232D37, $212C36
Data $212A34, $202833, $1E2831, $1E2630, $1D262F, $1B242C, $1B232C, $19222B
Data $19212A, $182029, $172028, $171F27, $394655, $394554, $384454, $374452
Data $364351, $354250, $34414F, $34404E, $323E4C, $313E4B, $313C4A, $2F3B48
Data $2E3A46, $2D3845, $2C3743, $2B3641, $2A343F, $28333E, $27323D, $26303B
Data $252E39, $232C37, $222B36, $212A34, $1F2932, $1E2831, $1E2630, $1C252E
Data $1C242D, $1B232B, $1A222B, $192129, $182029, $182028, $171F27, $394655
Data $394554, $374553, $374453, $374352, $364251, $35414F, $33404D, $333F4D
Data $313E4B, $303C49, $2F3B48, $2E3A46, $2D3944, $2C3743, $2A3642, $29343F
Data $28333E, $27313C, $252F3A, $242E39, $232C37, $222C36, $212A34, $202933
Data $1F2731, $1D262F, $1C252E, $1B242C, $1B232C, $1A222A, $19222A, $182128
Data $181F28, $171F27, $394655, $394654, $384553, $374453, $374351, $364251
Data $34404F, $333F4D, $333F4C, $313D4B, $303C4A, $2F3B48, $2E3946, $2D3845
Data $2C3743, $2B3541, $29343F, $28323E, $27313C, $252F3B, $252E39, $232C38
Data $222C36, $212A34, $202833, $1E2831, $1E2630, $1C252F, $1B242D, $1A232C
Data $19222A, $19222A, $182029, $181F28, $171F27, $394655, $384555, $384554
Data $374452, $364351, $354250, $34414F, $33404E, $333F4D, $313D4B, $313C49
Data $303B48, $2E3A47, $2D3844, $2B3643, $2A3542, $29343F, $28323E, $26313D
Data $26303A, $242E39, $232D37, $222C35, $202A34, $1F2932, $1E2831, $1D262F
Data $1D252E, $1B242D, $1A232C, $19222B, $18212A, $192128, $182028, $171F27
Data $394655, $394554, $384453, $374452, $364351, $354250, $35414F, $34404E
Data $333F4C, $313E4B, $313C4A, $2F3A48, $2E3A47, $2C3845, $2B3743, $2B3541
Data $293440, $28323E, $27323C, $25303A, $242E39, $232D37, $212B35, $212A34
Data $1F2932, $1E2831, $1D262F, $1C252E, $1B242D, $1B232C, $19222B, $19212A
Data $182128, $181F28, $171F27, $394655, $384655, $374453, $384352, $364352
Data $364250, $35414F, $343F4E, $333F4C, $313E4B, $303C49, $2F3B48, $2E3A47
Data $2D3844, $2C3743, $2B3542, $293440, $28323E, $27313C, $26303B, $242E39
Data $232D38, $222B36, $212A34, $1F2933, $1E2731, $1E262F, $1C252E, $1B242D
Data $1B232B, $1A222B, $182129, $182129, $171F27, $171F27, $394655, $384554
Data $384553, $374453, $364351, $364250, $34414F, $33404E, $333F4C, $323D4B
Data $313C49, $2F3B48, $2E3946, $2D3845, $2C3643, $2A3542, $293440, $28333E
Data $27313C, $26303B, $252E39, $232D37, $222C36, $212B34, $202833, $1F2731
Data $1D2730, $1C252E, $1C242D, $1A232C, $19222A, $19212A, $182029, $171F28
Data $171F27, $394655, $384654, $384553, $374452, $364351, $354250, $35414F
Data $34404E, $333F4C, $323E4B, $303C49, $2F3B48, $2E3A46, $2C3845, $2B3743
Data $2A3542, $293440, $28323E, $27313C, $252F3B, $252E38, $232D38, $222C35
Data $212A35, $1F2932, $1E2831, $1E2630, $1C252E, $1C242D, $1B232B, $1A222B
Data $19212A, $182129, $172027, $171F27, $394655, $394555, $384554, $374453
Data $364351, $364251, $34414F, $33404D, $333F4C, $313E4B, $313C4A, $2F3B48
Data $2E3946, $2D3844, $2B3743, $2B3642, $29333F, $28323E, $27313D, $25303A
Data $252E39, $232D37, $222C35, $202A34, $1F2932, $1E2731, $1E2630, $1D252E
Data $1C242D, $1A232C, $1A232A, $192129, $182128, $172028, $171F27, $394655
Data $394554, $374553, $374452, $364351, $364250, $34414F, $333F4D, $333E4D
Data $313D4B, $313C49, $2F3B48, $2E3946, $2D3844, $2B3743, $2B3641, $293440
Data $28323E, $27313C, $25303B, $242E39, $232D37, $222C36, $212A34, $1F2933
Data $1F2731, $1E262F, $1D252E, $1C242D, $1A232C, $19222A, $192129, $182129
Data $171F28, $171F27, $394655, $384554, $374554, $384452, $364351, $354250
Data $35414F, $33404D, $333F4D, $313E4B, $313C49, $303A48, $2E3A46, $2D3844
Data $2C3644, $2A3541, $293440, $28323E, $27313C, $262F3B, $242F39, $232C37
Data $222C36, $212A34, $1F2933, $1E2831, $1E2630, $1D252E, $1C242D, $1B232C
Data $19222B, $19212A, $192129, $182027, $171F27, $394655, $384654, $374554
Data $374453, $364351, $354250, $34414F, $34404D, $323F4C, $323E4B, $313C49
Data $2F3B47, $2E3A46, $2D3845, $2C3743, $2A3641, $29333F, $28333E, $27313C
Data $26303B, $242F38, $232D38, $222B35, $212A34, $1F2933, $1E2831, $1D262F
Data $1D262E, $1B242D, $1A232C, $1A222B, $19222A, $182029, $182028, $171F27
Data $394655, $384554, $384553, $374452, $364351, $354251, $35414F, $34404E
Data $333E4C, $323D4B, $303C49, $2F3B48, $2E3946, $2D3945, $2C3743, $2A3541
Data $2A3440, $28333E, $26313C, $252F3A, $242E39, $232D37, $222C36, $202A34
Data $1F2833, $1F2731, $1E262F, $1C252E, $1B242D, $1A232C, $1A222A, $18212A
Data $182128, $172028, $171F27, $394655, $384655, $384453, $374452, $374351
Data $364251, $34414F, $34404E, $333E4D, $323D4B, $303D4A, $303B48, $2F3A46
Data $2D3945, $2C3743, $2B3542, $293440, $28323E, $27313D, $26303B, $252E39
Data $232D38, $222B36, $212A34, $1F2933, $1E2731, $1D2630, $1C252F, $1B242D
Data $1B232C, $1A222B, $192129, $192029, $172028, $171F27, $394655, $394554
Data $384453, $374453, $374351, $364250, $35414F, $34404D, $333E4D, $323D4B
Data $303C4A, $2F3B48, $2F3946, $2D3845, $2B3743, $2A3641, $293440, $28323E
Data $27313C, $26303A, $242E38, $232D37, $212B36, $212B34, $1F2933, $1E2731
Data $1D2730, $1C252E, $1B242D, $1A232C, $1A222A, $192229, $182129, $182028
Data $171F27, $394655, $384655, $384554, $374353, $364351, $364250, $35414F
Data $343F4E, $323F4C, $313D4B, $313C49, $2F3B48, $2E3A46, $2D3845, $2B3743
Data $2A3541, $293340, $28333E, $27313C, $262F3B, $252E39, $232D37, $222C35
Data $212A34, $202933, $1F2731, $1D2630, $1D252E, $1C242D, $1B232B, $1A222B
Data $19212A, $182129, $181F28, $171F27, $394655, $384554, $384554, $374453
Data $364351, $364251, $34414F, $34404D, $333F4C, $323D4B, $313C49, $2F3B48
Data $2F3A47, $2D3845, $2B3743, $2A3641, $29343F, $28333E, $27313D, $26303B
Data $242E39, $232D37, $222C35, $212A34, $1F2832, $1E2831, $1E262F, $1D252E
Data $1B242D, $1A232B, $1A222A, $18212A, $192029, $172028, $171F27, $394655
Data $394554, $384553, $374452, $374352, $354250, $35414F, $33404D, $323F4C
Data $323D4B, $303D49, $2F3B48, $2E3947, $2D3845, $2C3743, $2B3541, $29343F
Data $28333E, $27323D, $262F3A, $242E39, $232D38, $222C35, $212A34, $1F2932
Data $1E2831, $1E2730, $1C252F, $1C242D, $1A232C, $19222A, $192129, $182029
Data $181F28, $171F27, $394655, $384654, $384454, $374453, $374351, $354251
Data $354150, $333F4E, $323F4D, $313E4B, $303C4A, $2F3B48, $2E3947, $2D3844
Data $2C3643, $2B3642, $293440, $28323E, $26313C, $25303B, $242E39, $232D37
Data $222C36, $212A34, $1F2933, $1F2831, $1E262F, $1C252E, $1B242D, $1A232C
Data $1A222A, $192129, $182028, $172027, $171F27, $394655, $394654, $384553
Data $374452, $364351, $354251, $34414F, $333F4E, $333F4D, $323E4B, $303C4A
Data $2F3B48, $2E3946, $2D3845, $2C3743, $2B3541, $2A343F, $28333E, $27313D
Data $26303A, $252E39, $232D38, $222B36, $212A34, $202933, $1E2731, $1D272F
Data $1C252E, $1B242D, $1B232C, $1A222B, $19212A, $182028, $181F28, $171F27
Data $394655, $394554, $384554, $374452, $364351, $354251, $34414F, $34404D
Data $323E4D, $313E4B, $303D49, $2F3B48, $2E3A47, $2D3845, $2C3743, $2A3541
Data $2A3440, $28323E, $27313C, $26303B, $252E39, $232D37, $212B36, $212A34
Data $202933, $1F2831, $1D262F, $1C252E, $1B242D, $1A232C, $19222A, $19212A
Data $182129, $182027, $171F27, $394655, $394655, $384554, $374452, $374351
Data $364251, $34414F, $34404D, $333E4C, $323D4B, $313D49, $2F3B48, $2E3A46
Data $2D3845, $2C3743, $2B3542, $2A343F, $28323E, $27313C, $26303A, $242E39
Data $232D37, $222C36, $202A34, $1F2933, $1F2731, $1D2630, $1C252E, $1C242D
Data $1B232C, $19222B, $192129, $192129, $171F28, $171F27, $394655, $384554
Data $384553, $374452, $374352, $364250, $35414F, $34404E, $333F4C, $323E4B
Data $303D4A, $2F3B48, $2E3947, $2D3845, $2C3743, $2A3542, $2A3440, $28323E
Data $27313C, $252F3A, $242E39, $232D37, $212C36, $212A34, $1F2932, $1E2731
Data $1D2730, $1C252F, $1C242D, $1A232C, $19222A, $192129, $182028, $172028
Data $171F27, $394655, $384554, $384553, $374452, $364352, $364250, $35404F
Data $34404E, $323F4C, $323E4B, $303C49, $2F3B48, $2E3946, $2D3844, $2B3743
Data $2B3542, $2A343F, $28333E, $26313D, $26303A, $242E39, $232D37, $222C35
Data $212A34, $1F2832, $1E2831, $1E272F, $1C252F, $1B242D, $1B232C, $1A222B
Data $19212A, $182028, $181F28, $171F27, $394655, $394554, $384554, $374452
Data $364352, $364251, $35414F, $33404E, $323F4C, $323E4B, $303C49, $303A48
Data $2E3A47, $2D3945, $2B3743, $2B3541, $293440, $28333E, $27313C, $26303B
Data $242E39, $232C37, $222B35, $202B35, $202933, $1E2731, $1E262F, $1C252E
Data $1C242D, $1B232C, $19222A, $192129, $192129, $172028, $171F27, $394655
Data $384554, $374554, $374452, $364352, $354251, $35414F, $343F4E, $333F4D
Data $313D4B, $313C49, $2F3B48, $2E3947, $2D3845, $2B3743, $2A3641, $293440
Data $28333E, $27313C, $25303A, $242E39, $232D37, $222C36, $212A35, $202832
Data $1E2831, $1D2630, $1D252E, $1B242C, $1A232C, $1A222A, $192129, $182128
Data $171F27, $171F27, $394655, $394554, $384453, $374452, $364351, $364250
Data $35414F, $34404E, $333F4D, $323D4B, $303C4A, $2F3A48, $2E3947, $2D3844
Data $2B3743, $2A3541, $293440, $28323E, $27313D, $26303B, $242E39, $232D37
Data $222C36, $202B35, $1F2832, $1E2731, $1E262F, $1D252E, $1C242D, $1B232C
Data $1A222A, $19212A, $182128, $182028, $171F27, $394655, $384554, $384453
Data $374452, $364352, $354250, $35414F, $34404D, $333E4D, $323E4B, $313D4A
Data $2F3B48, $2E3946, $2D3845, $2C3743, $2B3542, $293440, $28333E, $27313D
Data $252F3B, $242E39, $232D37, $222B36, $212A34, $202932, $1E2731, $1D262F
Data $1D262E, $1B252D, $1B232C, $1A222A, $192229, $192029, $172027, $171F27
Data $394655, $384554, $384554, $374352, $364352, $354251, $35414F, $33404E
Data $323F4C, $323D4B, $313C4A, $303B48, $2F3946, $2D3845, $2C3643, $2A3541
Data $2A343F, $28323E, $27313D, $26303A, $242E39, $232D37, $222C35, $212B34
Data $1F2832, $1E2731, $1D2630, $1C252F, $1B242D, $1B232B, $19222A, $19212A
Data $182029, $171F27, $171F27, $394655, $384554, $374553, $384453, $364352
Data $354250, $34414F, $343F4E, $333F4D, $313E4B, $303C49, $2F3B48, $2F3947
Data $2D3845, $2B3743, $2B3541, $293440, $28333E, $26313D, $26303B, $242F39
Data $232C38, $222B36, $212A34, $1F2833, $1F2831, $1D2630, $1C252F, $1B242D
Data $1B232C, $19222B, $192129, $182029, $181F27, $171F27, $394655, $384554
Data $384454, $384453, $374351, $354250, $354150, $34404E, $333F4C, $323D4B
Data $303C49, $303B48, $2E3946, $2D3845, $2C3744, $2A3541, $293440, $28333E
Data $27313D, $262F3A, $242F39, $232D38, $222B36, $212A34, $202932, $1E2731
Data $1E2730, $1D252E, $1B242D, $1B232C, $1A222A, $19212A, $182129, $172027
Data $171F27, $394655, $384654, $384453, $374453, $364352, $364250, $35414F
Data $34404D, $333F4C, $313E4B, $303C49, $2F3B48, $2E3A47, $2D3845, $2C3743
Data $2A3541, $293440, $28333E, $27323C, $26303B, $242E39, $232D37, $222C36
Data $212A34, $202933, $1F2832, $1D272F, $1C252E, $1B242D, $1B232C, $19222B
Data $192129, $182029, $172028, $171F27, $394655, $394654, $384554, $374452
Data $374351, $364250, $35414F, $343F4D, $323F4D, $313D4B, $303C49, $2F3B48
Data $2E3A46, $2D3844, $2C3743, $2B3542, $293440, $28333E, $26313D, $252F3B
Data $252E39, $232C38, $222B36, $212A34, $202932, $1F2731, $1D262F, $1C252E
Data $1B242D, $1B232C, $19222B, $192129, $182129, $182028, $171F27, $394655
Data $384554, $384554, $374453, $364351, $354250, $35414F, $333F4E, $323E4C
Data $323D4B, $313C49, $2F3B48, $2F3A46, $2D3844, $2C3743, $2B3542, $2A3440
Data $28333E, $27313D, $25303A, $242E39, $232D37, $222C35, $202A34, $1F2933
Data $1E2731, $1D2630, $1D252E, $1C252D, $1B232C, $1A222B, $192129, $182029
Data $171F28, $171F27, $394655, $384555, $384554, $374452, $364351, $354251
Data $35414F, $343F4D, $323E4C, $313D4B, $303C49, $2F3B48, $2E3A47, $2D3844
Data $2C3743, $2B3541, $293440, $28333E, $27313C, $25303B, $252F39, $232D38
Data $222B35, $212A34, $1F2833, $1F2731, $1E2630, $1C252E, $1B242D, $1A232C
Data $19222B, $192129, $182029, $181F28, $171F27, $394655, $384554, $384454
Data $374453, $364352, $354250, $34414F, $33404E, $333E4C, $313E4B, $313C49
Data $2F3B48, $2E3A46, $2D3844, $2C3743, $2A3541, $293440, $28323E, $26313D
Data $25303B, $252E39, $232D38, $222C36, $212A35, $202933, $1F2831, $1D2630
Data $1D252F, $1C242D, $1A232C, $1A222A, $192129, $182029, $171F28, $171F27
Data $394655, $394554, $384453, $374352, $364352, $364250, $34414F, $34404E
Data $333E4D, $323E4B, $313C4A, $2F3A48, $2E3946, $2D3944, $2C3743, $2A3542
Data $29343F, $28323E, $27313C, $25303B, $242E39, $232D37, $222C36, $212A34
Data $202932, $1E2831, $1E272F, $1C252E, $1B242D, $1B232C, $19222B, $192229
Data $182029, $182028, $171F27, $394655, $394654, $384553, $374452, $374351
Data $364250, $35414F, $34404D, $333F4D, $323E4B, $303C4A, $303B48, $2E3946
Data $2D3844, $2C3743, $2A3642, $293440, $28333E, $26313D, $26303A, $242E39
Data $232D37, $222B36, $212A34, $202932, $1E2731, $1D2630, $1C262E, $1C242D
Data $1B232C, $1A222B, $192129, $182128, $171F27, $171F27, $394655, $384655
Data $384453, $374453, $364351, $354251, $344150, $34404E, $323F4C, $323D4B
Data $303C4A, $303B48, $2E3A46, $2D3845, $2C3744, $2A3642, $293440, $28323E
Data $27313D, $25303A, $242E38, $242D37, $222B36, $212B34, $202832, $1E2731
Data $1D2630, $1D252E, $1B242D, $1A232C, $1A222B, $192129, $182129, $182028
Data $171F27, $394655, $384554, $384554, $374353, $364352, $364251, $34414F
Data $34404E, $333E4D, $323D4B, $313C49, $2F3A48, $2E3A46, $2D3945, $2C3743
Data $2A3541, $293440, $28333E, $27313D, $26303A, $252E39, $232D37, $222C35
Data $212A34, $202932, $1E2731, $1D2630, $1C252E, $1B252D, $1B232C, $19222A
Data $19212A, $182028, $182028, $171F27, $394655, $394654, $384553, $374453
Data $364351, $364250, $35414F, $34404E, $333E4C, $313E4B, $313D49, $2F3B48
Data $2F3A46, $2D3845, $2C3743, $2A3641, $293440, $28333E, $26313C, $26303B
Data $242E39, $232D37, $222C36, $212A34, $202932, $1E2731, $1E2730, $1C252F
Data $1B242D, $1A232C, $19222A, $192129, $182029, $172027, $171F27, $394655
Data $394655, $384453, $374452, $374351, $354250, $35414F, $34404D, $333F4C
Data $323E4B, $313C49, $303B48, $2E3A46, $2C3845, $2B3743, $2B3542, $293440
Data $28333E, $26313C, $25303B, $252F39, $242D37, $222B35, $212A34, $202932
Data $1E2831, $1D2630, $1C252E, $1B242D, $1B232B, $19222A, $192229, $182029
Data $181F28, $171F27, $394655, $394555, $384553, $374453, $374352, $354251
Data $35414F, $34404E, $323F4D, $313D4B, $313C49, $303B48, $2E3A47, $2D3945
Data $2C3643, $2B3641, $29343F, $28323E, $27313D, $252F3B, $242E39, $242D37
Data $222B35, $202A34, $1F2832, $1F2731, $1D262F, $1C252E, $1B242D, $1B232C
Data $19222B, $192129, $182029, $181F28, $171F27, $394655, $394654, $384454
Data $374353, $364352, $354250, $35414F, $333F4D, $333F4C, $313D4B, $303D4A
Data $2F3B48, $2E3A46, $2D3844, $2C3743, $2B3642, $293440, $28333E, $27313C
Data $25303A, $252E39, $232D37, $222C36, $202B34, $1F2932, $1E2732, $1D262F
Data $1D252F, $1B252D, $1B232B, $1A222B, $192129, $192129, $182028, $171F27
Data $394655, $394654, $384554, $374453, $364352, $354250, $35414F, $33404E
Data $323E4C, $323D4B, $313C49, $303B48, $2E3A46, $2D3845, $2C3643, $2A3642
Data $29343F, $28323E, $26313C, $25303A, $242F39, $232C38, $222B36, $212A35
Data $1F2932, $1F2831, $1E2730, $1D262E, $1B242D, $1B232C, $1A222A, $18212A
Data $182129, $181F28, $171F27, $394655, $384655, $384553, $374452, $364351
Data $354251, $35414F, $33404E, $323F4D, $323D4B, $313C49, $2F3B48, $2E3946
Data $2D3945, $2C3743, $2B3641, $29343F, $28333E, $27323C, $26303B, $242F39
Data $232D37, $222C35, $212A34, $1F2933, $1E2831, $1E272F, $1C252E, $1B242D
Data $1B232C, $1A222B, $19212A, $182128, $171F28, $171F27, $394655, $384554
Data $384454, $374452, $374351, $364251, $35414F, $34404E, $333E4C, $313D4B
Data $303C49, $2F3B48, $2E3A47, $2D3845, $2C3643, $2B3542, $293440, $28333E
Data $27313C, $26303A, $242E39, $232D37, $222C36, $212B34, $1F2833, $1F2731
Data $1D2730, $1C252E, $1B242D, $1B232B, $19222B, $192229, $182128, $171F27
Data $171F27, $394655, $394554, $384453, $384453, $364351, $364251, $35414F
Data $34404E, $323E4D, $323D4B, $313C49, $2F3B48, $2E3947, $2D3845, $2C3743
Data $2B3541, $293440, $28323E, $27313C, $26303B, $252E39, $232D37, $222B36
Data $212A35, $202932, $1F2731, $1D262F, $1D252F, $1C242D, $1A232B, $1A222B
Data $192129, $182129, $171F28, $171F27, $394655, $384555, $374554, $384452
Data $364351, $364250, $35414F, $34404D, $333F4D, $323E4B, $303C49, $2F3B48
Data $2E3946, $2D3844, $2B3643, $2A3641, $29343F, $28323E, $27313D, $26303B
Data $242E39, $232D37, $212C36, $212A34, $202933, $1E2831, $1E2730, $1D252E
Data $1C242D, $1A232B, $1A222B, $19212A, $182029, $181F27, $171F27, $394655
Data $384654, $374553, $374452, $374352, $354250, $35414F, $34404E, $323F4D
Data $323D4B, $313C4A, $2F3B48, $2E3947, $2D3845, $2C3743, $2A3542, $29343F
Data $28323E, $27313C, $262F3A, $252E39, $232D37, $222C36, $212B34, $1F2932
Data $1F2831, $1D2630, $1C252E, $1C242D, $1A232C, $1A222A, $19212A, $182129
Data $181F28, $171F27, $394655, $384654, $374553, $374452, $374351, $354251
Data $34414F, $34404E, $333F4D, $323D4B, $313C49, $2F3B48, $2E3A46, $2D3844
Data $2C3643, $2A3641, $293340, $28333E, $27313C, $252F3A, $242E39, $242D37
Data $222B36, $202A35, $1F2933, $1E2731, $1E2630, $1C252E, $1B242D, $1A232B
Data $19222A, $19222A, $182029, $182028, $171F27, $394655, $384555, $384453
Data $374452, $374352, $364250, $354050, $33404E, $333F4C, $323D4B, $303C4A
Data $303B48, $2E3A46, $2D3845, $2C3644, $2B3541, $2A343F, $28323E, $27313C
Data $25303B, $242E39, $232D38, $222B36, $212A34, $202932, $1E2731, $1D262F
Data $1C262E, $1B242D, $1A232C, $1A222A, $192129, $182029, $171F28, $171F27
Data $394655, $384555, $384553, $384453, $364351, $354251, $35414F, $34404E
Data $333F4C, $323D4B, $303C4A, $303B48, $2E3947, $2D3844, $2C3643, $2A3541
Data $293440, $28323E, $27313D, $26303A, $252E39, $232D37, $222B36, $202A34
Data $1F2933, $1E2831, $1E2630, $1D252E, $1C242D, $1A232B, $1A222B, $19222A
Data $182128, $172028, $171F27, $394655, $384554, $384454, $374452, $364351
Data $364250, $35414F, $33404D, $323F4D, $323D4B, $303C4A, $2F3B48, $2E3946
Data $2D3845, $2C3643, $2B3541, $29343F, $28323E, $27313D, $262F3B, $242E39
Data $232D38, $222C35, $212A34, $1F2833, $1F2831, $1D272F, $1C252F, $1B252D
Data $1B232C, $1A222B, $19212A, $182128, $181F27, $171F27, $394655, $394554
Data $384553, $374453, $364351, $364250, $34414F, $34404D, $333F4C, $323D4B
Data $303C49, $2F3B48, $2E3946, $2D3945, $2C3743, $2A3541, $2A3440, $28333E
Data $27313C, $252F3B, $252E39, $242D38, $222C36, $212A34, $202932, $1F2732
Data $1D2630, $1C262F, $1C242D, $1A232B, $19222B, $19212A, $182129, $182028
Data $171F27, $394655, $394555, $384554, $384452, $374352, $364250, $35414F
Data $33404D, $333F4C, $323D4B, $313C49, $2F3B48, $2E3A47, $2D3844, $2C3744
Data $2B3641, $2A343F, $28323E, $27313C, $262F3B, $252E39, $232D38, $222C35
Data $212A34, $202832, $1F2831, $1D2630, $1C252E, $1C242D, $1B232C, $19222B
Data $18212A, $182029, $182028, $171F27, $394655, $384555, $384553, $374452
Data $374351, $354250, $344150, $33404E, $333E4C, $313E4B, $313C49, $2F3B48
Data $2F3947, $2C3944, $2B3643, $2A3541, $2A3440, $28333E, $27313D, $25303B
Data $242E39, $232C38, $212B35, $212A34, $1F2932, $1F2731, $1D262F, $1C262E
Data $1B242D, $1B232C, $1A222A, $192129, $182029, $172028, $171F27, $394655
Data $384654, $384454, $374452, $364252, $354250, $34414F, $34404E, $333F4D
Data $313D4B, $303C49, $2F3B48, $2E3947, $2D3845, $2C3743, $2B3642, $293440
Data $28323E, $27313C, $26303A, $252E39, $232C37, $222C36, $212A35, $202932
Data $1E2831, $1D262F, $1D252E, $1C242D, $1A232C, $19222B, $192129, $192028
Data $171F28, $171F27, $394655, $394554, $374553, $374452, $364251, $354251
Data $35414F, $34404E, $323F4C, $323E4B, $313C49, $2F3A48, $2E3A46, $2D3845
Data $2C3643, $2B3541, $29343F, $28323E, $27313C, $262F3B, $252E39, $232D37
Data $212C36, $212A34, $1F2933, $1F2731, $1D262F, $1C252F, $1B242D, $1A232B
Data $1A222A, $19212A, $182129, $172027, $171F27, $394655, $384554, $374453
Data $374352, $364351, $354251, $35414F, $34404E, $323E4D, $313D4B, $313D4A
Data $2F3B48, $2E3946, $2D3845, $2C3743, $2B3641, $29343F, $28333E, $27313C
Data $25303B, $242F39, $242D37, $222B36, $212A34, $1F2933, $1E2731, $1D262F
Data $1C252E, $1C242D, $1A232C, $1A222B, $192129, $182129, $172028, $171F27
Data $394655, $394654, $384553, $374453, $364352, $364251, $34414F, $33404E
Data $333E4D, $323D4A, $303C49, $303B48, $2E3946, $2D3845, $2B3743, $2B3641
Data $2A343F, $28333E, $27313D, $25303B, $242E39, $232C37, $222C36, $202A34
Data $202832, $1E2731, $1E2630, $1C252E, $1B242D, $1A232C, $19222A, $19212A
Data $182028, $171F28, $171F27, $394655, $384654, $384553, $374453, $374351
Data $364250, $34414F, $34404D, $323E4D, $323E4B, $313C49, $2F3A48, $2E3947
Data $2D3845, $2C3744, $2B3541, $293440, $28323E, $27323C, $25303B, $252E39
Data $232D38, $212B36, $202A34, $1F2933, $1F2731, $1D272F, $1C252E, $1B252D
Data $1B232C, $19222B, $192129, $182128, $182028, $171F27, $394655, $394654
Data $384454, $374452, $364352, $354250, $35414F, $33404E, $333E4C, $313D4B
Data $303C49, $303B48, $2E3947, $2D3845, $2C3743, $2A3642, $293440, $28323E
Data $26313C, $25303A, $242F39, $232D37, $222B36, $202A34, $202932, $1E2731
Data $1D272F, $1D252E, $1B242D, $1B232C, $1A222B, $192229, $182129, $181F28
Data $171F27, $394655, $384654, $384454, $384453, $364351, $364251, $34404F
Data $34404E, $333E4C, $313D4B, $303C49, $2F3A48, $2E3947, $2D3844, $2C3743
Data $2A3541, $293440, $28333E, $27323C, $25303A, $242F39, $232D38, $222C36
Data $212B34, $1F2932, $1E2731, $1D2630, $1C252F, $1B242D, $1A232C, $19222B
Data $192129, $182128, $181F28, $171F27, $394655, $394554, $384453, $374353
Data $364351, $364250, $35414F, $34404E, $333E4C, $313D4B, $303C49, $2F3B48
Data $2E3946, $2D3845, $2B3743, $2A3541, $29343F, $28323E, $27313C, $25303A
Data $242F39, $232D37, $222B36, $202A34, $1F2932, $1E2731, $1D2730, $1C262E
Data $1C242D, $1B232C, $1A222B, $19212A, $182028, $181F28, $171F27, $394655
Data $394554, $374553, $374452, $374352, $364251, $35414F, $34404E, $333F4C
Data $323D4B, $313C4A, $303B48, $2E3A46, $2D3844, $2C3743, $2B3641, $293440
Data $28333E, $27313C, $25303B, $242E39, $232D38, $222B36, $202A34, $202933
Data $1E2731, $1E262F, $1C252F, $1C242D, $1A232C, $1A222A, $192129, $192028
Data $171F28, $171F27, $394655, $394554, $374454, $374453, $364251, $354250
Data $35414F, $33404D, $333F4D, $313E4B, $303C49, $303B48, $2E3946, $2D3844
Data $2B3743, $2A3542, $293440, $28323E, $27313C, $262F3B, $242E39, $232D37
Data $222B35, $212A34, $202933, $1E2831, $1D2730, $1C262E, $1C242D, $1A232B
Data $19222A, $192129, $182129, $181F27, $171F27, $394655, $384554, $384553
Data $374453, $364352, $354250, $35414F, $34404E, $333F4C, $323E4B, $313C4A
Data $2F3B48, $2E3A46, $2D3844, $2C3643, $2B3641, $293440, $28333E, $27323C
Data $25303B, $252F39, $232C37, $222B36, $212A34, $1F2933, $1E2732, $1D2630
Data $1C252E, $1B242D, $1A232C, $1A222A, $19222A, $182028, $172028, $171F27
Data $394655, $384654, $374453, $374453, $364352, $364250, $35414F, $34404E
Data $323F4D, $323E4B, $303C49, $2F3B48, $2E3A46, $2D3845, $2C3744, $2B3542
Data $2A3340, $28323E, $27313C, $262F3A, $242E39, $232D37, $212B36, $212B34
Data $1F2932, $1F2831, $1D2630, $1C262F, $1B242D, $1B232B, $1A222B, $19212A
Data $182029, $171F28, $171F27, $394655, $394555, $384554, $374452, $364352
Data $364250, $35414F, $34404E, $333F4C, $313E4B, $303C49, $2F3A47, $2E3A46
Data $2D3845, $2C3743, $2A3541, $29343F, $28333E, $27313C, $262F3B, $242E38
Data $232D37, $212B36, $212A34, $202933, $1F2731, $1D262F, $1C252E, $1C242D
Data $1B232B, $1A222B, $19222A, $182028, $182028, $171F27, $394655, $394554
Data $384554, $374452, $364351, $354250, $354150, $34404D, $323F4D, $313D4B
Data $313D49, $2F3B48, $2E3946, $2D3945, $2C3643, $2A3641, $2A3440, $28333E
Data $27313C, $26303B, $242E39, $232D37, $222B35, $202A34, $202933, $1F2831
Data $1E2630, $1D262E, $1B242D, $1A232B, $1A222B, $19212A, $182128, $182028
Data $171F27, $394655, $394654, $384453, $374453, $374352, $354250, $35414F
Data $34404E, $333E4C, $323D4B, $303C49, $2F3B48, $2E3947, $2D3844, $2C3743
Data $2A3542, $2A3440, $28333E, $27313D, $26303B, $242F39, $232D37, $222B35
Data $212A35, $1F2932, $1E2831, $1E2630, $1C252F, $1B242D, $1B232C, $1A222B
Data $192229, $182129, $172028, $171F27, $394655, $394655, $384553, $374453
Data $364352, $354250, $35414F, $33404E, $323F4D, $313D4B, $313C4A, $2F3B48
Data $2E3A47, $2D3845, $2C3743, $2B3642, $2A3440, $28323E, $27313C, $25303B
Data $252E39, $232D37, $222B36, $212A34, $1F2932, $1F2731, $1E2630, $1C252F
Data $1C252D, $1A232C, $1A222B, $19212A, $182128, $181F28, $171F27, $394655
Data $394554, $384454, $374452, $364252, $354250, $34414F, $34404E, $323F4C
Data $313D4A, $303D49, $2F3B48, $2E3947, $2D3845, $2C3743, $2B3541, $293440
Data $28323E, $27313D, $25303B, $242E38, $232C37, $222B36, $212A34, $202933
Data $1F2731, $1E2730, $1C252E, $1C242D, $1B232C, $19222A, $192129, $192128
Data $182027, $171F27, $394655, $384554, $384554, $374452, $364251, $354250
Data $34414F, $33404E, $333F4D, $313E4B, $313C49, $303B47, $2E3A47, $2D3845
Data $2C3743, $2B3541, $293440, $28323E, $27313C, $26303B, $242E39, $232D37
Data $222B36, $202A34, $202932, $1E2731, $1E2630, $1C252F, $1B242D, $1B232C
Data $1A222A, $19212A, $182129, $172028, $171F27, $394655, $384554, $384453
Data $374452, $364351, $354250, $35414F, $34404E, $323F4C, $323D4B, $313C4A
Data $2F3B48, $2E3947, $2D3944, $2C3743, $2A3541, $29343F, $28333E, $27313D
Data $262F3A, $242F39, $232D37, $222C36, $212A35, $202932, $1E2731, $1E262F
Data $1C252E, $1C242D, $1A232C, $1A222B, $182129, $182029, $181F27, $171F27


.BCF_CloseGadgetOn_Style01
Data 17
Data 17
Data $000000, $3882C6, $276FB8, $266CB3, $2E75B7, $3F83BC, $5897C5, $609BC9
Data $609BC9, $67A2CC, $67A2CC, $72ABD1, $72ABD1, $72ABD1, $8EBDDD, $8EC0E1
Data $000000, $3D86CA, $1755A6, $0D418F, $0B3781, $0C3B86, $0B3A85, $0A3782
Data $0B3984, $0B3984, $0B3A84, $0B3A84, $0C3C85, $0C3C85, $0C3C85, $124892
Data $3D7CB5, $AED3EB, $2C76BF, $0A3884, $C87622, $DE7E1C, $E6871C, $EE8A1E
Data $F49020, $F69322, $F79924, $F69926, $F89429, $F98528, $E96924, $CD4B20
Data $B13F22, $12468A, $ACD3E7, $2770BD, $0B3A82, $CF8C4C, $E48F41, $F08C27
Data $FC8E1C, $FF9821, $FFA323, $FFAD27, $FFB629, $FFB72B, $FFA92C, $FF8A2A
Data $F26525, $C84C23, $10448C, $B2D5E9, $256EBD, $0E4087, $CC8F59, $E19C5C
Data $462513, $49230D, $FE9A20, $FFA823, $FFB727, $FFC72A, $FFD02C, $492C0A
Data $49260A, $FF8728, $E56725, $124893, $B2D5EA, $256EBD, $0E4087, $CC8E55
Data $DE9755, $462413, $482613, $4A240C, $F49D1E, $FFB425, $F3BB26, $4A2E09
Data $4A2E0A, $492B0A, $FF9F2B, $F57B29, $124996, $B2D5EB, $256EBD, $0E4087
Data $D09157, $DD9654, $E79F57, $472513, $492713, $49250B, $F0A21E, $4A2A08
Data $4A2C09, $4A2E09, $FFC82D, $FFAE2C, $FB882D, $124996, $B2D5EB, $256EBD
Data $0E4087, $D49457, $DC9552, $E59D56, $E8A157, $482613, $4A2610, $4A2507
Data $4A2808, $4A2A09, $EEBC28, $FFC62D, $FFB02D, $FD8E2F, $124996, $B2D5EB
Data $256EBD, $0E4087, $D49457, $DC9453, $E19B56, $E9A25A, $E9A056, $4A2713
Data $4A250A, $4A2607, $F0AF25, $FFC129, $FFBF2B, $FEAD2C, $FD8E2E, $124996
Data $B2D5EB, $256EBD, $0E4087, $D29357, $D99353, $DF9A57, $E19C58, $472513
Data $492714, $49250C, $492507, $4A2708, $F0AC26, $FFB62A, $FEA62C, $FC8A2D
Data $124996, $B2D5EB, $256EBD, $0E4087, $D09359, $D79354, $DE9957, $442313
Data $462514, $492614, $F6A13E, $492307, $4A2508, $4A2608, $FEAB2A, $FF9C2A
Data $FD862C, $124996, $B2D5EB, $256EBD, $0E4087, $CD925A, $D69356, $422213
Data $442314, $462414, $EEA45C, $FEA241, $F3901E, $4A2308, $4A2408, $4A2309
Data $FF9127, $FA7E2A, $124996, $B2D5EA, $256FBD, $0E3F86, $CA905A, $D59359
Data $422214, $432314, $E9A360, $F3A862, $FC9C40, $FE8E1D, $FF9524, $4A2208
Data $4A2108, $FF8627, $F37327, $114792, $B0D5EA, $2871BD, $0A3780, $C98F5C
Data $D4935D, $D99860, $DF9C61, $E5A061, $EFA462, $F8943B, $FE881D, $FF8D23
Data $FF8F25, $FF8A27, $FF7B25, $E86725, $0F4289, $B0D5E9, $307AC1, $0B3D8B
Data $BF8E5E, $CC925E, $CD975F, $D29B60, $DA9F60, $E3A15C, $EB8B32, $F48522
Data $F98B25, $FA8D27, $F88427, $F57025, $D25F24, $174E91, $AAD2E7, $4891CF
Data $2065B3, $0C408F, $08317D, $09357F, $0A3880, $0D3C83, $0E3E85, $0E3E85
Data $0E3E86, $0E3E86, $0F4188, $0F4188, $0F4188, $205CA1, $5B99C9, $91C3E3
Data $000000, $3A85C8, $2A76BD, $2C74B9, $347BBC, $4589C1, $609FCA, $6AA4CE
Data $6AA4CE, $72ABD2, $72ABD2, $7DB2D6, $7DB2D6, $7DB2D6, $91C1DF, $8ABDE0
Data $000000

.BCF_CloseGadgetOff_Style01
Data 17
Data 17
Data $000000, $3882C6, $276FB8, $266CB3, $2E75B7, $3F83BC, $5897C5, $609BC9
Data $609BC9, $67A2CC, $67A2CC, $72ABD1, $72ABD1, $72ABD1, $8EBDDD, $8EC0E1
Data $000000, $3D86CA, $1755A6, $0D418F, $0B3781, $0C3B86, $0B3A85, $0A3782
Data $0B3984, $0B3984, $0B3A84, $0B3A84, $0C3C85, $0C3C85, $0C3C85, $124892
Data $3D7CB5, $AED3EB, $2C76BF, $0A3884, $8F1C00, $AE2700, $B93400, $C43800
Data $CD4100, $CF4500, $D14D00, $CF4D00, $D24600, $D43100, $BD0A00, $960000
Data $6F0000, $12468A, $ACD3E7, $2770BD, $0B3A82, $993B00, $B63F00, $C73B00
Data $D83E00, $DC4C00, $DC5B00, $DC6900, $DC7600, $DC7700, $DC6400, $DC3800
Data $CA0400, $8F0000, $10448C, $B2D5E9, $256EBD, $0E4087, $953F00, $B25100
Data $3E1500, $411300, $DB4F00, $DC6200, $DC7700, $DC8E00, $DC9A00, $422000
Data $421800, $DC3400, $B80700, $124893, $B2D5EA, $256EBD, $0E4087, $953E00
Data $AE4A00, $3D1500, $401700, $421500, $D35900, $DC7300, $D28300, $422300
Data $422300, $421E00, $DC5600, $CE2300, $124996, $B2D5EB, $256EBD, $0E4087
Data $9A4200, $AC4900, $BA5600, $3E1600, $411800, $421600, $CF6200, $421D00
Data $422000, $422200, $DC8F00, $DC6B00, $D63500, $124996, $B2D5EB, $256EBD
Data $0E4087, $A04600, $AB4800, $B85300, $BF5B00, $401800, $421800, $421600
Data $421A00, $421E00, $CD8600, $DC8C00, $DC6D00, $D93E00, $124996, $B2D5EB
Data $256EBD, $0E4087, $A04600, $AB4600, $B25000, $BD5A00, $C45F00, $421900
Data $421600, $421800, $CF7400, $DC8500, $DC8200, $DB6900, $D93E00, $124996
Data $B2D5EB, $256EBD, $0E4087, $9D4500, $A74500, $AF4F00, $B55500, $3F1600
Data $421900, $421600, $421600, $421900, $CF7000, $DC7600, $DB5F00, $D83800
Data $124996, $B2D5EB, $256EBD, $0E4087, $9A4500, $A44500, $AE4D00, $3B1400
Data $3E1600, $411800, $D45E00, $421400, $421700, $421800, $DB6600, $DC5100
Data $D93300, $124996, $B2D5EB, $256EBD, $0E4087, $964300, $A34500, $381200
Data $3A1400, $3D1500, $CA6200, $DB5A00, $D24700, $421400, $421500, $421300
Data $DC4200, $D52700, $124996, $B2D5EA, $256FBD, $0E3F86, $924100, $A14500
Data $371200, $391300, $BD5B00, $CB6200, $D85100, $DB3E00, $DC4800, $421100
Data $421000, $DC3300, $CB1800, $114792, $B0D5EA, $2871BD, $0A3780, $903F00
Data $A04500, $A74C00, $AF5100, $B85700, $C65D00, $D24600, $DB3500, $DC3C00
Data $DC3F00, $DC3800, $DC2300, $BC0700, $0F4289, $B0D5E9, $307AC1, $0B3D8B
Data $823E00, $954300, $964A00, $9D5000, $A85600, $B55800, $C03A00, $CD3100
Data $D43A00, $D53C00, $D23000, $CE1400, $9D0000, $174E91, $AAD2E7, $4891CF
Data $2065B3, $0C408F, $08317D, $09357F, $0A3880, $0D3C83, $0E3E85, $0E3E85
Data $0E3E86, $0E3E86, $0F4188, $0F4188, $0F4188, $205CA1, $5B99C9, $91C3E3
Data $000000, $3A85C8, $2A76BD, $2C74B9, $347BBC, $4589C1, $609FCA, $6AA4CE
Data $6AA4CE, $72ABD2, $72ABD2, $7DB2D6, $7DB2D6, $7DB2D6, $91C1DF, $8ABDE0
Data $000000

.BCF_CloseGadgetOn_Style02
Data 17
Data 17
Data $000000, $000000, $000000, $000000, $000000, $000000, $979EAE, $8A91A1
Data $7F8696, $767D8D, $9198A6, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $808696, $535A6C, $394051
Data $373E4E, $333A49, $31384A, $3C4354, $5C6272, $949AA8, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $5F6673, $3D3745, $77282F
Data $AB2B2C, $C83030, $D93333, $DD3232, $CE2F31, $9F2B2F, $563943, $7B8388
Data $000000, $000000, $000000, $000000, $000000, $57606D, $3D2C37, $902A2D
Data $BE3131, $D23333, $E93636, $F93939, $FF3B3B, $FF3B3B, $FF3A3B, $CD2F2F
Data $68353D, $777E89, $000000, $000000, $000000, $727889, $2F2C3A, $9A393B
Data $E68F8F, $F38F8F, $EB5252, $ED3333, $FB3738, $FF3B3B, $FF3D3C, $FF3F40
Data $FF3C3D, $DC3233, $633E4F, $9297A3, $000000, $000000, $404757, $763036
Data $F3B1B1, $FFF4F4, $503522, $502D1A, $E34242, $F63333, $F23636, $50230F
Data $502310, $FF4141, $FF3B3C, $BB3235, $5C647A, $000000, $757889, $292F3F
Data $BD6466, $FFFFFF, $FFF1F1, $503320, $502F1C, $4F2714, $E63131, $50220F
Data $502310, $502310, $FF4141, $FF4141, $FC3737, $505A75, $ABB2BF, $626878
Data $1F2433, $E49A9B, $FFFFFF, $FFE3E4, $FAB5B5, $502F1B, $4F2815, $4F220F
Data $50220F, $50230F, $EC3938, $FF4040, $FF4242, $FE3C3C, $546172, $9AA0B8
Data $5E6474, $1F2533, $F4B4B4, $FFFFFF, $FFE1E1, $FFB9B9, $F08D8D, $4F2916
Data $4F2310, $50220F, $EE3737, $FF3E3E, $FF4040, $FF4242, $FE3D3C, $535F6E
Data $979EB0, $636979, $1E2433, $EEACAC, $FFFFFF, $FFE2E2, $F9B5B5, $502E1B
Data $4F2916, $531414, $50220F, $50230F, $EE3A3A, $FF4040, $FF4242, $FE3D3C
Data $546073, $9AA1AF, $737989, $293040, $D17F80, $FFFFFF, $FFE7E7, $503320
Data $502F1C, $4F2815, $EC3636, $50220F, $502310, $502310, $FF4140, $FF4242
Data $FE3A3A, $515974, $A4AABA, $000000, $3E4555, $8F3E41, $FFE9E9, $FFF8F8
Data $503320, $502F1C, $E95050, $F63434, $F23535, $502310, $502310, $FF4141
Data $FF4040, $D83031, $5C627D, $000000, $000000, $707787, $432935, $C26465
Data $FFD4D4, $FFC1C1, $F47272, $EC3939, $F93636, $FF3A3B, $FF3C3C, $FF4040
Data $FF3F3F, $FF3939, $7A343F, $8F96A5, $000000, $000000, $000000, $5A6171
Data $552830, $B63F3F, $D24C4C, $DE3939, $EE3636, $FD3A39, $FF3B3A, $FF3D3D
Data $FF3C3C, $FD3939, $902B31, $797887, $000000, $000000, $000000, $000000
Data $000000, $5E6573, $4F323C, $96272A, $C53232, $DB3636, $EA3636, $F23737
Data $F23838, $CE2E2F, $753136, $817F89, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $808795, $525869, $3A414F, $353F49, $323B46
Data $30364A, $3B4054, $5B6072, $959BA6, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $979DAC, $8C92A2
Data $808696, $757C8C, $9199A7, $000000, $000000, $000000, $000000, $000000
Data $000000

.BCF_CloseGadgetOff_Style02
Data 17
Data 17
Data $000000, $000000, $000000, $000000, $000000, $000000, $979EAE, $8A91A1
Data $7F8696, $767D8D, $9198A6, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $808696, $535A6C, $394051
Data $373E4E, $333A49, $31384A, $3C4354, $5C6272, $949AA8, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $5F6673, $363746, $46212D
Data $601116, $720709, $810405, $860608, $7D0F12, $5E1E27, $433A45, $7B8388
Data $000000, $000000, $000000, $000000, $000000, $57606D, $2F2B37, $541E25
Data $690505, $790000, $900000, $A00000, $AC0000, $B10000, $A80000, $7F1619
Data $48343F, $777E89, $000000, $000000, $000000, $727889, $292C3A, $5D2026
Data $8D3636, $9A3636, $920000, $940000, $A20000, $B20000, $BE0000, $C70000
Data $BE0000, $8C1215, $4E3F53, $9297A3, $000000, $000000, $404757, $492730
Data $9D5F5F, $C09B9B, $462916, $44220F, $8E0000, $9D0000, $A30000, $471B08
Data $491B08, $D10000, $BF0000, $7A282F, $5C647A, $000000, $757889, $292F3F
Data $7C3C40, $C3AAAB, $C19898, $452714, $452411, $431C08, $930000, $451B08
Data $471B08, $481B08, $CF0000, $D20000, $A60607, $505A75, $ABB2BF, $626878
Data $1F2433, $965759, $CDBDBD, $BA8A8B, $AA5E5E, $442310, $441D0A, $441B08
Data $451B08, $461B08, $B40000, $CD0000, $D50000, $B90202, $546172, $9AA0B8
Data $5E6474, $1F2533, $A06667, $CFC1C1, $B98888, $AD6060, $9C3939, $441D0A
Data $441B08, $451B08, $A90000, $C20000, $CD0000, $D50000, $BF0202, $535F6E
Data $979EB0, $636979, $1E2433, $9C6162, $CEC0C0, $B98989, $A95E5E, $442310
Data $441D0A, $350000, $451B08, $461B08, $B50000, $CD0000, $D50000, $BD0202
Data $546073, $9AA1AF, $737989, $293040, $87474A, $C9B6B6, $BC8E8E, $452714
Data $452310, $441D09, $970000, $451B08, $471B08, $481B08, $CF0000, $D40000
Data $B20202, $515974, $A4AABA, $000000, $3E4555, $542128, $B69090, $C39F9F
Data $462815, $452310, $930000, $9D0000, $A20000, $471B08, $481B08, $CF0000
Data $CA0000, $8A181C, $5C627D, $000000, $000000, $707787, $302735, $74292D
Data $AE7B7B, $B16868, $9B1919, $930000, $A00000, $AE0000, $BB0000, $C70000
Data $C90000, $A80000, $543443, $8F96A5, $000000, $000000, $000000, $5A6171
Data $36242F, $650B0E, $790000, $850000, $950000, $A40000, $B00000, $BB0000
Data $BC0000, $A40000, $58242E, $777A89, $000000, $000000, $000000, $000000
Data $000000, $5E6573, $3B323E, $52151C, $6D0304, $820000, $910101, $990101
Data $990101, $7A0D11, $4E2F37, $7F818B, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $808795, $525869, $3A414F, $353F49, $323B46
Data $30364A, $3B4054, $5B6072, $959BA6, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $979DAC, $8C92A2
Data $808696, $757C8C, $9199A7, $000000, $000000, $000000, $000000, $000000
Data $000000

.BCF_CloseGadgetOn_Style03
Data 17
Data 17
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $5F6F7E, $5F6F7E, $0A0A0A, $5F7084, $5F7084, $5F7084
Data $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084
Data $5F7084, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $C9DCEC, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968
Data $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $C9DCEC
Data $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A
Data $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968
Data $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E
Data $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968
Data $4B5968, $C9DCEC, $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968
Data $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $4B5968, $38424E, $38424E, $38424E, $38424E
Data $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A

.BCF_CloseGadgetOff_Style03
Data 17
Data 17
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $FFDF3B, $FFDF3B, $0A0A0A, $0A1420, $0A1420, $0A1420
Data $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420
Data $1D2B3A, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A
Data $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E
Data $0A0A0A, $0A1420, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B
Data $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A
Data $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A
Data $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000
Data $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A
Data $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256
Data $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A
Data $1D2B3A, $FFC000, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A
Data $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A
Data $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420
Data $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000
Data $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A
Data $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E
Data $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B
Data $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A
Data $FFDF3B, $FFB20E, $0A0A0A, $314256, $314256, $314256, $314256, $314256
Data $314256, $314256, $314256, $314256, $314256, $314256, $314256, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A

; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_ReduceGadgetOn_Style01
Data 17
Data 17
Data $000000, $3882C6, $276FB8, $266CB3, $2E75B7, $3F83BC, $5897C5, $609BC9
Data $609BC9, $67A2CC, $67A2CC, $72ABD1, $72ABD1, $72ABD1, $8EBDDD, $8EC0E1
Data $000000, $3D86CA, $1755A6, $0D418F, $0B3781, $0C3B86, $0B3A85, $0A3782
Data $0B3984, $0B3984, $0B3A84, $0B3A84, $0C3C85, $0C3C85, $0C3C85, $124892
Data $3D7CB5, $AED3EB, $2C76BF, $0A3884, $507F50, $498345, $3D902F, $3E9D1F
Data $52AB1D, $69B724, $71C133, $7BCC4A, $97DB53, $9DE54D, $7FC93F, $5A9532
Data $4F7F2F, $12468A, $ACD3E7, $2770BD, $0B3A82, $568456, $508949, $46922F
Data $489D1D, $5DAC1F, $70BB29, $73C435, $84D04D, $97DE58, $9EE95B, $8AD551
Data $6BAD3D, $609D34, $10448C, $B2D5E9, $256EBD, $0E4087, $74A574, $6AA458
Data $5C9F2D, $200900, $71B426, $81CA36, $85D046, $9ADC5A, $A1EB68, $200900
Data $ADF078, $9CE460, $91E052, $124893, $B2D5EA, $256EBD, $0E4087, $9ACA99
Data $88BF6C, $6FAD30, $200900, $200900, $8CD74A, $9CDE5C, $ABEA69, $B4F875
Data $200900, $CBFF91, $C4FF84, $BDFF79, $124996, $B2D5EB, $256EBD, $0E4087
Data $AFD6A6, $9AC677, $79B339, $200900, $200900, $200900, $A5EC65, $B5F776
Data $BFFE7B, $200900, $D2FF98, $D2FF96, $CFFF90, $124996, $B2D5EB, $256EBD
Data $0E4087, $B1CF9F, $9BBF79, $79B241, $200900, $200900, $200900, $200900
Data $BCFE7C, $C2FF82, $200900, $D4FF9A, $D9FF9B, $D9FF98, $124996, $B2D5EB
Data $256EBD, $0E4087, $B0D0A0, $92BF77, $71B140, $200900, $200900, $200900
Data $200900, $200900, $C7FF8A, $200900, $E0FF93, $E2FF9B, $E0FFA0, $124996
Data $B2D5EB, $256EBD, $0E4087, $B0CF9F, $9EC077, $7CB13F, $200900, $200900
Data $200900, $200900, $BBFA7C, $BDFF7E, $200900, $DDFF9C, $D9FF9A, $D1FF93
Data $124996, $B2D5EB, $256EBD, $0E4087, $ACD6A6, $97C575, $76B535, $200900
Data $200900, $200900, $A6E466, $B3F373, $BEFD7A, $200900, $D6FF95, $D8FF92
Data $D6FF8C, $124996, $B2D5EB, $256EBD, $0E4087, $90C090, $82B767, $6BAC2E
Data $200900, $200900, $8CD445, $96DC56, $A7E866, $ACF373, $200900, $CDFF8E
Data $CCFF7C, $C7FF70, $124996, $B2D5EA, $256FBD, $0E3F86, $699869, $619953
Data $569B2E, $200900, $6EB123, $7CC531, $7ECD3F, $96D856, $9CE463, $200900
Data $AFF46D, $9BE455, $8EDB48, $114792, $B0D5EA, $2871BD, $0A3780, $528152
Data $4A8646, $44902E, $4D9C1D, $5FAB1D, $6AB926, $72C233, $8BCE4B, $9ADA55
Data $A3EC55, $91E048, $6BB637, $5AA131, $0F4289, $B0D5E9, $307AC1, $0B3D8B
Data $507F50, $478345, $40902F, $4A9E1F, $5BAB1D, $67B724, $72C133, $89CC4A
Data $9CD953, $A3E94D, $8AD83F, $60A832, $4F902F, $174E91, $AAD2E7, $4891CF
Data $2065B3, $0C408F, $08317D, $09357F, $0A3880, $0D3C83, $0E3E85, $0E3E85
Data $0E3E86, $0E3E86, $0F4188, $0F4188, $0F4188, $205CA1, $5B99C9, $91C3E3
Data $000000, $3A85C8, $2A76BD, $2C74B9, $347BBC, $4589C1, $609FCA, $6AA4CE
Data $6AA4CE, $72ABD2, $72ABD2, $7DB2D6, $7DB2D6, $7DB2D6, $91C1DF, $8ABDE0
Data $000000

.BCF_ReduceGadgetOff_Style01
Data 17
Data 17
Data $000000, $3882C6, $276FB8, $266CB3, $2E75B7, $3F83BC, $5897C5, $609BC9
Data $609BC9, $67A2CC, $67A2CC, $72ABD1, $72ABD1, $72ABD1, $8EBDDD, $8EC0E1
Data $000000, $3D86CA, $1755A6, $0D418F, $0B3781, $0C3B86, $0B3A85, $0A3782
Data $0B3984, $0B3984, $0B3A84, $0B3A84, $0C3C85, $0C3C85, $0C3C85, $124892
Data $3D7CB5, $AED3EB, $2C76BF, $0A3884, $134213, $0C4608, $005300, $016000
Data $156E00, $2C7A00, $348400, $3E8F0D, $5A9E16, $60A810, $428C02, $1D5800
Data $124200, $12468A, $ACD3E7, $2770BD, $0B3A82, $194719, $134C0C, $095500
Data $0B6000, $206F00, $337E00, $368700, $479310, $5AA11B, $61AC1E, $4D9814
Data $2E7000, $236000, $10448C, $B2D5E9, $256EBD, $0E4087, $376837, $2D671B
Data $1F6200, $200900, $347700, $448D00, $489309, $5D9F1D, $64AE2B, $200900
Data $70B33B, $5FA723, $54A315, $124893, $B2D5EA, $256EBD, $0E4087, $5D8D5C
Data $4B822F, $327000, $200900, $200900, $4F9A0D, $5FA11F, $6EAD2C, $77BB38
Data $200900, $8EC254, $87C247, $80C23C, $124996, $B2D5EB, $256EBD, $0E4087
Data $729969, $5D893A, $3C7600, $200900, $200900, $200900, $68AF28, $78BA39
Data $82C13E, $200900, $95C25B, $95C259, $92C253, $124996, $B2D5EB, $256EBD
Data $0E4087, $749262, $5E823C, $3C7504, $200900, $200900, $200900, $200900
Data $7FC13F, $85C245, $200900, $97C25D, $9CC25E, $9CC25B, $124996, $B2D5EB
Data $256EBD, $0E4087, $739363, $55823A, $347403, $200900, $200900, $200900
Data $200900, $200900, $8AC24D, $200900, $A3C256, $A5C25E, $A3C263, $124996
Data $B2D5EB, $256EBD, $0E4087, $739262, $61833A, $3F7402, $200900, $200900
Data $200900, $200900, $7EBD3F, $80C241, $200900, $A0C25F, $9CC25D, $94C256
Data $124996, $B2D5EB, $256EBD, $0E4087, $6F9969, $5A8838, $397800, $200900
Data $200900, $200900, $69A729, $76B636, $81C03D, $200900, $99C258, $9BC255
Data $99C24F, $124996, $B2D5EB, $256EBD, $0E4087, $538353, $457A2A, $2E6F00
Data $200900, $200900, $4F9708, $599F19, $6AAB29, $6FB636, $200900, $90C251
Data $8FC23F, $8AC233, $124996, $B2D5EA, $256FBD, $0E3F86, $2C5B2C, $245C16
Data $195E00, $200900, $317400, $3F8800, $419002, $599B19, $5FA726, $200900
Data $72B730, $5EA718, $519E0B, $114792, $B0D5EA, $2871BD, $0A3780, $154415
Data $0D4909, $075300, $105F00, $226E00, $2D7C00, $358500, $4E910E, $5D9D18
Data $66AF18, $54A30B, $2E7900, $1D6400, $0F4289, $B0D5E9, $307AC1, $0B3D8B
Data $134213, $0A4608, $035300, $0D6100, $1E6E00, $2A7A00, $358400, $4C8F0D
Data $5F9C16, $66AC10, $4D9B02, $236B00, $125300, $174E91, $AAD2E7, $4891CF
Data $2065B3, $0C408F, $08317D, $09357F, $0A3880, $0D3C83, $0E3E85, $0E3E85
Data $0E3E86, $0E3E86, $0F4188, $0F4188, $0F4188, $205CA1, $5B99C9, $91C3E3
Data $000000, $3A85C8, $2A76BD, $2C74B9, $347BBC, $4589C1, $609FCA, $6AA4CE
Data $6AA4CE, $72ABD2, $72ABD2, $7DB2D6, $7DB2D6, $7DB2D6, $91C1DF, $8ABDE0
Data $000000


.BCF_ReduceGadgetOn_Style02
Data 17
Data 17
Data $000000, $000000, $000000, $000000, $000000, $000000, $979EAE, $8A91A1
Data $7F8696, $767D8D, $9198A6, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $808696, $535A6C, $394051
Data $373E4E, $333A49, $31384A, $3C4354, $5C6272, $949AA8, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $5F6673, $504947, $A9743C
Data $ED9D36, $FCA835, $FCAD35, $FBB035, $E5A43C, $A27744, $4E4C4E, $7B8489
Data $000000, $000000, $000000, $000000, $000000, $57606D, $3F3B3C, $A27243
Data $EF9B3B, $FC9F34, $FCA534, $FCAB35, $FCB235, $FBB536, $E9AD45, $A98252
Data $414752, $777E8A, $000000, $000000, $000000, $727889, $51453A, $AC8457
Data $FAD38E, $FCC87E, $FCA747, $FC9D34, $FCA834, $FCB035, $FCB935, $FCC135
Data $F9BD3B, $B38C5F, $4E4F61, $9297A3, $000000, $000000, $404757, $C19B65
Data $F4E4B3, $FCFCF1, $361F09, $361F09, $FCA339, $FCA334, $FCAD35, $FCB435
Data $361F09, $FCC635, $F8BB3E, $9C8166, $5C647A, $000000, $757889, $292F3F
Data $FAFAD2, $FCFCF6, $FCFCEF, $361F09, $361F09, $361F09, $FCA134, $FCAB35
Data $FCB235, $361F09, $FCC435, $FCC637, $DEAF56, $505A75, $ABB2BF, $626878
Data $1F2433, $FCFCFC, $FCFCFC, $FCFCDE, $361F09, $361F09, $361F09, $361F09
Data $FCA934, $FCB035, $361F09, $FCC135, $FCC636, $EABF50, $546172, $9AA0B8
Data $5E6474, $1F2533, $FCFCFC, $FCFCFC, $FCFCDC, $361F09, $361F09, $361F09
Data $361F09, $361F09, $FCB035, $361F09, $FCC035, $FCC737, $EAC254, $535F6E
Data $979EB0, $636979, $1E2433, $FCFCFC, $FCFCFC, $FCFCDE, $361F09, $361F09
Data $361F09, $361F09, $FCA934, $FCB035, $361F09, $FCC135, $FCC736, $EABF52
Data $546073, $9AA1AF, $737989, $293040, $FBFBE4, $FCFCF8, $FCFCE6, $361F09
Data $361F09, $361F09, $FCA234, $FCAA34, $FCB135, $361F09, $FCC235, $FCC737
Data $E3B351, $515974, $A4AABA, $000000, $3E4555, $D8BB88, $FBFAD1, $FCFCF0
Data $361F09, $361F09, $FCA742, $FCA234, $FCAC35, $FCB435, $361F09, $FCC535
Data $F9C03B, $B28A5D, $5C627D, $000000, $000000, $707787, $73573C, $C8A06A
Data $FCEFBD, $FCDDA3, $FCAF55, $FC9D34, $FCA834, $FCAF35, $FCB735, $FCC035
Data $FAC039, $CE994D, $57545C, $8F96A5, $000000, $000000, $000000, $5A6171
Data $56463B, $CF8C41, $FCA53D, $FB9E34, $FBA434, $FBAB35, $FBB135, $FCB935
Data $F6B83A, $CA9546, $4B4A51, $777D8C, $000000, $000000, $000000, $000000
Data $000000, $5E6573, $4D4745, $A4723D, $E29938, $E59F38, $E2A13A, $E6A73B
Data $DC9F3E, $9A7244, $4C4B4D, $7F848E, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $808795, $525869, $3A414F, $353F49, $323B46
Data $30364A, $3B4054, $5B6072, $959BA6, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $979DAC, $8C92A2
Data $808696, $757C8C, $9199A7, $000000, $000000, $000000, $000000, $000000
Data $000000

.BCF_ReduceGadgetOff_Style02
Data 17
Data 17
Data $000000, $000000, $000000, $000000, $000000, $000000, $979EAE, $8A91A1
Data $7F8696, $767D8D, $9198A6, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $808696, $535A6C, $394051
Data $373E4E, $333A49, $31384A, $3C4354, $5C6272, $949AA8, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $5F6673, $463E3F, $804B1D
Data $B75E07, $CA6400, $CF6900, $CF6D01, $B9690E, $7F5329, $474649, $7B8489
Data $000000, $000000, $000000, $000000, $000000, $57606D, $383436, $7E4D27
Data $B95D0B, $C75B00, $CE6100, $D26700, $D56E00, $D57202, $C17318, $886037
Data $3F4550, $777E8A, $000000, $000000, $000000, $727889, $43362F, $875E31
Data $D2904B, $D6843A, $CF6303, $CF5900, $D46400, $D86C00, $DD7500, $E07D00
Data $D67C08, $926B45, $4B4B5E, $9297A3, $000000, $000000, $404757, $9A6B35
Data $D1A674, $E8C7AD, $361F09, $361F09, $CF5F00, $D05F00, $D46900, $D97000
Data $361F09, $E38200, $D27C0D, $826752, $5C647A, $000000, $757889, $292F3F
Data $DBB88F, $E5CBB2, $E6C5AB, $361F09, $361F09, $361F09, $CF5D00, $D36700
Data $D76E00, $361F09, $E18000, $E28303, $BD7E2F, $505A75, $ABB2BF, $626878
Data $1F2433, $E6D3BD, $E6CFBA, $E2BA9A, $361F09, $361F09, $361F09, $361F09
Data $D36500, $D76C00, $361F09, $E17D00, $E28302, $D28926, $546172, $9AA0B8
Data $5E6474, $1F2533, $E8D8C6, $E7D2BD, $E2BA98, $361F09, $361F09, $361F09
Data $361F09, $361F09, $D66C00, $361F09, $E17C00, $E28403, $D48E2B, $535F6E
Data $979EB0, $636979, $1E2433, $E7D4C1, $E7D0BC, $E2BB9A, $361F09, $361F09
Data $361F09, $361F09, $D36500, $D66C00, $361F09, $E17D00, $E28402, $D28A28
Data $546073, $9AA1AF, $737989, $293040, $E0C2A1, $E5CCB4, $E4BFA2, $361F09
Data $361F09, $361F09, $CF5E00, $D46600, $D76D00, $361F09, $E17E00, $E18403
Data $C47F28, $515974, $A4AABA, $000000, $3E4555, $B28450, $DCB78E, $E7C6AC
Data $361F09, $361F09, $CF6300, $D05E00, $D46800, $D87000, $361F09, $E38100
Data $DA7F09, $906741, $5C627D, $000000, $000000, $707787, $5A3E27, $A16F3A
Data $DEAB79, $DC995F, $D16B11, $CE5900, $D16400, $D76B00, $DB7300, $E07C00
Data $DB7E06, $A36A2A, $4F4D57, $8F96A5, $000000, $000000, $000000, $5A6171
Data $46362F, $9F5813, $C96100, $CB5A01, $D06001, $D36700, $D76D01, $DB7501
Data $D37808, $A16621, $44434C, $777D8C, $000000, $000000, $000000, $000000
Data $000000, $5E6573, $443E3E, $7D4B1F, $B25E0B, $BB630A, $BC660C, $C16B0C
Data $B46814, $79502A, $464548, $7F848E, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $808795, $525869, $3A414F, $353F49, $323B46
Data $30364A, $3B4054, $5B6072, $959BA6, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $979DAC, $8C92A2
Data $808696, $757C8C, $9199A7, $000000, $000000, $000000, $000000, $000000
Data $000000

.BCF_ReduceGadgetOn_Style03
Data 17
Data 17
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $5F6F7E, $5F6F7E, $0A0A0A, $5F7084, $5F7084, $5F7084
Data $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084
Data $5F7084, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968
Data $4B5968, $C9DCEC, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $C9DCEC, $4B5968
Data $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968
Data $C9DCEC, $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968, $38424E, $0A0A0A
Data $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $C9DCEC, $4B5968, $C9DCEC, $4B5968, $4B5968, $38424E
Data $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968
Data $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968
Data $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $C9DCEC, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $4B5968, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $4B5968, $38424E, $38424E, $38424E, $38424E
Data $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A



.BCF_ReduceGadgetOff_Style03
Data 17
Data 17
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $FFDF3B, $FFDF3B, $0A0A0A, $0A1420, $0A1420, $0A1420
Data $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420
Data $1D2B3A, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A
Data $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E
Data $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B
Data $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $1D2B3A
Data $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A
Data $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $FFC000, $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $314256, $0A0A0A
Data $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $314256
Data $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A
Data $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A
Data $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $1D2B3A
Data $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420
Data $1D2B3A, $1D2B3A, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000
Data $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A
Data $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E
Data $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B
Data $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A
Data $FFDF3B, $FFB20E, $0A0A0A, $314256, $314256, $314256, $314256, $314256
Data $314256, $314256, $314256, $314256, $314256, $314256, $314256, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A



; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_CheckBoxOn_Style01
Data 15
Data 15
Data $000000, $1A264E, $242C4F, $232A4C, $232A4B, $232A4B, $222A4B, $222A4B
Data $22294A, $22294A, $212949, $212849, $21294B, $1F2B51, $000000, $1A2750
Data $476597, $5BA0DB, $4B8FCE, $4A8CCB, $498AC9, $4887C5, $4685C3, $4583C1
Data $437FBD, $417CBA, $3E79B8, $3E7DBD, $2E4D83, $1E2A51, $282E50, $7EB2DF
Data $507F50, $468640, $3B9626, $47A41D, $63B321, $527C44, $5E7E5D, $8EC462
Data $96DF4A, $6BB138, $4F7F2F, $3972B0, $202849, $2A2E4E, $86B7E1, $5C8B5C
Data $549045, $4A9924, $56A51E, $72BA29, $223217, $1B2717, $344F34, $72966C
Data $84C15C, $6BAD3A, $386EAC, $212746, $2A2E4E, $83B3DD, $84B584, $73AE54
Data $62A320, $6EAD26, $84CB38, $38562A, $1B2717, $1B2717, $1B2717, $3C593C
Data $789E6E, $376AA9, $212647, $2A2E4E, $83B2DB, $A8D4A4, $8BC063, $6CAD26
Data $73BC38, $87D54D, $9DD966, $71946B, $2F492F, $1B2717, $1B2717, $2E472E
Data $3667A5, $212646, $2A2E4E, $81AFDA, $B0CF9F, $95BC6A, $72B234, $78C448
Data $95D461, $A1F061, $B8F77D, $70916D, $203320, $1B2717, $294129, $3465A2
Data $202646, $2A2E4E, $80AED9, $B0D0A0, $89BB69, $6DB133, $84C542, $8EC365
Data $739769, $476646, $1B2717, $1B2717, $1B2717, $3D5A3D, $33639F, $202545
Data $2A2E4D, $7FADD7, $B0CF9F, $96BC69, $78A45C, $61835D, $3A573A, $1B2717
Data $1B2717, $1B2717, $2B432B, $597857, $95B882, $31609D, $202545, $2A2D4D
Data $7EABD5, $7D9F7C, $567655, $304A30, $1B2717, $1B2717, $1B2717, $2F492F
Data $5E7E5B, $98BC82, $CDF592, $D4FF88, $305E9B, $202545, $2A2D4D, $7CA8D3
Data $263C26, $1B2717, $1B2717, $1B2717, $334E33, $5B7D57, $81AF66, $A1E574
Data $BCFC87, $C5FF7D, $B6FF60, $2F5C99, $202545, $2A2D4C, $7EA9D4, $1B2717
Data $1B2717, $365136, $62835D, $70A747, $73C039, $8FD24F, $9CE15C, $A6F05F
Data $90DB4E, $6EB839, $2D5B98, $202544, $272C4F, $739FCE, $415E41, $638362
Data $559643, $56A421, $63B321, $6FBF2F, $89CC4A, $9EDB53, $9EE849, $76C338
Data $4F902F, $2C5B97, $1E2648, $1A2750, $3D5684, $477EBA, $386DAA, $376BA7
Data $3469A4, $3364A1, $31629E, $31609D, $305E99, $2F5C97, $2D5A95, $2C5B9A
Data $253D6D, $1E2B51, $000000, $18254E, $20294C, $202748, $202749, $1F2648
Data $1F2648, $1F2648, $1F2647, $202647, $202647, $1F2546, $1F2649, $1F2C52
Data $000000




.BCF_CheckBoxOff_Style01
Data 15
Data 15
Data $000000, $1A264E, $242C4F, $232A4C, $232A4B, $232A4B, $222A4B, $222A4B
Data $22294A, $22294A, $212949, $212849, $21294B, $1F2B51, $000000, $1A2750
Data $476597, $5BA0DB, $4B8FCE, $4A8CCB, $498AC9, $4887C5, $4685C3, $4583C1
Data $437FBD, $417CBA, $3E79B8, $3E7DBD, $2E4D83, $1E2A51, $282E50, $7EB2DF
Data $507F50, $468640, $3B9626, $47A41D, $63B321, $6FBF2F, $7BCC4A, $9ADD53
Data $96E049, $6BB138, $4F7F2F, $3972B0, $202849, $2A2E4E, $86B7E1, $5C8B5C
Data $549045, $4A9924, $56A51E, $72BA29, $74C534, $89D350, $9BE35D, $9EE962
Data $85CC51, $6BAD3A, $386EAC, $212746, $2A2E4E, $83B3DD, $84B584, $73AE54
Data $62A320, $6EAD26, $84CB38, $8CD44C, $A3E261, $AAF372, $BAFA88, $B9F87F
Data $A7F663, $376AA9, $212647, $2A2E4E, $83B2DB, $A8D4A4, $8BC063, $6CAD26
Data $73BC38, $87D54D, $A1E361, $B0F170, $BEFD7B, $CDFF8E, $D0FF93, $C8FF88
Data $3667A5, $212646, $2A2E4E, $81AFDA, $B0CF9F, $95BC6A, $72B234, $78C448
Data $95D461, $A1F061, $BBFD7B, $C1FF80, $CBFF92, $D4FF9D, $D4FF94, $3465A2
Data $202646, $2A2E4E, $80AED9, $B0D0A0, $89BB69, $6DB133, $84C542, $93D454
Data $AEEE6E, $BCFD7B, $C9FF8C, $D9FF90, $E1FF96, $E0FFA0, $33639F, $202545
Data $2A2E4D, $7FADD7, $B0CF9F, $96BC69, $72B133, $77C448, $95D362, $A0E060
Data $BBFA7C, $BFFF7F, $D3FF92, $DEFF9E, $D1FF92, $31609D, $202545, $2A2D4D
Data $7EABD5, $A8D4A4, $8BBF63, $6BB425, $73C738, $87D44C, $A1E061, $B0F170
Data $BEFD7B, $CDFF8D, $D6FF92, $D4FF88, $305E9B, $202545, $2A2D4D, $7CA8D3
Data $81B181, $72AB53, $61A520, $6CB025, $85CA37, $8AD54A, $A1E260, $A6F071
Data $BCFC87, $C5FF7D, $B6FF60, $2F5C99, $202545, $2A2D4C, $7EA9D4, $5A895A
Data $508F44, $4C9824, $5CA41D, $6FB927, $73C433, $8FD24F, $9CE15C, $A6F05F
Data $90DB4E, $6EB839, $2D5B98, $202544, $272C4F, $739FCE, $507F50, $458640
Data $429626, $54A51D, $63B321, $6FBF2F, $89CC4A, $9EDB53, $9EE849, $76C338
Data $4F902F, $2C5B97, $1E2648, $1A2750, $3D5684, $477EBA, $386DAA, $376BA7
Data $3469A4, $3364A1, $31629E, $31609D, $305E99, $2F5C97, $2D5A95, $2C5B9A
Data $253D6D, $1E2B51, $000000, $18254E, $20294C, $202748, $202749, $1F2648
Data $1F2648, $1F2648, $1F2647, $202647, $202647, $1F2546, $1F2649, $1F2C52
Data $000000


.BCF_CheckBoxOn_Style02
Data 15
Data 15
Data $000000, $8C96AD, $79859A, $788294, $818A99, $92979F, $A7A9AB, $ADADB0
Data $ADADB0, $B2B3B5, $B2B3B5, $B9BABC, $CACACD, $CACCD3, $000000, $909AB2
Data $626C83, $4F5768, $494D59, $4D515E, $4B505D, $474D5A, $4A4F5C, $4A4F5C
Data $4B505C, $4B505C, $4C525D, $5A5E6B, $909196, $DBDCE1, $7F8BA3, $464E5C
Data $ADB4C3, $C8CAD7, $C7CBDB, $C3C8D9, $ABB2C7, $B0B8CA, $A3AABA, $B8C0CE
Data $B8C0CE, $BEC5D3, $8B929E, $595C62, $DADCDC, $7986A1, $4A505A, $DEE2E8
Data $CED0DC, $C1C5D5, $BFC4D5, $8B929E, $636469, $545555, $515151, $8B929E
Data $B5BDD0, $A4ADBB, $565A65, $DDDEDF, $7784A0, $51565F, $FBFAFD, $CBCEDB
Data $C1C5D5, $BFC4D5, $646468, $515151, $515151, $535354, $515151, $8B929E
Data $ACB3C1, $5A5E6D, $DDDEE0, $7784A0, $51565F, $FBFBFD, $CBCEDB, $C1C5D5
Data $BFC4D5, $8B929E, $575758, $515151, $515151, $525252, $515151, $ABB2C1
Data $5A5F70, $DDDEE1, $7784A0, $51565F, $FAFAFD, $CBCEDB, $C1C5D5, $BFC4D5
Data $A8AFC3, $8B929E, $515151, $515151, $515151, $5B5B5E, $A6ACBA, $5A5F70
Data $DDDEE1, $7784A0, $51565F, $FBFBFD, $CBCEDB, $C1C5D5, $BFC4D5, $8B929E
Data $535353, $515151, $515151, $555659, $8B929E, $ABB2C1, $5A5F70, $DDDEE1
Data $7784A0, $51565F, $FAFAFD, $CBCEDB, $BCC0CF, $8B929E, $515151, $515151
Data $515151, $515151, $8B929E, $B6BED0, $ABB2C1, $5A5F70, $DDDEE1, $7784A0
Data $51565F, $FBFBFD, $CBCEDB, $8B929E, $515151, $515151, $515151, $515151
Data $8B929E, $A7AFC3, $B6BED0, $ABB2C0, $5A5F70, $DDDEE0, $7785A0, $51555E
Data $F6F7FA, $CCCFDC, $515151, $515151, $515151, $515151, $8B929E, $A7AFC3
Data $A7AFC3, $B7BFD0, $ABB3C0, $585D6B, $DCDEE0, $7A87A1, $464D58, $D2D7DF
Data $D2D4E1, $515151, $515151, $515151, $8B929E, $AFB6CA, $AEB7CB, $AEB7CB
Data $BCC4D6, $9FA8B6, $545861, $DCDEDE, $838FA6, $4B5364, $8F96A6, $A5A7B4
Data $A7ABBB, $A4A9B8, $8E94A8, $949BAC, $949BAC, $9BA2AF, $9BA2AF, $9DA4B2
Data $747B88, $63656A, $D9DBDC, $9AA4B9, $707B93, $4D5668, $404654, $444A57
Data $484E58, $4E525B, $50545D, $50545D, $51545E, $51545E, $545760, $70727D
Data $A9ABB0, $CCCFD6, $000000, $8E99AF, $7D8BA0, $7F899B, $88909F, $989DA6
Data $ADB0B2, $B4B4B7, $B4B4B7, $B9BABD, $B9BABD, $C0C0C2, $CCCDD0, $C8CAD1
Data $000000


.BCF_CheckBoxOff_Style02
Data 15
Data 15
Data $000000, $8C96AD, $79859A, $788294, $818A99, $92979F, $A7A9AB, $ADADB0
Data $ADADB0, $B2B3B5, $B2B3B5, $B9BABC, $CACACD, $CACCD3, $000000, $909AB2
Data $626C83, $4F5768, $494D59, $4D515E, $4B505D, $474D5A, $4A4F5C, $4A4F5C
Data $4B505C, $4B505C, $4C525D, $5A5E6B, $909196, $DBDCE1, $7F8BA3, $464E5C
Data $ADB4C3, $C8CAD7, $C7CBDB, $C3C8D9, $ABB2C7, $B1B9CB, $B1B9CB, $B8C0CE
Data $B8C0CE, $BEC5D3, $8B929E, $595C62, $DADCDC, $7986A1, $4A505A, $DEE2E8
Data $CED0DC, $C1C5D5, $BFC4D5, $A8AFC3, $A9B0C4, $A9B0C4, $A6AEC3, $A6AEC3
Data $B5BDD0, $A4ADBB, $565A65, $DDDEDF, $7784A0, $51565F, $FBFAFD, $CBCEDB
Data $C1C5D5, $BFC4D5, $A8AFC3, $A9B0C4, $A9B0C4, $A7AFC3, $A7AFC3, $B7BFD0
Data $ACB3C1, $5A5E6D, $DDDEE0, $7784A0, $51565F, $FBFBFD, $CBCEDB, $C1C5D5
Data $BFC4D5, $A8AFC3, $A9B0C4, $A9B0C4, $A7AFC3, $A7AFC3, $B6BED0, $ABB2C1
Data $5A5F70, $DDDEE1, $7784A0, $51565F, $FAFAFD, $CBCEDB, $C1C5D5, $BFC4D5
Data $A8AFC3, $A9B0C4, $A9B0C4, $A7AFC3, $A7AFC3, $B6BED0, $ABB2C1, $5A5F70
Data $DDDEE1, $7784A0, $51565F, $FBFBFD, $CBCEDB, $C1C5D5, $BFC4D5, $A8AFC3
Data $A9B0C4, $A9B0C4, $A7AFC3, $A7AFC3, $B6BED0, $ABB2C1, $5A5F70, $DDDEE1
Data $7784A0, $51565F, $FAFAFD, $CBCEDB, $C1C5D5, $BFC4D5, $A8AFC3, $A9B0C4
Data $A9B0C4, $A7AFC3, $A7AFC3, $B6BED0, $ABB2C1, $5A5F70, $DDDEE1, $7784A0
Data $51565F, $FBFBFD, $CBCEDB, $C1C5D5, $BFC4D5, $A8AFC3, $A9B0C4, $A9B0C4
Data $A7AFC3, $A7AFC3, $B6BED0, $ABB2C0, $5A5F70, $DDDEE0, $7785A0, $51555E
Data $F6F7FA, $CCCFDC, $C1C5D5, $BFC4D5, $A8AFC3, $A9B0C4, $A9B0C4, $A7AFC3
Data $A7AFC3, $B7BFD0, $ABB3C0, $585D6B, $DCDEE0, $7A87A1, $464D58, $D2D7DF
Data $D2D4E1, $C7CBDB, $C5CADB, $ADB4C9, $AFB6CA, $AFB6CA, $AEB7CB, $AEB7CB
Data $BCC4D6, $9FA8B6, $545861, $DCDEDE, $838FA6, $4B5364, $8F96A6, $A5A7B4
Data $A7ABBB, $A4A9B8, $8E94A8, $949BAC, $949BAC, $9BA2AF, $9BA2AF, $9DA4B2
Data $747B88, $63656A, $D9DBDC, $9AA4B9, $707B93, $4D5668, $404654, $444A57
Data $484E58, $4E525B, $50545D, $50545D, $51545E, $51545E, $545760, $70727D
Data $A9ABB0, $CCCFD6, $000000, $8E99AF, $7D8BA0, $7F899B, $88909F, $989DA6
Data $ADB0B2, $B4B4B7, $B4B4B7, $B9BABD, $B9BABD, $C0C0C2, $CCCDD0, $C8CAD1
Data $000000

.BCF_CheckBoxOn_Style03
Data 15
Data 15
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $5F6F7E, $5F6F7E, $0A0A0A, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084
Data $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $575E61, $60625B, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $8B7848, $F5AD11, $C7962A, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $8E7B46, $FDB20F, $FFB10E, $FDB00F, $C6962A, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $9D813F, $FDB00F, $FFB20E, $FEB10E, $FAB010, $C99729, $4B5968
Data $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4D5A67, $A8873A, $FFB20E, $FFB20E, $FFB20E, $E9A718, $565E62, $38424E
Data $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $706B56
Data $D69E23, $FFB20E, $FEB20E, $EBA818, $82744C, $505B65, $38424E, $0A0A0A
Data $0A0A0A, $5F6F7E, $344453, $13110C, $5F7084, $756F52, $DBA020, $FEB10F
Data $FFB20E, $EBA918, $88774A, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $7F7D6B, $DAA120, $FFB20E, $FFB20E, $EBA818
Data $8D7947, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $684C0A, $DCA527, $FFB20E, $FFB20E, $EBA818, $907B45, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $FFB20E, $FFB20E, $FEB20E, $F1AB15, $927C44, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $FFB20E
Data $FFB20E, $FFB20E, $AB8838, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $4B5968
Data $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $38424E
Data $38424E, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A

.BCF_CheckBoxOff_Style03
Data 15
Data 15
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $5F6F7E, $5F6F7E, $0A0A0A, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084
Data $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E
Data $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A
Data $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $4B5968
Data $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $38424E
Data $38424E, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A


; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_ArrowDownOn_Style01
Data 17
Data 17
Data $000000, $3882C6, $276FB8, $266CB3, $2E75B7, $3F83BC, $5897C5, $609BC9
Data $609BC9, $67A2CC, $67A2CC, $72ABD1, $72ABD1, $72ABD1, $8EBDDD, $8EC0E1
Data $000000, $3D86CA, $1755A6, $0D418F, $0B3781, $0C3B86, $0B3A85, $0A3782
Data $0B3984, $0B3984, $0B3A84, $0B3A84, $0C3C85, $0C3C85, $0C3C85, $124892
Data $3D7CB5, $AED3EB, $2C76BF, $0A3884, $507F50, $498345, $328027, $3E9D1F
Data $52AB1D, $69B724, $71C133, $7BCC4A, $97DB53, $9DE54D, $7FC93F, $5A9532
Data $4F7F2F, $12468A, $ACD3E7, $2770BD, $0B3A82, $568456, $508949, $003504
Data $124F0A, $5AA81E, $70BB29, $73C435, $84D04D, $97DE58, $9EE95B, $8AD551
Data $6BAD3D, $609D34, $10448C, $B2D5E9, $256EBD, $0E4087, $74A574, $6AA458
Data $003504, $003504, $043A05, $519223, $85D046, $9ADC5A, $A1EB68, $ADF47A
Data $ADF078, $9CE460, $91E052, $124893, $B2D5EA, $256EBD, $0E4087, $9ACA99
Data $88BF6C, $003504, $003504, $003504, $003504, $225A17, $A2E063, $B4F875
Data $C3FE8A, $CBFF91, $C4FF84, $BDFF79, $124996, $B2D5EB, $256EBD, $0E4087
Data $AFD6A6, $9AC677, $003504, $003504, $003504, $003504, $003504, $043A07
Data $71AC4A, $CAFF8B, $D2FF98, $D2FF96, $CFFF90, $124996, $B2D5EB, $256EBD
Data $0E4087, $B1CF9F, $9BBF79, $003504, $003504, $003504, $003504, $003504
Data $003504, $003504, $25591D, $C3EF8E, $D9FF9B, $D9FF98, $124996, $B2D5EB
Data $256EBD, $0E4087, $B0D0A0, $92BF77, $003504, $003504, $003504, $003504
Data $003504, $003504, $003504, $003504, $003504, $E2FF9B, $E0FFA0, $124996
Data $B2D5EB, $256EBD, $0E4087, $B0CF9F, $9EC077, $003504, $003504, $003504
Data $003504, $003504, $003504, $003504, $25591D, $CCEF90, $D9FF9A, $D1FF93
Data $124996, $B2D5EB, $256EBD, $0E4087, $ACD6A6, $97C575, $003504, $003504
Data $003504, $003504, $003504, $043907, $71AB4A, $CBFF8A, $D6FF95, $D8FF92
Data $D6FF8C, $124996, $B2D5EB, $256EBD, $0E4087, $90C090, $82B767, $003504
Data $003504, $003504, $003504, $215A16, $9EDE61, $ACF373, $BDFC89, $CDFF8E
Data $CCFF7C, $C7FF70, $124996, $B2D5EA, $256FBD, $0E3F86, $699869, $619953
Data $003504, $003504, $043A05, $4E8F20, $7ECD3F, $96D856, $9CE463, $ACF471
Data $AFF46D, $9BE455, $8EDB48, $114792, $B0D5EA, $2871BD, $0A3780, $528152
Data $4A8646, $003504, $134F0A, $5CA71C, $6AB926, $72C233, $8BCE4B, $9ADA55
Data $A3EC55, $91E048, $6BB637, $5AA131, $0F4289, $B0D5E9, $307AC1, $0B3D8B
Data $507F50, $478345, $348027, $4A9E1F, $5BAB1D, $67B724, $72C133, $89CC4A
Data $9CD953, $A3E94D, $8AD83F, $60A832, $4F902F, $174E91, $AAD2E7, $4891CF
Data $2065B3, $0C408F, $08317D, $09357F, $0A3880, $0D3C83, $0E3E85, $0E3E85
Data $0E3E86, $0E3E86, $0F4188, $0F4188, $0F4188, $205CA1, $5B99C9, $91C3E3
Data $000000, $3A85C8, $2A76BD, $2C74B9, $347BBC, $4589C1, $609FCA, $6AA4CE
Data $6AA4CE, $72ABD2, $72ABD2, $7DB2D6, $7DB2D6, $7DB2D6, $91C1DF, $8ABDE0
Data $000000

.BCF_ArrowDownOff_Style01
Data 17
Data 17
Data $000000, $064596, $003586, $003281, $003A85, $0A468A, $1A5994, $205D98
Data $205D98, $24649C, $24649C, $2C6BA2, $2C6BA2, $2C6BA2, $3F7DAF, $3F7FB3
Data $000000, $094A9A, $001D71, $000C57, $000446, $00074C, $00064B, $000447
Data $000549, $000549, $000649, $000649, $00084B, $00084B, $00084B, $00115A
Data $094082, $5691BD, $003B8D, $000549, $0E3D0E, $074103, $004901, $005B00
Data $106900, $277500, $2F7F00, $398A08, $559911, $5BA30B, $3D8700, $185300
Data $0D3D00, $001050, $5591BA, $00368C, $000647, $144214, $0E4707, $003504
Data $023F03, $1A6800, $2E7900, $318200, $428E0B, $559C16, $5CA719, $48930F
Data $296B00, $1E5B00, $000E53, $5994BC, $00348B, $000B4D, $326332, $286216
Data $003504, $003504, $023704, $286901, $438E04, $589A18, $5FA926, $6BB238
Data $6BAE36, $5AA21E, $4F9E10, $00115C, $5994BD, $00348B, $000B4D, $588857
Data $467D2A, $003504, $003504, $003504, $003504, $144C09, $63A225, $72B633
Data $81BC48, $89BD4F, $82BD42, $7BBD37, $00125F, $5994BD, $00348B, $000B4D
Data $6D9464, $588435, $003504, $003504, $003504, $003504, $003504, $033805
Data $4A8523, $88BD49, $90BD56, $90BD54, $8DBD4E, $00125F, $5994BD, $00348B
Data $000B4D, $6F8D5D, $597D37, $003504, $003504, $003504, $003504, $003504
Data $003504, $003504, $194E11, $87B251, $97BD59, $97BD56, $00125F, $5994BD
Data $00348B, $000B4D, $6E8E5E, $507D35, $003504, $003504, $003504, $003504
Data $003504, $003504, $003504, $003504, $003504, $A0BD59, $9EBD5E, $00125F
Data $5994BD, $00348B, $000B4D, $6E8D5D, $5C7E35, $003504, $003504, $003504
Data $003504, $003504, $003504, $003504, $194E11, $8FB253, $97BD58, $8FBD51
Data $00125F, $5994BD, $00348B, $000B4D, $6A9464, $558333, $003504, $003504
Data $003504, $003504, $003504, $033805, $498423, $89BD48, $94BD53, $96BD50
Data $94BD4A, $00125F, $5994BD, $00348B, $000B4D, $4E7E4E, $407525, $003504
Data $003504, $003504, $003504, $124B08, $5FA022, $6AB131, $7BBA47, $8BBD4C
Data $8ABD3A, $85BD2E, $00125F, $5994BD, $00358B, $000A4C, $275627, $1F5711
Data $003504, $003504, $023704, $246601, $3C8B00, $549614, $5AA221, $6AB22F
Data $6DB22B, $59A213, $4C9906, $00115A, $5894BD, $00378C, $000445, $103F10
Data $084404, $003504, $033E03, $1C6700, $287700, $308000, $498C09, $589813
Data $61AA13, $4F9E06, $297400, $185F00, $000C4F, $5894BB, $013E90, $000852
Data $0E3D0E, $054103, $004901, $085C00, $196900, $257500, $307F00, $478A08
Data $5A9711, $61A70B, $489600, $1E6600, $0D4E00, $001759, $5390BA, $10549F
Data $002B80, $000B57, $000040, $000243, $000545, $000848, $00094B, $00094B
Data $00094C, $00094C, $000C4E, $000C4E, $000C4E, $00236C, $1C5B98, $4283B5
Data $000000, $084997, $003B8B, $003987, $043F8A, $0E4D90, $20609A, $26659E
Data $26659E, $2C6BA2, $2C6BA2, $3372A6, $3372A6, $3372A6, $4280B1, $3D7DB2
Data $000000

.BCF_ArrowDownOn_Style02
Data 17
Data 17
Data $000000, $8C96AD, $79859A, $788294, $818A99, $92979F, $A7A9AB, $ADADB0
Data $ADADB0, $B2B3B5, $B2B3B5, $B9BABC, $B9BABC, $B9BABC, $CACACD, $CACCD3
Data $000000, $909AB2, $626C83, $4F5768, $494D59, $4D515E, $4B505D, $474D5A
Data $4A4F5C, $4A4F5C, $4B505C, $4B505C, $4C525D, $4C525D, $4C525D, $5A5E6B
Data $909196, $DBDCE1, $7F8BA3, $464E5C, $9EA4B2, $B5B9C6, $A2A7B5, $B1B6C7
Data $A2A9BC, $A2AABC, $A4ACBD, $A7AFBE, $A9B0BF, $AEB5C3, $AFB6C4, $A8AFBD
Data $888F9A, $595C62, $DADCDC, $7986A1, $4A505A, $C7CBD3, $CDD0DC, $444A57
Data $626875, $A8AFC2, $AAB1C5, $AAB1C5, $A9B1C5, $AAB2C6, $B5BCCF, $B6BED0
Data $B4BCCE, $9AA2B0, $565A65, $DDDEDF, $7784A0, $51565F, $DCDDE2, $D0D3DF
Data $444A56, $444A56, $484E5A, $838A9B, $A9B0C4, $A7AFC3, $A9B1C5, $B5BDCE
Data $B7BFD0, $B5BDCE, $A2A9B8, $5A5E6D, $DDDEE0, $7784A0, $51565F, $E0E1E5
Data $D0D3DF, $444A56, $444A56, $444A56, $444A56, $5A606E, $A2A9BD, $A9B1C5
Data $B4BCCE, $B6BED0, $B5BDCE, $A2A9B9, $5A5F70, $DDDEE1, $7784A0, $51565F
Data $DFE0E5, $D0D2DF, $444A56, $444A56, $444A56, $444A56, $444A56, $464C59
Data $808798, $B4BCCE, $B6BED0, $B5BDCE, $A2A9B9, $5A5F70, $DDDEE1, $7784A0
Data $51565F, $E0E1E5, $D0D3DF, $444A57, $444A56, $444A56, $444A56, $444A56
Data $444A56, $444A56, $585F6C, $ADB5C6, $B5BDCE, $A2A9B9, $5A5F70, $DDDEE1
Data $7784A0, $51565F, $DFE0E5, $D0D2DF, $444A56, $444A56, $444A56, $444A56
Data $444A56, $444A56, $444A56, $444A56, $444A56, $B5BDCE, $A2A9B9, $5A5F70
Data $DDDEE1, $7784A0, $51565F, $E0E1E5, $D0D3DF, $444A56, $444A56, $444A56
Data $444A56, $444A56, $444A56, $444A56, $585F6C, $ADB5C6, $B5BDCE, $A2A9B9
Data $5A5F70, $DDDEE1, $7784A0, $51565F, $DFE0E5, $D0D2DF, $444A56, $444A56
Data $444A56, $444A56, $444A56, $464C59, $808798, $B4BCCE, $B6BED0, $B5BDCE
Data $A2A9B9, $5A5F70, $DDDEE1, $7784A0, $51565F, $DFE0E5, $D0D3DF, $444A56
Data $444A56, $444A56, $444A56, $5A606E, $A2A9BD, $A9B1C5, $B4BCCE, $B6BED0
Data $B5BDCE, $A2A9B8, $5A5F70, $DDDEE0, $7785A0, $51555E, $D8DAE0, $D1D3DF
Data $444A56, $444A56, $484E5A, $848B9C, $AAB1C5, $A8B0C4, $AAB2C6, $B6BECF
Data $B8C0D1, $B6BECF, $A1A8B6, $585D6B, $DCDEE0, $7A87A1, $464D58, $BDC1CB
Data $CACDDA, $444A57, $626876, $A9AFC3, $ABB2C5, $ABB2C6, $ABB3C6, $ADB5C8
Data $B6BECF, $B8BFD1, $B4BCCD, $959DAB, $545861, $DCDEDE, $838FA6, $4B5364
Data $89909F, $9C9FAD, $8E92A1, $9A9FAF, $8D93A5, $8E95A5, $9096A6, $939AA8
Data $949BA9, $989EAC, $989EAC, $9399A7, $7C828E, $63656A, $D9DBDC, $9AA4B9
Data $707B93, $4D5668, $404654, $444A57, $484E58, $4E525B, $50545D, $50545D
Data $51545E, $51545E, $545760, $545760, $545760, $70727D, $A9ABB0, $CCCFD6
Data $000000, $8E99AF, $7D8BA0, $7F899B, $88909F, $989DA6, $ADB0B2, $B4B4B7
Data $B4B4B7, $B9BABD, $B9BABD, $C0C0C2, $C0C0C2, $C0C0C2, $CCCDD0, $C8CAD1
Data $000000


.BCF_ArrowDownOff_Style02
Data 17
Data 17
Data $000000, $636D84, $505C71, $4F596B, $586170, $696E76, $7E8082, $848487
Data $848487, $898A8C, $898A8C, $909193, $909193, $909193, $A1A1A4, $A1A3AA
Data $000000, $677189, $39435A, $262E3F, $202430, $242835, $222734, $1E2431
Data $212633, $212633, $222733, $222733, $232934, $232934, $232934, $313542
Data $67686D, $B2B3B8, $56627A, $1D2533, $757B89, $8C909D, $818593, $888D9E
Data $798093, $798193, $7B8394, $7E8695, $808796, $858C9A, $868D9B, $7F8694
Data $5F6671, $303339, $B1B3B3, $505D78, $212731, $9EA2AA, $A4A7B3, $444A56
Data $585E6B, $80879B, $81889C, $81889C, $80889C, $81899D, $8C93A6, $8D95A7
Data $8B93A5, $717987, $2D313C, $B4B5B6, $4E5B77, $282D36, $B3B4B9, $A7AAB6
Data $444A56, $444A56, $464C59, $6A7081, $80879B, $7E869A, $80889C, $8C94A5
Data $8E96A7, $8C94A5, $79808F, $313544, $B4B5B7, $4E5B77, $282D36, $B7B8BC
Data $A7AAB6, $444A56, $444A56, $444A56, $444A56, $515765, $7B8396, $80889C
Data $8B93A5, $8D95A7, $8C94A5, $798090, $313647, $B4B5B8, $4E5B77, $282D36
Data $B6B7BC, $A7A9B6, $444A56, $444A56, $444A56, $444A56, $444A56, $454B58
Data $686F7F, $8B93A5, $8D95A7, $8C94A5, $798090, $313647, $B4B5B8, $4E5B77
Data $282D36, $B7B8BC, $A7AAB6, $444A56, $444A56, $444A56, $444A56, $444A56
Data $444A56, $444A56, $515764, $878FA1, $8C94A5, $798090, $313647, $B4B5B8
Data $4E5B77, $282D36, $B6B7BC, $A7A9B6, $444A56, $444A56, $444A56, $444A56
Data $444A56, $444A56, $444A56, $444A56, $444A56, $8C94A5, $798090, $313647
Data $B4B5B8, $4E5B77, $282D36, $B7B8BC, $A7AAB6, $444A56, $444A56, $444A56
Data $444A56, $444A56, $444A56, $444A56, $515764, $878FA1, $8C94A5, $798090
Data $313647, $B4B5B8, $4E5B77, $282D36, $B6B7BC, $A7A9B6, $444A56, $444A56
Data $444A56, $444A56, $444A56, $454B58, $686F7F, $8B93A5, $8D95A7, $8C94A5
Data $798090, $313647, $B4B5B8, $4E5B77, $282D36, $B6B7BC, $A7AAB6, $444A56
Data $444A56, $444A56, $444A56, $515765, $7B8396, $80889C, $8B93A5, $8D95A7
Data $8C94A5, $79808F, $313647, $B4B5B7, $4E5C77, $282C35, $AFB1B7, $A8AAB6
Data $444A56, $444A56, $464C59, $6A7182, $81889C, $7F879B, $81899D, $8D95A6
Data $8F97A8, $8D95A6, $787F8D, $2F3442, $B3B5B7, $515E78, $1D242F, $9498A2
Data $A1A4B1, $444A56, $585E6B, $81879C, $82899C, $82899D, $828A9D, $848C9F
Data $8D95A6, $8F96A8, $8B93A4, $6C7482, $2B2F38, $B3B5B5, $5A667D, $222A3B
Data $606776, $737684, $6C717F, $717686, $646A7C, $656C7C, $676D7D, $6A717F
Data $6B7280, $6F7583, $6F7583, $6A707E, $535965, $3A3C41, $B0B2B3, $717B90
Data $47526A, $242D3F, $171D2B, $1B212E, $1F252F, $252932, $272B34, $272B34
Data $282B35, $282B35, $2B2E37, $2B2E37, $2B2E37, $474954, $808287, $A3A6AD
Data $000000, $657086, $546277, $566072, $5F6776, $6F747D, $848789, $8B8B8E
Data $8B8B8E, $909194, $909194, $979799, $979799, $979799, $A3A4A7, $9FA1A8
Data $000000

.BCF_ArrowDownOn_Style03
Data 17
Data 17
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $5F6F7E, $5F6F7E, $0A0A0A, $5F7084, $5F7084, $5F7084
Data $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084
Data $5F7084, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC
Data $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $C9DCEC, $C9DCEC, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968, $38424E, $0A0A0A
Data $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $38424E
Data $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968
Data $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $4B5968, $38424E, $38424E, $38424E, $38424E
Data $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A


.BCF_ArrowDownOff_Style03
Data 17
Data 17
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $FFDF3B, $FFDF3B, $0A0A0A, $0A1420, $0A1420, $0A1420
Data $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420
Data $1D2B3A, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420
Data $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A
Data $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E
Data $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B
Data $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $FFC000, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A
Data $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A, $314256, $0A0A0A
Data $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $314256
Data $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A
Data $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A
Data $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A
Data $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E
Data $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B
Data $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A
Data $FFDF3B, $FFB20E, $0A0A0A, $314256, $314256, $314256, $314256, $314256
Data $314256, $314256, $314256, $314256, $314256, $314256, $314256, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A

; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_ArrowUpOn_Style01
Data 17
Data 17
Data $000000, $3882C6, $276FB8, $266CB3, $2E75B7, $3F83BC, $5897C5, $609BC9
Data $609BC9, $67A2CC, $67A2CC, $72ABD1, $72ABD1, $72ABD1, $8EBDDD, $8EC0E1
Data $000000, $3D86CA, $1755A6, $0D418F, $0B3781, $0C3B86, $0B3A85, $0A3782
Data $0B3984, $0B3984, $0B3A84, $0B3A84, $0C3C85, $0C3C85, $0C3C85, $124892
Data $3D7CB5, $AED3EB, $2C76BF, $0A3884, $507F50, $498345, $3D902F, $3E9D1F
Data $52AB1D, $69B724, $71C133, $7BCC4A, $97DB53, $9DE54D, $68AE34, $5A9532
Data $4F7F2F, $12468A, $ACD3E7, $2770BD, $0B3A82, $568456, $508949, $46922F
Data $489D1D, $5DAC1F, $70BB29, $73C435, $84D04D, $92D955, $28621A, $013604
Data $6BAD3D, $609D34, $10448C, $B2D5E9, $256EBD, $0E4087, $74A574, $6AA458
Data $5C9F2D, $5DA11B, $71B426, $81CA36, $85D046, $619E3A, $063C08, $003504
Data $003504, $9CE460, $91E052, $124893, $B2D5EA, $256EBD, $0E4087, $9ACA99
Data $88BF6C, $6FAD30, $6AAB21, $79C137, $84CE46, $225A17, $003504, $003504
Data $003504, $003504, $C4FF84, $BDFF79, $124996, $B2D5EB, $256EBD, $0E4087
Data $AFD6A6, $9AC677, $79B339, $6DB52F, $4A8D2D, $033906, $003504, $003504
Data $003504, $003504, $003504, $D2FF96, $CFFF90, $124996, $B2D5EB, $256EBD
Data $0E4087, $B1CF9F, $9BBF79, $70A83C, $144D0D, $003504, $003504, $003504
Data $003504, $003504, $003504, $013605, $D9FF9B, $D9FF98, $124996, $B2D5EB
Data $256EBD, $0E4087, $B0D0A0, $92BF77, $003504, $003504, $003504, $003504
Data $003504, $003504, $003504, $003504, $003504, $E2FF9B, $E0FFA0, $124996
Data $B2D5EB, $256EBD, $0E4087, $B0CF9F, $9EC077, $72A73A, $144D0D, $003504
Data $003504, $003504, $003504, $003504, $003504, $003504, $D9FF9A, $D1FF93
Data $124996, $B2D5EB, $256EBD, $0E4087, $ACD6A6, $97C575, $76B535, $6CBE2B
Data $49902A, $033906, $003504, $003504, $003504, $003504, $003504, $D8FF92
Data $D6FF8C, $124996, $B2D5EB, $256EBD, $0E4087, $90C090, $82B767, $6BAC2E
Data $67AF1F, $79C232, $84CB41, $215A16, $003504, $003504, $003504, $003504
Data $CCFF7C, $C7FF70, $124996, $B2D5EA, $256FBD, $0E3F86, $699869, $619953
Data $569B2E, $59A01C, $6EB123, $7CC531, $7ECD3F, $5E9B37, $063C08, $003504
Data $003504, $9BE455, $8EDB48, $114792, $B0D5EA, $2871BD, $0A3780, $528152
Data $4A8646, $44902E, $4D9C1D, $5FAB1D, $6AB926, $72C233, $8BCE4B, $95D552
Data $296318, $013604, $6BB637, $5AA131, $0F4289, $B0D5E9, $307AC1, $0B3D8B
Data $507F50, $478345, $40902F, $4A9E1F, $5BAB1D, $67B724, $72C133, $89CC4A
Data $9CD953, $A3E94D, $71BB34, $60A832, $4F902F, $174E91, $AAD2E7, $4891CF
Data $2065B3, $0C408F, $08317D, $09357F, $0A3880, $0D3C83, $0E3E85, $0E3E85
Data $0E3E86, $0E3E86, $0F4188, $0F4188, $0F4188, $205CA1, $5B99C9, $91C3E3
Data $000000, $3A85C8, $2A76BD, $2C74B9, $347BBC, $4589C1, $609FCA, $6AA4CE
Data $6AA4CE, $72ABD2, $72ABD2, $7DB2D6, $7DB2D6, $7DB2D6, $91C1DF, $8ABDE0
Data $000000

.BCF_ArrowUpOff_Style01
Data 17
Data 17
Data $000000, $064596, $003586, $003281, $003A85, $0A468A, $1A5994, $205D98
Data $205D98, $24649C, $24649C, $2C6BA2, $2C6BA2, $2C6BA2, $3F7DAF, $3F7FB3
Data $000000, $094A9A, $001D71, $000C57, $000446, $00074C, $00064B, $000447
Data $000549, $000549, $000649, $000649, $00084B, $00084B, $00084B, $00115A
Data $094082, $5691BD, $003B8D, $000549, $0E3D0E, $074103, $004E00, $005B00
Data $106900, $277500, $2F7F00, $398A08, $559911, $5BA30B, $327801, $185300
Data $0D3D00, $001050, $5591BA, $00368C, $000647, $144214, $0E4707, $045000
Data $065B00, $1B6A00, $2E7900, $318200, $428E0B, $529915, $175209, $003504
Data $296B00, $1E5B00, $000E53, $5994BC, $00348B, $000B4D, $326332, $286216
Data $1A5D00, $1B5F00, $2F7200, $3F8800, $438E04, $377411, $043A05, $003504
Data $003504, $5AA21E, $4F9E10, $00115C, $5994BD, $00348B, $000B4D, $588857
Data $467D2A, $2D6B00, $286900, $377F00, $469008, $144C09, $003504, $003504
Data $003504, $003504, $82BD42, $7BBD37, $00125F, $5994BD, $00348B, $000B4D
Data $6D9464, $588435, $377100, $2B7300, $236606, $023705, $003504, $003504
Data $003504, $003504, $003504, $90BD54, $8DBD4E, $00125F, $5994BD, $00348B
Data $000B4D, $6F8D5D, $597D37, $336B00, $084103, $003504, $003504, $003504
Data $003504, $003504, $003504, $013604, $97BD59, $97BD56, $00125F, $5994BD
Data $00348B, $000B4D, $6E8E5E, $507D35, $003504, $003504, $003504, $003504
Data $003504, $003504, $003504, $003504, $003504, $A0BD59, $9EBD5E, $00125F
Data $5994BD, $00348B, $000B4D, $6E8D5D, $5C7E35, $356A00, $084103, $003504
Data $003504, $003504, $003504, $003504, $003504, $003504, $97BD58, $8FBD51
Data $00125F, $5994BD, $00348B, $000B4D, $6A9464, $558333, $347300, $2A7C00
Data $226903, $023704, $003504, $003504, $003504, $003504, $003504, $96BD50
Data $94BD4A, $00125F, $5994BD, $00348B, $000B4D, $4E7E4E, $407525, $296A00
Data $256D00, $378000, $468D03, $124B08, $003504, $003504, $003504, $003504
Data $8ABD3A, $85BD2E, $00125F, $5994BD, $00358B, $000A4C, $275627, $1F5711
Data $145900, $175E00, $2C6F00, $3A8300, $3C8B00, $35720E, $043905, $003504
Data $003504, $59A213, $4C9906, $00115A, $5894BD, $00378C, $000445, $103F10
Data $084404, $024E00, $0B5A00, $1D6900, $287700, $308000, $498C09, $559513
Data $185208, $003504, $297400, $185F00, $000C4F, $5894BB, $013E90, $000852
Data $0E3D0E, $054103, $004E00, $085C00, $196900, $257500, $307F00, $478A08
Data $5A9711, $61A70B, $3B8501, $1E6600, $0D4E00, $001759, $5390BA, $10549F
Data $002B80, $000B57, $000040, $000243, $000545, $000848, $00094B, $00094B
Data $00094C, $00094C, $000C4E, $000C4E, $000C4E, $00236C, $1C5B98, $4283B5
Data $000000, $084997, $003B8B, $003987, $043F8A, $0E4D90, $20609A, $26659E
Data $26659E, $2C6BA2, $2C6BA2, $3372A6, $3372A6, $3372A6, $4280B1, $3D7DB2
Data $000000

.BCF_ArrowUpOn_Style02
Data 17
Data 17
Data $000000, $8C96AD, $79859A, $788294, $818A99, $92979F, $A7A9AB, $ADADB0
Data $ADADB0, $B2B3B5, $B2B3B5, $B9BABC, $B9BABC, $B9BABC, $CACACD, $CACCD3
Data $000000, $909AB2, $626C83, $4F5768, $494D59, $4D515E, $4B505D, $474D5A
Data $4A4F5C, $4A4F5C, $4B505C, $4B505C, $4C525D, $4C525D, $4C525D, $5A5E6B
Data $909196, $DBDCE1, $7F8BA3, $464E5C, $9EA4B2, $B5B9C6, $B7BBCA, $B1B6C7
Data $A2A9BC, $A2AABC, $A4ACBD, $A7AFBE, $A9B0BF, $AEB5C3, $9CA3B0, $A8AFBD
Data $888F9A, $595C62, $DADCDC, $7986A1, $4A505A, $C7CBD3, $CDD0DC, $C3C7D7
Data $BDC2D3, $ABB2C6, $AAB1C5, $AAB1C5, $A9B1C5, $A7AFC2, $606774, $444A56
Data $B4BCCE, $9AA2B0, $565A65, $DDDEDF, $7784A0, $51565F, $DCDDE2, $D0D3DF
Data $C2C6D6, $BCC2D3, $ABB2C5, $A9B0C4, $A9B0C4, $82899A, $484E5A, $444A56
Data $444A56, $B5BDCE, $A2A9B8, $5A5E6D, $DDDEE0, $7784A0, $51565F, $E0E1E5
Data $D0D3DF, $C2C6D6, $BCC2D3, $ABB2C5, $A3AABE, $5A606E, $444A56, $444A56
Data $444A56, $444A56, $B5BDCE, $A2A9B9, $5A5F70, $DDDEE1, $7784A0, $51565F
Data $DFE0E5, $D0D2DF, $C2C6D6, $BCC2D3, $818898, $464C59, $444A56, $444A56
Data $444A56, $444A56, $444A56, $B5BDCE, $A2A9B9, $5A5F70, $DDDEE1, $7784A0
Data $51565F, $E0E1E5, $D0D3DF, $B8BCCC, $5A606D, $444A56, $444A56, $444A56
Data $444A56, $444A56, $444A56, $444A56, $B5BDCE, $A2A9B9, $5A5F70, $DDDEE1
Data $7784A0, $51565F, $DFE0E5, $D0D2DF, $444A56, $444A56, $444A56, $444A56
Data $444A56, $444A56, $444A56, $444A56, $444A56, $B5BDCE, $A2A9B9, $5A5F70
Data $DDDEE1, $7784A0, $51565F, $E0E1E5, $D0D3DF, $B8BCCC, $5A606D, $444A56
Data $444A56, $444A56, $444A56, $444A56, $444A56, $444A56, $B5BDCE, $A2A9B9
Data $5A5F70, $DDDEE1, $7784A0, $51565F, $DFE0E5, $D0D2DF, $C2C6D6, $BCC2D3
Data $818898, $464C59, $444A56, $444A56, $444A56, $444A56, $444A56, $B5BDCE
Data $A2A9B9, $5A5F70, $DDDEE1, $7784A0, $51565F, $DFE0E5, $D0D3DF, $C2C6D6
Data $BCC2D3, $ABB2C5, $A3AABE, $5A606E, $444A56, $444A56, $444A56, $444A56
Data $B5BDCE, $A2A9B8, $5A5F70, $DDDEE0, $7785A0, $51555E, $D8DAE0, $D1D3DF
Data $C3C7D7, $BDC2D4, $ACB2C6, $AAB1C5, $AAB1C5, $838A9B, $484E5A, $444A56
Data $444A56, $B6BECF, $A1A8B6, $585D6B, $DCDEE0, $7A87A1, $464D58, $BDC1CB
Data $CACDDA, $C3C7D7, $BDC3D4, $ACB2C7, $ABB2C5, $ABB2C6, $ABB3C6, $AAB2C4
Data $616774, $444A56, $B4BCCD, $959DAB, $545861, $DCDEDE, $838FA6, $4B5364
Data $89909F, $9C9FAD, $9EA2B1, $9A9FAF, $8D93A5, $8E95A5, $9096A6, $939AA8
Data $949BA9, $989EAC, $898F9C, $9399A7, $7C828E, $63656A, $D9DBDC, $9AA4B9
Data $707B93, $4D5668, $404654, $444A57, $484E58, $4E525B, $50545D, $50545D
Data $51545E, $51545E, $545760, $545760, $545760, $70727D, $A9ABB0, $CCCFD6
Data $000000, $8E99AF, $7D8BA0, $7F899B, $88909F, $989DA6, $ADB0B2, $B4B4B7
Data $B4B4B7, $B9BABD, $B9BABD, $C0C0C2, $C0C0C2, $C0C0C2, $CCCDD0, $C8CAD1
Data $000000


.BCF_ArrowUpOff_Style02
Data 17
Data 17
Data $000000, $636D84, $505C71, $4F596B, $586170, $696E76, $7E8082, $848487
Data $848487, $898A8C, $898A8C, $909193, $909193, $909193, $A1A1A4, $A1A3AA
Data $000000, $677189, $39435A, $262E3F, $202430, $242835, $222734, $1E2431
Data $212633, $212633, $222733, $222733, $232934, $232934, $232934, $313542
Data $67686D, $B2B3B8, $56627A, $1D2533, $757B89, $8C909D, $8E92A1, $888D9E
Data $798093, $798193, $7B8394, $7E8695, $808796, $858C9A, $7A818F, $7F8694
Data $5F6671, $303339, $B1B3B3, $505D78, $212731, $9EA2AA, $A4A7B3, $9A9EAE
Data $9499AA, $82899D, $81889C, $81889C, $80889C, $7F879B, $565C6A, $444A56
Data $8B93A5, $717987, $2D313C, $B4B5B6, $4E5B77, $282D36, $B3B4B9, $A7AAB6
Data $999DAD, $9399AA, $82899C, $80879B, $80879B, $687081, $464C59, $444A56
Data $444A56, $8C94A5, $79808F, $313544, $B4B5B7, $4E5B77, $282D36, $B7B8BC
Data $A7AAB6, $999DAD, $9399AA, $82899C, $7D8497, $515765, $444A56, $444A56
Data $444A56, $444A56, $8C94A5, $798090, $313647, $B4B5B8, $4E5B77, $282D36
Data $B6B7BC, $A7A9B6, $999DAD, $9399AA, $696F7F, $454B58, $444A56, $444A56
Data $444A56, $444A56, $444A56, $8C94A5, $798090, $313647, $B4B5B8, $4E5B77
Data $282D36, $B7B8BC, $A7AAB6, $9296A6, $525865, $444A56, $444A56, $444A56
Data $444A56, $444A56, $444A56, $444A56, $8C94A5, $798090, $313647, $B4B5B8
Data $4E5B77, $282D36, $B6B7BC, $A7A9B6, $444A56, $444A56, $444A56, $444A56
Data $444A56, $444A56, $444A56, $444A56, $444A56, $8C94A5, $798090, $313647
Data $B4B5B8, $4E5B77, $282D36, $B7B8BC, $A7AAB6, $9296A6, $525865, $444A56
Data $444A56, $444A56, $444A56, $444A56, $444A56, $444A56, $8C94A5, $798090
Data $313647, $B4B5B8, $4E5B77, $282D36, $B6B7BC, $A7A9B6, $999DAD, $9399AA
Data $696F7F, $454B58, $444A56, $444A56, $444A56, $444A56, $444A56, $8C94A5
Data $798090, $313647, $B4B5B8, $4E5B77, $282D36, $B6B7BC, $A7AAB6, $999DAD
Data $9399AA, $82899C, $7D8497, $515765, $444A56, $444A56, $444A56, $444A56
Data $8C94A5, $79808F, $313647, $B4B5B7, $4E5C77, $282C35, $AFB1B7, $A8AAB6
Data $9A9EAE, $9499AB, $83899D, $81889C, $81889C, $697081, $464C59, $444A56
Data $444A56, $8D95A6, $787F8D, $2F3442, $B3B5B7, $515E78, $1D242F, $9498A2
Data $A1A4B1, $9A9EAE, $949AAB, $83899E, $82899C, $82899D, $828A9D, $828A9D
Data $565D6A, $444A56, $8B93A4, $6C7482, $2B2F38, $B3B5B5, $5A667D, $222A3B
Data $606776, $737684, $757988, $717686, $646A7C, $656C7C, $676D7D, $6A717F
Data $6B7280, $6F7583, $676D7B, $6A707E, $535965, $3A3C41, $B0B2B3, $717B90
Data $47526A, $242D3F, $171D2B, $1B212E, $1F252F, $252932, $272B34, $272B34
Data $282B35, $282B35, $2B2E37, $2B2E37, $2B2E37, $474954, $808287, $A3A6AD
Data $000000, $657086, $546277, $566072, $5F6776, $6F747D, $848789, $8B8B8E
Data $8B8B8E, $909194, $909194, $979799, $979799, $979799, $A3A4A7, $9FA1A8
Data $000000

.BCF_ArrowUpOn_Style03
Data 17
Data 17
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $5F6F7E, $5F6F7E, $0A0A0A, $5F7084, $5F7084, $5F7084
Data $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084, $5F7084
Data $5F7084, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC
Data $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $C9DCEC, $C9DCEC
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A
Data $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $C9DCEC, $C9DCEC
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E
Data $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968, $4B5968
Data $C9DCEC, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084, $4B5968
Data $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A, $5F7084
Data $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC, $4B5968, $4B5968
Data $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453, $0A0A0A
Data $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $C9DCEC, $C9DCEC
Data $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E, $344453
Data $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $C9DCEC, $C9DCEC, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A, $5F6F7E
Data $344453, $0A0A0A, $5F7084, $4B5968, $4B5968, $4B5968, $4B5968, $4B5968
Data $4B5968, $4B5968, $4B5968, $4B5968, $4B5968, $38424E, $0A0A0A, $0A0A0A
Data $5F6F7E, $344453, $0A0A0A, $4B5968, $38424E, $38424E, $38424E, $38424E
Data $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $38424E, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A

.BCF_ArrowUpOff_Style03
Data 17
Data 17
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $FFDF3B, $FFDF3B, $0A0A0A, $0A1420, $0A1420, $0A1420
Data $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420, $0A1420
Data $1D2B3A, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000
Data $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A
Data $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000
Data $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E
Data $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B
Data $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A
Data $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $FFC000, $FFC000
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A
Data $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $FFC000, $FFC000
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256
Data $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A
Data $FFC000, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420, $1D2B3A
Data $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A, $0A1420
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E, $0A0A0A
Data $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $FFC000, $FFC000
Data $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B, $FFB20E
Data $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $FFC000, $FFC000, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A, $FFDF3B
Data $FFB20E, $0A0A0A, $0A1420, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A
Data $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $1D2B3A, $314256, $0A0A0A, $0A0A0A
Data $FFDF3B, $FFB20E, $0A0A0A, $314256, $314256, $314256, $314256, $314256
Data $314256, $314256, $314256, $314256, $314256, $314256, $314256, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A, $0A0A0A
Data $0A0A0A

; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_ArrowRightOn

.BCF_ArrowRightOff

; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_ArrowLeftOn

.BCF_ArrowLeftOff

; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BFF_SliderBackground_Style01
Data 80
Data 21
Data $1C65A5, $1C65A6, $1D66A7, $1D66A7, $1C65A5, $1C64A5, $1B63A4, $1B62A3
Data $1A60A2, $1960A1, $185FA0, $175E9F, $165C9E, $165A9D, $15599C, $13579B
Data $12559A, $115498, $115296, $115195, $115195, $1C66A5, $1D67A6, $1E68A8
Data $1E67A8, $1E66A6, $1D64A5, $1C63A4, $1B62A4, $1A61A3, $1960A2, $185FA1
Data $175E9F, $175C9E, $165A9D, $15599C, $14579B, $13559A, $125498, $115396
Data $115295, $115295, $1D68A5, $1D68A6, $1E68A9, $1E67A9, $1E66A7, $1D65A6
Data $1C64A5, $1C63A4, $1B62A3, $1A61A2, $195FA1, $195EA0, $185D9F, $165B9D
Data $15599C, $14579B, $13559A, $125499, $115397, $115296, $115295, $1F69A5
Data $1F69A6, $1F69A8, $1F68A9, $1E67A8, $1E66A7, $1D65A5, $1C64A4, $1B62A4
Data $1A60A3, $195FA2, $185EA1, $185D9F, $175B9D, $16599C, $14579B, $13559A
Data $115498, $115296, $115195, $115195, $206AA5, $206AA6, $206BA8, $206AA9
Data $1F68A8, $1F66A7, $1E65A6, $1D64A5, $1C62A4, $1B60A3, $1A5FA1, $195EA0
Data $185D9F, $175B9D, $16599C, $14579B, $13559A, $115498, $115296, $115195
Data $115195, $216BA5, $216BA6, $216BA8, $206BA9, $1F69A8, $1E68A7, $1E66A6
Data $1E64A5, $1D62A4, $1C60A3, $1B5FA2, $195EA1, $185D9F, $175B9D, $16599C
Data $14579A, $135599, $115498, $115296, $115195, $115195, $226CA5, $226CA6
Data $226BA8, $216AAA, $206AA9, $1F68A8, $1E65A7, $1E63A6, $1D62A4, $1C61A3
Data $1B60A2, $1A5FA1, $195D9F, $175B9D, $16599C, $14579B, $13559A, $115498
Data $115296, $115195, $115195, $236DA5, $236DA6, $236CA8, $226AAA, $2069A9
Data $1F68A8, $1F66A6, $1E64A5, $1D62A4, $1C60A3, $1B5FA1, $195EA0, $185D9F
Data $175B9D, $16599C, $15579B, $13559A, $125498, $115296, $125195, $125195
Data $236DA5, $236DA6, $236CA8, $226BAA, $206AA9, $1F68A8, $1F66A6, $1F65A5
Data $1E63A4, $1D61A3, $1B5FA1, $1A5E9F, $195D9E, $175A9D, $16579C, $15569A
Data $135597, $125497, $115295, $115194, $115194, $246EA5, $246EA6, $236EA8
Data $236CAA, $226AA9, $2168A8, $1F66A6, $1F65A5, $1E63A4, $1D61A2, $1B5FA0
Data $1A5DA0, $195C9F, $175A9D, $16599B, $155799, $135498, $125397, $115195
Data $125094, $125094, $246EA5, $246EA6, $256EA8, $246DAA, $236AA9, $2168A8
Data $1F66A7, $1E64A6, $1E62A4, $1D60A2, $1C5FA0, $1B5E9E, $1A5C9D, $185A9C
Data $16579B, $155699, $155397, $135296, $125194, $115193, $115193, $246FA5
Data $246FA6, $246EA8, $236CAA, $226AA9, $2168A8, $2066A6, $1F64A5, $1E62A3
Data $1D60A2, $1C5FA0, $1B5E9E, $195C9D, $17599B, $16579A, $155698, $145497
Data $135296, $125094, $115093, $115093, $256FA5, $256FA6, $256FA8, $246DAA
Data $236BA9, $2168A9, $2067A7, $1F64A5, $1E62A3, $1D60A1, $1C5EA0, $1A5D9E
Data $195C9D, $18599B, $17569A, $155598, $135396, $125295, $115194, $115093
Data $115093, $256FA5, $256FA6, $256FA8, $256CA9, $236AA8, $2268A7, $2066A6
Data $1F64A5, $1E62A3, $1D60A2, $1B5EA0, $1A5D9E, $195C9D, $17599B, $16569A
Data $155597, $135395, $125295, $115093, $114F92, $114F92, $256FA5, $256FA6
Data $266FA8, $256DAA, $246BA9, $2268A8, $2067A5, $1F64A4, $1E62A3, $1D60A2
Data $1C5FA0, $1B5E9E, $195C9C, $17599A, $165699, $145497, $135296, $115195
Data $115093, $114F92, $114F92, $2570A5, $2570A6, $266FA8, $256CAA, $246AA9
Data $2268A8, $2066A5, $1F64A4, $1E62A3, $1D60A1, $1B5E9F, $1A5C9D, $195A9C
Data $17589A, $165799, $145597, $135295, $115194, $114F93, $114E92, $114E92
Data $2570A5, $2570A6, $256FA8, $256CAA, $236AA9, $2267A8, $2066A5, $1F63A4
Data $1E61A2, $1D5FA1, $1B5D9F, $1A5B9E, $195A9C, $17589A, $165698, $145496
Data $135294, $115193, $114F92, $114E91, $114E91, $266FA5, $266FA6, $256EA8
Data $246CAA, $236AA9, $2267A8, $2065A5, $1F64A4, $1E62A2, $1D60A1, $1C5D9F
Data $1A5B9D, $185A9B, $175899, $165698, $155496, $135294, $125193, $114F91
Data $114E90, $114E90, $266FA5, $266FA6, $256FA8, $246DA9, $236AA8, $2267A7
Data $2066A5, $1F63A4, $1E61A2, $1D5FA0, $1B5D9E, $195B9C, $185A9B, $175899
Data $165597, $145395, $135194, $115193, $114F91, $114E90, $114E90, $2670A5
Data $2670A6, $266FA8, $256DA9, $246BA8, $2268A7, $2066A5, $1F63A4, $1E61A2
Data $1D5FA0, $1B5D9E, $195C9C, $185A9B, $175799, $165497, $145395, $135193
Data $115092, $114F91, $114E90, $114E90, $2670A5, $2670A6, $256FA8, $246DAA
Data $236BA9, $2268A8, $2066A5, $1F63A4, $1E60A2, $1D5EA0, $1B5D9D, $195C9C
Data $185A9B, $175799, $165497, $145295, $135093, $115092, $114F91, $114E90
Data $114E90, $2670A5, $2670A6, $266FA8, $256CAA, $246AA9, $2267A8, $2066A5
Data $1F63A4, $1E61A2, $1D5FA0, $1B5D9D, $195B9B, $18599A, $175698, $165397
Data $145295, $135193, $115092, $114F91, $114E90, $114E90, $2670A5, $2670A6
Data $266FA8, $256CAA, $246AA9, $2267A8, $2066A5, $1F63A4, $1E61A2, $1D5FA0
Data $1B5D9E, $195B9C, $18599B, $175799, $165497, $145395, $135093, $114F92
Data $114E91, $114E90, $114E90, $2671A5, $2670A6, $266FA8, $256CAA, $246AA9
Data $2267A8, $2066A5, $1F63A4, $1E61A2, $1D5FA0, $1B5D9D, $195B9C, $18599B
Data $175699, $165396, $145294, $135092, $114F92, $114E91, $114D90, $114D90
Data $2671A5, $2670A6, $266FA8, $256CAA, $246AA9, $2267A8, $2066A5, $1F63A4
Data $1E61A2, $1D5FA0, $1B5D9D, $195B9C, $18599B, $175699, $165396, $145294
Data $135092, $114F92, $114E91, $114D90, $114D90, $2671A5, $2670A6, $266FA8
Data $256DAA, $246BA9, $2268A8, $2066A5, $1F63A4, $1E61A2, $1D5FA0, $1B5D9E
Data $1A5B9C, $19599B, $175699, $165396, $145294, $135092, $114F92, $114E91
Data $114D90, $114D90, $2671A5, $2671A6, $2670A8, $256DAA, $246AA9, $2267A8
Data $2066A5, $1F63A4, $1E61A2, $1D5FA0, $1B5D9E, $195B9D, $18599B, $175698
Data $165395, $145294, $135093, $114F92, $114E91, $114D90, $114D90, $2571A5
Data $2571A6, $2670A8, $256DAA, $246BA9, $2268A8, $2066A6, $1F64A4, $1E62A2
Data $1D60A0, $1B5D9E, $195B9C, $18599A, $175798, $165496, $145394, $135093
Data $114F92, $114E91, $114D90, $114D90, $2571A5, $2571A6, $2670A8, $256EAA
Data $246CA9, $2269A8, $2067A6, $1F64A4, $1E62A2, $1D60A0, $1B5D9E, $195B9D
Data $18599B, $175698, $165395, $145293, $135092, $114F91, $114E91, $114D90
Data $114D90, $2672A5, $2671A6, $2670A8, $256EAA, $246CA9, $2269A8, $2067A5
Data $1F64A4, $1E62A2, $1D60A0, $1B5D9E, $195B9C, $18599B, $175699, $165396
Data $145294, $135092, $114F91, $114E91, $114D90, $114D90, $2672A5, $2671A6
Data $2670A8, $256EAA, $246CA9, $2269A8, $2067A6, $1F64A5, $1E62A3, $1D60A1
Data $1B5D9F, $195B9D, $18599B, $175699, $165396, $145294, $135091, $114F90
Data $114E90, $114D90, $114D90, $2672A5, $2671A6, $2670A8, $256EAA, $246CA9
Data $2269A9, $2067A7, $1F64A6, $1E62A3, $1D60A0, $1B5D9D, $195C9C, $185A9B
Data $175799, $165396, $145294, $135092, $114F91, $114E91, $114D90, $114D90
Data $2672A5, $2671A6, $2670A8, $256EAA, $246CA9, $2269A9, $2067A7, $1F64A6
Data $1E62A3, $1D60A1, $1B5D9E, $195B9C, $18599B, $175798, $165495, $145394
Data $135093, $114F92, $114E91, $114D90, $114D90, $2672A5, $2672A6, $2671A8
Data $256EAA, $246CA9, $2269A9, $2067A7, $1F64A5, $1E62A3, $1D60A1, $1B5E9F
Data $195C9D, $185A9B, $175799, $165396, $145294, $135092, $114F92, $114E91
Data $114D90, $114D90, $2673A5, $2673A6, $2672A8, $2570AA, $246DA9, $226AA9
Data $2067A7, $1F64A5, $1E62A3, $1D60A1, $1B5E9F, $195C9D, $185A9B, $175799
Data $165496, $145294, $135092, $114F92, $114E91, $114D90, $114D90, $2673A5
Data $2673A6, $2672A8, $266FAA, $246DA9, $236AA9, $2168A7, $2065A5, $1E62A3
Data $1D5FA1, $1C5D9F, $1A5B9D, $185A9B, $175799, $165496, $145294, $135092
Data $114F92, $114E91, $114D90, $114D90, $2673A5, $2673A6, $2672A8, $2670AA
Data $246DA9, $2369A9, $2167A7, $2064A5, $1E63A3, $1C61A1, $1B5F9F, $1A5D9D
Data $195A9B, $175799, $165496, $145294, $135092, $115092, $114E91, $114D90
Data $114D90, $2674A5, $2673A6, $2672A8, $266FAA, $246DA9, $236AA9, $2168A8
Data $2065A7, $1E63A4, $1D61A2, $1C5E9F, $1B5C9D, $195A9B, $175799, $165496
Data $145294, $135092, $114F92, $114E91, $114D90, $114D90, $2674A5, $2673A6
Data $2672A8, $256FAA, $246DA9, $226AA9, $2169A8, $2066A7, $1E63A4, $1C60A2
Data $1B5E9F, $1A5C9D, $195A9C, $175799, $165496, $145294, $135092, $114F92
Data $114E91, $114E90, $114E90, $2674A5, $2674A6, $2673A8, $2570AA, $246EA9
Data $226BA9, $2169A8, $2066A7, $1E63A4, $1D61A2, $1C5FA0, $1B5D9D, $195A9B
Data $175799, $165497, $145295, $135093, $114F92, $114E91, $114D90, $114D90
Data $2674A5, $2674A6, $2673A8, $2570AA, $246EA9, $236BA9, $2269A8, $2066A7
Data $1E63A4, $1D61A2, $1C5FA0, $1B5D9D, $195A9B, $175799, $165497, $145295
Data $135093, $114F92, $114E91, $114D90, $114D90, $2674A5, $2674A6, $2773A8
Data $2671AA, $256FA9, $236CA9, $2269A8, $2066A7, $1E63A4, $1D61A2, $1C5F9F
Data $1B5C9D, $195A9B, $175899, $165597, $145395, $135093, $115092, $114E91
Data $114D90, $114D90, $2675A5, $2674A6, $2673A8, $2671AA, $256FA9, $246CA9
Data $2169A8, $1F66A7, $1E63A4, $1D61A2, $1C5FA0, $1B5D9E, $195A9C, $175799
Data $165496, $145295, $135093, $114F92, $114E91, $114D90, $114D90, $2674A5
Data $2674A6, $2773A8, $2671AA, $256FA9, $236CA9, $2169A8, $2066A7, $1E63A4
Data $1D61A2, $1C5FA0, $1B5D9E, $195A9C, $175799, $165496, $145295, $135093
Data $114F92, $114E91, $114D90, $114D90, $2674A5, $2674A6, $2673A8, $2670AA
Data $246EA9, $236BA9, $2169A8, $2066A7, $1E64A4, $1E62A2, $1D5FA0, $1B5C9E
Data $195A9C, $175899, $165596, $145394, $135092, $114F92, $114E91, $114D90
Data $114D90, $2674A5, $2674A6, $2773A8, $2671AA, $256FA9, $236CA9, $226AA8
Data $2067A7, $1E64A4, $1D62A2, $1C5FA0, $1B5C9E, $195A9C, $175799, $165496
Data $145295, $135093, $114F92, $114E91, $114D90, $114D90, $2674A5, $2674A6
Data $2673A8, $2571A9, $246FA9, $236CA9, $2269A9, $2166A7, $1F64A4, $1E62A2
Data $1C5FA0, $1A5C9E, $195A9C, $175899, $165596, $145395, $135093, $114F92
Data $114E91, $114D90, $114D90, $2674A5, $2674A6, $2673A8, $2571AA, $246FA9
Data $236CA9, $226AA8, $2166A7, $1F63A4, $1E61A2, $1C5FA0, $1A5D9E, $185B9C
Data $175899, $165496, $145295, $135093, $115092, $114E91, $114D90, $114D90
Data $2674A5, $2674A6, $2773A8, $2671AA, $256FA9, $236CA9, $226AA8, $2167A7
Data $1F64A5, $1E62A3, $1C5FA0, $1A5C9E, $195A9C, $17579A, $165497, $145296
Data $135093, $114F92, $114E91, $114D90, $114D90, $2774A5, $2774A6, $2774A8
Data $2672AA, $256FA9, $236CA9, $216AA8, $2067A7, $1E64A5, $1D62A3, $1C5FA1
Data $1B5C9F, $195A9C, $175899, $165596, $145395, $135093, $114F92, $114E91
Data $114D90, $114D90, $2674A5, $2674A6, $2774A8, $2672AA, $256FA9, $236CA9
Data $226AA8, $2167A7, $1F64A5, $1E62A3, $1C60A1, $1A5E9E, $195B9C, $17589A
Data $165597, $145496, $135193, $114F92, $114E91, $114E90, $114E90, $2674A5
Data $2674A6, $2674A8, $2672AA, $256FA9, $246CA9, $216AA8, $2067A7, $1F64A5
Data $1E62A3, $1D60A1, $1B5E9E, $195B9C, $17589A, $165597, $145396, $135193
Data $115092, $114E91, $114D90, $114D90, $2675A5, $2675A6, $2774A8, $2771A9
Data $266FA9, $246CA9, $216AA9, $1F67A8, $1E64A5, $1D62A3, $1C60A1, $1B5E9E
Data $195B9C, $17589A, $165597, $145396, $135193, $115092, $114F91, $114E90
Data $114E90, $2675A5, $2675A6, $2775A8, $2772A9, $266FA9, $236CA9, $216AA9
Data $2067A8, $1F65A5, $1E63A3, $1C60A1, $1A5D9E, $195B9C, $17589A, $165597
Data $145396, $135193, $115092, $114E91, $114D90, $114D90, $2675A5, $2675A6
Data $2775A8, $2772A9, $266FA9, $236CA9, $216BA9, $2068A8, $1F65A5, $1E63A4
Data $1D60A2, $1B5D9F, $195B9C, $17589A, $165597, $145396, $135193, $115092
Data $114E91, $114D90, $114D90, $2675A5, $2675A6, $2775A8, $2772A9, $256FA9
Data $246CA9, $226AA9, $2167A8, $1F65A5, $1E63A3, $1D60A1, $1C5E9E, $1A5C9C
Data $18599A, $165597, $145396, $135193, $115092, $114E91, $114D90, $114D90
Data $2675A5, $2675A6, $2775A8, $2772A9, $266FA9, $246CA9, $216BA9, $1F68A8
Data $1E65A5, $1E62A4, $1D60A2, $1B5E9F, $195C9C, $17599A, $165597, $145395
Data $135193, $115093, $114E91, $114D90, $114D90, $2676A5, $2676A6, $2775A8
Data $2772A9, $256FA9, $246CA9, $226AA9, $2167A8, $1F65A6, $1E63A4, $1D60A2
Data $1C5EA0, $1A5C9D, $18599A, $165597, $145395, $135193, $115092, $114E91
Data $114D90, $114D90, $2676A5, $2676A6, $2775A8, $2772A9, $2570A9, $246DA9
Data $226BA9, $2168A8, $1F65A6, $1E62A4, $1D60A2, $1B5EA0, $195C9D, $17599A
Data $165598, $145496, $135294, $115092, $114E90, $114E90, $114E90, $2676A5
Data $2676A6, $2775A8, $2772A9, $2570A9, $246DA9, $226BA9, $2168A8, $1F65A6
Data $1E62A4, $1D60A2, $1C5EA0, $1A5C9D, $18599A, $165597, $145395, $135193
Data $115092, $114F91, $114E90, $114E90, $2776A5, $2776A6, $2775A8, $2772A9
Data $2570A9, $246DA9, $226CA9, $2168A8, $1F65A7, $1E62A5, $1D60A3, $1C5EA0
Data $1A5C9D, $18599A, $165597, $145396, $135194, $115093, $114F91, $114E90
Data $114E90, $2676A5, $2676A6, $2776A8, $2773A9, $2570A9, $246DA9, $226CA9
Data $2168A9, $1F65A7, $1E62A5, $1D60A2, $1B5E9F, $195C9D, $17599B, $165698
Data $145497, $135294, $115193, $114F91, $114E90, $114E90, $2776A5, $2776A6
Data $2776A8, $2773A9, $2570A9, $246DA9, $226CA9, $2168A9, $1F65A7, $1E62A5
Data $1D60A2, $1C5EA0, $1A5C9E, $18599B, $165598, $145496, $135294, $115193
Data $114F92, $114E91, $114E91, $2776A5, $2776A6, $2775A8, $2672A9, $2570A9
Data $236DA9, $226CA9, $2169A8, $1F66A7, $1E64A5, $1D61A3, $1C5EA0, $1A5C9D
Data $18599B, $16569A, $145498, $135295, $115193, $114F91, $114E90, $114E90
Data $2776A5, $2776A6, $2776A8, $2773A9, $2570A9, $246DA9, $226CA9, $2169A8
Data $1F66A7, $1E64A5, $1D62A3, $1C5FA1, $1A5C9F, $18599C, $165699, $155497
Data $135294, $125194, $114F92, $114E91, $114E91, $2676A5, $2676A6, $2775A8
Data $2772A9, $2570A9, $246DA9, $226CA9, $2169A8, $1F66A7, $1E63A5, $1D61A3
Data $1C5FA1, $1A5D9F, $185A9C, $165699, $155497, $135295, $125194, $114F92
Data $114E91, $114E91, $2676A5, $2676A6, $2776A8, $2774A9, $2571A9, $246EA9
Data $226CA9, $2169A9, $1F66A8, $1E64A6, $1D62A4, $1C60A2, $1A5D9F, $185A9C
Data $165799, $145598, $135296, $115195, $114F93, $114E92, $114E92, $2675A5
Data $2675A6, $2775A8, $2774A9, $2571A9, $246EA9, $226CA9, $2169A9, $1F67A8
Data $1E65A6, $1D62A4, $1C5FA2, $1A5DA0, $185A9D, $16579A, $145598, $135395
Data $115295, $115093, $114F92, $114F92, $2676A5, $2676A6, $2676A8, $2674A9
Data $2571A9, $246EA9, $226CA9, $2169A9, $1F67A8, $1E65A6, $1D62A4, $1C5FA2
Data $1A5DA0, $185B9D, $16589A, $155698, $135396, $125296, $115194, $115093
Data $115092, $2675A5, $2675A6, $2775A8, $2673A9, $2571A9, $236EA9, $226CA9
Data $2169A9, $1F66A8, $1E64A6, $1D62A4, $1C5FA2, $1A5DA0, $185B9D, $16589A
Data $155698, $135396, $125295, $115093, $114F92, $114F92, $2674A5, $2674A6
Data $2674A8, $2673A9, $2571A9, $246EA9, $226CA9, $2169A9, $1F67A9, $1E65A7
Data $1D63A4, $1C61A2, $1A5EA0, $185B9E, $16589B, $14569A, $135397, $125296
Data $125194, $115093, $115092, $2574A5, $2574A6, $2574A8, $2473A9, $2370A9
Data $226DA9, $216CA9, $2069A9, $1F66A8, $1E64A6, $1D62A4, $1C60A2, $1A5EA0
Data $185B9D, $16589A, $155799, $135497, $125296, $115094, $115093, $115093
Data $2473A5, $2473A6, $2574A8, $2573A9, $2370A9, $226DA9, $206CA9, $1F69A9
Data $1F67A8, $1E65A6, $1D62A4, $1C60A2, $1A5EA0, $185B9E, $16589B, $15569A
Data $135397, $125396, $115194, $115093, $115092, $2472A5, $2472A6, $2572A8
Data $2471A9, $236FA9, $216CA9, $206BA9, $1F68A9, $1E66A8, $1E64A6, $1D62A4
Data $1C60A2, $1A5EA0, $185B9E, $16589B, $15569A, $145397, $135396, $125194
Data $115093, $115092, $2371A5, $2371A6, $2372A8, $2371A9, $226FA9, $216CA9
Data $206BA9, $1F68A9, $1E65A8, $1D63A6, $1C62A4, $1B60A2, $195EA0, $175B9E
Data $16589B, $14579A, $135497, $115296, $115094, $115093, $115093, $2370A5
Data $2370A6, $2371A8, $2270A9, $216FA9, $206CA9, $1F6AA9, $1F68A8, $1E66A7
Data $1D64A6, $1B62A4, $1A5FA2, $195DA0, $175B9E, $16589B, $14579A, $135497
Data $115396, $115194, $115093, $115093, $2270A5, $2270A6, $2270A8, $216FA9
Data $206DA9, $206BA9, $1F69A9, $1E68A8, $1D66A7, $1C64A5, $1B61A3, $195FA1
Data $185DA0, $175B9E, $16589B, $14579A, $135497, $115396, $115194, $115093
Data $115093, $216EA5, $216EA6, $226FA8, $226EA9, $206DA9, $1F6AA9, $1E69A9
Data $1E66A8, $1D64A6, $1C63A5, $1A61A3, $195FA1, $185D9F, $175B9D, $16589B
Data $145799, $135497, $115396, $115294, $115193, $115192, $1E6DA5, $1F6DA6
Data $206EA8, $206DA9, $1F6CA9, $1F6AA9, $1E68A9, $1D66A8, $1C64A6, $1B62A5
Data $1A60A3, $195EA1, $185C9F, $165A9D, $15589B, $135699, $125497, $115396
Data $115294, $115193, $115193, $1E6CA5, $1E6CA6, $1F6CA8, $1F6CAA, $1E6BA9
Data $1E69A9, $1E66A8, $1D65A7, $1B63A5, $1A62A4, $1960A2, $185EA1, $175C9F
Data $165A9D, $15579B, $135699, $125397, $115296, $115194, $105093, $105093


.BFF_SliderBackground_Style02
Data 80
Data 21
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E90
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E90, $787F92, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E90, $787F92, $7C8396, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E90, $787F92
Data $7C8396, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E90, $787F92, $7C8396, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E90, $787F92, $7C8396, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E90, $787F92, $7C8396
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E90, $787F92, $7C8396, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E90
Data $787F92, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E90, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5
Data $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7
Data $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3
Data $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA
Data $959BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9
Data $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F
Data $878EA0, $8A91A3, $8C94A5, $9096A7, $9399AA, $959BAC, $969DAD, $999FAE
Data $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395
Data $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A3, $8D94A5
Data $8F96A7, $9299AA, $949BAC, $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA
Data $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D
Data $858C9E, $868D9F, $878EA0, $8A91A3, $8D94A5, $8F96A7, $9299AA, $949BAB
Data $969DAD, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F
Data $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0
Data $8A91A3, $8D94A5, $8F96A7, $9299AA, $949BAB, $969DAD, $999FAE, $9DA3B1
Data $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799
Data $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A2, $8D94A5, $8F96A7
Data $9299AA, $949BAB, $969DAC, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0
Data $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B, $848B9D, $858C9E
Data $868D9F, $878EA0, $8A91A2, $8D94A5, $8F96A7, $9299AA, $949BAB, $969DAC
Data $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91
Data $7C8395, $808799, $82899B, $848B9D, $858C9E, $868D9F, $878EA0, $8A91A2
Data $8D94A5, $8F96A7, $9299AA, $949BAB, $969DAC, $999FAE, $9DA3B1, $A3A8B5
Data $AAAFBA, $B2B7C0, $BDC0C9, $777E8F, $787F91, $7C8395, $808799, $82899B
Data $848B9D, $858C9E, $868D9F, $878EA0, $8A91A2, $8D94A5, $8F96A7, $9299AA
Data $949BAB, $969DAC, $999FAE, $9DA3B1, $A3A8B5, $AAAFBA, $B2B7C0, $BDC0C9


.BFF_SliderBackground_Style03
Data 80
Data 21
Data $3C4958, $384553, $374352, $354250, $33404E, $313E4B, $303C49, $2E3A46
Data $2C3844, $2A3540, $28323E, $25303B, $242E38, $222C36, $202933, $1E2831
Data $1C252E, $1A232C, $1A222B, $182028, $202830, $3C4958, $384554, $364352
Data $354250, $34404E, $323E4B, $303C49, $2E3946, $2C3744, $2A3540, $28333E
Data $26303B, $242E38, $222C36, $1F2933, $1E2730, $1D252E, $1B232C, $19222A
Data $182028, $202830, $3C4958, $384454, $374352, $354250, $34404E, $323E4B
Data $303C49, $2F3A47, $2C3744, $2A3541, $28333E, $25303C, $242E38, $222B36
Data $202933, $1E2731, $1C262E, $1B232C, $1A222A, $192028, $202830, $3C4958
Data $384553, $374352, $364250, $34404E, $323E4B, $313C49, $2E3A46, $2B3743
Data $2B3541, $28323E, $26303B, $242E38, $212C36, $202933, $1E2731, $1D262F
Data $1B232C, $19222B, $182029, $202830, $3C4958, $384454, $364351, $354250
Data $34404E, $313E4B, $303C49, $2E3A46, $2C3744, $2B3540, $28333E, $26313C
Data $242D38, $222B36, $202933, $1E2731, $1C252E, $1B232C, $1A222A, $182029
Data $202830, $3C4958, $374553, $374352, $364250, $33404D, $323E4C, $303C49
Data $2E3A46, $2C3843, $2A3541, $28333E, $26303B, $242D38, $222C36, $202933
Data $1E2730, $1C252E, $1B232C, $1A222A, $182128, $202830, $3C4958, $384553
Data $374352, $354150, $333F4D, $323E4B, $303C49, $2E3946, $2C3744, $2A3540
Data $28323E, $26303B, $242D39, $222C36, $202933, $1E2731, $1C252F, $1A232C
Data $19222A, $182029, $202830, $3C4958, $384554, $364351, $354250, $33404E
Data $323E4C, $313C49, $2E3A47, $2C3743, $2A3541, $28323E, $26303B, $242E38
Data $222C35, $1F2933, $1E2730, $1D252E, $1A232C, $19222B, $192128, $202830
Data $3C4958, $384453, $364351, $354250, $34404E, $323E4B, $303B49, $2E3A47
Data $2B3744, $2A3541, $28323E, $26313B, $242E38, $212B35, $202933, $1E2730
Data $1C252E, $1B232C, $19222B, $182128, $202830, $3C4958, $374453, $374352
Data $364250, $343F4E, $323E4B, $303C49, $2E3A47, $2C3743, $2A3541, $28323E
Data $26303B, $242E39, $222B36, $202933, $1E2730, $1C252E, $1B232C, $19222A
Data $182128, $202830, $3C4958, $384553, $364352, $354250, $33404E, $323E4B
Data $303C49, $2E3946, $2C3744, $2A3541, $28333E, $26303B, $242E38, $222C36
Data $202933, $1E2731, $1C252E, $1B232C, $19222A, $182029, $202830, $3C4958
Data $384553, $364351, $354250, $34404E, $323E4B, $303C49, $2E3A46, $2B3744
Data $2A3541, $28323E, $26303B, $242E38, $222C36, $202933, $1E2731, $1C252E
Data $1B232C, $1A222B, $182129, $202830, $3C4958, $384554, $364352, $354250
Data $33404D, $323E4B, $303C49, $2E3946, $2C3743, $2A3541, $28323E, $26303B
Data $242E38, $222C35, $1F2933, $1E2731, $1D252E, $1B232C, $1A222A, $182128
Data $202830, $3C4958, $374553, $364351, $354250, $333F4D, $323D4C, $303C49
Data $2E3946, $2C3743, $2A3541, $28323E, $26303B, $242E38, $222C36, $202933
Data $1F2730, $1D252E, $1B232C, $19222A, $182129, $202830, $3C4958, $374554
Data $374351, $354250, $34404D, $323E4C, $313B49, $2E3A46, $2C3744, $2A3541
Data $28323E, $26303B, $242E38, $222B36, $202933, $1E2731, $1D252E, $1B232C
Data $19222B, $192129, $202830, $3C4958, $374554, $364352, $354250, $34404D
Data $323E4B, $303C48, $2E3A46, $2C3744, $2A3540, $28323E, $26303B, $242E38
Data $222B35, $202933, $1E2730, $1D262E, $1A232C, $1A222B, $182029, $202830
Data $3C4958, $384553, $364351, $354250, $34404E, $323D4B, $303C49, $2E3946
Data $2C3844, $2A3541, $28333E, $25303B, $242E38, $222C36, $1F2933, $1F2730
Data $1C252E, $1A232C, $19222A, $182128, $202830, $3C4958, $384453, $374351
Data $354250, $34404E, $323D4C, $303C49, $2F3A46, $2C3844, $2A3541, $28323E
Data $26303C, $242E39, $222B36, $202933, $1E2731, $1C252F, $1B232C, $1A222A
Data $192029, $202830, $3C4958, $384453, $374352, $364250, $34404D, $323D4C
Data $303C49, $2F3946, $2C3744, $2A3541, $28323E, $26303B, $242E38, $212B36
Data $202A33, $1E2731, $1C252E, $1A232C, $1A222A, $182129, $202830, $3C4958
Data $384554, $364352, $364250, $343F4E, $313E4B, $303C49, $2E3A46, $2C3744
Data $2A3441, $28333E, $26303B, $242E38, $222C35, $202933, $1E2731, $1D252E
Data $1B232C, $1A222B, $182129, $202830, $3C4958, $384554, $364352, $354250
Data $34404D, $323E4B, $303C49, $2F3A47, $2C3744, $2A3540, $28333E, $26303C
Data $242E38, $222C35, $202933, $1E2730, $1D252E, $1A232C, $19222A, $182029
Data $202830, $3C4958, $384553, $374352, $354250, $33404D, $323E4B, $303C49
Data $2E3947, $2C3744, $2A3540, $28333E, $26303B, $242E39, $222C35, $202933
Data $1E2831, $1D252F, $1B232C, $19222A, $182029, $202830, $3C4958, $384454
Data $374352, $354251, $333F4E, $313E4C, $303C49, $2E3947, $2C3743, $2A3541
Data $28323E, $25303B, $242E38, $222C36, $202933, $1F2730, $1C252E, $1A232C
Data $1A222A, $182028, $202830, $3C4958, $384553, $364351, $354250, $333F4E
Data $323E4C, $303C49, $2E3946, $2C3744, $2B3540, $28333E, $26303B, $242E39
Data $222B36, $202933, $1E2730, $1C252E, $1B232C, $1A222B, $182028, $202830
Data $3C4958, $384554, $364351, $354250, $34404D, $313E4C, $303C49, $2E3A47
Data $2C3744, $2A3541, $28323E, $26303B, $242E38, $212B36, $202933, $1E2730
Data $1C252E, $1A232C, $19222A, $182129, $202830, $3C4958, $384554, $374351
Data $354250, $34404D, $323D4B, $303C49, $2E3A46, $2C3744, $2B3541, $28323E
Data $26303B, $242E38, $222C36, $1F2933, $1E2731, $1C252E, $1B232C, $19222A
Data $192129, $202830, $3C4958, $384553, $374352, $364250, $34404E, $323E4B
Data $303C49, $2E3947, $2C3744, $2A3541, $28323E, $26303B, $242E38, $212C36
Data $202933, $1E2731, $1C252F, $1B232C, $19222A, $182028, $202830, $3C4958
Data $384553, $364352, $364150, $34404E, $323E4B, $303C49, $2E3946, $2C3743
Data $2B3541, $28333E, $26303B, $242E38, $222C35, $202933, $1E2830, $1C252F
Data $1B232C, $1A222B, $182028, $202830, $3C4958, $384554, $364352, $364250
Data $33404E, $323E4B, $303B49, $2E3A47, $2C3844, $2A3541, $28333E, $26303B
Data $242D38, $222B35, $202A34, $1E2730, $1C252E, $1B232C, $19222A, $192129
Data $202830, $3C4958, $374554, $364352, $354250, $343F4E, $323E4C, $303C49
Data $2E3947, $2C3744, $2A3541, $28333E, $26303B, $242E38, $222C36, $202933
Data $1E2731, $1D252E, $1A232C, $1A222A, $182128, $202830, $3C4958, $384453
Data $364351, $364250, $34404E, $323E4C, $303B49, $2E3947, $2C3743, $2A3541
Data $28323E, $26303C, $242E38, $222C36, $1F2933, $1E2730, $1D252E, $1B232C
Data $1A222A, $182128, $202830, $3C4958, $384453, $364352, $354250, $34404D
Data $323E4C, $303C49, $2E3946, $2C3744, $2A3541, $28333E, $26303C, $242E38
Data $222B36, $202933, $1E2730, $1D262E, $1B242C, $1A222A, $192028, $202830
Data $3C4958, $384554, $364352, $354250, $33404E, $323E4B, $313C49, $2F3946
Data $2C3744, $2A3540, $28323E, $26303B, $242E38, $222C35, $202933, $1E2731
Data $1C252F, $1B232C, $19222A, $182029, $202830, $3C4958, $374553, $374352
Data $354250, $343F4E, $323E4C, $303C49, $2F3947, $2C3744, $2A3541, $28333E
Data $26303C, $242E39, $222B36, $202933, $1E2731, $1C252F, $1B232C, $19222A
Data $182028, $202830, $3C4958, $384454, $374352, $354250, $34404E, $323E4B
Data $303C49, $2E3946, $2C3744, $2A3541, $28333E, $26303B, $242E39, $222B36
Data $202933, $1E2731, $1D252E, $1B232C, $1A222A, $182129, $202830, $3C4958
Data $384453, $364352, $364250, $34404D, $323E4B, $303C49, $2E3A47, $2C3744
Data $2A3541, $28333E, $26313B, $242E38, $222C36, $202933, $1E2831, $1C252E
Data $1B232C, $19222A, $182029, $202830, $3C4958, $384554, $374351, $364250
Data $343F4D, $313E4C, $303C49, $2E3A46, $2C3743, $2A3541, $28333E, $25303C
Data $242D39, $222B36, $202933, $1E2730, $1C252E, $1B232C, $19222A, $182129
Data $202830, $3C4958, $384554, $364352, $354250, $333F4E, $323D4B, $303C49
Data $2F3A46, $2C3743, $2B3541, $28333E, $26303B, $242E38, $222C35, $1F2933
Data $1E2731, $1D252E, $1B242C, $1A222A, $182029, $202830, $3C4958, $384554
Data $364351, $354250, $343F4D, $313D4B, $303C49, $2E3A47, $2C3743, $2A3541
Data $28333E, $26303B, $242E39, $222B35, $202933, $1F2731, $1C252E, $1A232C
Data $19222A, $182029, $202830, $3C4958, $384454, $364352, $354250, $33404E
Data $323E4B, $303C49, $2E3A46, $2C3743, $2A3541, $28323E, $25303C, $242E39
Data $222C36, $202934, $1E2731, $1D252F, $1B232C, $1A222A, $182029, $202830
Data $3C4958, $384453, $364352, $354250, $34404E, $323E4C, $303B49, $2E3946
Data $2C3843, $2A3541, $28323E, $26303B, $242E38, $222C36, $202933, $1E2830
Data $1C252E, $1B232C, $19222A, $182029, $202830, $3C4958, $384553, $374351
Data $364250, $34404D, $323E4C, $303C49, $2E3946, $2C3743, $2A3541, $28333E
Data $26303B, $242E38, $222B36, $202933, $1E2731, $1C262E, $1B232C, $1A222A
Data $182128, $202830, $3C4958, $384454, $364352, $354251, $34404E, $323E4B
Data $303C49, $2E3A46, $2C3744, $2A3541, $28323E, $26303B, $242E38, $222C36
Data $202933, $1E2731, $1D252E, $1A232C, $1A222A, $182129, $202830, $3C4958
Data $384554, $364352, $354250, $34404E, $323D4C, $303B49, $2E3A46, $2C3844
Data $2A3541, $28333E, $26303B, $242E38, $222C35, $202933, $1E2731, $1C252E
Data $1B242C, $19222A, $182028, $202830, $3C4958, $384553, $364352, $364250
Data $34404E, $323E4B, $303C49, $2F3A46, $2C3744, $2A3541, $28333E, $26303B
Data $242E38, $222C36, $202933, $1E2731, $1C252F, $1A232C, $19222A, $182028
Data $202830, $3C4958, $384453, $374351, $354250, $34404D, $323E4B, $313C49
Data $2E3A46, $2B3744, $2A3541, $28333E, $25303B, $252E38, $222B35, $202933
Data $1E2731, $1C252E, $1B232C, $19222A, $182029, $202830, $3C4958, $384553
Data $374352, $354250, $34404E, $313E4C, $313C49, $2E3A47, $2C3744, $2A3540
Data $28323E, $26303C, $242E38, $222B35, $1F2933, $1E2730, $1C252E, $1B232C
Data $19222A, $182029, $202830, $3C4958, $384454, $364352, $354250, $343F4D
Data $323E4B, $303C49, $2E3A46, $2C3743, $2A3541, $28333E, $26303B, $242E38
Data $222C36, $1F2A33, $1E2731, $1D252F, $1B242C, $1A222A, $192129, $202830
Data $3C4958, $384554, $364352, $354250, $33404E, $323D4B, $313C49, $2E3A46
Data $2C3744, $2A3541, $28323E, $25303B, $242E39, $222B36, $202933, $1F2831
Data $1D262E, $1B232C, $19222A, $182129, $202830, $3C4958, $384553, $364351
Data $354250, $33404E, $323E4C, $303C49, $2E3946, $2C3844, $2A3540, $28333E
Data $26313B, $242E38, $222C35, $202933, $1E2830, $1C252E, $1B232C, $1A222B
Data $182128, $202830, $3C4958, $384454, $374351, $364250, $34404E, $323D4B
Data $303C49, $2E3A47, $2C3744, $2A3541, $28333E, $26303B, $242E38, $222C36
Data $202933, $1E2731, $1C252E, $1B232C, $19222A, $182128, $202830, $3C4958
Data $384453, $374352, $364250, $34404E, $323D4C, $303C49, $2E3947, $2C3744
Data $2A3541, $28323E, $26303B, $242E38, $222B36, $202933, $1E2730, $1D252F
Data $1B232C, $1A222A, $182129, $202830, $3C4958, $374554, $374351, $364250
Data $34404D, $323E4C, $303C49, $2E3946, $2C3743, $2A3540, $28323E, $26303C
Data $242E38, $212C36, $202933, $1E2831, $1D252E, $1B232C, $1A222B, $182029
Data $202830, $3C4958, $374553, $374352, $354250, $34404E, $323E4C, $303C49
Data $2E3947, $2C3744, $2A3541, $28323E, $26303B, $242E38, $222C36, $202A33
Data $1E2731, $1C252E, $1B232C, $1A222A, $182129, $202830, $3C4958, $374553
Data $374351, $354250, $34404E, $323E4C, $303C49, $2E3A46, $2C3743, $2A3541
Data $28333E, $26303B, $242E38, $222B36, $1F2934, $1E2731, $1C252E, $1A232C
Data $19222A, $182029, $202830, $3C4958, $384453, $374352, $364150, $33404E
Data $323E4B, $303C49, $2E3A46, $2C3744, $2B3540, $28323E, $26303B, $242E39
Data $222B36, $202933, $1E2730, $1C262E, $1A232C, $1A222A, $182029, $202830
Data $3C4958, $384554, $374352, $354250, $34404E, $323E4B, $303C49, $2E3947
Data $2C3743, $2A3541, $28323E, $26303B, $242E38, $222B36, $1F2933, $1E2731
Data $1D252E, $1B232C, $1A222B, $182128, $202830, $3C4958, $384454, $364351
Data $364250, $33404D, $323E4C, $303C49, $2E3946, $2C3744, $2A3540, $28323E
Data $26303C, $242E39, $222C35, $202933, $1E2830, $1C252F, $1B242C, $1A222B
Data $182128, $202830, $3C4958, $384553, $364352, $354250, $34404D, $323E4B
Data $303C49, $2E3946, $2C3844, $2A3541, $28333E, $26303B, $252E39, $222C36
Data $202933, $1E2731, $1C262F, $1B232C, $19222B, $182129, $202830, $3C4958
Data $384554, $374352, $364250, $33404D, $323E4B, $303C49, $2E3A47, $2C3744
Data $2B3541, $28323E, $26303B, $242E39, $222C35, $202933, $1E2731, $1C252E
Data $1B232C, $19222B, $182029, $202830, $3C4958, $384553, $374351, $354250
Data $33404E, $323E4B, $303C49, $2E3A47, $2B3743, $2A3541, $28333E, $26303C
Data $242D39, $212B35, $202933, $1E2730, $1C262E, $1B232C, $1A222A, $182029
Data $202830, $3C4958, $384554, $364352, $354250, $34404E, $323E4C, $303C49
Data $2E3947, $2C3744, $2A3541, $28323E, $26303B, $242D38, $222C36, $202933
Data $1E2730, $1D252E, $1B232C, $19222A, $192028, $202830, $3C4958, $374553
Data $364351, $354250, $34404E, $323E4B, $303B49, $2E3A46, $2C3744, $2A3540
Data $28323E, $26303B, $242E38, $212C36, $202933, $1E2730, $1C252F, $1A232C
Data $1A222A, $182129, $202830, $3C4958, $374453, $364351, $354250, $34404E
Data $313D4C, $303C49, $2E3946, $2C3744, $2A3540, $28333E, $26303B, $242E38
Data $222B36, $202933, $1E2730, $1C252E, $1B232C, $1A222A, $182129, $202830
Data $3C4958, $384553, $364352, $354250, $33404E, $323D4B, $303C49, $2E3946
Data $2C3744, $2B3540, $28333E, $26303C, $242D38, $222C36, $202933, $1E2731
Data $1C252E, $1A232C, $19222A, $182028, $202830, $3C4958, $384553, $374352
Data $354250, $33404D, $323E4C, $303B49, $2E3947, $2C3744, $2A3541, $28323E
Data $26313B, $242E39, $212B36, $1F2933, $1E2730, $1C262E, $1B242C, $19222A
Data $182128, $202830, $3C4958, $384454, $364352, $354250, $34404E, $323D4B
Data $303C49, $2E3947, $2C3744, $2A3541, $28323E, $25303B, $242E38, $222B36
Data $202933, $1E2730, $1D252E, $1B232C, $1A222A, $182129, $202830, $3C4958
Data $384454, $374352, $354150, $34404E, $323D4B, $303B49, $2E3947, $2C3743
Data $2A3541, $28333E, $26313B, $242E39, $222C36, $202A33, $1E2731, $1C252F
Data $1A232C, $19222A, $182128, $202830, $3C4958, $384453, $364352, $364250
Data $34404E, $323D4B, $303C49, $2E3946, $2C3744, $2A3540, $28323E, $26303B
Data $242E38, $222B36, $1F2933, $1E2731, $1C262E, $1B232C, $1A222B, $182028
Data $202830, $3C4958, $374553, $374352, $364250, $34404E, $323E4B, $313C49
Data $2E3A46, $2C3743, $2A3541, $28333E, $26303B, $242E39, $222B36, $202933
Data $1E2730, $1D252F, $1B232C, $1A222A, $192028, $202830, $3C4958, $374454
Data $364352, $354250, $34404D, $323E4C, $303C49, $2E3946, $2C3743, $2A3541
Data $28323E, $26303B, $242E38, $222B35, $202933, $1E2831, $1C262E, $1B232C
Data $19222A, $182129, $202830, $3C4958, $384553, $364352, $354250, $34404E
Data $323E4B, $303C49, $2E3A46, $2C3743, $2A3541, $28333E, $26313B, $242E38
Data $222B36, $202933, $1E2731, $1C252E, $1A232C, $1A222A, $182028, $202830
Data $3C4958, $374453, $364352, $364250, $34404E, $323E4C, $303C49, $2E3A46
Data $2C3744, $2B3441, $28323E, $26303B, $242E38, $212B36, $202A33, $1E2731
Data $1C262F, $1B232C, $1A222B, $182029, $202830, $3C4958, $384554, $364352
Data $364250, $34404E, $323E4B, $303B48, $2E3A46, $2C3744, $2A3540, $28333E
Data $26303B, $242E38, $212B36, $202933, $1E2730, $1C252E, $1B232C, $1A222B
Data $182028, $202830, $3C4958, $384554, $364351, $354250, $34404E, $313E4C
Data $303C49, $2E3946, $2C3744, $2A3541, $28333E, $26303B, $242E38, $222B35
Data $202933, $1F2731, $1D262E, $1A232C, $1A222B, $182128, $202830, $3C4958
Data $384453, $374352, $354250, $34404E, $323D4B, $303C49, $2E3947, $2C3743
Data $2A3541, $28333E, $26303C, $242E38, $222B35, $202933, $1E2731, $1C252F
Data $1B232C, $1A222A, $182129, $202830, $3C4958, $384554, $364352, $354250
Data $33404E, $313E4C, $303C49, $2E3A47, $2C3744, $2B3541, $28323E, $26303B
Data $242E38, $222B36, $202933, $1F2731, $1C252F, $1B242C, $1A222B, $182128
Data $202830, $3C4958, $384454, $364352, $354250, $34404E, $313E4B, $303C49
Data $2E3947, $2C3744, $2A3541, $28323E, $26303C, $242D38, $222B36, $202933
Data $1F2731, $1C252E, $1B232C, $19222A, $192128, $202830, $3C4958, $384554
Data $364351, $354250, $33404E, $323E4C, $313C48, $2E3A47, $2C3744, $2A3541
Data $28323E, $26303B, $242E38, $222B36, $202933, $1E2731, $1C252F, $1B232C
Data $1A222A, $182129, $202830, $3C4958, $384453, $364351, $354250, $34404E
Data $323E4B, $303C49, $2E3947, $2C3843, $2A3540, $28333E, $26303B, $242E38
Data $222C36, $202933, $1E2730, $1D252E, $1B232C, $19222A, $182028, $202830


; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_MousePointer01
Data 27
Data 26
Data $000000, $6F716F, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $CCD4CF, $748D76, $547755, $627E62, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $C4CAC4, $386237, $1F5D1E, $337830
Data $427B3C, $617C5A, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $3B3B3B, $366D34
Data $045200, $005D00, $106A0B, $287022, $40773B, $567751, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $598B56, $146911, $006300, $006E00, $096F0A, $137214, $1E731E
Data $2B732E, $467349, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $364136, $348232, $046F04, $007704, $097E0F
Data $0C8013, $0C7911, $0F7615, $1B7822, $2B742D, $416F43, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $4C894C, $107014
Data $027207, $0E8215, $158B1C, $188C1E, $16871E, $16811B, $197C1C, $1F761F
Data $20641E, $396337, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $2E3E2F, $206F26, $066A0F, $218928, $339D36, $36A238, $2F9B30, $299529
Data $248D21, $20861C, $1E7D19, $1F7119, $276821, $3A6234, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $4A8453, $287832, $489D49, $67BF63, $6FC968
Data $5CBA54, $47AA3F, $3EA634, $3EA834, $3FAA36, $34992B, $25861E, $1F7219
Data $22641C, $2F5B2E, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $364637, $3A713E, $5DA358
Data $92DF87, $9BEA91, $83D578, $63BA58, $52AF47, $4AAC3D, $4CB13E, $4AB33E
Data $45AF3A, $3DA234, $2F9029, $20771F, $145D17, $255A28, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $547554, $4F9149, $90DE84, $AAF6A0, $A3EC98, $8DD683, $74C46C, $5EB152
Data $5CB34C, $59BB48, $57C044, $53BF42, $4DBA3F, $3FAA39, $248D24, $137017
Data $08460E, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $384038, $4C8445, $71BB66, $A6EE9D, $AFF4A8, $A6E7A0
Data $93D98C, $79C46E, $6ABC5A, $62BD4E, $61C64A, $5DCB48, $5CCC49, $4FC145
Data $2D9D2A, $147D16, $0E5013, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $4D7849, $56964F, $A5E49E
Data $B8F8B5, $B0F0AF, $A6EAA1, $93DC88, $7DCD6C, $6ECA59, $6ACF54, $66CF4F
Data $63D052, $4EBB44, $218C1E, $116A12, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $3C4C3B
Data $41743F, $81BA80, $BBF5BA, $C1FFC1, $B5F8B1, $A0E996, $8CDE7C, $77D263
Data $71D15C, $6DD257, $6DD65A, $50B744, $157810, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $4A724A, $659665, $A7DEA8, $C0FBBF, $C1FFBD, $B1FEA8
Data $9CF18D, $7CD968, $77D661, $74DA5F, $7BE068, $6ACD5E, $35942D, $145D13
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $384839, $3E6842, $80B582, $B6F3B6
Data $C5FFC2, $B7FFAD, $A2FA93, $88E674, $82E46C, $7BE066, $7BDF68, $81E072
Data $69C65F, $3C9136, $134C11, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $3E6242
Data $538A57, $84C587, $A3EFA2, $ABFFA1, $98F589, $88E973, $84E76E, $81E66C
Data $7EE36A, $84E473, $82E077, $62BF5D, $388A34, $195116, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $314434, $346836, $559B57, $78C976, $8CE583, $79D96C, $73D65F
Data $79DF64, $8BEF74, $8EF079, $84E572, $81E073, $78DA6F, $5EBC55, $2F8925
Data $0E4D07, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $325F34, $347E35, $52A64F, $58B54F
Data $3D9E32, $4FB03E, $6ECD58, $86E671, $8CEB76, $84E571, $80E36F, $77DE6A
Data $68D45D, $4CB83E, $258919, $0B4F04, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $314C31, $266B26
Data $32842F, $288121, $12620A, $2C841E, $4EA63B, $6FC95D, $81DC6D, $81E06E
Data $79E069, $6EDE62, $62D655, $52CA44, $47B738, $1F7D13, $074401, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $134A13, $166316, $135511, $000000, $2C6625, $3F8930, $57A549
Data $76C766, $78D468, $72D964, $69DC5C, $59D24E, $53CD45, $4CBD3E, $1B7C0F
Data $0A5104, $2A4526, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $314D31, $2B612E, $000000, $000000, $000000
Data $305927, $3B7832, $509945, $64BB58, $67CB5C, $5CCF4F, $54CB48, $48BA3A
Data $288D1B, $116006, $174413, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $2A4927, $386C30, $4F9B48, $5AB752, $53C04A
Data $4FBD45, $2E8C23, $135E0A, $113C0C, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $283F27, $2E682C
Data $3A9034, $3EA538, $2F9225, $195F11, $1C4017, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $142B12, $1E601A, $1C7C18, $11630D, $173D15, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $142813, $145611, $174414, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $194419
Data $000000, $000000, $000000, $000000, $000000, $000000



.BCF_MousePointer02
Data 27
Data 26
Data $000000, $6D7170, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $C5D3D2, $435EBB, $2A4E99, $4C767A, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $B9C3CE, $122F97, $062B7C, $0F488C
Data $1B528A, $476E7B, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $3A3B3B, $123E8A
Data $002200, $002B00, $013659, $093E7D, $1A4D8A, $396578, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $316D92, $023566, $003000, $003A00, $003B56, $023E6D, $064179
Data $0C487F, $265C77, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $2E403D, $105489, $003B3F, $00423F, $004963
Data $014C6B, $014467, $01416E, $05457E, $0C487E, $215576, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $266A8C, $013C6C
Data $003E4C, $014E6E, $03577A, $04597C, $03537C, $034D78, $04477A, $06437A
Data $07386E, $1A456E, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $233C3A, $073F7D, $003663, $075589, $0F6C97, $107399, $0D6A92, $0A638A
Data $085A80, $06527A, $054875, $063E72, $0B3C72, $1B446E, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $236292, $094393, $1B6CA8, $3399BA, $3BA7BD
Data $2A92B0, $1B7D9F, $157896, $157A96, $157D97, $0F688C, $08527C, $063F72
Data $08376B, $123A6B, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $283F46, $144194, $2B74B2
Data $5FC9CE, $6ADBD3, $4FB9C6, $3092B2, $2283A6, $1D7F9E, $1E869F, $1D899F
Data $19839B, $147396, $0D5D8A, $07447B, $033165, $0B3768, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $2C5093, $215EA7, $5DC7CC, $7DEFDA, $74DED6, $5ABBCC, $3FA0BF, $2C86AE
Data $2A89AA, $2893A7, $269BA4, $2399A2, $1F929F, $157D9A, $085A84, $023D6F
Data $00214F, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $2B3547, $20569A, $3D93BB, $78E1D8, $83ECDD, $78D6DA
Data $60C0D0, $44A0C0, $3695B4, $2F96AB, $2EA3A8, $2BAAA7, $2AACA8, $209CA4
Data $0C6C8B, $02486F, $012A56, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $26528D, $2664AC, $76D1D9
Data $8FF2E3, $85E5E0, $78DBDA, $60C4CE, $48ADBF, $3AA9B3, $36B0B0, $33B0AC
Data $30B2AE, $1F93A4, $07597C, $023D5E, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $2B4150
Data $194595, $4D92CA, $93EDE5, $9CFEE8, $8BF2E1, $70D9D5, $59C7C8, $42B5BA
Data $3DB3B5, $39B5B2, $39BBB4, $218EA4, $034463, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $234A8F, $3364BA, $79C7DD, $9BF7E7, $9CFEE6, $86FDDD
Data $6BE6D1, $47C0BD, $42BBB8, $3FC1B7, $46CBBD, $36ADB6, $10638C, $03345B
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $223656, $173899, $4C8BCB, $8DEAE3
Data $A2FEE8, $8EFEE0, $73F6D4, $54D4C4, $4ED1BF, $46CBBB, $46C9BD, $4DCBC2
Data $35A3B7, $146194, $032752, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $1A3989
Data $2456B1, $50A2CE, $74E3DB, $7EFEDA, $66EDCF, $54D9C3, $50D6C0, $4DD4BF
Data $49CFBE, $50D1C3, $4ECBC5, $2F99B6, $125893, $052B5A, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $1C3153, $11388F, $256AB2, $43A7C5, $59D3CC, $44C0BF, $3FBBB7
Data $44C9BA, $57E3C4, $5BE5C6, $50D3C2, $4DCBC3, $43C1C1, $2C95B0, $0D5685
Data $01273D, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $113580, $0F4996, $2278AC, $278BAC
Data $146E94, $20859F, $3AADB2, $52D4C2, $59DCC5, $50D3C2, $4CCFC1, $42C7BE
Data $34B8B6, $1E8F9F, $085674, $012832, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $193757, $093A80
Data $0E5091, $094E7F, $03354D, $0C517C, $1F789C, $3BA7B6, $4DC4C0, $4DCBC0
Data $44CBBD, $3AC7B9, $2FBBB0, $22A9A4, $1B8E99, $06486A, $001F1E, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $03225C, $03316F, $032D57, $000000, $0F4269, $16588D, $2676A8
Data $41A4BB, $43B8BD, $3EC0BA, $35C4B5, $28B5AB, $23ADA4, $1E969F, $044763
Data $00243D, $122A56, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $193957, $0D3A76, $000000, $000000, $000000
Data $123766, $14488C, $2168A4, $3193B2, $33AAB5, $2AB0AC, $24AAA7, $1B929B
Data $095A78, $023142, $06244D, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $0F2961, $133C88, $206AA7, $288EAE, $239BA8
Data $2096A4, $0C5983, $032F52, $031D41, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $112457, $0E3A80
Data $125D96, $157699, $0D5F85, $042F62, $072053, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $051638, $073469, $054773, $023358, $051D50, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $071732, $032B5B, $05244E, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $072553
Data $000000, $000000, $000000, $000000, $000000, $000000



.BCF_MousePointer03
Data 27
Data 26
Data $000000, $717156, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $D4D487, $BD5414, $994612, $817A0C, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $D4CD30, $912C16, $742A16, $883F15
Data $8B4912, $846F0C, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $3B3B35, $863814
Data $392416, $162A16, $5B3216, $7B3815, $8A4512, $7E640D, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $956710, $613116, $162D16, $163516, $4A3516, $603816, $6F3A15
Data $754012, $76570D, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $414106, $844B14, $393516, $163B16, $4A4116
Data $524316, $523D16, $583B16, $6A3D15, $764012, $754F0E, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $8C6410, $5A3616
Data $2F3816, $564516, $644D16, $694E16, $664916, $664416, $6B4016, $703D15
Data $683212, $6F3F0E, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $3D4006, $6E3914, $413216, $774B16, $8D6116, $906716, $885F16, $815816
Data $7B4F16, $754816, $724016, $703915, $723512, $713D0E, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $8B5A11, $7F3D16, $A26116, $BC9116, $C2A216
Data $B38916, $A17216, $986D16, $986F16, $997216, $8E5D16, $7C4816, $703915
Data $6B3212, $69320E, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $494007, $8B3A14, $B46916
Data $DACC16, $DFE316, $D0B816, $B98916, $AB7916, $A47516, $A57C16, $A47F16
Data $9F7916, $976716, $885316, $733D15, $592D13, $60310E, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $944711, $A85416, $D8CA16, $E8FF16, $E4E716, $D6BA16, $C59A16, $B57C16
Data $B37F16, $B18B16, $AF9316, $AC9116, $A68916, $997216, $7B4F16, $5F3715
Data $3A2010, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $4A3407, $9C4D14, $C38B16, $E6EC16, $EBFA16, $E6DD16
Data $DAC016, $C99A16, $BE8C16, $B88E16, $B79D16, $B4A616, $B3A716, $A89516
Data $866116, $614016, $462610, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $8F4911, $AE5916, $E5D616
Data $F0FF16, $ECF116, $E6E316, $DAC616, $CCA916, $C1A416, $BEAD16, $BBAD16
Data $B9AF16, $A78B16, $774E16, $523712, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $544108
Data $923D14, $CE8916, $F2FC16, $F5FF16, $EEFF16, $E2E116, $D6CA16, $C7B216
Data $C3B116, $C0B216, $C0BA16, $A98516, $623E15, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $8D4211, $BA5916, $E6CA16, $F5FF16, $F5FF16, $ECFF16
Data $E0F316, $CBC016, $C7BA16, $C5C216, $CACE16, $BEA916, $8D5816, $542F11
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $563209, $913214, $CE8216, $EFF716
Data $F7FF16, $F0FF16, $E3FF16, $D3DA16, $CFD616, $CACE16, $CACC16, $CECE16
Data $BD9D16, $935615, $4F2410, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $843311
Data $AC4C16, $D09B16, $E4EE16, $E9FF16, $DDFC16, $D3E116, $D0DD16, $CEDA16
Data $CCD416, $D0D616, $CFCE16, $B89116, $904D15, $582610, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $522D09, $873214, $AD5F16, $C8A216, $D6D816, $C9C016, $C5BA16
Data $C9CC16, $D5EE16, $D7F116, $D0D816, $CECE16, $C8C216, $B58C16, $874C16
Data $472410, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $793011, $8D4116, $AB6D16, $B08216
Data $976316, $A87A16, $C1A916, $D2DA16, $D6E516, $D0D816, $CED416, $C7CA16
Data $BDB616, $A58616, $7B4C16, $412510, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $57320A, $773514
Data $8C4716, $7F4516, $573013, $834816, $A76D16, $C2A216, $CEC616, $CECE16
Data $C9CE16, $C1CA16, $B8BA16, $ABA416, $A18516, $734016, $391E10, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $542112, $652E16, $532911, $000000, $6B3B0F, $944F15, $AF6B16
Data $C79F16, $C8B616, $C4C016, $BDC616, $B1B216, $ACA916, $A58E16, $6E4016
Data $472414, $57250B, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $57340A, $6F3410, $000000, $000000, $000000
Data $6B300E, $8F4014, $A95D16, $B98B16, $BCA616, $B3AD16, $ADA616, $A28916
Data $804F16, $582D14, $4C200D, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $61250D, $893614, $A85F16, $B18516, $AC9316
Data $A88E16, $874E16, $5C2B14, $441C0D, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $55200B, $7C3413
Data $945316, $986B16, $885516, $652C14, $521E0D, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $371409, $662F12, $6F4016, $582F14, $4C1C0D, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $311407, $562812, $4C200D, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $4E210D
Data $000000, $000000, $000000, $000000, $000000, $000000


.BCF_MousePointer04
Data 27
Data 26
Data $495B51, $505957, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $42574C, $7A7779, $7D7E7E, $565B59, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $626668, $A09D9D, $A7A4A2
Data $868A87, $5C6560, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $3F4D48
Data $868685, $B4B6B3, $C6C9C8, $B7B0B3, $8B8988, $5C6761, $2E3E36, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $606761, $A89EA0, $CBC7C9, $DFDDDE, $D8D7D4, $ACAAA8
Data $5D695D, $3E6741, $305A3A, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $364942, $828085, $B6B2B8, $DEDEDE
Data $EEF1F0, $D6D6D5, $768673, $4C8246, $4E9445, $468140, $365F3F, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $5D6467
Data $A9A2A6, $D7D2D4, $EFF1F4, $FAFAFC, $D3DACE, $6A9066, $4D9242, $5CAA4A
Data $549948, $478148, $3C6548, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $3A4141, $83827D, $ADAEA5, $E3E2E1, $F7F7F8, $FCFEFC, $CCCECA
Data $6A8763, $509243, $60B64E, $61B34A, $57984C, $49854A, $376B47, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $466042, $587458, $A5AEA5, $F2EDEF
Data $FAFAFC, $FFFFFF, $D1D5D1, $6A8762, $49893C, $58B14C, $69C45D, $66BB5A
Data $58A64E, $4A8B47, $3E7348, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $29472D, $4C8547
Data $62895A, $B2B8B0, $F7EFF8, $F8F8FC, $FFFFFF, $D5D7D4, $758672, $488043
Data $51A748, $6CC65F, $77D665, $71D15E, $63B659, $497C4E, $425750, $2C3935
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $478840, $5E9F4C, $628560, $B7B7B8, $F2EDF3, $FBFBFB, $FFFFFF
Data $E1DFE2, $7B9377, $47813E, $5BA74F, $61BF53, $72D663, $70BD64, $577752
Data $646263, $575E5A, $495851, $323D38, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $214025, $5BA84E, $579B4C, $668062, $CECFCE
Data $F8F5F8, $FCFDFA, $FFFFFF, $DDDBDE, $6E8A69, $447F3A, $519F45, $60A155
Data $6A8866, $767A76, $747476, $6C6E6D, $616361, $585856, $49554D, $2A4036
Data $000000, $000000, $000000, $000000, $000000, $000000, $468E45, $64BF57
Data $55984B, $71896D, $D7D9D6, $F8F4F9, $FFFBFF, $FFFFFF, $DADED8, $718C6B
Data $487541, $678462, $9A9A9B, $9B929D, $838182, $777072, $6F6E6E, $706C6B
Data $575755, $2F4239, $000000, $000000, $000000, $000000, $000000, $000000
Data $1E3822, $57AF4E, $5FC050, $4D8C43, $7D907A, $E3DFE5, $FAF6FA, $FAFCF9
Data $FFFFFF, $D9DAD7, $9BA499, $BEC2BE, $C2BEC4, $ABA6AC, $919292, $807F7F
Data $767374, $5E5C5B, $46574F, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $438343, $65C555, $5BB34E, $4F8048, $8D998C
Data $E4E7E3, $F2FBF1, $FBF9FB, $FFFDFF, $F5EEF5, $E5E1E5, $CDCECE, $B2B3B2
Data $9C9E9D, $8A8789, $6C706E, $363E3B, $2C3F37, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $5DA350, $62C454
Data $55A149, $52784B, $9AA999, $ECE7EE, $F8F5F9, $FDFFFD, $FAFAF9, $E9EAEA
Data $D9D8D9, $BEBEC0, $A1A1A1, $7B7A7A, $464646, $272325, $1D1B1C, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $47813F, $6AC157, $5DB850, $4D9445, $4D7344, $A7A9A6, $EDEAEE, $F8F9F8
Data $F9FBFA, $F5F6F6, $DCDCDC, $BEC0C1, $848585, $4D4749, $312C2E, $2A2C2A
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $5DA54F, $6CCC5E, $54A64C, $486F3E, $899388
Data $DCDCDF, $EAE8EB, $F4F2F5, $F2F2F3, $D9DAD9, $939594, $595C5B, $564C4F
Data $3A3B3B, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $428141, $6FC564, $5C9F54
Data $718271, $ABADAF, $C5C7C9, $D8D8DA, $E1DEE1, $E2E0E0, $A7A4A5, $706F70
Data $848383, $636967, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $54884C, $607E56, $87898A, $A5A2A7, $B2B6B6, $C0C1C3, $CECCCD, $A8A3A4
Data $777274, $AEACAD, $929393, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $425042, $6F6B68, $828181, $909090, $A3A5A4, $B0B2B1
Data $9F9C9D, $6A6667, $8C8B8C, $A7ACA8, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $6B6168, $757672, $80807E
Data $949494, $8E8E8E, $585657, $595858, $777D79, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $424D46
Data $6C6E69, $77777B, $7A7A7B, $4F4E4F, $323031, $464A48, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $676262, $6F696C, $4C4749, $292829, $202221, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $414542, $4E5350, $2F3230, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $16231E
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000

.BCF_MousePointer05
Data 27
Data 26
Data $606060, $636363, $636363, $636363, $636363, $636363, $636363, $636363
Data $636363, $636363, $636363, $636363, $636363, $636363, $636363, $646464
Data $676767, $666666, $636363, $636462, $676D5C, $6B7657, $6D7D52, $70814E
Data $72864C, $728849, $000000, $636363, $637A57, $91B47B, $AECA9C, $A7C693
Data $97BC7E, $94BA7B, $96BC7C, $92B977, $8EB773, $89B56C, $84B165, $7AAB59
Data $77A953, $6FA44A, $549428, $4E9020, $468A14, $4B9113, $519811, $569E10
Data $59A30F, $59A20D, $619324, $6C863F, $000000, $000000, $636363, $758B68
Data $AFCC9A, $B2D09B, $ADCE95, $A8CC8D, $A3C986, $9DC67E, $97C377, $90C06F
Data $8BBD67, $86BA5F, $80B757, $71AF42, $60A52B, $549E1A, $56A215, $5BA814
Data $60AE13, $64B311, $67B510, $62B00C, $74963B, $000000, $000000, $000000
Data $000000, $6F6F6F, $8D9F82, $AFCD9A, $ACCE94, $A8CC8D, $A3CA86, $9DC77E
Data $97C477, $91C06F, $8CBE67, $87BB60, $7EB654, $69AA37, $58A121, $55A216
Data $5BA814, $60AD13, $65B312, $68B711, $69B90F, $66AF10, $799B3E, $000000
Data $000000, $000000, $000000, $000000, $656565, $8C9E80, $A9CA93, $A7CB8D
Data $A3CA86, $9DC77F, $98C477, $92C16F, $8CBE67, $87BB60, $7CB552, $63A730
Data $55A119, $59A615, $5FAD14, $64B213, $69B811, $6CBC10, $6BBB0D, $6FA721
Data $729437, $000000, $000000, $000000, $000000, $000000, $000000, $666666
Data $94A68A, $A5C78D, $A2C886, $9DC77F, $98C478, $92C16F, $8DBE68, $88BC60
Data $7BB54F, $5CA426, $56A317, $5CAA15, $62B013, $67B712, $6BBC10, $6EBF0F
Data $6CBB0C, $79A334, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $636363, $849777, $9FC485, $9CC57E, $98C478, $92C16F
Data $8DBE68, $87BC60, $7BB550, $5AA322, $58A616, $5FAC14, $64B313, $69BA11
Data $6EBE11, $70C10F, $6BB60F, $7DA538, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $636363, $8C9E81, $99C17C
Data $96C276, $90C06D, $8CBE67, $88BC60, $81B858, $69AC35, $5BA818, $60AF14
Data $65B512, $6BBB12, $6FC210, $6FC00D, $72AD20, $739932, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $696969, $8D9F81, $91BC72, $90BF6E, $8CBE67, $88BC60, $83B959, $79B448
Data $60AA1D, $60AF14, $66B612, $6CBD11, $70C20F, $6DBD0C, $7BA733, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $686868, $859979, $8CB96B, $89BB64, $87BC60
Data $83B959, $7DB850, $67AF29, $62AF15, $67B712, $6CBD11, $6FC10F, $6CB80F
Data $7EA737, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $666666, $839876
Data $80B25C, $82B759, $83B959, $7FB952, $73B43A, $64B019, $67B712, $6CBD10
Data $6DBE0E, $72AB22, $709632, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $676767, $6E855F, $6DA744, $80B657, $7FB852, $7CB946, $6BB323
Data $67B613, $6BBB10, $69B90C, $7BA337, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $636363, $5C764A, $6CA641, $7CB54E
Data $7FB849, $70B62D, $66B513, $69B910, $66B00F, $7BA13B, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $646464
Data $5B7549, $64A337, $74B33E, $69B124, $64B313, $65B40F, $6CA226, $6D8F37
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $646464, $587443, $559D1B, $5CA915, $61B011, $60AE0D
Data $789742, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $646561, $58793B, $539E10
Data $5CA910, $5DA212, $779443, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $676E5C, $5C7F37, $529D0D, $63912C, $69813D, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $6A7557, $5C8233, $72874C, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $6D7D53, $71834D
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000

.BCF_MousePointer06
Data 27
Data 26
Data $9B9B9B, $69696A, $505356, $4B4F53, $494A4B, $3E3D3D, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $CCCCCD, $A9A39E, $8F755E, $A1815F, $736B64, $616264
Data $585858, $494949, $403F3F, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $ABADAD, $B39A83, $B27844, $B3804A
Data $817468, $717173, $6E6E6E, $6A6A6A, $616161, $595858, $47494A, $39393B
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $999DA1, $D0AF8A
Data $A87E53, $73787F, $5E5E5E, $6C6B6B, $777575, $767575, $6C6B6B, $625D5A
Data $756558, $71665B, $4B4D50, $3C3C3E, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $787A7C, $D9C7B4, $C5B099, $78797C, $353535, $3D3D3D, $4D4B4B, $5B5959
Data $6E6D6E, $727172, $6B6158, $9C6F3D, $B0854E, $716C62, $454950, $373839
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $515050, $E1E1E3, $FFFFFF, $A5A5A4, $3C3E40, $3E4447
Data $363F42, $394146, $3D3C3B, $555353, $666769, $696869, $957249, $C69241
Data $B38F63, $736D6B, $414548, $2D2D2D, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $C5C5C5, $FCFCFC, $D8D8D8
Data $464646, $38434A, $3D5767, $3A474F, $394850, $3A484E, $3F3F3E, $575655
Data $696C73, $716962, $A37740, $C48A54, $A28B7D, $5C5D5E, $393A3A, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $939393
Data $F9F9F9, $EEEEED, $706E6E, $516A79, $3D5564, $384B57, $3E6176, $394952
Data $3A4D59, $3A4348, $454341, $626264, $6E7176, $6D6055, $91643F, $9F8371
Data $726F6F, $424444, $252525, $000000, $000000, $000000, $000000, $000000
Data $000000, $6B6A6A, $D1CECC, $F1F1F0, $B1B0B0, $4F5152, $5B87A1, $3D7DA4
Data $384A55, $3B5C70, $3D657F, $38464F, $3A4F5C, $424547, $575352, $717174
Data $696969, $665951, $81726D, $7C7776, $4D4D4D, $363535, $000000, $000000
Data $000000, $000000, $000000, $4B4C4D, $ADA29A, $B7ADA5, $D5D5D5, $5E6163
Data $91C6E5, $5686A4, $37617C, $3D7DA3, $394F5D, $3D6681, $3D657F, $38454E
Data $40484D, $565554, $7A7979, $767678, $696767, $75706F, $6E6D6C, $525252
Data $3B3B3B, $000000, $000000, $000000, $000000, $000000, $989188, $998064
Data $C3C1C1, $888989, $70787D, $81C6D7, $3FB0E4, $395A71, $3C7AA1, $3D7DA5
Data $39515F, $3D6F8D, $3B596C, $3D3D3D, $4D4B4B, $5B5A5A, $5D5C5C, $595959
Data $656464, $6E6D6D, $5F5F5F, $404040, $000000, $000000, $000000, $000000
Data $6A6A6B, $C09D75, $897562, $B3B5B8, $666D72, $A4E5F2, $6BAAB5, $3D89B5
Data $3D95CD, $395D73, $3D88B7, $3D799F, $353B3E, $383635, $414141, $494949
Data $4F4F4F, $4A4A4A, $464646, $474646, $4F4F4F, $515151, $353535, $000000
Data $000000, $000000, $34363A, $BEA78A, $B68345, $AEACAD, $7E8081, $788084
Data $9EE7E6, $4DCCEB, $3D637E, $3E94C9, $3D92C7, $354046, $353535, $373737
Data $454444, $414141, $434343, $373636, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $898680, $E1B55D, $958165
Data $ABACB1, $656F74, $B8EDF1, $8DBDBC, $41A3D4, $3B96D1, $36454F, $353535
Data $393939, $4A494A, $4A4A49, $383737, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $48484F
Data $CABA83, $B08F3B, $A4A2A9, $8A8989, $747B7F, $BDF8FB, $55CBED, $354351
Data $353535, $3D3D3D, $515151, $555454, $4C4B4B, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $7C7A76, $E0BD53, $958469, $C6C7CD, $646769, $7DADB8
Data $517279, $353535, $393939, $555455, $5A5959, $575657, $454544, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $44474D, $CDBA7B, $B58D3B, $B1B1B6
Data $B9B8B9, $3F3D3F, $353535, $383837, $515151, $636161, $5F5E5E, $525151
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $84817B
Data $D19F55, $887667, $D7D9DD, $777676, $404040, $484848, $595959, $555555
Data $4B4A4A, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $3F4144, $BAA082, $9D734A, $B6B6B9, $929191, $5F5D5D, $525353
Data $3C3D3D, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $73706C, $AA8761, $A89F98, $999A9D
Data $605F5F, $595959, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $847A73
Data $9D938A, $A1A1A2, $616161, $4A4949, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $464646, $A9A7A5, $B9B8B7, $646464, $3D3D3D, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $5E5E5E, $C0C0C0, $767676, $333333
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $767676
Data $8E8D8D, $2E2E2E, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $2C2C2C, $696969, $3A3A3A, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $2D2D2D, $343434, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000

.BCF_MousePointer07
Data 20
Data 20
Data $203848, $183848, $203848, $203848, $203C48, $203C50, $203C50, $203C50
Data $203C50, $203C50, $203850, $183850, $183850, $183850, $183850, $183850
Data $182C38, $000000, $000000, $000000, $203848, $58D4F8, $60D4F8, $68D8F8
Data $70DCF8, $70ECF8, $70E0F8, $68D4F8, $68C4F8, $60CCF8, $58C4F8, $48ACF8
Data $48ACF8, $40A8F8, $3088D8, $183850, $000000, $000000, $000000, $000000
Data $203848, $48ACF8, $58C8F8, $60C8F8, $68D4F8, $70E0F8, $70E4F8, $70E8F8
Data $70DCF8, $68D4F8, $60CCF8, $58B4F8, $50B8F8, $48B0F8, $204460, $000000
Data $000000, $000000, $000000, $000000, $000000, $203848, $50BCF8, $58BCF8
Data $60C0F8, $68D8F8, $70DCF8, $70D8F8, $70E4F8, $70D8F8, $68D0F8, $60CCF8
Data $60D0F8, $203850, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $203848, $40ACF8, $48B4F8, $50B8F8, $60C4F8, $68D4F8, $68C8F8
Data $70C8F8, $70D4F8, $70D8F8, $70DCF8, $70DCF8, $183850, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $203848, $40A0F8
Data $48ACF8, $50B0F8, $58BCF8, $68D0F8, $68D4F8, $70D8F8, $70D4F8, $70E4F8
Data $70E4F8, $183850, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $203848, $389CF8, $40A0F8, $48A4F8, $50B8F8, $58BCF8
Data $60CCF8, $68CCF8, $70CCF8, $70E0F8, $70E0F8, $183850, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $203848
Data $3898F8, $40A4F8, $48B0F8, $50B4F8, $58BCF8, $60C4F8, $68D4F8, $70DCF8
Data $78E0F8, $80C4E0, $283C48, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $203848, $38A0F8, $3898F8, $409CF8, $40A0F8
Data $48ACF8, $58C4F8, $60C8F8, $68C0F8, $70D8F8, $70D0F8, $78C0E8, $283C48
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $203848, $3894F0, $3898F8, $3888F8, $40A0F8, $48B4F8, $50C0F8, $58C0F8
Data $68CCF8, $68C4F8, $70DCF8, $70D0F0, $203C48, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $203848, $3098F0, $3094F0, $3898F0
Data $3898F0, $40A0F8, $48A8F8, $50B4F8, $58B4F8, $60C8F8, $68CCF8, $70D8F8
Data $68C4F8, $203C48, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $203848, $3090E8, $3094E8, $3894F0, $3894F0, $389CF0, $48A4F8
Data $50ACF8, $58BCF8, $60C8F8, $68C8F8, $68D0F8, $68C0F8, $203848, $000000
Data $000000, $000000, $000000, $000000, $000000, $203848, $308CE8, $308CE0
Data $3094F0, $3080C8, $284458, $183850, $40A8F8, $48B8F8, $50B4F8, $58BCF8
Data $60CCF8, $60C4F8, $204460, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $203848, $308CE0, $3094E8, $2864A0, $000000, $000000
Data $203848, $3888E8, $48ACF8, $50A8F8, $58B8F8, $489CE0, $182C38, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $203848, $3088E0
Data $3094E8, $205480, $000000, $000000, $000000, $183440, $3888C8, $48A8F8
Data $50B0F8, $183848, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $203848, $3094E0, $204868, $000000, $000000
Data $000000, $000000, $183040, $306CA0, $4094F0, $183040, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $203848
Data $3088D8, $183440, $000000, $000000, $000000, $000000, $000000, $182C38
Data $183040, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $203848, $203848, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $204058, $204060, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000


; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

; Paysage
.BCF_WindowIcon01
Data 17
Data 17
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $0448FE, $1B5FFE, $2C70FE, $3F81FE, $4E8EFE, $5BA1FE
Data $67A9FE, $76B6FE, $1FA141, $008500, $009600, $00A100, $009F00, $008E00
Data $007600, $434343, $434343, $084EFC, $2165FC, $3778FE, $488CFE, $5B9DFC
Data $67ABFE, $76B8FE, $7FC3F6, $0CA10E, $008E00, $00A500, $04B000, $06AE00
Data $009D00, $008300, $434343, $434343, $175DFE, $3074FE, $4589FC, $5B9FFE
Data $6CB0FC, $7DC1FC, $8ED0FE, $8ED6E7, $06A500, $00A100, $0ABF00, $17C908
Data $1BC510, $0EB208, $009400, $434343, $434343, $2165FC, $3D7FFE, $5296FE
Data $67ABFE, $7DC1FA, $90D4FC, $A1E3FE, $9DE5E5, $0AB000, $00B200, $19D006
Data $28DC17, $2ADA1F, $1DC315, $01A300, $434343, $434343, $286AFC, $4387FE
Data $5D9FFC, $72B8FA, $87CEFC, $9DE1FE, $A9F0FE, $ABF6EB, $1BBA0C, $00BC00
Data $23DF12, $37ED26, $34E72C, $2AD221, $0AAE06, $434343, $434343, $2E72FE
Data $4A90FE, $63A9FE, $7DC3FC, $94D8FE, $A5EBFE, $B8FAFE, $C1FEF8, $39C930
Data $01C700, $2CE91B, $41FA30, $43F439, $32DC2C, $15B60E, $434343, $434343
Data $3278FE, $5094FC, $67AEFE, $7FC7FA, $98DFFC, $AEF2FC, $BFFEFC, $D0FEFE
Data $67DC6A, $08D200, $34F221, $48FE37, $4AFC3F, $3DE532, $19BA12, $434343
Data $434343, $3278FE, $5094FC, $6AAEFE, $85C9FC, $9AE1FE, $B2F4FC, $BFFEFA
Data $D6FEFE, $90E79F, $12D400, $34F41F, $4AFE3B, $4AFC3F, $3BE734, $1DBF17
Data $434343, $434343, $3278FE, $4E94FE, $67AEFE, $85C7FE, $9ADFFE, $AEF2FC
Data $BCFCFE, $CEFEFE, $B2F0D4, $2AD817, $30F019, $48FE37, $4AFC3D, $39E530
Data $1BBC15, $434343, $434343, $2A70FE, $488EFC, $63A7FE, $78BFFE, $90D6FE
Data $A3E9FC, $B0F6FA, $BCFEFE, $C5FCFE, $54DF52, $23E510, $3DF62C, $3DF232
Data $32DA28, $12B40C, $434343, $434343, $266AFE, $4185FC, $569DFC, $6EB4FE
Data $85C7FE, $96DAFE, $A3E9FA, $B0F2FE, $BCFAFE, $7BE594, $1DD606, $32E71F
Data $34E326, $26CB1D, $0AA906, $434343, $434343, $1D61FE, $397DFC, $4E92FC
Data $63A7FE, $78BCFC, $89CEFE, $98DCFE, $A1E5FE, $A9E9FE, $89E1C5, $1BCE08
Data $23D610, $26D41D, $1BBF12, $019D00, $434343, $434343, $1254FE, $2A70FE
Data $4185FE, $5498FE, $67ABFC, $76BAFE, $83C7FC, $90D2FE, $94D6FE, $8CD6E9
Data $26C31B, $0CC100, $10BF0A, $0AAB01, $009000, $434343, $434343, $0448FE
Data $1B5FFE, $2E74FE, $4183FC, $5296FE, $5FA3FC, $6CB0FE, $76BAFE, $7DBFFE
Data $83C3FE, $32B643, $00A500, $00A300, $009400, $007B00, $434343, $434343
Data $0043FE, $1059FE, $266AFE, $377BFE, $458CFE, $5498FE, $61A5FE, $6AAEFE
Data $70B2FE, $78B6FE, $3BB26C, $009A00, $009400, $008900, $007200, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343

; Disquette
.BCF_WindowIcon02
Data 17
Data 17
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $535121, $7A7517, $786E19, $786C1A, $7A691B, $7D661C
Data $7A621E, $7B5E1F, $7C5B20, $7D5921, $7E5523, $7F5224, $7F4D25, $884C1F
Data $52342A, $434343, $434343, $F3F279, $FAF5B0, $F0E791, $EBDE79, $E5D363
Data $E9CD3A, $FFEC11, $FFEC00, $FFDF00, $FFCE00, $FFC000, $FFB500, $FFA800
Data $FF9C00, $D26002, $434343, $434343, $FFFFFF, $EFEFF6, $DDDDE5, $CDCED7
Data $BDC0CA, $A2A4AC, $D5B72F, $FFE400, $F3BF05, $D7BA63, $D5B661, $CDA952
Data $C49C4A, $BF9140, $8D5101, $434343, $434343, $FFFFFF, $E5E5E5, $DBDBDB
Data $CDCDCE, $BFC0C1, $A8ABB3, $CDB239, $FFDE00, $E7C64D, $F6FDFF, $E9EBF0
Data $D3D4D8, $BFC0C3, $AEB3BC, $6B665F, $434343, $434343, $FFFFFF, $E4E4E4
Data $DADADA, $CDCDCD, $BFBFC0, $A8A9B0, $CEB237, $FFDF00, $E7C757, $DEC36D
Data $FCAC00, $FCA400, $FD9700, $D77D00, $61543E, $434343, $434343, $FFFFFF
Data $E4E4E4, $DADADA, $CDCDCD, $BFBFC0, $A8A9B0, $CEB237, $FFDF00, $E2C457
Data $DEB948, $FFB200, $FFAB00, $FFA200, $EF8000, $5C4D36, $434343, $434343
Data $FFFFFF, $E4E4E4, $DADADA, $CDCDCD, $BFBFC0, $A8A9B0, $CEB237, $FFDE00
Data $EBCA54, $EBDFBF, $E8C157, $DDB24A, $D3A136, $BA8E40, $695E4E, $434343
Data $434343, $FFFFFF, $E4E4E4, $DADADA, $CDCDCD, $BFBFC0, $A8A9B0, $CEB237
Data $FFDE00, $ECCA4E, $FFFFFF, $FFFFFF, $E9EFFD, $D5DBEB, $C7CEDB, $776D5F
Data $434343, $434343, $FFFFFF, $E4E4E4, $DADADA, $CDCDCD, $BFBFC0, $A8A9B0
Data $CEB237, $FFDE00, $ECCA4F, $FFFFFF, $FFFFFF, $EEEFEF, $DFDFDF, $CDCED0
Data $766D5F, $434343, $434343, $FFFFFF, $E4E4E4, $DADADA, $CDCDCD, $BFBFC0
Data $A8A9B0, $CEB237, $FFDE00, $ECCA4F, $FFFFFF, $FFFFFF, $EEEEEE, $DEDEDE
Data $CDCED0, $766D5F, $434343, $434343, $FFFFFF, $E4E4E4, $DADADA, $CDCDCD
Data $BFBFC0, $A8A9B0, $CEB237, $FFDE00, $EECA4F, $FFFFFF, $FFFFFF, $EEEEEE
Data $DEDEDE, $CDCED0, $766D5F, $434343, $434343, $FFFFFF, $E5E5E5, $DBDBDB
Data $CDCDCD, $C0C0C1, $A9ABB2, $CDB239, $FFDE00, $EBCA52, $FFFFFF, $FFFFFF
Data $F0F3F9, $DFE2E9, $CDD1DB, $756F66, $434343, $434343, $FFFFFF, $F8F8FF
Data $E2E2EB, $D3D4DE, $C1C3D0, $A2A5B2, $D4B52F, $FFE200, $E9BD23, $DAD1B6
Data $DACEAE, $CBBD9C, $BFB090, $B3A284, $775824, $434343, $434343, $F8F68E
Data $F9F5BF, $EEE59F, $E8DB88, $DFD073, $DFC648, $FFE914, $FFEC00, $FFDB00
Data $FFC300, $FFB600, $FFAB00, $FF9E00, $FF9500, $CA5D02, $434343, $434343
Data $605E1C, $8F8813, $8A7F15, $8C7D16, $8D7916, $907718, $8F7219, $8E6C1A
Data $90681B, $92661C, $93611D, $925D1E, $93561F, $9A5319, $593323, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343

; Texte mode
.BCF_WindowIcon03
Data 17
Data 17
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $DDDDDD, $E0E0E0, $E2E2E2, $E0E0E0, $E0E0E0, $E4E4E4
Data $E2E2E2, $D7D7D7, $CCCCCC, $C2C2C3, $C1C0BD, $D5C199, $ECD18B, $D7B757
Data $A38F45, $434343, $434343, $EAEAEA, $7B797B, $DADADA, $7B797B, $D3D3D3
Data $7B797B, $B0B0B0, $ADADAD, $AFAFAF, $A0A1A4, $6E695E, $DAB94D, $FFE447
Data $DAB918, $B5AC81, $434343, $434343, $E7E7E7, $7B797B, $DBDBDB, $CFCFCF
Data $ADADAD, $AFAFAF, $BDBDBD, $BEBEBE, $ADADAD, $9A9A9C, $707174, $A18D1E
Data $D6BF13, $AEA557, $C1C2CA, $434343, $434343, $E8E8E8, $D4D4D4, $C2C2C2
Data $A7A7A7, $B8B8B8, $C0C0C0, $ACACAC, $949494, $878787, $7F7F7F, $6A6A6A
Data $909088, $B5B6AF, $BDBEC2, $CFCFCF, $434343, $434343, $EAEAEA, $B4B4B4
Data $989898, $B2B2B2, $ABABAB, $949494, $868686, $808080, $797979, $6E6E6E
Data $949494, $C9CACC, $D2D3D5, $7B797B, $CDCDCD, $434343, $434343, $D7D7D7
Data $808080, $9A9A9A, $959595, $868686, $808080, $7C7C7C, $747474, $787878
Data $A3A3A3, $CECECE, $7B797B, $CFCFCF, $7B797B, $CDCDCD, $434343, $434343
Data $B1B1B1, $6D6D6D, $868686, $7C7C7C, $777777, $757575, $797979, $919191
Data $C0C0C0, $D0D0D0, $D0D0D0, $7B797B, $CFCFCF, $7B797B, $CDCDCD, $434343
Data $434343, $C8C8C8, $717171, $717171, $7B7B7B, $8B8B8B, $A4A4A4, $C0C0C0
Data $CECECE, $D1D1D1, $7B797B, $CFCFCF, $7B797B, $CFCFCF, $7B797B, $CDCDCD
Data $434343, $434343, $EDEDED, $C4C4C4, $C2C2C2, $C9C9C9, $CECECE, $D7D7D7
Data $D3D3D3, $7B797B, $CECECE, $7B797B, $CFCFCF, $7B797B, $CFCFCF, $7B797B
Data $CDCDCD, $434343, $434343, $CCCCCC, $C9C9C9, $CECECE, $CDCDCD, $CDCDCD
Data $7B797B, $D0D0D0, $7B797B, $CECECE, $7B797B, $CFCFCF, $7B797B, $CFCFCF
Data $7B797B, $CDCDCD, $434343, $434343, $585858, $5A5A5A, $5D5D5D, $7B797B
Data $808080, $7B797B, $D0D0D0, $7B797B, $CECECE, $7B797B, $CFCFCF, $7B797B
Data $CFCFCF, $7B797B, $CDCDCD, $434343, $434343, $2C2929, $575757, $5A5A5A
Data $7B797B, $7C7C7C, $7B797B, $D0D0D0, $7B797B, $CECECE, $7B797B, $CFCFCF
Data $7B797B, $CFCFCF, $7B797B, $CDCDCD, $434343, $434343, $2C2929, $2C2929
Data $5A5A5A, $7B797B, $7D7D7D, $7B797B, $D0D0D0, $7B797B, $CECECE, $7B797B
Data $CFCFCF, $7B797B, $CFCFCF, $7B797B, $CDCDCD, $434343, $434343, $2C2929
Data $2C2929, $2C2929, $5D5E5E, $7E7E7E, $7B797B, $CFCFCF, $7B797B, $CDCDCD
Data $7B797B, $CECECE, $7B797B, $CECECE, $7B797B, $CDCDCD, $434343, $434343
Data $2C2929, $2C2929, $2C2929, $2C2929, $7B7B7B, $D2D2D2, $D3D3D3, $D1D1D1
Data $D1D1D1, $D0D0D0, $D2D2D2, $CFCFCF, $D1D1D1, $CCCCCC, $CCCCCC, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343

; Configuration
.BCF_WindowIcon04
Data 17
Data 17
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $898989, $DFDBDB, $A6ADAF, $607B8B, $A9A8A6, $CBCAC7
Data $BAB7BD, $7B8470, $576945, $96949B, $9F9FA0, $828486, $615B3B, $585238
Data $707279, $434343, $434343, $B1AEAE, $C5CDCB, $4DB5CE, $0097EF, $004AB8
Data $A5A5B4, $9AAC88, $60C711, $21AC00, $335F00, $8E8A9A, $999454, $E9C200
Data $E09000, $765515, $434343, $434343, $AFADAD, $90BFBE, $7CEBFE, $11B7FF
Data $004DF8, $425491, $ACCD87, $A0FF56, $39D000, $0A6600, $5A5C56, $D4D079
Data $FFE926, $FFB800, $B26216, $434343, $434343, $B2B0AF, $9CBBBA, $68DCF4
Data $10B8FF, $0045E8, $666F9A, $9DBE7B, $8EFB3C, $38D000, $0E5D00, $6C6A70
Data $C4BD63, $FFEB1D, $FFB700, $9C5A16, $434343, $434343, $B6B6B6, $E8E3E2
Data $53A0B4, $007BC7, $2D5F9C, $C8C4C5, $A6ACA2, $4D9C0E, $188700, $5A6C44
Data $9F9CA9, $817E5A, $B79600, $A96C00, $665A43, $434343, $434343, $B4B4B4
Data $FFFFFF, $E5E2E2, $BBBFC2, $DCD6D0, $DCDCDA, $CDCACE, $A6A5A8, $8E908D
Data $A8A5AC, $A0A2A0, $8E8E94, $706F6A, $66696A, $76797E, $434343, $434343
Data $B6B6B6, $FAFAFA, $C1C1C1, $A8A5A5, $A2A0A0, $A2A2A2, $BEBFBE, $C4C2C5
Data $B7B5B8, $A8A8A8, $9F9F9F, $969696, $8D8E90, $848587, $7B7B7B, $434343
Data $434343, $A6A6A6, $949494, $6C6C6C, $878787, $A2A2A2, $A0A0A0, $8A8A8A
Data $B4B4B4, $B4B4BD, $A0A0AC, $9797A3, $8D8D99, $82828E, $787884, $747680
Data $434343, $434343, $8E8E8E, $7E7E7E, $858585, $8D8D8D, $888888, $BABABA
Data $BBBBBB, $8B8B90, $A0A070, $A9A965, $A6A669, $A2A263, $9D9C60, $9A9959
Data $82824D, $434343, $434343, $B2B2B2, $F5F5F5, $E9E9E9, $E2E2E2, $A0A0A0
Data $A9A9A9, $E5E5E5, $909096, $B7A800, $FFF859, $FFF466, $FFF465, $FFF468
Data $FFFA69, $D5C52A, $434343, $434343, $B5B5B5, $FDFDFD, $F2F2F2, $ECECEC
Data $ACACAC, $A9A9A9, $E3E3E3, $9A9CA2, $B78D00, $FFD900, $FFD301, $FFD300
Data $FFD301, $FFD602, $D7B016, $434343, $434343, $B5B5B5, $FDFDFD, $EFEFEF
Data $E8E8E8, $A5A5A5, $A8A8A8, $E5E5E5, $888D94, $A95D00, $FFA200, $FF9F00
Data $FF9F00, $FF9F00, $FFA300, $D28616, $434343, $434343, $929292, $919191
Data $919191, $919191, $7E7E7E, $B4B4B4, $CACACA, $878B90, $916820, $AC5C00
Data $A85D00, $A55A00, $A25700, $A25400, $875216, $434343, $434343, $9B9B9B
Data $767676, $6D6D6D, $8D8D8D, $A8A8A8, $B5B5B5, $8A8A8A, $A3A3A3, $AFB4BD
Data $999FA9, $9197A2, $878D97, $7C828D, $737984, $71767E, $434343, $434343
Data $ACACAC, $DFDFDF, $8A8A8A, $7E7E7E, $878787, $828282, $A8A8A8, $BABABA
Data $ADADAD, $A4A4A5, $9D9D9F, $949495, $8A8A8C, $828284, $7C7C7D, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343

; Carres couleur
.BCF_WindowIcon05
Data 17
Data 17
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $592E2E, $C63818, $CF401A, $CF291C, $D11D1D, $D31D1D
Data $CF2020, $3D3838, $2B80A6, $4EB0D9, $3F99D8, $2E88DA, $2779DB, $2264E1
Data $3950AE, $434343, $434343, $E6620D, $FFD8AC, $FFCEAD, $FF8858, $FF4A14
Data $FF1A00, $FF0000, $710F1F, $90FFFF, $EDFFFF, $A7F0FF, $67CCFF, $36ADFF
Data $0F8EFF, $146CED, $434343, $434343, $E48C43, $FFFFFD, $FFEAD8, $FF9F77
Data $FF5A29, $FF2700, $FF0000, $812633, $C4FFFF, $FFFFFF, $B4F7FF, $71D1FF
Data $3DB2FF, $1495FF, $1877EB, $434343, $434343, $E4873F, $FFFFF2, $FFE3CE
Data $FF9A71, $FF5724, $FF2600, $FF0000, $802231, $BCFFFF, $FFFFFF, $B1F5FF
Data $6FD0FF, $3BB1FF, $1293FF, $1875EB, $434343, $434343, $E48741, $FFFFF2
Data $FFE3CE, $FF9A71, $FF5724, $FF2600, $FF0000, $802231, $BEFFFF, $FFFFFF
Data $B1F5FF, $6FD0FF, $3BB1FF, $1293FF, $1875EB, $434343, $434343, $E48B43
Data $FFFFFF, $FFEDDA, $FFA279, $FF5D29, $FF2B00, $FF0000, $7E2233, $C6FFFF
Data $FFFFFF, $BEFCFF, $77D6FF, $41B6FF, $1596FF, $1878EB, $434343, $434343
Data $E4570E, $FFBA9B, $FFB19F, $FF6F4F, $FF330D, $FF0300, $FF0000, $6E0A24
Data $41EBFF, $9BF2FF, $65CEFF, $33ADFF, $0C92FF, $0074FF, $185CEB, $434343
Data $434343, $6C5C0E, $6A6100, $776A00, $745500, $713D00, $6E2700, $6E0300
Data $5A391C, $3E9043, $589A34, $5A8638, $587331, $57642C, $524F2C, $3F3737
Data $434343, $434343, $51DF0E, $B2FF76, $BEFF83, $92FF3B, $6CFA02, $52EA00
Data $21C100, $629800, $FFFF2F, $FFFF83, $FFFF41, $FFFA00, $FFE700, $FFD100
Data $EBA318, $434343, $434343, $8BE43E, $FFFFFF, $FFFFDE, $C6FF7C, $95FC2B
Data $73EB00, $3DC400, $7EB200, $FFFFC8, $FFFFFF, $FFFF9D, $FFFF48, $FFF003
Data $FFDE00, $EBB718, $434343, $434343, $8BE442, $FFFFF4, $F7FFCE, $BFFF71
Data $90FA24, $6FEA00, $39C100, $7CB100, $FFFFBF, $FFFFF5, $FFFF90, $FFFF3E
Data $FFED00, $FFDB00, $EBB518, $434343, $434343, $89E43F, $FFFFF2, $F7FFCE
Data $BFFF71, $90F924, $6FEA00, $39C100, $7CB100, $FFFFBE, $FFFFF5, $FFFF90
Data $FFFF3E, $FFED00, $FFDB00, $EBB518, $434343, $434343, $8CE444, $FFFFFC
Data $FAFFD5, $C1FF77, $92FC27, $6FEB00, $3DC300, $7EB200, $FFFFC6, $FFFFFC
Data $FFFF95, $FFFF43, $FFED00, $FFDD00, $EBB718, $434343, $434343, $6BE613
Data $F0FFC4, $EDFFBE, $B9FF64, $8BFA17, $6CEA00, $38BE00, $6EA000, $FFFF7E
Data $FFFFDA, $FFFF81, $FFFF33, $FFED00, $FFDA00, $EDB214, $434343, $434343
Data $56A320, $64D113, $70C728, $61BA15, $55AC16, $4CA017, $3B8818, $6A7F19
Data $D2C61A, $E1D32E, $E0C521, $E1B81D, $E2AC1E, $E39B18, $B57631, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343

; Applications
.BCF_WindowIcon06
Data 17
Data 17
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $555555, $525252, $635736, $594F34, $606060, $636363
Data $8B6E31, $E9AA2F, $B27A1D, $5C5750, $7C7C7C, $808080, $848484, $868787
Data $898989, $434343, $434343, $4F4F4F, $695E3A, $FFED9F, $F5D97F, $554D3B
Data $535353, $9A7B37, $FFD74F, $FDB62D, $5D513F, $7C7C7C, $7D7D7D, $737372
Data $858685, $898989, $434343, $434343, $494948, $A7985B, $FFFDC5, $FFEFAA
Data $DDBE64, $B98D30, $F4BD44, $FFC84B, $FFB62E, $9F6314, $595551, $5E5345
Data $9E5912, $6B6866, $898989, $434343, $434343, $555555, $4B4A48, $C7B88A
Data $FFEDA7, $FFE48A, $FFDE70, $FFD15C, $FFC548, $FFBA35, $FFA91A, $D87F0C
Data $DB8110, $FF930A, $965519, $757474, $434343, $434343, $555555, $575757
Data $635D4A, $FFEA9A, $FFE189, $FFD971, $FCCC5C, $F5BC43, $F7B334, $FEB029
Data $FFA71A, $FF9C11, $FF9009, $CD6405, $696562, $434343, $434343, $46443C
Data $42423E, $897A4B, $FFF09F, $FFE187, $F7D06C, $DAAF29, $E8B806, $E3B309
Data $DE9E19, $FBA11C, $FF9B11, $EE7C05, $5E544C, $898989, $434343, $434343
Data $EBDC9D, $F2E0A7, $F9E49F, $FFE99F, $FFE088, $DFB944, $EDBD00, $D2A80C
Data $D0A70B, $E4B800, $E19810, $FF9911, $F27C04, $5F544A, $838383, $434343
Data $434343, $EFE7BF, $FFFFEE, $FFF4BF, $FFE79D, $F9DA85, $DEB629, $D9AC01
Data $59554C, $635F56, $C7A20F, $E3AB04, $F99210, $FF8A07, $C86409, $9A4F15
Data $434343, $434343, $B1A471, $EDDDA6, $F7E29B, $FFE89C, $FEDD85, $E0B835
Data $D9AC00, $58544B, $666663, $B2911A, $E6B201, $F5900F, $FF8B09, $FF8503
Data $FF7A00, $434343, $434343, $484847, $464645, $61583E, $FFE086, $FFE286
Data $EAC359, $E1B407, $C59F0C, $A88A1B, $E7BC01, $DEA108, $FB9210, $FF8907
Data $E97104, $E06200, $434343, $434343, $555555, $575757, $4C4C4C, $BDA45D
Data $FFE583, $FFD56B, $E7B842, $DCAD0F, $DFB003, $D9A20C, $EF9915, $FF980F
Data $EE7903, $5E5147, $6F6F6E, $434343, $434343, $555555, $575757, $585347
Data $EBD184, $FFE080, $FFD869, $FFCF57, $F7BA40, $F1AC2D, $F9A623, $FFA318
Data $FF980E, $E77603, $605853, $898989, $434343, $434343, $555555, $515151
Data $9B8A4F, $FFF399, $FFE17E, $ECBB48, $F3B838, $FFC23D, $FFB730, $FFA91F
Data $FA9710, $FA910C, $FF8E07, $BB5C08, $6D6B6A, $434343, $434343, $555555
Data $575757, $494742, $BC9F51, $DCB14B, $4E4739, $534835, $D59827, $FFBF32
Data $F09613, $604A31, $78542A, $F78005, $875020, $777777, $434343, $434343
Data $555555, $575757, $5A5A5A, $4D4C49, $4D4A42, $666666, $666666, $8B6526
Data $FEAE25, $CA7C0F, $666564, $777777, $60554B, $777776, $898989, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343, $434343, $434343, $434343, $434343, $434343, $434343, $434343
Data $434343

; ----------------------------------------
; Datas Raw des icones divers
; ----------------------------------------
.BCF_IconFolder
Data 15
Data 15
Data $000000, $000000, $000000, $CC9934, $CB9833, $C99631, $C7942F, $C5922D
Data $C28F2A, $C08D28, $BD8A25, $BD8A25, $BA8722, $000000, $000000, $000000
Data $000000, $CC9934, $FFFFFF, $FFF791, $FFEB85, $FFE07B, $FFD46F, $FFCC67
Data $FFCC67, $FFCC67, $FFCC67, $FFCC67, $B5821D, $000000, $000000, $CC9934
Data $FFFFFF, $FFFF99, $FFF48E, $FFE681, $C5922D, $CC9934, $CB9833, $C5922D
Data $BF8C27, $BF8C27, $B88520, $B3811B, $000000, $000000, $CB9833, $FFFFFF
Data $FFFF99, $FFF48E, $C5922D, $FFFFFF, $FFFF99, $FFFF99, $FFFF99, $FFFF99
Data $FFFF99, $FFFF99, $B07E18, $000000, $000000, $C99631, $FFFFFF, $FFFF99
Data $FFF48E, $C5922D, $FFFFFF, $FFFF99, $FFF791, $FFEB85, $FFE07B, $FFE07B
Data $FFD46F, $AE7C16, $000000, $000000, $C7942F, $FFFFFF, $FFFF99, $FFF48E
Data $C5922D, $FFFFFF, $FFFF99, $FFF791, $FFEB85, $FFE07B, $FFE07B, $FFD46F
Data $AB7913, $000000, $000000, $000000, $C28F2A, $FFFFFF, $FFF48E, $C5922D
Data $FFFFFF, $FFFF99, $FFF791, $FFEB85, $FFE07B, $FFE07B, $FFD46F, $A87610
Data $000000, $000000, $000000, $000000, $BD8A25, $FFFFFF, $C5922D, $FFFFFF
Data $FFFF99, $FFF791, $FFEB85, $FFE07B, $FFE07B, $FFD46F, $A5730D, $000000
Data $000000, $000000, $000000, $BA8722, $FFFFFF, $C5922D, $FFFFFF, $FFFF99
Data $FFF791, $FFEB85, $FFE07B, $FFE07B, $FFD46F, $A3710B, $000000, $000000
Data $000000, $000000, $B7841F, $FFFFFF, $C08D28, $FFFFFF, $FFFF99, $FFF791
Data $FFEB85, $FFE07B, $FFE07B, $FFD46F, $A06E08, $000000, $000000, $000000
Data $000000, $B5821D, $FFFFFF, $BC8924, $FFFFFF, $FFFF99, $FFF791, $FFEB85
Data $FFE07B, $FFE07B, $FFD46F, $9E6C06, $000000, $000000, $000000, $000000
Data $B3811B, $FFFFFF, $B88520, $FFFFFF, $FFFF99, $FFF791, $FFEB85, $FFE07B
Data $FFE07B, $FFD46F, $9C6A04, $000000, $000000, $000000, $000000, $B07E18
Data $AE7C16, $B4811C, $FFE681, $F8C560, $EFBC57, $E6B34E, $DCA944, $DCA944
Data $D3A03B, $9A6802, $000000, $000000, $000000, $000000, $000000, $000000
Data $B3811B, $FFFFFF, $FFFF99, $FFFF99, $FFFF99, $FFFF99, $FFFF99, $FFFF99
Data $996701, $000000, $000000, $000000, $000000, $000000, $000000, $B3811B
Data $A3710B, $A06E08, $9E6C06, $9C6A04, $9A6802, $9A6802, $996701, $000000
Data $000000




.BCF_IconFile
Data 15
Data 15
Data $A7A1A6, $B39799, $B1B0B4, $CBCCCF, $CBCCCF, $CACBCE, $CACBCE, $CBCCCF
Data $CECFD2, $CECFD2, $CACBCE, $CACBCE, $CACBCE, $D2D3D5, $989BA2, $CEB8BA
Data $EAA6A6, $EADDDD, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $A2A4A9, $C8AEB1, $EA9F9F
Data $EAD3D3, $FBFAFC, $F5F6F6, $F8F8F8, $F9F9F9, $E7E7E7, $D7D7D7, $F6F6F6
Data $F7F7F7, $F7F7F7, $F3F3F3, $F7F7F7, $A1A3A9, $C8B1B5, $EAA0A0, $EACFCF
Data $EEEDEE, $B7B8B9, $B1B1B1, $E4E4E4, $C0C0C0, $BABABA, $DCDCDC, $D8D8D8
Data $B2B2B2, $B9B9B9, $F3F3F3, $A1A3A9, $C8A0A3, $EA4F4F, $EACBCB, $F9F9FA
Data $F6F7F6, $E9E9E9, $F4F4F4, $E0E0E0, $CECECE, $F0F0F0, $F5F5F5, $EFEFEF
Data $E7E7E7, $F6F6F6, $A1A3A9, $C8868A, $EA1818, $EACFD1, $F8F7F9, $F9FAF9
Data $FAFAFA, $F7F7F7, $FDFDFD, $FFFFFF, $F7F7F7, $F7F7F7, $F8F8F8, $F8F8F8
Data $F3F3F3, $A5A7AD, $C77B7E, $EA0000, $EACCCF, $F7F7F8, $F7F7F8, $F6F6F7
Data $F9F9F9, $E0E0E0, $D5D5D5, $F2F2F2, $EEEEEE, $EDEDED, $EBEBEB, $F5F5F5
Data $A4A6AC, $C77377, $EA0000, $E9C9CB, $F6F8F6, $FAF7F9, $F7F7F7, $F0F0F0
Data $BFBFBF, $BBBBBB, $DBDBDB, $D3D3D3, $B3B3B3, $B7B7B7, $F3F3F3, $A1A3A9
Data $C77276, $EA0000, $E7C4C4, $F7F8F6, $F6F3F6, $F4F4F4, $F8F8F8, $DFDFDF
Data $CFCFCF, $EFEFEF, $F3F3F3, $F0F0F0, $EAEAEA, $F3F3F3, $A2A4AA, $C77174
Data $EA0000, $E4C1C2, $F5F6F4, $FCFAFC, $F7F7F7, $F4F4F4, $F8F8F8, $F9F9F9
Data $F5F5F5, $EFEFEF, $F0F0F0, $F4F4F4, $F4F4F4, $9FA1A6, $C57174, $EA0000
Data $E1C0C0, $EFF0EE, $CAC7CA, $D5D5D6, $F3F3F3, $E2E2E2, $E3E3E3, $E7E7E7
Data $F1F1F1, $F1F1F1, $F1F1F1, $F7F7F7, $8D909B, $C57174, $EA0000, $E0C0C0
Data $D6DCDC, $C1BEBF, $BDBDBD, $ECECEC, $C5C5C5, $B5B5B5, $D6D6D6, $F5F5F5
Data $EFEFEF, $F1F1F1, $8A8E97, $000000, $C76F72, $EA0000, $E0C0C0, $F7F3F7
Data $D6D2D0, $DEDFDF, $F4F4F4, $F2F2F2, $EDEDED, $EFEFEF, $F4F4F4, $F4F4F4
Data $868991, $000000, $000000, $CF7D81, $EA0000, $EACCCC, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $8A8D94, $000000
Data $000000, $000000, $7B7A84, $786B72, $787A82, $999BA2, $999CA3, $999CA3
Data $999CA3, $9A9DA4, $989BA2, $999CA3, $888B94, $000000, $000000, $000000
Data $000000


.BCF_IconPicture
Data 15
Data 15
Data $A7A1A6, $B39799, $B1B0B4, $B0B3B6, $B0B1B5, $AFB0B4, $B1B4B8, $B3B7BE
Data $B1B4B8, $B1B3B6, $B0B1B5, $AFB0B4, $AFB0B4, $B8B9BB, $787B83, $CEB8BA
Data $EAA6A6, $EADDDD, $EAEAEA, $EAEAEA, $EAEAEA, $E4D3BF, $D4B38A, $D9D3CB
Data $E6E9EA, $E7E7E6, $E9E9E9, $EAEAEA, $EAEAEA, $83858B, $C8AEB1, $EA9F9F
Data $EAD3D3, $EAEAEA, $EAEAEA, $D5B596, $CA9A52, $E1C965, $B18E4D, $C0C1C8
Data $E0E0E0, $E0E0E0, $E2E2E2, $EAEAEA, $82848B, $C8B1B5, $EAA0A0, $EACFCF
Data $EAEAEA, $DECBB6, $C79A65, $907458, $D8BA64, $CDA340, $9F958E, $DFE2E8
Data $E1E1E1, $E2E2E2, $EAEAEA, $82848B, $C8A0A3, $EA4F4F, $EACBCB, $E7E8E6
Data $DBB992, $DEC099, $987B64, $D7B05D, $E9BA44, $A1783C, $BFC7D3, $E1E1E0
Data $E2E2E2, $EAEAEA, $82848B, $C8868A, $EA1818, $EACFD1, $E7D7C4, $B8AE9E
Data $8CC7D9, $CDB171, $E6BE61, $EAB541, $DC991A, $A5783D, $E4E8EA, $E2E2E2
Data $EAEAEA, $82848B, $C77B7E, $EA0000, $EACCCF, $DBBF9A, $BDC0B9, $67BDE4
Data $D8CF98, $EAB757, $EAA124, $E99611, $D67C2E, $9A8B73, $E0E4E9, $EAEAEA
Data $82848B, $C77377, $EA0000, $E9C9CB, $CFC1A4, $DCC7AC, $EAA76B, $EABB6F
Data $EAB658, $EA9609, $E49C39, $B090EA, $966F35, $D2D9E2, $EAEAEA, $82848B
Data $C77276, $EA0000, $E7C4C4, $D5CDBD, $D3B395, $EA9448, $E6A950, $EAB35D
Data $EA8E00, $E78700, $BE7092, $90662C, $CED5DF, $EAEAEA, $83858C, $C77174
Data $EA0000, $E4C1C2, $DEE3E1, $C7A47B, $E7B08A, $E7B367, $EAAD24, $DE941B
Data $57B41C, $A69100, $837769, $C1C5C9, $E8E8E7, $808287, $C57174, $EA0000
Data $E1C0C0, $E3EAEA, $C2AD9A, $CBAF7E, $EADDAD, $EAD626, $E0A743, $3BE35E
Data $739900, $D6DDE4, $E0E0E0, $C1C1C2, $6C6F7B, $C57174, $EA0000, $E0C0C0
Data $DEE6E6, $DDDFE6, $AE957B, $BA8434, $DC9500, $DD7300, $9B5F00, $774A03
Data $EAEAEA, $D5D5D5, $686D77, $000000, $C76F72, $EA0000, $E0C0C0, $DDE4E4
Data $DDDCDC, $D3D7DD, $A99E95, $97765B, $8E6D4A, $957971, $A0A1AC, $DEDEDE
Data $646770, $000000, $000000, $CF7D81, $EA0000, $EACCCC, $E9EAEA, $E4E6E6
Data $E9E9E8, $EAEAEA, $E4E8EA, $DEE4EA, $E8E9EA, $EAEAEA, $686C73, $000000
Data $000000, $000000, $7B7A84, $786B72, $787A82, $787C84, $797C84, $797B83
Data $797C84, $797C84, $7A7D84, $797D85, $7A7D85, $000000, $000000, $000000
Data $000000


.BCF_IconHtm
Data 15
Data 15
Data $BCC1CA, $BAC4D2, $CBCDD0, $CBCCCF, $CBCCCF, $CACBCE, $CACBCE, $CBCCCF
Data $CECFD2, $CECFD2, $CACBCE, $CACBCE, $CACBCE, $D2D3D5, $989BA2, $CCD7E8
Data $CDDEFD, $F2F7FF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $A2A4A9, $C6CFE1, $C3D3F1
Data $EBF1FB, $FFFFFF, $FFFFFF, $F9FBFD, $BDD6F4, $79A9EB, $669BE6, $A6C1EC
Data $EEF2F7, $FFFFFF, $FFFFFF, $FFFFFF, $A1A3A9, $C3CEE0, $B9CCF0, $EDF2FB
Data $FFFFFF, $E9F1FC, $64A1E7, $4E95E0, $266FD8, $0047CB, $0A50CD, $588BE0
Data $D0E1F5, $FFFFFF, $FFFFFF, $A1A3A9, $BCC9DF, $ADC5EE, $E9EFFA, $F4F8FB
Data $9DC4EE, $B1D2F0, $ABD0F1, $82B6EE, $0D5ACF, $3B7DD9, $BFE8F9, $CDEDFC
Data $E8F4F9, $FFFFFF, $A1A3A9, $A9BCDA, $79A1E0, $E6EDF8, $C4D8F8, $D4E6F1
Data $B9D5F4, $A5CBF0, $A2D0F2, $8BC2F0, $B3E1F9, $CDF3FF, $E4FBFF, $C8DFF5
Data $FFFFFF, $A5A7AD, $A2B7D7, $5B8CDB, $E6EDF8, $BAD2EF, $E1EBFB, $BCD6F4
Data $7FB0EA, $66A2E4, $ADDCF7, $C9EEFC, $D0F3FC, $E3FBFF, $C2D3F1, $FFFFFF
Data $A4A6AC, $9DB3D4, $578BDA, $E6EFFA, $BCD5F3, $E0EFFA, $ACCEF1, $74A9E6
Data $4889DE, $87BDEE, $BFE6F7, $D4F5FD, $E4FBFD, $D5E2F2, $FFFFFF, $A1A3A9
Data $99AFD1, $467ECF, $E2EBF8, $BED4F3, $DEEDF7, $AACDF1, $7DACE6, $4383DD
Data $1161D2, $326DD4, $A0C9EF, $E5FFFF, $DCE8F8, $FFFFFF, $A2A4AA, $93ACCF
Data $3775C8, $DCE5F2, $CADCF0, $D4E9F5, $A9CEF1, $77AAE7, $4487DE, $0855D4
Data $3D7DD8, $BAE0F4, $E1FBFD, $DFF5FA, $FFFFFF, $9FA1A6, $8FA9CE, $2D6DC5
Data $DBE5F0, $F5F7FD, $AECCF2, $ABCDEE, $7EAFE5, $3F7FDD, $4387DE, $8AC2EC
Data $A6D3F5, $D1EFFA, $E3EEF3, $FFFFFF, $8D909B, $8AA5CC, $2366C1, $DAE2ED
Data $FFFFFF, $EBF1F8, $75AAE8, $2B7FDD, $1068D4, $4A93E3, $3979DA, $76A6E6
Data $E4F0F8, $FEFEFE, $8A8E97, $000000, $84A1C8, $125CBB, $D7E0EC, $FFFFFF
Data $FFFFFF, $FAFBFB, $B8D1EF, $78A8E6, $8FB9E8, $BCD6F1, $F0F5FA, $FFFFFF
Data $868991, $000000, $000000, $95B0D7, $3678D1, $E2ECFA, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $8A8D94, $000000
Data $000000, $000000, $999DA7, $9197A0, $989BA2, $999BA2, $999CA3, $999CA3
Data $999CA3, $9A9DA4, $989BA2, $999CA3, $888B94, $000000, $000000, $000000
Data $000000


.BCF_IconSystem
Data 15
Data 15
Data $BCC1CA, $BAC4D2, $CBCDD0, $CBCCCF, $CBCCCF, $CACBCE, $CACBCE, $CBCCCF
Data $CECFD2, $CECFD2, $CACBCE, $CACBCE, $CACBCE, $D2D3D5, $989BA2, $CCD7E8
Data $CDDEFD, $F2F7FF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $A2A4A9, $C6CFE1, $C3D3F1
Data $EBF1FB, $FFFFFD, $FFFFFB, $FFFFF9, $68A4F6, $2C64CD, $BFD5E6, $FFFFFF
Data $FFFFFF, $FEFDF8, $F8F9FB, $FFFFFF, $A1A3A9, $C3CEE0, $B9CCF0, $EDF2FB
Data $FFFFFB, $4B94EB, $002DB1, $AEE5FF, $0F84DA, $1B65C0, $E5E7F6, $6899D7
Data $FFFFFC, $FCF8FA, $FFFFFF, $A1A3A9, $BCC9DF, $ADC5EE, $E9EFFA, $D9D6F7
Data $90C4F4, $AEF7FF, $86CDFE, $82C9FE, $1782E5, $6FC3FF, $0044C0, $78A1DE
Data $FFFFFF, $FFFFFF, $A1A3A9, $A9BCDA, $79A1E0, $E6EDF8, $4192E5, $AAE6FF
Data $317ACD, $C3D8F2, $CEEFFF, $9BE2FF, $ADE9FF, $004DCE, $FFF5F7, $FFFFFA
Data $FFFFFF, $A5A7AD, $A2B7D7, $5B8CDB, $E6EDF8, $E0F1FE, $4EA0DC, $0E399C
Data $FFFFFF, $FFFFFE, $D5EAFB, $84D9FE, $076FD5, $2D82D0, $B2CDEC, $FFFFFF
Data $A4A6AC, $9DB3D4, $578BDA, $E6EFFA, $9AD5FF, $4D90D4, $073DA0, $FFFFFF
Data $FFFCFA, $FFFFFB, $9CD4FE, $C0EDFF, $EEFFFF, $5AA3E7, $FFFFFF, $A1A3A9
Data $99AFD1, $467ECF, $E2EBF8, $C0DBF9, $6BB7F6, $002D9E, $91B5E9, $FFFFFF
Data $FFFFF0, $CBE7FA, $A4DAFF, $A2C7EC, $EDEDF4, $FFFFFF, $A2A4AA, $93ACCF
Data $3775C8, $DCE5F2, $FFFFFE, $8CC1FB, $2798E1, $155DC0, $87BFF8, $FBF1FB
Data $A9D8FB, $A7DFFF, $096DC8, $A8C7EC, $FFFFFF, $9FA1A6, $8FA9CE, $2D6DC5
Data $DBE5F0, $FFFFFC, $B8D0F5, $108EFE, $1491F0, $38AAFF, $33AEFD, $7DD1FA
Data $B0E4FF, $6FBAF4, $75A7DC, $FFFFFF, $8D909B, $8AA5CC, $2366C1, $DAE2ED
Data $FBF7FD, $FFFFF9, $FFFFEE, $419FF2, $0079FD, $59ABFD, $249FF1, $003EBC
Data $DDDDF7, $FFFFFF, $8A8E97, $000000, $84A1C8, $125CBB, $D7E0EC, $F7F5F4
Data $F2F8F9, $FCF8FB, $FFFBF5, $CDD2D6, $FAEAED, $4996EC, $F0E7EC, $FFFFFF
Data $868991, $000000, $000000, $95B0D7, $3678D1, $E2ECFA, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $8A8D94, $000000
Data $000000, $000000, $999DA7, $9197A0, $989BA2, $999BA2, $999CA3, $999CA3
Data $999CA3, $9A9DA4, $989BA2, $999CA3, $888B94, $000000, $000000, $000000
Data $000000


.BCF_IconExe
Data 15
Data 15
Data $BCC1CA, $BAC4D2, $CBCDD0, $CBCCCF, $CBCCCF, $CACBCE, $CACBCE, $CBCCCF
Data $CECFD2, $CECFD2, $CACBCE, $CACBCE, $CACBCE, $D2D3D5, $989BA2, $CCD7E8
Data $CDDEFD, $F2F7FF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $A2A4A9, $C6CFE1, $C3D3F1
Data $EBF1FB, $FFFFFF, $8492C8, $9DA4CE, $AAB1D3, $A9AFD2, $A9AFD3, $A9B1D3
Data $ACB4D5, $A5ADD4, $C0C7DD, $FFFFFF, $A1A3A9, $C3CEE0, $B9CCF0, $EDF2FB
Data $FFFFFF, $8691CC, $DBDBE9, $FFFFFF, $FFFFFE, $FFFFFE, $FFFFFD, $FFFEFC
Data $FFFFFE, $AAB2D0, $FFFFFF, $A1A3A9, $BCC9DF, $ADC5EE, $E9EFFA, $FFFFFF
Data $7B89CC, $CFD1E8, $FFFFFF, $FEFFFE, $FCFCFE, $F9F9FC, $F7F6F9, $F7F6FA
Data $ADB4D1, $FFFFFF, $A1A3A9, $A9BCDA, $79A1E0, $E6EDF8, $FFFFFF, $7281CC
Data $C9CCE8, $FFFFFE, $FCFCFD, $F9F9FB, $F5F5F8, $F3F2F6, $F3F3F7, $ACB2D0
Data $FFFFFF, $A5A7AD, $A2B7D7, $5B8CDB, $E6EDF8, $FFFFFF, $6B79CE, $C3C8E9
Data $FFFFFE, $FAFAFC, $F6F6FA, $F3F2F7, $F0EFF5, $EFF0F6, $ACB2D0, $FFFFFF
Data $A4A6AC, $9DB3D4, $578BDA, $E6EFFA, $FFFFFF, $6271CC, $BEC3E8, $FFFFFC
Data $F7F7FA, $F4F3F8, $F0EFF5, $EDECF3, $EDEDF4, $ABB1CC, $FFFFFF, $A1A3A9
Data $99AFD1, $467ECF, $E2EBF8, $FFFFFF, $596CCB, $B8BEE9, $FEFDFB, $F4F3F7
Data $F1F0F5, $ECEDF2, $E9E9F1, $EAE9F2, $AAAFC8, $FFFFFF, $A2A4AA, $93ACCF
Data $3775C8, $DCE5F2, $FFFFFF, $5065CC, $B3BBE9, $FDFBF9, $F2F1F6, $EDEDF3
Data $E9E9F0, $E5E6EF, $E8E8F0, $AAAFC5, $FFFFFF, $9FA1A6, $8FA9CE, $2D6DC5
Data $DBE5F0, $FFFFFF, $475DCE, $AEB7EA, $FBF8F7, $EEEEF5, $E9EAF3, $E6E6EE
Data $E2E3ED, $E7E6EF, $AAAFC3, $FFFFFF, $8D909B, $8AA5CC, $2366C1, $DAE2ED
Data $FFFFFF, $465DCB, $ACB6E7, $F8F7F3, $ECEBF0, $E9E8EF, $E6E6EE, $E5E5ED
Data $E4E4EC, $ADB1C2, $8A8E97, $000000, $84A1C8, $125CBB, $D7E0EC, $FFFFFF
Data $465DCB, $8492C8, $9DA4CE, $AAB1D3, $A9AFD2, $A9AFD3, $A9B1D3, $ACB4D5
Data $868991, $000000, $000000, $95B0D7, $3678D1, $E2ECFA, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $8A8D94, $000000
Data $000000, $000000, $999DA7, $9197A0, $989BA2, $999BA2, $999CA3, $999CA3
Data $999CA3, $9A9DA4, $989BA2, $999CA3, $888B94, $000000, $000000, $000000
Data $000000


.BCF_IconText
Data 15
Data 15
Data $A7A1A6, $B39799, $B1B0B4, $B0B3B6, $B0B1B5, $AFB0B4, $B1B4B8, $B3B7BE
Data $B1B4B8, $B1B3B6, $B0B1B5, $AFB0B4, $AFB0B4, $B8B9BB, $787B83, $CEB8BA
Data $EAA6A6, $EADDDD, $E9E9E9, $EAEAEA, $E9E9E9, $EAEAEA, $E9E9E9, $EAEAEA
Data $E9E9E9, $EAEAEA, $E9E9E9, $EAEAEA, $EAEAEA, $83858B, $C8AEB1, $EA9F9F
Data $EAD3D3, $494B54, $E2E2E2, $494B54, $E2E2E2, $494B54, $E2E2E2, $494B54
Data $E2E2E2, $494B54, $E2E2E2, $EAEAEA, $82848B, $C8B1B5, $EAA0A0, $EACFCF
Data $494B54, $E2E2E2, $E1E1E1, $E2E2E2, $494B54, $E2E2E2, $494B54, $E2E2E2
Data $494B54, $E2E2E2, $EAEAEA, $82848B, $C8A0A3, $EA4F4F, $EACBCB, $494B54
Data $E2E2E2, $494B54, $E2E2E2, $494B54, $E2E2E2, $494B54, $E2E2E2, $E1E1E1
Data $E2E2E2, $EAEAEA, $82848B, $C8868A, $EA1818, $EACFD1, $E1E1E1, $E2E2E2
Data $494B54, $E2E2E2, $E1E1E1, $E2E2E2, $E2E2E2, $E2E2E2, $494B54, $E2E2E2
Data $EAEAEA, $82848B, $C77B7E, $EA0000, $EACCCF, $E0E0E0, $E2E2E2, $494B54
Data $E2E2E2, $494B54, $E2E2E2, $494B54, $E2E2E2, $E1E1E1, $E2E2E2, $EAEAEA
Data $82848B, $C77377, $EA0000, $E9C9CB, $E1E1E1, $E2E2E2, $E1E1E1, $E2E2E2
Data $494B54, $E2E2E2, $494B54, $E2E2E2, $E0E0E0, $E2E2E2, $EAEAEA, $82848B
Data $C77276, $EA0000, $E7C4C4, $E0E0E0, $E2E2E2, $494B54, $E2E2E2, $494B54
Data $E2E2E2, $494B54, $E2E2E2, $E1E1E1, $E2E2E2, $EAEAEA, $83858C, $C77174
Data $EA0000, $E4C1C2, $E1E1E1, $E2E2E2, $E1E1E1, $E2E2E2, $E1E1E1, $E2E2E2
Data $E2E2E2, $E2E2E2, $E0E0E0, $E2E2E2, $E8E8E7, $808287, $C57174, $EA0000
Data $E1C0C0, $E0E0E0, $E2E2E2, $494B54, $E2E2E2, $494B54, $E2E2E2, $494B54
Data $E0E0E0, $E2E2E2, $E0E0E0, $C1C1C2, $6C6F7B, $C57174, $EA0000, $E0C0C0
Data $E1E1E1, $E2E2E2, $494B54, $E2E2E2, $E1E1E1, $E2E2E2, $E1E1E1, $E2E2E2
Data $EAEAEA, $D5D5D5, $686D77, $000000, $C76F72, $EA0000, $E0C0C0, $E1E1E0
Data $E2E2E2, $E1E1E0, $E2E2E2, $E1E1E0, $E2E2E2, $E1E1E0, $E2E2E2, $DEDEDE
Data $646770, $000000, $000000, $CF7D81, $EA0000, $EACCCC, $E9EAEA, $E4E6E6
Data $E9E9E8, $EAEAEA, $E4E8EA, $DEE4EA, $E8E9EA, $EAEAEA, $686C73, $000000
Data $000000, $000000, $7B7A84, $786B72, $787A82, $787C84, $797C84, $797B83
Data $797C84, $797C84, $7A7D84, $797D85, $7A7D85, $000000, $000000, $000000
Data $000000


.BCF_IconVideo
Data 15
Data 15
Data $BCC1CA, $BAC4D2, $CBCDD0, $CBCCCF, $CBCCCF, $CACBCE, $CACBCE, $CBCCCF
Data $CECFD2, $CECFD2, $CACBCE, $CACBCE, $CACBCE, $D2D3D5, $989BA2, $CCD7E8
Data $CDDEFD, $F2F7FF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $A2A4A9, $C6CFE1, $C3D3F1
Data $EBF1FB, $FBFBF9, $FFFFFF, $FFFFFF, $141414, $767676, $FFFFFF, $F5F5F5
Data $F1F1F1, $F7F7F7, $F9F9F9, $FFFFFF, $A1A3A9, $C3CEE0, $B9CCF0, $EDF2FB
Data $FFFFFF, $FFFFFF, $0F0D0B, $7B7B7E, $080300, $696A6B, $FFFFFF, $F9F7F7
Data $F2F2F2, $F9F9F9, $FFFFFF, $A1A3A9, $BCC9DF, $ADC5EE, $E9EFFA, $FFFFFF
Data $020200, $A6ADB5, $FFFFFF, $939CAE, $000000, $8E8E8D, $FFFFFF, $FBFBFB
Data $F6F6F6, $FFFFFF, $A1A3A9, $A9BCDA, $79A1E0, $E6EDF8, $464646, $ADB1AD
Data $FFFFFF, $E4F8FF, $C0CCDF, $585450, $000000, $A7A4A6, $FFFFFF, $FCFCFC
Data $FFFFFF, $A5A7AD, $A2B7D7, $5B8CDB, $E6EDF8, $2A2A2A, $FFFFFF, $ECFDFF
Data $AEB7BE, $B4B7B7, $FFFFFF, $6F777A, $000000, $B7B5B5, $FFFFFF, $FFFFFF
Data $A4A6AC, $9DB3D4, $578BDA, $E6EFFA, $9E9E9C, $464544, $FFFFFF, $BFC8CF
Data $FFFFFF, $FFFFFF, $A2A4AF, $655F5E, $1F2223, $D3D3D3, $FFFFFF, $A1A3A9
Data $99AFD1, $467ECF, $E2EBF8, $FFFFFF, $6C6A6C, $353030, $FFFFFF, $FFFFFF
Data $676F73, $A5AEB3, $FFFFFF, $BEBEBD, $515351, $FFFFFF, $A2A4AA, $93ACCF
Data $3775C8, $DCE5F2, $FAFCFC, $FFFFFF, $757674, $000000, $101518, $B8CAD4
Data $FFFFFF, $FFFFFF, $636262, $515151, $FFFFFF, $9FA1A6, $8FA9CE, $2D6DC5
Data $DBE5F0, $F2F2F6, $F9F9F9, $FFFFFF, $5E5E5C, $000000, $9EA8B1, $FFFFFF
Data $C3C1C5, $C9C7C6, $EEEEEE, $FFFFFF, $8D909B, $8AA5CC, $2366C1, $DAE2ED
Data $F3F2F3, $F1F1F1, $FAFCFC, $FFFFFF, $696965, $000000, $121513, $898885
Data $FFFFFF, $FFFFFF, $8A8E97, $000000, $84A1C8, $125CBB, $D7E0EC, $F3F3F1
Data $EDEDEE, $E2E2E2, $F9F9F9, $FFFFFF, $686666, $191919, $D5D5D5, $FFFFFF
Data $868991, $000000, $000000, $95B0D7, $3678D1, $E2ECFA, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $8A8D94, $000000
Data $000000, $000000, $999DA7, $9197A0, $989BA2, $999BA2, $999CA3, $999CA3
Data $999CA3, $9A9DA4, $989BA2, $999CA3, $888B94, $000000, $000000, $000000
Data $000000

.BCF_IconAudio
Data 15
Data 15
Data $BCC1CA, $BAC4D2, $CBCDD0, $CBCCCF, $CBCCCF, $CACBCE, $CACBCE, $CBCCCF
Data $CECFD2, $CECFD2, $CACBCE, $CACBCE, $CACBCE, $D2D3D5, $989BA2, $CCD7E8
Data $CDDEFD, $F2F7FF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $A2A4A9, $C6CFE1, $C3D3F1
Data $EBF1FB, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $B7BBB6
Data $617C55, $888A84, $B6B5B7, $FFFFFF, $A1A3A9, $C3CEE0, $B9CCF0, $EDF2FB
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $C5CEC5, $7CA574, $AAF684
Data $487319, $596050, $FFFFFF, $A1A3A9, $BCC9DF, $ADC5EE, $E9EFFA, $ECEDEA
Data $E8EBE4, $E8ECE3, $EAEEE4, $F0F1F0, $879689, $BFE4B5, $BBF999, $5B9914
Data $4A6224, $FFFFFF, $A1A3A9, $A9BCDA, $79A1E0, $E6EDF8, $6B7855, $5D7835
Data $587532, $577334, $5A7A36, $4F782B, $7CB860, $97DD73, $537330, $6E7168
Data $FFFFFF, $A5A7AD, $A2B7D7, $5B8CDB, $E6EDF8, $8CAD57, $78AA2F, $57762F
Data $6B7F53, $6D894D, $748D59, $617751, $46623B, $868687, $B8B6B9, $FFFFFF
Data $A4A6AC, $9DB3D4, $578BDA, $E6EFFA, $99BC60, $74A132, $98A587, $E9ECE6
Data $E7ECE3, $EDEEEC, $939C95, $5E844D, $737A6C, $A19FA2, $FFFFFF, $A1A3A9
Data $99AFD1, $467ECF, $E2EBF8, $8FB15A, $6D9630, $AEB9A1, $FFFFFF, $FFFFFF
Data $BDC5C0, $90B589, $AFF48A, $4E8017, $545F42, $FFFFFF, $A2A4AA, $93ACCF
Data $3775C8, $DCE5F2, $92B45D, $6D9931, $B0B8A6, $FFFFFF, $FFFFFF, $87948A
Data $C7E9C0, $C5FFA3, $5EA110, $46611B, $FFFFFF, $9FA1A6, $8FA9CE, $2D6DC5
Data $DBE5F0, $9BBF62, $7DB133, $798865, $AAAFA5, $B3B7AE, $6D8465, $B4E3A3
Data $C0FF9A, $559114, $495B2B, $FFFFFF, $8D909B, $8AA5CC, $2366C1, $DAE2ED
Data $76966C, $6B9A27, $507618, $4E7021, $4F7622, $4E7B21, $68A04A, $7EBD5C
Data $546C3C, $7D7E7B, $8A8E97, $000000, $84A1C8, $125CBB, $D7E0EC, $B5B6B5
Data $7A8570, $65744F, $65774F, $667B50, $697C54, $5F7152, $586A4E, $9F9F9E
Data $C4C4C5, $000000, $000000, $95B0D7, $3678D1, $E2ECFA, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $8A8D94, $000000
Data $000000, $000000, $999DA7, $9197A0, $989BA2, $999BA2, $999CA3, $999CA3
Data $999CA3, $9A9DA4, $989BA2, $999CA3, $888B94, $000000, $000000, $000000
Data $000000


.BCF_IconZip
Data 15
Data 15
Data $BCC1CA, $BAC4D2, $CBCDD0, $CBCCCF, $CBCCCF, $CACBCE, $CACBCE, $CBCCCF
Data $CECFD2, $CECFD2, $CACBCE, $CACBCE, $CACBCE, $D2D3D5, $989BA2, $CCD7E8
Data $CDDEFD, $F2F7FF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $A2A4A9, $C6CFE1, $C3D3F1
Data $EBF1FB, $978B8E, $5F5B6C, $C8CCD3, $8E93A0, $8E93A0, $C4C6CC, $9697A8
Data $B9BBBB, $B9BBBB, $DADCD7, $FFFFFF, $A1A3A9, $C3CEE0, $B9CCF0, $EDF2FB
Data $A2968B, $4D2C28, $DD6ACF, $AF7084, $88495D, $1839DD, $251396, $46F03F
Data $14BE0D, $1F5E05, $FFFFFF, $A1A3A9, $BCC9DF, $ADC5EE, $E9EFFA, $9B8D98
Data $6F700B, $DD6ACF, $AF7084, $88495D, $1839DD, $251396, $46F03F, $14BE0D
Data $496C01, $FFFFFF, $A1A3A9, $A9BCDA, $79A1E0, $E6EDF8, $9E8E93, $46282A
Data $DD6ACF, $AF7084, $88495D, $1839DD, $251396, $46F03F, $14BE0D, $1F5E05
Data $FFFFFF, $A5A7AD, $A2B7D7, $5B8CDB, $E6EDF8, $9E8E93, $46282A, $DD6ACF
Data $AF7084, $88495D, $1839DD, $251396, $46F03F, $14BE0D, $1F5E05, $FFFFFF
Data $A4A6AC, $9DB3D4, $578BDA, $E6EFFA, $9C8E93, $492B05, $76580B, $908D70
Data $696649, $49431F, $5E4315, $B89147, $865F15, $4B290A, $FFFFFF, $A1A3A9
Data $99AFD1, $467ECF, $E2EBF8, $9C8F96, $492636, $76580B, $908D70, $696649
Data $49431F, $5E4315, $B89147, $865F15, $4B290A, $FFFFFF, $A2A4AA, $93ACCF
Data $3775C8, $DCE5F2, $988A90, $432629, $E66BE2, $AB668E, $843F67, $1931C9
Data $1304A0, $39F735, $07C503, $116006, $FFFFFF, $9FA1A6, $8FA9CE, $2D6DC5
Data $DBE5F0, $9E9498, $3C1E22, $DD6ACF, $AF7084, $88495D, $1839DD, $251396
Data $46F03F, $14BE0D, $185D07, $FFFFFF, $8D909B, $8AA5CC, $2366C1, $DAE2ED
Data $FCFDFD, $EAF0EB, $DD6ACF, $AF7084, $88495D, $1839DD, $251396, $46F03F
Data $14BE0D, $1A5809, $8A8E97, $000000, $84A1C8, $125CBB, $D7E0EC, $F2F2F3
Data $FDFCFC, $C0C2BE, $C5C5C5, $C5C5C5, $C7C6CB, $C8C8CB, $C5CDC1, $CAD0C6
Data $868991, $000000, $000000, $95B0D7, $3678D1, $E2ECFA, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $8A8D94, $000000
Data $000000, $000000, $999DA7, $9197A0, $989BA2, $999BA2, $999CA3, $999CA3
Data $999CA3, $9A9DA4, $989BA2, $999CA3, $888B94, $000000, $000000, $000000
Data $000000

; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_SubMenuMark
Data 9
Data 14
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $002C00
Data $002C00, $002C00, $002C00, $002C00, $002C00, $002C00, $002C00, $002C00
Data $002C00, $002C00, $002C00, $000000, $000000, $002C00, $159E15, $0C8F0C
Data $25B125, $65D567, $C5F2C5, $A4FFA4, $5EF85E, $72DA72, $2FB82F, $30B930
Data $002C00, $000000, $000000, $000000, $003200, $0F950F, $21AB20, $5ED260
Data $C1F1C1, $A4FFA4, $5EF85E, $65D565, $39BF39, $002F00, $000000, $000000
Data $000000, $000000, $000000, $003B00, $26B126, $5ED25E, $BDF1C1, $A4FFA4
Data $5EF85E, $77DC77, $003500, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $004B00, $60D360, $C1F1C1, $A4FFA4, $5EF85E, $004000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $016301, $CAF2CA, $A4FFA4, $004D00, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $002C00, $002C00, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000

; --------------------------------------------------------------------------------------------------------------------------------------------------------------------

.BCF_MessageBoxIcon01
Data 35
Data 35
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $DFB220, $D7AD21, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $E3B621, $A28421, $736221, $C29D21, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $E3B621, $A38621, $796821, $A18A21
Data $7B6721, $C39D21, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $E3B621, $A48621
Data $706121, $FAD621, $FFEF21, $B19721, $766321, $C39D21, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $E2B521, $A48721, $706121, $F6D421, $FFE321, $FFDB21, $FFE921, $AF9521
Data $786521, $C19B21, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $E0B320, $A88B21, $6E6021, $F6D221, $FFE321, $FFDA21
Data $FFDB21, $FFDC21, $FFE821, $AE9521, $796521, $C29D21, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $DCB22D, $A98C27, $6E5E21, $F5D221
Data $FFE321, $FFDA21, $FFDB21, $FFDB21, $FFDB21, $FFDC21, $FFE821, $AA9221
Data $796621, $BF9A21, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $DBB238, $D6C58D
Data $796A36, $EECD21, $FFE421, $FFDA21, $FFDB21, $FFDB21, $FFDB21, $FFDA21
Data $FFDA21, $FFDD21, $FFE821, $AA9021, $7D6921, $C09B21, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $D4AC33, $E9D9A6, $CDC9B6, $F8D431, $FFE121, $FFDA21, $FFDB21, $FFDB21
Data $FFDA21, $FFE321, $FFE821, $FFE721, $FFE321, $FFDD21, $FFE621, $A48D21
Data $7D6821, $BD9921, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $D5AB33, $EBDBA8, $DAD8D0, $FFF4B3, $FFE53B, $FFD921
Data $FFDB21, $FFDB21, $FFDD21, $FFDD21, $AF9421, $847221, $AE9221, $E5C121
Data $FFE421, $FFE321, $FFE721, $A38C21, $816C21, $BC9921, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $D3AB33, $EEE0AE, $E1E0D7, $FFF6C1
Data $FFFDBD, $FFE457, $FFD921, $FFDB21, $FFDB21, $FFDE21, $FFDF21, $695A21
Data $212121, $212121, $2F2C21, $867221, $F7D221, $FFE521, $FFE621, $A18921
Data $816B21, $BB9821, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $D3AA33, $F1E3B4
Data $E8E8E3, $FFF8CB, $FFFEC0, $FFF9BD, $FFEE81, $FFD921, $FFDB21, $FFDB21
Data $FFDE21, $FFE021, $6B5C21, $212121, $212121, $212121, $212121, $5B4E21
Data $F8D021, $FFE321, $FFE621, $9C8621, $836E21, $B99721, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $CFA831, $F5E8BA, $EFEFED, $FFFBD6, $FFFFCC, $FFFCC1, $FFFCB8, $FFF6A5
Data $FFDE37, $FFDA21, $FFDB21, $FFDE21, $FFE021, $6B5C21, $212121, $212121
Data $212121, $212121, $212121, $6A5B21, $FFDC21, $FFE121, $FFE621, $9C8621
Data $836E21, $BA9721, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $CDA430, $F7E9BC, $F5F7F7, $FFFDDE, $FFFFD5, $FFFECC
Data $FFF8C1, $F6E9B6, $FFFAB3, $FFEE70, $FFD921, $FFDB21, $FFDE21, $FFE021
Data $6A5B21, $212121, $212121, $212121, $212121, $212121, $796821, $FFD821
Data $FFDE21, $FFDC21, $FFE521, $988321, $866F21, $B69421, $000000, $000000
Data $000000, $000000, $000000, $000000, $CCA42E, $F9ECC1, $FAFEFF, $FFFFE8
Data $FFFFDF, $FFFFD5, $FFFFCC, $EDE3C1, $B1B2B6, $CDC6AE, $FBEAA1, $FFE847
Data $FFDB21, $FFDE21, $FFDF21, $796521, $212121, $212121, $212121, $483F21
Data $BEA121, $FFE321, $FFDE21, $FFDB21, $FFDA21, $FFDF21, $FFE521, $988221
Data $887221, $B79421, $000000, $000000, $000000, $000000, $C69F2C, $FAEDC2
Data $FFFFFF, $FFFFF0, $FFFFE7, $FFFFDF, $FFFFD5, $FFFFCC, $D4D0C1, $B1B2B6
Data $A4A5AB, $A7A5A4, $D5C78B, $FFDB32, $FFDC21, $FFE621, $F7D721, $B49B21
Data $393421, $7E6C21, $F2D021, $FFE821, $FFDC21, $FFDB21, $FFDB21, $FFDB21
Data $FFDB21, $FFDE21, $FFE521, $937E21, $8A7221, $B49121, $000000, $000000
Data $C39E2F, $FBEDC3, $FFFFFF, $FFFFF8, $FFFFEF, $FFFFE7, $FFFFDF, $FFFFD5
Data $FFFBCC, $C8C6C1, $B4B5B6, $ACACAC, $9B9C9F, $898D9B, $BAAE7B, $FFE232
Data $9E8621, $7F6F21, $F8D321, $F6CE21, $FFDF21, $FFE321, $FFDA21, $FFDB21
Data $FFDB21, $FFDB21, $FFDB21, $FFDB21, $FFDA21, $FFDF21, $FFE421, $937E21
Data $967C21, $A98821, $000000, $EFD682, $FFFFFF, $FFFFFF, $FFFFF8, $FFFFF0
Data $FFFFE7, $FFFFDF, $FFFFD5, $FFF8CC, $C5C4C1, $B5B5B6, $ACACAC, $A0A0A0
Data $8B8D95, $C3BA8E, $F8E178, $3A3939, $212121, $A18921, $FFED21, $FFDC21
Data $FFDB21, $FFDB21, $FFDB21, $FFDB21, $FFDB21, $FFDB21, $FFDB21, $FFDB21
Data $FFDA21, $FFE321, $FFE321, $564B21, $C39F21, $000000, $D6AF3C, $FFF7DB
Data $FFFFFF, $FFFFF8, $FFFFF0, $FFFFE7, $FFFFDF, $FFFFD5, $FFFACC, $C7C6C1
Data $B4B5B6, $ACACAC, $9E9EA0, $858995, $B2AA8A, $FFEF83, $9A9274, $504D41
Data $D3B121, $FFE821, $FFE521, $FFDD21, $FFDA21, $FFDB21, $FFDB21, $FFDB21
Data $FFDB21, $FFDB21, $FFDA21, $FFDE21, $FFE521, $998321, $947B21, $A88A20
Data $000000, $000000, $D3AD3C, $FDF5D9, $FFFFFF, $FFFFEF, $FFFFE7, $FFFFDF
Data $FFFFD5, $FFFFCC, $D2CEC1, $B2B3B6, $A6A7AC, $9D9DA0, $B8B095, $EDDA8A
Data $FFF17E, $FFEB75, $FFEB6C, $EFD442, $776521, $BCA121, $FFE621, $FFE121
Data $FFDB21, $FFDB21, $FFDB21, $FFDB21, $FFDB21, $FFDD21, $FFE621, $998321
Data $877121, $B49120, $000000, $000000, $000000, $000000, $D9B13D, $FAF2D7
Data $FCFDFF, $FFFFE7, $FFFFDF, $FFFFD5, $FFFFCC, $E9E3C1, $AEB0B6, $BFBAAC
Data $EADCA0, $FFF595, $FFF58A, $FFEE7E, $FFF073, $BEAD69, $6C6861, $2F3039
Data $252421, $816E21, $F5CE21, $FFE821, $FFDC21, $FFDB21, $FFDA21, $FFDF21
Data $FFE621, $9D8521, $867021, $B59320, $000000, $000000, $000000, $000000
Data $000000, $000000, $D8B13E, $F8EED1, $F7F7F5, $FFFFDE, $FFFFD5, $FFFECC
Data $FFF7C1, $EDE2B6, $FFF6AC, $FFFAA0, $FFF495, $FFEF8A, $FFEF7E, $FFEF73
Data $918968, $4E5160, $545454, $2A2A2C, $212121, $413A21, $B89C21, $FFDB21
Data $FFDC21, $FFDC21, $FFE621, $9E8821, $836E21, $B59420, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $DCB441, $F5ECCE
Data $F1F0EB, $FFFED5, $FFFECC, $FFFBC1, $FFFCB6, $FFF8AC, $FFF4A0, $FFF295
Data $FFF08A, $FFEF7E, $FFEF73, $988E68, $54565D, $575757, $424242, $222221
Data $212121, $484021, $FFD621, $FFE221, $FFE621, $A28A21, $826C21, $BA9720
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $DEB73F, $EFE6C7, $EBEAE2, $FFFCCB, $FFFDC1, $FFF8B6
Data $FFF7AC, $FFF4A0, $FFF295, $FFF08A, $FFEF7E, $FFEF73, $988E68, $54565E
Data $555554, $4B4B4C, $25262D, $302D21, $CDAE21, $FFE521, $FFE721, $A28B21
Data $826D21, $B89720, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $DFB840, $ECE3C1
Data $E3E2D6, $FFF9C1, $FFFAB6, $FFF7AC, $FFF4A0, $FFF295, $FFF08A, $FFEF7E
Data $FFEF73, $948B68, $4D505E, $4A4C54, $3C404C, $585138, $CBAC21, $FFE821
Data $FFE821, $A58E21, $7E6A21, $BD9921, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $E0B83F, $E6DCB8, $DFDBCC, $FFF8B6, $FFF9AC, $FFF4A0
Data $FFF295, $FFF08A, $FFEF7E, $FFEE73, $A99B68, $706C5E, $857C54, $B8A34C
Data $FAD93F, $FFE724, $FFE921, $A89021, $7E6B21, $BE9821, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $E0B83F, $E2D7B1
Data $D8D3C0, $FFF6AB, $FFF7A0, $FFF295, $FFF08A, $FFED7E, $FFEC73, $FFE668
Data $FFE35E, $FFEA54, $FFED4B, $FFE642, $FFE928, $A99121, $7A6821, $BD9A21
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $E2BB40, $DCD0A9, $D2CDB5, $FFF59F, $FFF595, $FFEF8A
Data $FFED7E, $FFEC73, $FFEB68, $FFE95E, $FFE554, $FFE34B, $FFED43, $B0982C
Data $7B6721, $BF9B21, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $E3BB3D, $D5C9A0
Data $CDC5A7, $FFF294, $FFF38A, $FFED7E, $FFEC73, $FFE968, $FFE75E, $FFE554
Data $FFEE4B, $BBA744, $83702E, $BE9821, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $E4BB3F, $CFC397, $C6BF9B, $FFF18A, $FFF07E, $FFEB73
Data $FFE968, $FFE85E, $FFF054, $C3AD4C, $8E7D43, $C2A12A, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $E6BE3D, $C9BB8D
Data $C1B890, $FFEF7E, $FFEE73, $FFE968, $FFF15E, $C6B255, $94844C, $C2A230
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $E6BE3C, $C3B583, $BBB083, $FFED73, $FFF668, $CCB85F
Data $988A56, $C7A636, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $E7BE3A, $BCAE79
Data $B8AD79, $C9B869, $A39561, $C8A83B, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $E8BE38, $B5A56F, $9E946E, $CAAB40, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $E8BE36, $D7B33E
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000


.BCF_MessageBoxIcon02
Data 35
Data 35
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $013CAA, $033A99, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0036A5, $77A0D9, $B3CFF3, $0F4399, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $0035A4, $739DD7, $ABCBF0, $85B3EA
Data $ACCBF3, $0E4097, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0034A4, $719BD6
Data $B1CFF0, $1F76DE, $0E6CDD, $7AADE9, $ADCBF2, $0B3E94, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $0034A4, $6D98D6, $B3D0F0, $2278DF, $1C75DF, $2078E0, $136FDE, $7DAFE9
Data $ABCAF2, $0A3C91, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0033A3, $6995D4, $B5D1F1, $2379DF, $1C75DF, $2178E0
Data $2178E0, $2078E0, $1370DE, $81B1EA, $A8C7F1, $083A8E, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $053EA8, $6A96D5, $B6D2F1, $257ADF
Data $1B75DF, $2178E0, $2178E0, $2178E0, $2178E0, $2077E0, $1470DE, $84B3EA
Data $A5C6F0, $07378B, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $1046AA, $ACC3E5
Data $BBD5F2, $257ADF, $1B74DF, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0
Data $2178E0, $2077E0, $1470DD, $87B5EB, $A2C3F0, $053588, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $0F45A9, $B1C7E7, $E6F1FB, $2E80E0, $1973DF, $2178E0, $2178E0, $2178E0
Data $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2077E0, $1470DE, $8BB8EB
Data $9FC1EF, $043385, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0F44A9, $B2C6E7, $F5FAFE, $AECDF3, $3081E2, $1D76DF
Data $2078E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0
Data $2178E0, $2077E0, $1570DE, $8EBAEB, $9CBFEE, $033182, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $0F44A9, $B4C8E7, $F8FCFF, $BDD6F5
Data $B0CFF4, $468FE5, $0F6DDD, $1C75DF, $2178E0, $2178E0, $2178E0, $2178E0
Data $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $1F77E0, $1571DE, $92BBEC
Data $99BCED, $022F7F, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0E43A8, $B5C8E7
Data $FCFEFF, $C5DBF6, $B4D1F5, $BFD8F6, $B2D0F4, $B1D0F4, $73A9EB, $1872DE
Data $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0
Data $2178E0, $1F77E0, $1671DE, $95BDEC, $95BAEC, $002C7C, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $0E43A8, $B6C9E6, $FFFFFF, $CEE1F7, $C4DBF6, $E3EEFB, $FCFDFE, $FFFFFF
Data $FFFFFF, $99C1F0, $1470DE, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0
Data $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $1F77E0, $1671DE, $98BFED
Data $92B7EB, $002A79, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0D41A7, $B6C8E7, $FFFFFF, $D7E7F9, $D0E2F8, $F5F9FD
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $96BFF0, $1470DE, $2178E0, $2178E0
Data $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0, $2178E0
Data $2178E0, $1E77E0, $1772DE, $9BC2ED, $8EB5EA, $002976, $000000, $000000
Data $000000, $000000, $000000, $000000, $0C40A6, $B6C8E6, $FFFFFF, $E1EDFA
Data $D4E5F9, $F3F8FD, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $97C0F0
Data $126FDD, $2178E0, $2178E0, $2077E0, $1A74DF, $1872DF, $1772DF, $2077E0
Data $1F77E0, $1873DF, $1873DF, $1772DF, $1D75DF, $1F77E0, $1872DE, $9FC3EE
Data $8BB3E9, $002772, $000000, $000000, $000000, $000000, $0A3FA6, $B6C8E6
Data $FFFFFF, $E9F1FC, $DBE9FA, $E8F0FB, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FEFEFE, $CFE2F8, $8DBAEF, $297DE1, $1C75DF, $1A74DF, $1C75DF, $408AE4
Data $5698E7, $5698E7, $247AE0, $2B7EE1, $5195E6, $5095E6, $5397E6, $3886E3
Data $1E76DF, $1E76E0, $1973DE, $A1C5EE, $87B0E8, $002570, $000000, $000000
Data $0C45A9, $B5C6E5, $FFFFFF, $EFF5FC, $E5EFFB, $DDEBFA, $F5F9FD, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $DCE9FA, $90BBEF, $90BCEF, $74AAEB, $2379E0
Data $3785E2, $BFD8F6, $FAFCFE, $FFFFFF, $F1F7FD, $2D7FE1, $5095E6, $FFFFFF
Data $FFFFFF, $FFFFFF, $8FBBEF, $136FDE, $2178E0, $1E76E0, $1A74DE, $A2C6EE
Data $7DA9E6, $00296E, $000000, $698CCA, $FFFFFF, $F6FAFD, $EDF4FC, $E6F0FB
Data $DEEBFA, $F8FBFE, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $DAE8FA, $90BBEF
Data $88B6EE, $7EB1ED, $7DB0EC, $DBE9FA, $FFFFFF, $FFFFFF, $FFFFFF, $F1F6FD
Data $2C7FE1, $5095E6, $FFFFFF, $FFFFFF, $FFFFFF, $8FBBEF, $136FDE, $2178E0
Data $2178E0, $1A74E0, $2076DD, $DDECFA, $3672CC, $000000, $1B50AE, $D0DBEE
Data $FFFFFF, $EEF5FC, $E6F0FB, $DDEAFA, $F3F8FD, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FDFEFF, $D7E6F9, $BBD6F5, $BCD6F5, $EEF4FC, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $F1F7FD, $2D7FE2, $5195E6, $FFFFFF, $FFFFFF, $FFFFFF
Data $90BBEF, $136FDE, $2178E0, $1E76E0, $1972DE, $9DC3ED, $83ADE8, $002C73
Data $000000, $000000, $1C4EAD, $D1DDEF, $FFFFFF, $E7F0FB, $DBEAFA, $E6F0FB
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $F4F8FD, $CFE2F8, $2A7DE1, $4A91E6
Data $E8F1FB, $E5EFFB, $F0F6FC, $81B3ED, $1571DE, $1F76E0, $1772DE, $9CC1ED
Data $8DB4E9, $002876, $000000, $000000, $000000, $000000, $1C4FAE, $D1DDF0
Data $FFFFFF, $DEEBFA, $D5E6F9, $F4F8FD, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $D0E3F8, $4D93E6
Data $2178E0, $2078E0, $2379E0, $2C7FE1, $2C7FE1, $2C7FE1, $267BE0, $1E76E0
Data $1771DE, $99C0ED, $90B6EA, $002B7A, $000000, $000000, $000000, $000000
Data $000000, $000000, $1E4FAE, $D0DDF0, $FDFFFF, $D4E5F9, $D1E3F8, $F3F7FD
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $D1E3F8, $5F9EE8, $478FE5, $267BE0, $1F77E0, $2077E0, $1D76DF, $1D76DF
Data $1D76DF, $1D76DF, $1671DE, $96BEEC, $93B8EB, $002D7D, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $1E51AF, $D0DCF0
Data $FAFDFF, $CADFF7, $C3DAF6, $D6E6F9, $ECF3FC, $F7FAFE, $FBFCFE, $FAFCFE
Data $F6F9FD, $E2EDFB, $AACBF3, $64A0E9, $5798E7, $5397E7, $3E89E4, $1F77E0
Data $2178E0, $2178E0, $2178E0, $1F77E0, $1570DE, $92BCEC, $97BBEC, $012F80
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $1F51AF, $CFDCF0, $F6FAFE, $C2D9F6, $B4D1F5, $ADCDF3
Data $AACBF3, $A7C9F3, $9EC4F1, $8EBAEF, $78ADEC, $67A2EA, $63A0E9, $5B9BE8
Data $5195E7, $4990E5, $297DE1, $1F77E0, $2178E0, $2077E0, $1571DE, $90BAEB
Data $9ABDED, $023184, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $2053B0, $CEDBF0
Data $F1F7FD, $B9D3F5, $ADCDF3, $A3C7F2, $96BFF1, $8CB8EF, $82B3EE, $78ADEC
Data $6FA7EB, $65A1E9, $5A9BE8, $5195E7, $4A90E5, $3584E2, $1F77DF, $1F77E0
Data $1470DE, $8CB8EB, $9DC0ED, $043387, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $2053B0, $CCDAF0, $EBF4FD, $AECDF3, $A3C7F2, $99C1F1
Data $8FBAEF, $84B4EE, $79ADEC, $6FA7EB, $65A1E9, $5A9BE8, $5195E7, $4890E5
Data $3C89E3, $2178E0, $1470DE, $88B6EA, $A0C2EE, $05358A, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $1F53B1, $CAD9EF
Data $E6F0FB, $A2C6F1, $98C0F1, $8FBBEF, $84B4EE, $79ADEC, $6FA7EB, $65A1E9
Data $5A9BE8, $5195E7, $4890E5, $3E8AE4, $1873DE, $84B3E9, $A3C4EF, $06378D
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $1F54B1, $C7D8EF, $E0ECFA, $97BFF0, $8DBAEF, $84B4EE
Data $79ADEC, $6FA7EB, $65A1E9, $5A9BE8, $5195E7, $478FE5, $3483E2, $89B6EA
Data $A5C5F0, $073990, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $1F54B1, $C5D7EE
Data $DAE8F9, $8BB8EE, $83B3ED, $79ADEC, $6FA7EB, $65A1E9, $5A9BE8, $5095E7
Data $3D88E3, $92BCEC, $ABC9F1, $093C93, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $1E53B2, $C3D5EE, $D3E5F8, $80B2ED, $78ADEC, $6FA7EB
Data $65A1E9, $5A9BE8, $468EE5, $94BCED, $B7D2F4, $114397, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $1D53B2, $C1D4EE
Data $CCE0F6, $74AAEB, $6DA7EB, $65A1E9, $5094E6, $97BFED, $BDD6F6, $184A9C
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $1C53B2, $BFD3ED, $C6DCF5, $68A3EA, $5899E8, $9AC1EE
Data $C3DAF7, $1D4FA0, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $1A52B2, $BCD0EC
Data $BDD6F3, $A3C6EF, $C7DDF8, $2455A4, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $1951B2, $BBD1ED, $D5E6FB, $2A5AA7, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $1852B4, $2153A5
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000

.BCF_MessageBoxIcon03
Data 35
Data 35
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $016501, $046204, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $005E00, $519E51, $A0D1A0, $0E5F0E, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $005E00, $4D9C4D, $C1E1C1, $A6D5A6
Data $A7D7A7, $0B5D0B, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $005D00, $4A9A4A
Data $C6E3C6, $45AB45, $1D9B1D, $8DCB8D, $A9D7A9, $0A5A0A, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $005E00, $479847, $C7E4C7, $47AC47, $28A028, $30A430, $259F25, $90CB90
Data $A7D6A7, $085708, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $005D00, $449644, $C7E4C7, $49AD49, $28A028, $31A431
Data $31A431, $30A430, $269F26, $92CD92, $A4D5A4, $075607, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $006100, $469846, $C7E3C7, $4BAE4B
Data $28A028, $31A431, $31A431, $31A431, $31A431, $30A430, $269F26, $95CE95
Data $A2D4A2, $065406, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $016301, $86B986
Data $D1E9D1, $4BAE4B, $28A028, $32A432, $31A431, $31A431, $31A431, $31A431
Data $31A431, $30A430, $269F26, $97CF97, $9FD29F, $055205, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $016201, $8BBC8B, $F5FBF5, $55B355, $259F25, $31A431, $31A431, $31A431
Data $31A431, $31A431, $31A431, $31A431, $31A431, $2FA32F, $269F26, $9AD09A
Data $9CD19C, $045004, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $016101, $8CBC8C, $FAFEFA, $C2E4C2, $46AE46, $2CA22C
Data $31A431, $2EA22E, $2AA12A, $2CA22C, $30A430, $31A431, $31A431, $30A430
Data $30A330, $2FA32F, $1D9B1D, $92CD92, $9ACF9A, $034E03, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $016001, $8EBD8E, $FDFFFD, $CAE7CA
Data $B9E0B9, $66BB66, $28A028, $269F26, $3AA83A, $58B558, $47AE47, $28A028
Data $2FA32F, $31A431, $2CA22C, $32A432, $2DA22D, $76C276, $70C070, $9DD29D
Data $96CD96, $024C02, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $016001, $8FBE8F
Data $FFFFFF, $D2EBD2, $BDE1BD, $BBE1BB, $89CB89, $2BA12B, $8DCD8D, $F2F9F2
Data $FFFFFF, $FBFDFB, $A1D5A1, $2FA32F, $2AA12A, $A7D8A7, $C0E3C0, $34A534
Data $E1F1E1, $E3F3E3, $2CA12C, $9FD29F, $94CC94, $014901, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $005F00, $90BE90, $FFFFFF, $DAEEDA, $C6E5C6, $C0E3C0, $B7DFB7, $A4D7A4
Data $7DC57D, $B5DEB5, $A6D7A6, $AEDBAE, $DAEFDA, $FFFFFF, $9FD49F, $239D23
Data $D7EDD7, $E2F2E2, $92CE92, $C7E6C7, $82C882, $28A028, $289F28, $A3D5A3
Data $91CA91, $004800, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $005E00, $91BE91, $FFFFFF, $E1F1E1, $CFEACF, $C8E6C8
Data $BFE3BF, $B2DDB2, $AFDBAF, $97D197, $76C276, $76C276, $58B558, $32A532
Data $74C274, $EBF6EB, $3FAA3F, $B4DEB4, $F3FAF3, $C2E4C2, $FFFFFF, $6BBD6B
Data $28A028, $2EA32E, $29A029, $A6D5A6, $8FC98F, $004500, $000000, $000000
Data $000000, $000000, $000000, $000000, $005C00, $91BE91, $FFFFFF, $E8F5E8
Data $D8EED8, $D1EBD1, $C7E6C7, $BCE1BC, $C5E5C5, $E9F5E9, $FEFFFE, $FFFFFF
Data $FFFFFF, $FFFFFF, $DCEFDC, $5FB85F, $75C275, $63BA63, $97D197, $FFFFFF
Data $B4DEB4, $CEE9CE, $2EA32E, $30A330, $31A431, $2FA32F, $2AA02A, $A8D6A8
Data $8CC78C, $004400, $000000, $000000, $000000, $000000, $005C00, $91BD91
Data $FFFFFF, $EEF7EE, $E0F1E0, $DAEEDA, $D0EAD0, $C7E6C7, $E0F1E0, $FDFEFD
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $87CA87
Data $2CA22C, $83C883, $FFFFFF, $BBE0BB, $58B558, $2AA12A, $31A431, $31A431
Data $31A431, $2EA32E, $2BA12B, $AAD7AA, $89C589, $004200, $000000, $000000
Data $005B00, $91BD91, $FFFFFF, $F4FAF4, $E8F5E8, $E1F2E1, $D7EDD7, $D4ECD4
Data $EFF8EF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $F5FAF5, $49AF49, $64BB64, $FFFFFF, $DEF0DE, $31A431
Data $2FA32F, $31A431, $31A431, $31A431, $31A431, $2EA32E, $2CA12C, $ABD8AB
Data $80C180, $004400, $000000, $4C934C, $FFFFFF, $F9FDF9, $EFF8EF, $E9F5E9
Data $E5F3E5, $E6F4E6, $F8FCF8, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $CDE8CD, $5AB65A, $30A330, $3FAA3F
Data $F4FAF4, $FCFDFC, $4DB04D, $2CA22C, $31A431, $31A431, $31A431, $31A431
Data $31A431, $2BA22B, $30A130, $DFF2DF, $3D993D, $000000, $0D690D, $B7D4B7
Data $FFFFFF, $F1F9F1, $E8F5E8, $F3F9F3, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $C9E7C9, $6FBF6F
Data $AAD9AA, $52B352, $5EB85E, $D5ECD5, $FFFFFF, $60B960, $29A029, $31A431
Data $31A431, $31A431, $31A431, $2FA32F, $28A028, $A0D3A0, $8CC78C, $034E03
Data $000000, $000000, $0B660B, $B8D5B8, $FFFFFF, $EBF6EB, $E0F1E0, $E5F3E5
Data $F5FBF5, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF
Data $C2E4C2, $A0D5A0, $F9FCF9, $F0F8F0, $41AB41, $BBE1BB, $C0E3C0, $FFFFFF
Data $75C275, $279F27, $31A431, $31A431, $31A431, $2FA32F, $28A028, $A0D3A0
Data $94CB94, $004D00, $000000, $000000, $000000, $000000, $0D670D, $B7D5B7
Data $FFFFFF, $E4F3E4, $D7EDD7, $D1EAD1, $D6EDD6, $E5F3E5, $F0F8F0, $F6FBF6
Data $F4FAF4, $E4F3E4, $B2DDB2, $B4DEB4, $FAFDFA, $FFFFFF, $D2EBD2, $54B454
Data $ECF6EC, $B6DEB6, $FFFFFF, $8ECD8E, $259E25, $31A431, $31A431, $2FA42F
Data $279F27, $9DD19D, $98CD98, $024F02, $000000, $000000, $000000, $000000
Data $000000, $000000, $0D690D, $B7D5B7, $FFFFFF, $DCEFDC, $CFEACF, $C5E5C5
Data $BFE2BF, $C7E6C7, $BDE1BD, $B1DCB1, $AEDBAE, $D8EED8, $FFFFFF, $FFFFFF
Data $FFFFFF, $A3D6A3, $7DC57D, $FFFFFF, $A0D5A0, $FFFFFF, $BCE1BC, $29A129
Data $31A431, $2FA32F, $269F26, $9BD19B, $9ACE9A, $035103, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0E690E, $B6D5B6
Data $FFFFFF, $D4EBD4, $C6E5C6, $BFE2BF, $D5ECD5, $F6FBF6, $FEFFFE, $FFFFFF
Data $FFFFFF, $FFFFFF, $FFFFFF, $E0F1E0, $63B963, $A6D7A6, $FFFFFF, $65BB65
Data $A2D6A2, $90CE90, $34A634, $2EA32E, $269E26, $98CF98, $9DCF9D, $045204
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0E6B0E, $B5D4B5, $FDFFFD, $CBE7CB, $BDE2BD, $B2DDB2
Data $B8E0B8, $D1EBD1, $E5F3E5, $EDF7ED, $E8F4E8, $C6E6C6, $7AC47A, $5CB65C
Data $9BD39B, $D7EDD7, $34A534, $BAE0BA, $F1F9F1, $3CA93C, $239E23, $96CE96
Data $9FD19F, $055405, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0E6B0E, $B3D4B3
Data $F9FDF9, $C2E4C2, $B4DEB4, $A9D9A9, $9CD49C, $96D096, $90CE90, $84C884
Data $73C173, $6EBF6E, $68BC68, $5DB75D, $5CB75C, $42AB42, $52B252, $59B659
Data $249E24, $93CD93, $A2D3A2, $065706, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0E6B0E, $B1D3B1, $F6FBF6, $B9DFB9, $AAD9AA, $A2D6A2
Data $97D197, $8DCC8D, $83C883, $7AC47A, $70C070, $67BB67, $5EB85E, $54B454
Data $4CB04C, $2CA22C, $1D9B1D, $91CC91, $A5D4A5, $075807, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0F6D0F, $B0D2B0
Data $F2F9F2, $AFDBAF, $9FD59F, $98D198, $8ECD8E, $84C884, $7AC47A, $70C070
Data $67BB67, $5EB85E, $56B456, $4DB14D, $2BA12B, $8DCA8D, $A7D5A7, $095B09
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0E6D0E, $ADD1AD, $EDF7ED, $A4D6A4, $95D095, $8ECD8E
Data $84C884, $7AC47A, $70C070, $67BB67, $5EB85E, $55B455, $43AC43, $93CD93
Data $A8D6A8, $0A5D0A, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0E6D0E, $ABD0AB
Data $E8F5E8, $9AD29A, $8BCC8B, $84C884, $7AC47A, $70C070, $67BB67, $5EB85E
Data $4BB04B, $9CD19C, $AED9AE, $0B5E0B, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0D6D0D, $A7CFA7, $E4F2E4, $90CD90, $81C781, $7AC47A
Data $70C070, $67BB67, $54B354, $9DD29D, $B9DFB9, $136413, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0C6D0C, $A5CDA5
Data $DFF0DF, $85C885, $77C377, $70C070, $5DB75D, $A1D4A1, $BFE2BF, $196A19
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0C6D0C, $A3CCA3, $DAEEDA, $7BC47B, $64BA64, $A5D5A5
Data $C4E4C4, $1F6E1F, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0B6D0B, $A0CBA0
Data $D3EAD3, $B3DCB3, $C8E7C8, $247324, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $0A6C0A, $9ECB9E, $D2ECD2, $2A772A, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $0C6F0C, $186D18
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000

.BCF_FileRequesterIconHD
Data 50
Data 50
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $676669, $BAB7BE
Data $C8C7D0, $C2C1CB, $9B95A3, $66626C, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $B3B0BB
Data $BCC9C6, $68907B, $447E5C, $40895E, $60A47E, $91B5A8, $ACABBA, $59545F
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $D6D5DC, $ABBBB4, $114A25, $004413, $00541F, $015F24, $006F28, $098C39
Data $39AA65, $93B3AC, $4F4A56, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $A6A6C0, $B3B3CE, $B8B8D5, $A1A1B7
Data $7C7B8C, $9A99AD, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $9BB8A7, $B2BDB9, $073617, $003F17, $084F22, $095927, $0A622B
Data $0B6E30, $0A7733, $048A35, $17AD50, $88A8A4, $413B47, $000000, $000000
Data $000000, $000000, $000000, $000000, $FCFBFE, $E8E8EA, $FAFAFD, $FFFFFF
Data $FEFDFF, $BFBFC3, $414148, $818388, $8E9593, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $C8CECC, $173D26, $003010, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8138, $088F3A, $26B45F, $7D9C9B
Data $332F39, $000000, $000000, $000000, $000000, $FCFBFE, $FCFBFE, $F5F4F7
Data $F3F2F5, $F2F1F4, $F4F3F6, $F2F0F4, $4B6156, $09481F, $167B3D, $0F7C38
Data $0F7C38, $0F7C38, $0F7C38, $0E7C38, $0D7B37, $0D7B36, $0C7A36, $0B7A35
Data $0A7A35, $0A7A35, $0A7B35, $0A7C35, $0B7C36, $0B7D36, $0C7E37, $0C7F37
Data $0C7F37, $0C7F37, $0C7F37, $156F37, $7CAA8F, $819089, $002005, $053718
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0D8B3C
Data $08A643, $35BD71, $85859A, $000000, $000000, $000000, $FCFBFE, $F6F6FA
Data $EFEEF1, $EFEEF1, $EFEFF2, $EFEFF2, $EEEEF1, $F6F3F9, $C8D0CE, $1C5C34
Data $006823, $078035, $078035, $078035, $078035, $078136, $088336, $088437
Data $098538, $098739, $0A883A, $0A893A, $0A8A3B, $0A8A3B, $0A8A3A, $098A3A
Data $098A3A, $098A3A, $098A3A, $098A3A, $098A3A, $D9DCDE, $E5E4E8, $5F7468
Data $002106, $053718, $06441D, $084F22, $095927, $0A622B, $0B7030, $0C7B35
Data $0C8439, $0E8E3D, $0E9941, $11BF56, $6CA093, $36323F, $000000, $D9D8DF
Data $D9D8DF, $EBEBEF, $ECECF0, $ECECF1, $ECECF1, $ECECF1, $ECECF0, $EBEBEF
Data $F7F3FA, $BDCAC6, $3B7C55, $157339, $157339, $157339, $157339, $157539
Data $15763A, $15783A, $147A3B, $147C3C, $157E3C, $15803D, $16823F, $178340
Data $188440, $188441, $198542, $1A8643, $1A8643, $1A8643, $E6E5EB, $E4E2E8
Data $E7E4EA, $607469, $002207, $053718, $003D15, $004517, $004E1B, $005920
Data $036827, $05742D, $067E32, $088837, $0D953F, $0BB34C, $4AB481, $574F65
Data $000000, $D9D8DF, $D9D8DF, $E9E8EE, $E8E9EE, $E9E9EE, $E9E9EE, $E9E9EE
Data $E9E9EE, $E9E8ED, $E7E7ED, $EFECF3, $E6E5EB, $D5DADB, $CCD6D5, $D6DCDE
Data $DFE1E5, $E4E4EA, $EBE7EF, $F4ECF7, $F5EDF8, $F2ECF6, $F0EBF4, $ECE9F1
Data $EAE8EF, $EAE8EF, $E9E8EE, $E8E7ED, $E7E7EC, $E7E7EC, $E7E7EC, $E7E6EC
Data $E6E5EB, $DDDCE2, $E3E1E6, $5F7469, $002106, $053718, $456D57, $5A7D6D
Data $517665, $4A7462, $42725D, $3B6F5A, $356D57, $306B53, $15793F, $0A9D41
Data $2AB469, $545773, $A6A5AB, $E2E2EA, $E3E2E8, $E4E4EA, $E5E5EB, $E6E6EB
Data $E6E6EB, $E6E6EB, $E6E6EB, $E6E6EB, $E5E5EA, $E5E5EA, $E7E5EC, $E8E6ED
Data $E9E6EE, $E8E6ED, $E6E5EC, $E6E5EB, $E5E4EB, $E5E4EA, $E4E4E9, $E5E4EA
Data $E5E4EA, $E5E4EA, $E5E4EA, $E5E4EA, $E5E4EA, $E5E5EA, $E5E5EA, $E5E5EA
Data $E5E4EA, $E4E4EA, $E4E3E8, $DAD9DF, $E0DFE4, $5F7468, $002106, $08391A
Data $869992, $A4AAAF, $9198A0, $858D96, $757D8A, $67707F, $5C6576, $50586D
Data $1E6140, $078E39, $25B264, $515773, $B2B1B9, $E3E2EB, $E0DFE6, $E2E2E7
Data $E4E3E8, $E4E4E9, $E4E4EA, $E4E4EA, $E4E4EA, $E4E4EA, $E4E4E9, $E3E3E9
Data $E3E3E9, $E3E2E8, $E2E2E8, $E2E2E8, $E2E2E8, $E2E2E8, $E2E2E8, $E2E2E9
Data $E3E2E9, $E3E3E9, $E3E3E9, $E3E3E9, $E3E3E9, $E3E3E9, $E3E3E9, $E3E3E9
Data $E3E3E9, $E3E3E9, $E3E3E9, $E2E2E8, $E1E1E7, $D6D7DE, $DEDDE3, $5F7368
Data $002106, $07381A, $627E70, $788A85, $6A7C79, $627573, $566C6B, $4C6364
Data $445D5E, $3C5559, $185E39, $098B38, $25B164, $525873, $C2C1C9, $DEDDE6
Data $DEDDE4, $DFE0E6, $E1E1E7, $E1E2E8, $E2E2E8, $E2E2E8, $E2E2E8, $E2E2E8
Data $E2E2E8, $E2E2E8, $E1E1E7, $E1E1E7, $E1E1E7, $E1E1E7, $E1E1E7, $E1E1E7
Data $E1E1E7, $E1E1E7, $E1E1E7, $E1E1E7, $E1E1E7, $E1E1E8, $E1E1E8, $E1E1E8
Data $E1E1E8, $E1E1E8, $E1E1E7, $E1E0E7, $E1E1E7, $E0E0E6, $DFDFE6, $D5D4DC
Data $DDDCE2, $5F7368, $002106, $08381B, $798F87, $939D9F, $838C90, $778288
Data $69757E, $5C6A74, $53606C, $495564, $1C5A3C, $078937, $25B164, $525873
Data $C6C5CF, $D9D8E2, $DAD9E1, $DCDCE3, $DDDDE5, $DEDEE5, $DEDEE5, $DEDEE5
Data $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4
Data $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4, $DEDEE4
Data $DDDDE4, $DDDDE4, $DDDDE4, $DDDDE4, $DDDDE4, $DDDDE4, $DDDDE4, $DDDDE4
Data $DCDCE2, $D2D1D8, $DAD9E0, $5E7368, $002107, $063718, $6A8478, $8A9696
Data $798688, $6F7D80, $627176, $56676E, $4D5F67, $43555F, $185B38, $088A37
Data $25B164, $505772, $BFBEC9, $D5D4DF, $D6D6DF, $D8D8E1, $DBDBE2, $DBDBE1
Data $DBDBE1, $DBDBE1, $DBDBE1, $DBDBE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1
Data $DADAE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1
Data $DADAE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1, $DADAE1
Data $DADAE1, $DADAE1, $D8D8E0, $CECED6, $D8D6DE, $5E7367, $002106, $07381A
Data $688376, $81918E, $738281, $69797A, $5D6F71, $52666A, $495F63, $40565D
Data $195D39, $098A38, $24B064, $505772, $BDBBC7, $D2D2DD, $D3D3DC, $D6D5DE
Data $D8D8DF, $D8D8DF, $D8D8E0, $D8D8E0, $D8D8E0, $D8D8E0, $D8D8E0, $D8D8E0
Data $D8D8E0, $D8D8E0, $D7D7E0, $D8D8E0, $D8D8E0, $D8D8E0, $D8D8E0, $D8D8E0
Data $D7D7E0, $D7D7E0, $D7D7E0, $D7D7E0, $D7D7E0, $D7D7E0, $D7D7E0, $D7D7E0
Data $D7D7E0, $D7D7E0, $D7D7E0, $D7D7DF, $D6D6DF, $CCCBD4, $D7D5DD, $5D7267
Data $002106, $073819, $7E938B, $9EA6AA, $8C949A, $808991, $717A85, $636E7B
Data $596373, $4E576A, $1C5A3C, $078937, $24B064, $515773, $B8B7C4, $CFCEDB
Data $D0CFDB, $D4D3DD, $D5D5DE, $D5D5DE, $D5D5DE, $D5D5DE, $D5D5DE, $D5D5DE
Data $D5D5DE, $D5D5DD, $D5D5DD, $D5D5DD, $D5D5DD, $D5D5DD, $D5D5DD, $D5D5DD
Data $D5D5DD, $D5D5DD, $D5D5DD, $D5D5DD, $D5D5DD, $D5D5DD, $D5D5DD, $D4D4DD
Data $D4D4DD, $D4D4DD, $D4D4DD, $D4D4DD, $D4D4DD, $D4D4DD, $D3D2DC, $C9C8D2
Data $D5D2DB, $5D7267, $002106, $07381A, $7B9188, $99A1A4, $879195, $7C868D
Data $6D7882, $606C78, $56626F, $4B5668, $1C5B3C, $078937, $24B064, $525873
Data $B4B3C0, $CBCAD8, $CDCCD8, $D0D0DA, $D2D2DC, $D2D2DC, $D2D2DB, $D2D2DB
Data $D2D2DB, $D2D2DB, $D2D2DB, $D2D2DB, $D2D2DB, $D2D2DB, $D2D2DB, $D2D2DB
Data $D2D2DB, $D2D2DB, $D2D2DB, $D2D2DB, $D1D1DB, $D1D1DA, $D1D1DA, $D1D1DA
Data $D1D1DA, $D1D1DA, $D1D1DA, $D1D1DA, $D1D1DA, $D1D1DA, $D1D1DA, $D1D1DA
Data $D0CFD9, $C5C5CF, $D2D0D9, $5D7167, $002106, $07381A, $8C9E98, $AFB5BA
Data $9CA2AA, $8E95A0, $7D8593, $6E7687, $626A7E, $555C74, $1F5D40, $078A36
Data $24B063, $515772, $B0AEBC, $C7C6D4, $C9C9D4, $CCCCD7, $CECED8, $CECED8
Data $CECED8, $CECED8, $CECED7, $CECED7, $CECED7, $CECED8, $CECED8, $CECED8
Data $CECED8, $CECED8, $CECED8, $CECED8, $CECED8, $CECED8, $CECED8, $CECED8
Data $CECED8, $CECED8, $CDCDD8, $CDCDD8, $CDCDD8, $CDCDD8, $CDCDD8, $CDCDD8
Data $CDCDD8, $CDCDD8, $CCCCD7, $C2C1CC, $CECDD7, $5C7166, $002206, $073819
Data $6C867A, $869393, $778485, $6D7B7E, $606F74, $55666C, $4C5D65, $43545E
Data $195A39, $078937, $23B063, $505671, $ACABBB, $C3C2D0, $C5C5D2, $C9C9D4
Data $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5
Data $CBCBD6, $CBCBD6, $CBCBD6, $CBCBD6, $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5
Data $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $CACAD5, $CACAD5, $CACAD5
Data $CACAD5, $CBCBD5, $CACAD5, $CACAD5, $C9C9D4, $BFBDC9, $CDCBD5, $5C7166
Data $002106, $08381A, $82968E, $A0A7AB, $8E959C, $828A93, $727B87, $646E7C
Data $5A6373, $4E576B, $1D5B3D, $078936, $23B063, $515772, $A9A7B8, $C0BFCE
Data $C2C2D0, $C6C6D2, $C9C9D4, $C9C9D4, $C9C9D4, $C9C9D4, $C9C9D4, $C9C9D4
Data $C8C8D4, $C8C8D4, $C8C8D3, $C8C8D3, $C8C8D3, $C8C8D3, $C8C8D3, $C8C8D3
Data $C8C8D3, $C8C8D3, $C8C8D3, $C8C8D3, $C8C8D3, $C8C8D3, $C8C8D3, $C8C8D3
Data $C8C8D3, $C8C8D2, $C8C8D2, $C8C8D2, $C8C8D2, $C8C8D2, $C7C7D1, $BBBAC8
Data $CBC9D4, $5C7066, $002207, $063819, $688376, $82918F, $748382, $6A7A7B
Data $5D7072, $52666A, $4A5F64, $40565D, $195D39, $088A38, $24B063, $525773
Data $A4A3B3, $BCBBCB, $BFBECD, $C3C3CF, $C5C5D1, $C5C5D1, $C5C5D2, $C5C5D2
Data $C5C5D1, $C5C5D1, $C5C5D1, $C5C5D1, $C5C5D1, $C5C5D1, $C5C5D0, $C5C5D0
Data $C5C5D0, $C5C5D0, $C5C5D0, $C5C5D0, $C5C5D0, $C5C5D0, $C5C5D0, $C5C5D0
Data $C5C5D0, $C5C5D0, $C5C5D0, $C5C5D0, $C5C5D0, $C4C4D0, $C4C4D0, $C4C4D0
Data $C3C3CF, $B8B7C6, $C9C7D2, $5C7066, $002206, $07391A, $768E83, $919E9D
Data $818F90, $768588, $68797E, $5C6F75, $52666D, $485C67, $1C653F, $09913A
Data $24B163, $525773, $9F9FB1, $B7B7C8, $BBBAC9, $BFBFCD, $C2C2CF, $C2C2CF
Data $C2C2CE, $C2C2CE, $C2C2CE, $C1C1CD, $C1C1CD, $C1C1CD, $C1C1CE, $C1C1CE
Data $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE
Data $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE, $C1C1CE
Data $C1C1CE, $C1C1CE, $C0BFCD, $B3B3C2, $C6C4CF, $5B7065, $002308, $053718
Data $0D4523, $0F4A26, $0F4D27, $0F532A, $0F5D2D, $0E6530, $0E6B33, $0F7236
Data $0D833B, $0DA043, $24B566, $505571, $9C9AAD, $B5B3C5, $B7B7C7, $BCBBCA
Data $BFBFCC, $BFBFCC, $BFBFCB, $BFBFCB, $BFBFCB, $BFBFCB, $BEBECB, $BEBECB
Data $BEBECB, $BEBECB, $BFBFCC, $BEBECC, $BEBECC, $BEBECC, $BEBECB, $BEBECB
Data $BEBECB, $BEBECB, $BEBECB, $BEBECB, $BEBECB, $BEBECB, $BEBECB, $BEBECB
Data $BEBECB, $BEBECB, $BEBECB, $BEBECB, $BCBCCA, $B1B0BF, $C3C1CE, $5B6F65
Data $002308, $053718, $04421B, $054B1F, $065423, $075E27, $096B2D, $0A7632
Data $0A7F37, $0C893B, $0E9641, $0EA948, $24B867, $505572, $9997AA, $B1AFC3
Data $B5B4C5, $B9B9C7, $BCBCCA, $BCBCCA, $BCBCCA, $BCBCCA, $BCBCCA, $BCBCCA
Data $BCBCCA, $BCBCCA, $BCBCCA, $BCBCCA, $BCBCC9, $BCBCC9, $BCBCC9, $BCBCC9
Data $BCBCC9, $BBBBC8, $BBBBC8, $BBBBC8, $BBBBC8, $BBBBC8, $BBBBC8, $BBBBC8
Data $BBBBC8, $BBBBC8, $BBBBC8, $BBBBC8, $BBBBC9, $BBBBC9, $BABAC8, $AEADBD
Data $C2C0CC, $5A6F65, $002308, $053718, $06441D, $084F22, $095927, $0A622B
Data $0B6F30, $0C7B35, $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B867, $515672
Data $9593A7, $ADACC0, $B1B0C1, $B6B5C5, $B9B9C8, $B9B9C8, $B9B9C8, $B9B9C8
Data $B9B9C8, $B9B9C7, $B9B9C7, $B9B9C7, $B9B9C7, $B9B9C7, $B8B8C7, $B8B8C7
Data $B8B8C6, $B8B8C6, $B8B8C6, $B8B8C6, $B8B8C6, $B8B8C6, $B8B8C6, $B8B8C6
Data $B8B8C7, $B8B8C7, $B8B8C7, $B8B8C7, $B8B8C7, $B8B8C7, $B8B8C7, $B8B8C7
Data $B7B6C6, $AAA9BA, $BFBDCA, $5A6F64, $002308, $053718, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $515772, $918EA3, $A9A7BC, $ADACBF, $B2B1C2, $B5B5C4, $B5B5C4
Data $B5B5C4, $B5B5C4, $B5B5C4, $B5B5C4, $B5B5C4, $B5B5C3, $B5B5C3, $B5B5C3
Data $B5B5C4, $B5B5C4, $B5B5C4, $B5B5C4, $B5B5C4, $B5B5C4, $B4B4C4, $B4B4C4
Data $B4B4C4, $B4B4C4, $B4B4C3, $B4B4C3, $B4B4C3, $B4B4C3, $B4B4C3, $B4B4C3
Data $B4B4C3, $B4B4C3, $B2B2C2, $A7A6B7, $BDBBC8, $596E64, $002308, $053718
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $515772, $8C8AA0, $A5A3B9, $AAA9BC, $AFAEBF
Data $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1
Data $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C2, $B2B2C2, $B2B2C2, $B1B1C1
Data $B1B1C1, $B1B1C1, $B1B1C1, $B1B1C1, $B1B1C0, $B1B1C0, $B1B1C0, $B1B1C0
Data $B1B1C0, $B1B1C0, $B1B1C0, $B1B1C0, $B0B0BF, $A4A3B4, $BAB8C7, $596E64
Data $002308, $053718, $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35
Data $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515772, $89879D, $A2A0B7
Data $A6A5BA, $ABACBC, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0
Data $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFBF, $AFAFBF
Data $AFAFBF, $AFAFBF, $AFAFBF, $AFAFBE, $AFAFBE, $AFAFBE, $AFAFBF, $AFAFBF
Data $AFAFBF, $AFAFBF, $AFAFBF, $AFAFBF, $AEAEBF, $AEAEBF, $ADADBE, $A1A0B3
Data $B7B6C5, $596D63, $002308, $053718, $06441D, $084F22, $095927, $0A622B
Data $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515772
Data $86839A, $9E9CB5, $A3A2B7, $A9A8BB, $ADADBE, $ADADBE, $ADADBE, $ADADBE
Data $ADADBE, $ADADBE, $ADADBE, $ACACBE, $ACACBE, $ACACBE, $ACACBD, $ACACBD
Data $ACACBD, $ACACBD, $ACACBD, $ACACBD, $ACACBD, $ACACBD, $ACACBD, $ACACBD
Data $ACACBD, $ACACBD, $ACACBD, $ACACBD, $ACACBD, $ACACBD, $ACACBD, $ACACBD
Data $AAA9BC, $9E9DB0, $B6B4C3, $596D63, $002308, $053718, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $565C79, $817E97, $9A98B1, $9F9EB4, $A5A4B7, $A9A8BA, $A9A9BA
Data $A9A9BA, $A9A9BA, $A9A9BA, $A9A9BA, $A9A9BA, $A8A8BA, $A8A8BA, $A8A8BA
Data $A8A8BA, $A8A8BA, $A8A8BA, $A8A8BA, $A8A8BA, $A8A8BA, $A8A8BA, $A8A8BA
Data $A8A8BA, $A8A8BA, $A8A8BA, $A8A8BA, $A8A8BA, $A8A8B9, $A8A8B9, $A8A8B9
Data $A8A8B9, $A8A8B9, $A6A5B8, $9A99AD, $B3B1C1, $586D63, $002308, $053718
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $585E7C, $7D7A94, $9593AD, $9B9AB1, $A1A1B4
Data $A5A4B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7
Data $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B8
Data $A5A5B8, $A4A4B7, $A4A4B7, $A4A4B7, $A4A4B6, $A4A4B6, $A4A4B6, $A4A4B6
Data $A4A4B6, $A4A4B6, $A4A4B6, $A4A4B6, $A3A2B5, $9795AA, $AFAEBF, $586C62
Data $002308, $053718, $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35
Data $0C8439, $0E8D3D, $0F9A43, $0EAB49, $23B766, $575E7B, $797691, $928FAB
Data $9796AE, $9F9DB3, $A3A2B6, $A3A2B6, $A2A2B6, $A2A2B6, $A2A2B6, $A2A2B6
Data $A2A2B6, $A2A2B6, $A2A2B6, $A2A2B6, $A2A2B6, $A2A2B6, $A2A2B6, $A2A2B5
Data $A2A2B5, $A2A2B5, $A2A2B5, $A2A2B5, $A2A2B5, $A2A2B4, $A2A2B4, $A2A2B4
Data $A2A2B5, $A2A2B5, $A2A2B5, $A2A2B5, $A2A2B5, $A1A1B5, $A09FB4, $9492A8
Data $ADACBE, $576C62, $002308, $053718, $06441D, $084F22, $095927, $0A622B
Data $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49, $23B766, $575D7B
Data $77738E, $8F8CA8, $9594AC, $9B9BB1, $9F9FB4, $A0A0B4, $A0A0B4, $A0A0B4
Data $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3
Data $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3
Data $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3
Data $9C9CB1, $908FA6, $ACAABC, $576B62, $002308, $053718, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49
Data $23B766, $565C7A, $716E8A, $8A88A5, $9190A8, $9796AD, $9B9BB0, $9C9CB0
Data $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0
Data $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9B9BB0
Data $9B9BB0, $9B9BB0, $9B9BB0, $9B9BB0, $9B9BB0, $9B9BB0, $9B9BB0, $9B9BAF
Data $9B9BAF, $9B9BAF, $9898AE, $8C8BA2, $A9A7B9, $566B61, $002308, $053718
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D
Data $0F9A43, $0EAB49, $23B766, $555B79, $6D6988, $8685A2, $8D8CA5, $9392AA
Data $9898AD, $9999AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD
Data $9898AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD
Data $9898AD, $9898AE, $9898AE, $9898AD, $9898AD, $9898AD, $9898AC, $9898AC
Data $9898AC, $9898AC, $9898AC, $9797AC, $9595AB, $88889F, $A6A4B7, $566A61
Data $002308, $053718, $06441D, $084F22, $095927, $0A622B, $0B7030, $0C7A35
Data $0C8439, $0E8D3D, $0F9A43, $0EAB49, $23B766, $565B7A, $696885, $8382A0
Data $8A89A4, $9090A8, $9595AB, $9696AC, $9696AC, $9696AC, $9696AC, $9696AC
Data $9696AC, $9696AB, $9696AB, $9696AB, $9696AB, $9696AB, $9595AB, $9595AB
Data $9595AB, $9595AB, $9595AB, $9595AB, $9595AB, $9595AB, $9595AA, $9595AA
Data $9595AA, $9595AB, $9595AB, $9595AB, $9595AB, $9595AB, $9292A9, $85859D
Data $A4A3B5, $566A61, $002308, $053718, $06451D, $085123, $095B28, $0A652C
Data $0B7231, $0C7D36, $0C8539, $0E8D3D, $0F9A43, $0EAB49, $23B766, $565B7A
Data $666581, $7F7E9C, $8686A0, $8D8CA5, $9292A8, $9393A9, $9393A9, $9393A9
Data $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9
Data $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9
Data $9393A9, $9393A9, $9292A9, $9292A9, $9292A9, $9292A9, $9292A9, $9292A9
Data $8F8FA6, $82829B, $A2A1B3, $566B61, $002308, $053818, $06481F, $0D5929
Data $166A35, $1B753C, $1B7E41, $168541, $118A3F, $0F8F3F, $0F9A43, $0EAB49
Data $23B766, $565B7A, $62627E, $7A7A98, $82829C, $8888A1, $8E8EA5, $8F8FA6
Data $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6
Data $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6
Data $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6
Data $8F8FA6, $8E8EA5, $8B8BA3, $7D7E97, $9E9DB0, $566B61, $002408, $053B1A
Data $0F5228, $1F683C, $217041, $207243, $1E7644, $167F40, $138740, $129042
Data $0F9B43, $0EAB49, $23B766, $575C7B, $5F5F7A, $767694, $7D7D98, $83839D
Data $8989A2, $8B8BA4, $8C8CA4, $8C8CA4, $8C8CA4, $8C8CA4, $8C8CA3, $8B8BA3
Data $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA4
Data $8B8BA4, $8B8BA4, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3
Data $8B8BA3, $8B8BA2, $8B8BA2, $8A8AA2, $86869F, $797994, $9B9AAD, $576B62
Data $002508, $0A411F, $1F5E38, $256943, $2F5F4F, $395164, $3C506E, $365D63
Data $1D7648, $0E8A40, $0E9743, $0CAA48, $23B766, $575C7B, $54546D, $737390
Data $797994, $7F7F9A, $85859E, $8888A0, $8989A1, $8989A1, $8989A1, $8888A1
Data $8888A0, $8787A0, $86869F, $86869F, $86869E, $86869E, $86869F, $86869F
Data $87879F, $8787A0, $8787A0, $8787A0, $8787A0, $8787A0, $8888A0, $8888A0
Data $8888A0, $8888A0, $8888A0, $8888A0, $8787A0, $86869E, $82829C, $767690
Data $9997AB, $586C63, $002609, $124A27, $26603F, $38535B, $30548D, $1271C0
Data $0F79C9, $1F73C0, $42618D, $257451, $09943D, $0AA744, $23B766, $585D7C
Data $000000, $6E6E8C, $747490, $7B7B96, $81819A, $83839C, $84849D, $85859E
Data $84849D, $84849D, $83839C, $82829B, $80809A, $7F7F98, $7F7F98, $7F7F98
Data $7F7F99, $80809A, $80809A, $81819B, $81819B, $82829B, $82829B, $82829B
Data $83839B, $83839C, $83839C, $83839C, $83839C, $83839C, $83839C, $81819A
Data $7E7E98, $72728C, $9694A9, $576D64, $002709, $1A4E2E, $2A5C44, $3E4772
Data $0778C9, $018ADF, $36A2E4, $3EABEC, $3D84C8, $41646D, $0A8E3E, $07A342
Data $23B766, $585D7C, $000000, $686885, $6F6F8B, $74748F, $7A7A95, $7D7D97
Data $7F7F99, $7F7F99, $7E7E98, $7C7C97, $7B7B95, $787893, $777792, $767692
Data $767592, $767591, $777692, $777792, $787892, $787792, $787893, $797994
Data $797994, $7A7A95, $7A7A95, $7B7B95, $7B7B96, $7C7C96, $7C7C96, $7C7C96
Data $7B7B96, $7A7A95, $787892, $6C6C86, $9392A6, $586C65, $002709, $1E5132
Data $2B5A43, $3A4D7D, $0080D5, $158FDC, $7DC4EE, $94D1F5, $56A0DA, $426375
Data $0B8B3F, $06A13F, $23B766, $575C7B, $000000, $000000, $6A6A86, $6D6D88
Data $73738E, $757590, $777792, $767691, $757590, $72728E, $70708B, $6E6D8B
Data $656580, $5D5F78, $595C73, $62627C, $656580, $686783, $6B6A87, $6F6C8B
Data $6F6C8B, $6F6C8B, $706E8B, $6F6E8B, $6F6E8A, $6F6E8A, $70708B, $70708B
Data $71718C, $71718C, $70708C, $70708B, $6F6F89, $6C6C86, $8E8DA2, $556B62
Data $002709, $1A4E2E, $285D42, $424E72, $0D75C7, $0E92E3, $78C5F1, $8ED4FB
Data $618EC9, $366464, $08903D, $07A342, $23B766, $575B7A, $000000, $000000
Data $5D5D76, $686884, $6C6C87, $6F6F89, $70708A, $70708A, $6E6E88, $6A6A85
Data $6A6987, $464B5C, $13261F, $072212, $062613, $062613, $062613, $072815
Data $082916, $092B18, $0B2D1B, $0D2F1D, $0F3120, $113221, $123223, $143325
Data $163428, $19362A, $1A372C, $1C382E, $1D3930, $1E3A31, $1E3A31, $64637F
Data $8C899F, $60766A, $002307, $124827, $25603D, $345A54, $3A5E8A, $2377BF
Data $4590D1, $548DC1, $44697D, $197947, $0B943F, $0BAF4B, $6CA093, $514862
Data $000000, $000000, $000000, $61617D, $666682, $686883, $696984, $696984
Data $676782, $666682, $3C414F, $001505, $001F06, $012C11, $033215, $033215
Data $033215, $033215, $033315, $033315, $033415, $033415, $033415, $033415
Data $023514, $023514, $023514, $023614, $013614, $013614, $013714, $013714
Data $013714, $013714, $87859A, $82918A, $002105, $0A401F, $1F5D37, $256941
Data $286644, $326157, $326262, $21694E, $137D3F, $108C41, $0C9A42, $2AB867
Data $85859A, $000000, $000000, $000000, $000000, $000000, $595973, $62627D
Data $63637E, $62627D, $61617C, $525168, $1B2324, $22342D, $2D493C, $0C2918
Data $042711, $042711, $042711, $042D14, $053015, $053216, $063617, $063919
Data $063A1A, $063B1A, $063C1A, $063D1B, $063E1B, $063E1C, $063F1C, $06401C
Data $06411C, $06431D, $06431D, $06421D, $4F8169, $C8CECC, $173E27, $003311
Data $0F5127, $1F663B, $237041, $1F7440, $197A3E, $168240, $158842, $109041
Data $1EAA55, $7D9C9B, $332F39, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $4C4C62, $595972, $5E5E79, $49495D, $454454, $605F71
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $9BB8A7
Data $B2BDB9, $073717, $004218, $0D5729, $156935, $1B743D, $1C7F42, $168540
Data $0D8D3E, $16A74D, $88A8A4, $413B47, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $D6D5DC, $ABBBB4, $114B25, $004513, $005620, $016125
Data $007129, $098E3A, $39AA66, $93B3AC, $4F4A56, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $B3B0BB, $BCC9C6, $68907B
Data $447F5C, $40895E, $60A47F, $91B5A8, $ACABBA, $59545F, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $676669, $BAB7BE, $C8C7D0, $C2C1CB, $9B95A3, $66626C, $000000, $000000
Data $000000, $000000, $000000, $000000



.BCF_FileRequesterIconCD
Data 50
Data 50
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $476696, $7094C9, $7C9DCD, $86A2CB
Data $8CA5C9, $8AA4C8, $83A0CB, $7C9DCD, $7094C7, $425C85, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $6E95CF, $7D9BC7, $839CBE, $7F95B6, $7E93B3
Data $778DAE, $738AAC, $5A749F, $375B8E, $426495, $4F6F9C, $5B78A2, $6883AE
Data $7590BA, $7D9CCA, $6B8AB8, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $6087C2, $7E9DCB, $839BBC, $8196B3, $7B90AE, $798DAD
Data $788DAE, $758CAD, $738CAE, $758CAF, $6580AA, $3B5F96, $406397, $426499
Data $446699, $46699A, $486A9A, $51709E, $6280AC, $7996C0, $819FCC, $5676A6
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $537AB2, $86A0C9, $8A9EBB, $8699B4, $8498B3, $8397B4
Data $8095B5, $7D93B5, $7B91B4, $7990B4, $788FB4, $7890B6, $6B87AF, $41669E
Data $476BA1, $4B6EA4, $4F72A6, $5375A8, $5678A9, $5979A9, $5978A8, $5977A6
Data $5F7DAA, $7792BC, $829EC9, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $7E9ECD, $8DA1BE, $8D9EB8, $8E9EB9, $8C9EB9
Data $889BB9, $8499B8, $8198B8, $7F97B8, $7D95B8, $7B93B8, $7A92B8, $7B95B9
Data $6B89B4, $456CA6, $4B70A8, $4F74AA, $5378AD, $577AAE, $5C7EB0, $5F80B1
Data $6383B4, $6586B4, $6686B3, $6381AF, $6684B0, $7F9BC5, $7A97C2, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $8AA4C7, $91A2BA, $95A5BB, $95A5BC
Data $8FA1BC, $8C9FBB, $899DBB, $869BBB, $839ABB, $8099BB, $7F98BB, $7C97BB
Data $7C96BC, $7D97BD, $6A89B7, $4770AB, $4E74AF, $5279B1, $567CB4, $5C7EB5
Data $6082B7, $6386B9, $6889BA, $6C8CBB, $6F8EBC, $718FBC, $718EBA, $6B89B6
Data $7391BC, $8BA8D4, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $678EC9, $91A5C3, $96A5BC, $9CAABF
Data $97A8BF, $95A5BF, $90A4BE, $8DA0BE, $8B9FBE, $889DBE, $869CBE, $829BBE
Data $809ABF, $7F99BF, $7D99C0, $7F9AC2, $6689BA, $4B74B3, $517AB6, $557DB8
Data $5A80BA, $5E83BC, $6388BD, $668BBF, $6C8DC2, $7090C2, $7393C3, $7796C4
Data $7997C4, $7A97C3, $7895BF, $7390BD, $8AA6CE, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $6F95CE, $95A8C3, $9EABBF
Data $A0AEC3, $9BAAC2, $98A9C2, $95A7C2, $92A5C0, $8EA2C2, $8CA0C0, $899FC0
Data $879EC2, $849DC2, $829CC3, $819BC3, $7F9BC4, $819DC6, $6086BC, $4D78B8
Data $537EBC, $5981BD, $5D84C0, $6188C2, $668CC5, $6A8FC6, $6F92C8, $7295C8
Data $7798C9, $7B9BCA, $7E9DCA, $819ECA, $829FC9, $819EC8, $7997C4, $8AA6CE
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $6790CA, $96A9C3
Data $A2AFC2, $A4B0C5, $9EADC4, $9BABC4, $99AAC3, $96A8C3, $92A6C3, $8FA5C3
Data $8DA2C3, $8BA1C4, $88A0C4, $869FC5, $839EC6, $819DC6, $819DC8, $819DC8
Data $5C83BF, $517CBE, $5781C2, $5C86C4, $5F89C6, $648CC8, $6990CA, $6D92CC
Data $7197CD, $7599D0, $7A9CD1, $7E9FD1, $81A1D2, $84A4D1, $88A5D1, $89A6D0
Data $88A5CE, $7F9DC9, $8DA8D1, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $95A8C5, $A6B1C3, $A7B3C6, $A2B0C6, $A0AFC5, $9DADC6, $9AACC5, $97A9C6
Data $93A8C6, $91A6C6, $8EA5C6, $8BA2C7, $89A1C7, $87A0C8, $86A0C9, $84A0C9
Data $83A0CB, $7F9ECB, $5681C3, $5481C5, $5A86C7, $5F8ACA, $628DCC, $6890CE
Data $6C95D1, $7097D2, $749AD4, $799DD5, $7DA0D6, $80A4D7, $84A6D7, $88A8D7
Data $8BA9D7, $8EACD6, $90ACD6, $8DA9D4, $84A2D0, $8FACD6, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $8BA4C8, $A4B0C2, $ABB6C8, $A6B3C7, $A4B1C7, $A0AFC7, $9DAEC7
Data $9BACC7, $98ABC7, $96A9C7, $92A8C8, $8FA6C8, $8DA5C8, $8BA4CA, $89A2CB
Data $87A1CB, $84A1CC, $87A4CE, $7A9BCC, $5482C7, $5786CA, $5C8ACC, $608DD0
Data $6490D2, $6A95D4, $6E98D6, $739BD7, $789ED9, $7BA2D9, $7FA5DB, $83A7DC
Data $87AADC, $8BACDD, $8EAEDD, $91B0DC, $95B1DC, $95B0DA, $92AED9, $89A8D5
Data $8DABD6, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $819FCC, $9FADC2, $AEB9C9, $A9B6C8, $A7B4C8, $A4B3C8
Data $A1B0C8, $9EAFC9, $9BAEC9, $99ACC9, $97ABCA, $93A9CA, $90A8CB, $8EA7CB
Data $8CA6CC, $8AA5CD, $88A4CE, $84A4D0, $87A5D2, $6F95CE, $4F80CB, $5687D0
Data $5B8BD3, $608FD5, $6593D7, $6C98D9, $719CDA, $759EDC, $7AA2DD, $7EA5E0
Data $82A7E1, $86ABE1, $8AADE2, $8EB0E3, $91B1E3, $95B4E3, $98B5E2, $9AB7E1
Data $9AB6E0, $96B3DD, $8FAFDD, $738FB7, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $96A9C4, $AEB9C8, $ADB8C9, $A9B6C9
Data $A7B5C9, $A5B4C9, $A2B1C9, $9FB0CA, $9CAECA, $9AADCA, $98ACCB, $95AACC
Data $91A9CC, $8FA8CD, $8CA7CE, $89A5D0, $8BA8D2, $92ACD4, $9FB6D6, $8FABD3
Data $81A1D1, $86A6D3, $88A7D5, $82A5D6, $799FD9, $709CDD, $719DE1, $77A2E2
Data $7CA6E3, $80A9E4, $84ABE5, $88AEE5, $8CB0E5, $90B3E5, $93B5E5, $98B7E5
Data $9AB9E5, $9DBBE5, $9FBBE5, $9EBAE4, $96B5E2, $95B4E3, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $86A1CA, $A9B4C5, $B0BBCB
Data $ADB9CB, $AAB7CB, $A8B6CB, $A6B5CB, $A2B3CB, $A0B1CB, $9DB0CC, $9BAFCD
Data $99ADCD, $96ACCE, $92ABD0, $8EA8D0, $8FAAD2, $A1B6D5, $ABBDD8, $A5B9D9
Data $95B0D9, $608ED3, $5689D3, $5F8ED3, $6390D4, $739BD4, $8AA8D5, $97B0D7
Data $8EAEDD, $7CA7E4, $7DA8E5, $82ABE5, $87AEE5, $8BB1E5, $8FB4E5, $92B6E5
Data $96B8E5, $9ABAE5, $9DBCE5, $A0BDE5, $A1BFE5, $A2BFE5, $A0BDE5, $97B7E5
Data $84A2CD, $000000, $000000, $000000, $000000, $000000, $5F84BE, $9BABC5
Data $B4BDCB, $AFBACB, $ADB9CB, $AAB8CB, $A8B7CB, $A6B6CC, $A4B4CC, $A0B3CD
Data $9EB1CE, $9BAFD0, $98AFD0, $96AED1, $91ABD1, $9DB3D4, $B0C2D9, $9FB7D9
Data $83A6D9, $7BA0D9, $7BA0DA, $6492D7, $4C83D5, $3B78D3, $417CD4, $457ED4
Data $4C82D5, $5F8ED5, $84A5D4, $9EB7DA, $8EB1E2, $82ADE5, $89B1E5, $8DB5E5
Data $91B6E5, $95B9E5, $98BCE5, $9CBDE5, $9FC0E5, $A1C2E5, $A4C3E5, $A7C4E5
Data $A6C2E5, $A0BFE5, $99B9E5, $000000, $000000, $000000, $000000, $000000
Data $829FCA, $ABB6C7, $B4BECD, $AFBBCC, $AEBACD, $ABB9CD, $A9B8CD, $A7B7CE
Data $A5B6CE, $A1B4CE, $9EB3D0, $9DB1D1, $9AB0D2, $95ADD2, $A8B9D6, $B1C2DA
Data $8DACDA, $81A5DA, $9BB6DD, $ACC0DF, $9DB7DC, $98B4DC, $7BA0D9, $3977D2
Data $467FD4, $4A81D4, $4E83D4, $5084D5, $5387D5, $6C96D5, $9CB4D6, $9AB9E0
Data $89B5E5, $8FB8E5, $93BAE5, $97BCE5, $9BBFE5, $9EC2E5, $A0C4E5, $A5C5E5
Data $A7C6E5, $AAC6E5, $AAC7E5, $A8C5E5, $9FC0E5, $809DC7, $000000, $000000
Data $000000, $000000, $91A7C5, $B5BECC, $B3BDCD, $B0BBCD, $AEBBCD, $ACB9CD
Data $AAB8CE, $A7B7CE, $A5B6D0, $A2B5D1, $A0B4D1, $9DB3D2, $99AFD3, $AABCD6
Data $B0C2DB, $84A7DA, $98B4DC, $B5C6E0, $B9C9E0, $9FB8DD, $5289D9, $3274D6
Data $417EDA, $3E7CD9, $417ED7, $4680D5, $4E83D4, $5287D5, $578AD5, $578AD6
Data $6391D6, $9BB3D6, $9EBDE0, $8FBAE5, $96BDE5, $99C0E5, $9CC2E5, $A0C4E5
Data $A4C6E5, $A7C7E5, $AAC9E5, $ACCAE5, $ADCAE5, $ACCAE5, $A6C7E5, $99BBE3
Data $000000, $000000, $000000, $7999CA, $A2B0C6, $B7C0CE, $B3BDCE, $B0BCCE
Data $AEBBCE, $ACBACE, $AAB9D0, $A8B8D1, $A6B7D1, $A2B6D2, $A0B5D3, $9CB3D3
Data $A6B9D6, $B5C4DB, $8BABDB, $A0B9DD, $C2CDE1, $A2BBDD, $739DDB, $4883DA
Data $000000, $000000, $000000, $000000, $000000, $306ECC, $407DD9, $4F84D5
Data $5589D5, $5C8CD6, $5F8ED6, $6893D6, $A1B7D7, $9DC0E2, $96BFE5, $9BC2E5
Data $9EC5E5, $A2C7E5, $A6C8E5, $A9CAE5, $ACCCE5, $AECCE5, $AFCDE5, $AFCDE5
Data $ADCCE5, $A4C7E5, $607CA1, $000000, $000000, $829FC9, $AFBAC9, $B7C0CE
Data $B3BDCE, $B0BCCE, $AFBCD0, $ADBBD0, $ABB9D0, $A8B9D1, $A6B8D2, $A4B7D3
Data $A0B6D4, $9FB5D5, $B9C6DA, $95B1DB, $ABBFDF, $BDCBE1, $9AB5DC, $6193DD
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $3675D6, $5083D7, $5C8AD5, $618ED6, $628FD7, $789CD7, $ABBFDA
Data $9AC3E5, $9CC4E5, $A0C6E5, $A5C8E5, $A8CAE5, $ABCCE5, $ADCDE5, $B0D0E5
Data $B3D1E5, $B4D0E5, $B1D0E5, $A9CDE5, $84A4CC, $000000, $000000, $95AAC8
Data $B7C0CD, $B6BFCE, $B3BECE, $B0BDCE, $AFBCD0, $ADBBD1, $ABBAD1, $A9B9D3
Data $A7B8D3, $A5B7D4, $A0B6D5, $AFC0D8, $AABEDC, $98B4DD, $BDCCE1, $AEC2DF
Data $9AB5DC, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $5083D7, $5486D6, $5F8BD6, $658FD7
Data $6690D7, $95ABD7, $AAC5E0, $9FC6E5, $A2C8E5, $A7CAE5, $AACCE5, $ADCEE5
Data $AFD0E5, $B3D2E5, $B5D2E5, $B6D3E5, $B6D3E5, $B0D3E5, $98B8D9, $000000
Data $4C6894, $9DADC6, $B9C2CE, $B6BFD0, $B4BFD0, $B1BDD0, $AFBDD1, $ADBCD2
Data $ABBBD2, $A9BAD3, $A7B9D4, $A5B8D5, $A2B7D6, $B9C7DB, $98B3DC, $A1B9DD
Data $A9BEDD, $7CA2DD, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $3C78D7
Data $5E87D7, $658CD7, $6A8ED8, $7A98D8, $AEBFDB, $A4C8E5, $A7CAE5, $AACCE5
Data $ADCEE5, $B0D1E5, $B4D2E5, $B5D4E5, $B8D5E5, $BAD5E5, $BAD5E5, $B6D6E5
Data $A4C9E5, $000000, $6B90C7, $AEBACB, $B9C2D0, $B6C0D0, $B4BFD1, $B1BED1
Data $B0BDD2, $AEBCD2, $ACBBD3, $AABAD4, $A8BAD5, $A4B8D6, $ABBDD8, $B5C5DC
Data $8FAEDB, $B6C6E0, $9AB5DD, $5089DD, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $2662BD, $517ED9, $6587D7, $6C8AD8, $6F8DD8, $A4B1D9, $ADC9E3
Data $AACAE5, $AECDE5, $B1D0E5, $B5D1E5, $B7D3E5, $B9D5E5, $BBD6E5, $BDD7E5
Data $BDD7E5, $BBD8E5, $AED2E5, $57749C, $7A9BCC, $ACB8C9, $BAC3D0, $B6C0D0
Data $B4BFD1, $B1BED1, $B0BED2, $AEBDD3, $ACBCD4, $AABBD5, $A8BBD6, $A4B8D7
Data $B3C3DA, $AABEDC, $8DACDB, $ABBFDF, $8DADE0, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $647FD8, $647FD8, $6C84D8, $6F86D9
Data $959FD9, $B4C7E0, $ACCCE5, $B1CEE5, $B5D1E5, $B8D3E5, $BBD4E5, $BDD6E5
Data $BFD7E5, $C0D9E5, $C2D9E5, $C2DAE5, $B1D4E4, $7798C5, $88A5CD, $AEBACA
Data $B9C3D1, $B6C0D0, $B5BFD1, $B3BED2, $B0BED3, $AEBDD3, $ACBCD4, $AABCD6
Data $A8BBD6, $A4B9D7, $B8C6DA, $A1B9DC, $A4BBDF, $A5BCDD, $7DA6E3, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $3871D4, $6077D9
Data $6A7CD9, $6E7EDA, $8A91D9, $B8C4E0, $AFCDE5, $B4CEE5, $B8D2E5, $BBD4E5
Data $BED6E5, $C0D8E5, $C3D9E5, $C5DAE5, $C6DAE5, $C6DBE5, $B7D8E4, $8AA9D1
Data $97AED0, $B5BFCD, $B9C2D1, $B6C0D1, $B5C0D2, $B3BFD2, $B0BED3, $AEBDD4
Data $ADBDD5, $ABBCD6, $A9BCD7, $A5BAD9, $B9C7DB, $A0B8DC, $A8BEDF, $BBCAE1
Data $7DA7E5, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $3672D9, $5B71D9, $6574DA, $6C78DA, $8689DA, $B7C2E0, $AFD0E5, $B5D1E5
Data $B9D3E5, $BDD6E5, $C0D8E5, $C4D9E5, $C6DBE5, $C8DCE5, $C9DDE5, $C9DDE5
Data $BBDCE4, $97B3D3, $97AED0, $B5BFCD, $B9C2D1, $B6C0D1, $B5C0D2, $B3BFD3
Data $B1BED4, $AEBDD4, $ADBDD5, $ABBCD7, $A9BCD8, $A6BAD9, $B9C7DB, $A0B9DC
Data $9DB7DD, $B4C5E0, $7CA6E4, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $306CD2, $536EDA, $5F71DB, $6572DB, $8183DA, $B4C2E0
Data $ADD2E5, $B4D3E5, $B8D5E5, $BDD8E5, $C0D9E5, $C5DBE5, $C7DDE5, $C9DFE5
Data $CBE0E5, $CBE1E5, $BDE0E4, $97B3D3, $88A5CD, $AEBACA, $BAC3D1, $B6C0D1
Data $B5C0D2, $B3BFD3, $B1BFD4, $AFBED5, $ADBDD6, $ABBDD7, $AABCD9, $A6BBDA
Data $B8C7DC, $A1B9DC, $9CB7DD, $BBCBE1, $7FA6E1, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $316ED3, $4B70DA, $5672DB, $5E70DC
Data $7C83DB, $ADC2E0, $A8D5E5, $AFD5E5, $B5D8E5, $BADAE5, $BFDCE5, $C3DFE5
Data $C6E1E5, $C8E2E5, $CBE3E5, $CCE5E5, $BDE2E4, $8BABD1, $799BCB, $ACB8CA
Data $BAC4D1, $B6C2D1, $B5C0D2, $B3BFD3, $B1BFD4, $AFBED5, $ADBED7, $ACBDD8
Data $AABDD9, $A7BBDB, $B5C5DC, $A9BEDC, $93B0DC, $B8C8E0, $8AABDC, $3877D4
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $3672CB, $2E72D7, $4179DB
Data $4E78DC, $5373DC, $7A8EDC, $A4C9E2, $A1D7E5, $A9D9E5, $AFDBE5, $B5DDE5
Data $BBE0E5, $BFE2E5, $C3E4E5, $C7E5E5, $C9E5E5, $CBE5E5, $BBE0E4, $7798C4
Data $688CC2, $AFBBCD, $BAC3D1, $B6C2D1, $B5C0D3, $B3BFD3, $B1BFD5, $AFBFD6
Data $AEBED7, $ACBED8, $AABDDA, $A7BCDC, $AEC0DD, $B5C5DC, $8FADDC, $B5C6E0
Data $8AAADB, $3074DA, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $296FD2
Data $2C83D9, $3986DB, $4482DC, $487DDC, $81A5DD, $99D5E4, $9ADBE5, $A2DDE5
Data $A9DFE5, $AEE2E5, $B5E4E5, $BAE5E5, $BEE5E5, $C3E5E5, $C5E5E5, $C7E5E5
Data $BBDDE5, $567099, $456088, $9FB0C9, $BAC3D0, $B6C2D1, $B5C0D3, $B3BFD3
Data $B1BFD5, $AFBFD6, $AEBED7, $ACBED9, $AABEDA, $A9BDDC, $A7BDDF, $BAC9DD
Data $96B1DB, $A5BBDD, $A4BBDD, $286BD1, $3371D3, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $258DD3, $2388D5, $2C99DA, $3593DB, $3B8DDC, $4A8FDD, $8ABFDF, $8EDCE5
Data $95DFE5, $9BE2E5, $A2E4E5, $A9E5E5, $AFE5E5, $B5E5E5, $B9E5E5, $BDE5E5
Data $BFE5E5, $C2E5E5, $B3D7E5, $000000, $000000, $96AAC9, $B9C2CE, $B7C2D2
Data $B5C0D3, $B3BFD3, $B1BFD5, $AFBFD6, $AEBED8, $ACBED9, $ABBEDB, $A9BEDD
Data $A5BDE0, $B4C5E0, $ACBFDB, $8BABDB, $4C82D4, $3573D1, $3371D3, $3073D8
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $2D6DD0, $258DD3, $26A9D6, $2CA5D9, $32A1DA, $329ADC, $5FACDD
Data $89D6E2, $88E2E5, $90E2E5, $97E5E5, $9DE5E5, $A5E5E5, $ABE5E5, $B0E5E5
Data $B6E5E5, $B9E5E5, $BAE5E5, $BEE5E5, $A4C4D9, $000000, $000000, $86A1CB
Data $B1BCCB, $B8C2D2, $B5C0D3, $B3BFD3, $B1BFD5, $AFBFD6, $AEBED8, $ACBED9
Data $ABBEDB, $A9BEDD, $A7BEE0, $A6BFE3, $BFCCDD, $779DD7, $3071D2, $90ADDB
Data $4B7FD4, $2F6BD1, $3373DA, $2968C4, $000000, $000000, $000000, $000000
Data $000000, $2A6CD0, $46A8CA, $3097CE, $2FB5D2, $2EB3D5, $2EB0D8, $2EACD9
Data $3DADDA, $7DCCDF, $81E2E5, $86E4E5, $8EE5E5, $95E5E5, $9CE5E5, $A2E5E5
Data $A9E5E5, $ADE5E5, $B3E5E5, $B6E5E5, $B7E5E5, $BDE5E5, $8CAACB, $000000
Data $000000, $6988B7, $A7B6CB, $B9C3D1, $B5C0D2, $B3BFD3, $B1BFD5, $B0BFD6
Data $AEBFD8, $ACBFD9, $ABBEDB, $A9BEDD, $A8BEE0, $A5BDE3, $B0C6E4, $91ACD5
Data $3673D1, $4C81D5, $8CAADA, $638DD5, $3B6ED0, $376CD2, $3871D7, $3671D2
Data $3673D5, $3371CE, $3B79CD, $428CCC, $46A8CA, $41B8CC, $39B8D1, $34BAD3
Data $30B8D5, $2FB6D8, $6BC8DA, $81E0E3, $7FE4E5, $87E5E5, $8DE5E5, $95E5E5
Data $9BE5E5, $A1E5E5, $A7E5E5, $ACE5E5, $B1E5E5, $B4E5E5, $B5E5E5, $BBE2E5
Data $617B9F, $000000, $000000, $000000, $98ADCD, $B7C0D0, $B5C0D2, $B3BFD3
Data $B1BFD5, $AFBFD6, $AEBFD7, $ACBFDA, $ABBEDC, $A9BEDF, $A8BFE1, $A7BFE4
Data $A2BEE5, $87ABDD, $7499D0, $326FD1, $5C8BD6, $96AFDC, $90A8DA, $6D8AD4
Data $647ED0, $6079CC, $637DCA, $6286C8, $6395C7, $5FA4C8, $56AEC9, $4CB7CB
Data $43BBCE, $37BDD1, $35BDD3, $65CBD5, $82DDE1, $7BE5E5, $82E5E5, $89E5E5
Data $8FE5E5, $96E5E5, $9CE5E5, $A2E5E5, $A9E5E5, $ADE5E5, $B1E5E5, $B3E5E5
Data $B8E5E5, $B0CEE4, $000000, $000000, $000000, $000000, $839FC8, $ADBACC
Data $B7C2D2, $B3BFD3, $B1BFD4, $AFBFD6, $AEBFD8, $ACBFDA, $ABBFDC, $A9BEDF
Data $A8BFE1, $A9C0E4, $9EBBE5, $5E99E5, $78A5DD, $80A0D1, $3D73CE, $3E73D2
Data $6E90D7, $8C9FD8, $A2A9D9, $A9ABD7, $989CD2, $647FC7, $6A90C7, $669FC8
Data $5FACC8, $53B7CA, $46BCCC, $4FC3CD, $78D0D2, $87DFDF, $7DE5E5, $81E5E5
Data $87E5E5, $8CE5E5, $92E5E5, $99E5E5, $9EE5E5, $A5E5E5, $AAE5E5, $AFE5E5
Data $B1E5E5, $B1E5E5, $BEE5E5, $89A4C5, $000000, $000000, $000000, $000000
Data $000000, $9EB0CB, $B6C0D0, $B1BFD2, $B1BFD4, $AFBED5, $AEBED7, $ACBFDA
Data $ABBFDC, $AABEDF, $A9BFE1, $A9C0E5, $9BBAE5, $5D99E5, $5A9BE5, $72A6E1
Data $8CABD5, $698DCE, $406ECE, $446CCE, $5571D0, $596DCB, $6977CB, $687AC8
Data $6B89C7, $6999C6, $65A8C7, $6BB8C7, $7FC8C9, $96D6D3, $8FE1E1, $84E5E5
Data $84E5E5, $87E5E5, $8AE5E5, $90E5E5, $96E5E5, $9BE5E5, $A1E5E5, $A8E5E5
Data $ADE5E5, $B0E5E5, $B3E5E5, $B8E5E5, $B9D7E5, $000000, $000000, $000000
Data $000000, $000000, $000000, $87A1C9, $ACB9CC, $B4C0D2, $B0BED3, $AFBED5
Data $AEBED7, $ACBEDA, $ABBEDC, $AABEDF, $A9BFE2, $A9C0E5, $9BBAE5, $5E9AE5
Data $5E9CE5, $60A0E5, $6AA7E4, $87AFDC, $92AAD5, $8697CE, $7782CB, $747AC9
Data $7A7CC7, $8486C6, $8E93C5, $9EA9C5, $ACBEC7, $B5D1CE, $ADDCDA, $9BE3E5
Data $91E4E5, $8DE4E5, $8BE5E5, $8CE5E5, $8FE5E5, $93E5E5, $99E5E5, $9FE5E5
Data $A5E5E5, $AAE5E5, $AFE5E5, $B4E5E5, $B5E5E5, $C0E5E5, $90ABCC, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $9CB0CE, $B3BECE
Data $B0BED3, $AEBED4, $ADBED6, $ACBED9, $ABBEDB, $AABEDF, $A9BFE2, $A9C0E5
Data $9DBBE5, $619CE5, $5E9DE5, $63A2E5, $69A6E5, $6DAAE5, $7AAFE5, $8FB4E2
Data $A2B4DB, $B1B5D7, $BDB7D5, $C7BCD4, $CCC4D5, $CCCED9, $C5D8E1, $B9DFE5
Data $ADE2E5, $A4E3E5, $9BE4E5, $96E5E5, $92E5E5, $92E5E5, $95E5E5, $98E5E5
Data $9DE5E5, $A2E5E5, $A8E5E5, $ADE5E5, $B3E5E5, $B4E5E5, $BCE5E5, $B8D4E5
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $7592BB, $A6B6CE, $B3BFD3, $AEBDD4, $ADBDD6, $ACBED8, $ABBEDB, $A9BEDF
Data $A8BFE1, $A8C0E5, $A2BEE5, $669FE5, $5E9DE5, $64A2E5, $6AA8E5, $70ABE5
Data $7AAFE5, $83B3E5, $91B7E5, $A1BBE5, $B3C2E5, $BFC8E5, $C6CEE5, $C9D6E5
Data $C6DAE5, $BFE0E5, $B8E2E5, $AEE4E5, $A5E5E5, $9EE5E5, $9AE5E5, $99E5E5
Data $9AE5E5, $9DE5E5, $A0E5E5, $A7E5E5, $ABE5E5, $B0E5E5, $B4E5E5, $B7E5E5
Data $C4E3E5, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $90ABD2, $A9B8CD, $B0BED3, $ACBCD4, $ACBDD8
Data $AABDDA, $A9BEDD, $A8BEE2, $A7BFE5, $A8C2E5, $70A4E5, $5D9CE5, $64A4E5
Data $6BA8E5, $71ACE5, $7AB0E5, $86B4E5, $93B7E5, $A2BBE5, $B4C2E5, $C0C7E5
Data $C9CDE5, $CDD5E5, $CCDBE5, $C7E0E5, $BFE2E5, $B7E4E5, $AEE5E5, $A6E5E5
Data $A1E5E5, $9FE5E5, $9EE5E5, $A2E5E5, $A6E5E5, $AAE5E5, $AFE5E5, $B3E5E5
Data $B5E5E5, $C3E5E5, $A0BBDB, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $9AB0D2, $ACBAD0
Data $AEBDD4, $ABBCD7, $AABDDA, $A9BEDD, $A8BEE1, $A7BFE4, $AAC3E5, $80ACE5
Data $5C9CE5, $64A5E5, $6BA9E5, $71ADE5, $7BB1E5, $86B5E5, $93B8E5, $A2BCE5
Data $B3C2E5, $C0C8E5, $CBCEE5, $D1D6E5, $D2DBE5, $CCE1E5, $C6E3E5, $BEE5E5
Data $B6E5E5, $AEE5E5, $A9E5E5, $A6E5E5, $A6E5E5, $A7E5E5, $AAE5E5, $ADE5E5
Data $B1E5E5, $B3E5E5, $BEE5E5, $B4CEE4, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $9CB3D2, $ABBAD1, $ACBDD6, $A9BCD8, $A8BDDB, $A7BDE0, $A6BEE3
Data $A9C2E5, $91B6E5, $5E9DE5, $63A5E5, $6BA9E5, $71AEE5, $7AB3E5, $86B6E5
Data $93B9E5, $A2BDE5, $B4C2E5, $C2C8E5, $CCCEE5, $D2D6E5, $D5DCE5, $D3E1E5
Data $CCE4E5, $C5E5E5, $BDE5E5, $B6E5E5, $AFE5E5, $ACE5E5, $ABE5E5, $ACE5E5
Data $AEE5E5, $B0E5E5, $B3E5E5, $BDE5E5, $B8D3E5, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $9DB4D4, $A8B9D3, $AABCD7, $A8BCDA
Data $A7BDDF, $A6BEE3, $A6C0E5, $9EBDE5, $64A0E5, $63A2E5, $6BA9E5, $71AEE5
Data $7AB3E5, $86B6E5, $93BAE5, $A2BDE5, $B3C3E5, $C2C8E5, $CCD0E5, $D4D7E5
Data $D7DDE5, $D6E2E5, $D1E5E5, $CBE5E5, $C5E5E5, $BDE5E5, $B7E5E5, $B3E5E5
Data $B1E5E5, $B1E5E5, $B1E5E5, $B3E5E5, $BCE5E5, $B8D3E5, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $9BB4D8
Data $A2B8D4, $A9BCD9, $A6BCDD, $A5BDE2, $A5BFE5, $A6C2E5, $72A8E5, $61A0E5
Data $6AA9E5, $71AEE5, $7BB3E5, $86B7E5, $93BAE5, $A2BFE5, $B3C4E5, $C2C9E5
Data $CCD1E5, $D5D8E5, $D8DFE5, $D9E3E5, $D6E5E5, $D1E5E5, $CAE5E5, $C4E5E5
Data $BEE5E5, $B9E5E5, $B6E5E5, $B4E5E5, $B5E5E5, $BDE5E5, $B3CEE5, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $92AFD9, $A0B8DA, $A5BADB, $A6BDE0, $A4BDE4, $A8C2E5
Data $83B0E5, $5FA0E5, $6AA8E5, $70AEE5, $7AB3E5, $86B7E5, $93BBE5, $A2BFE5
Data $B3C4E5, $C0CAE5, $CCD2E5, $D5D8E5, $D9DFE5, $DBE3E5, $D9E5E5, $D5E5E5
Data $D0E5E5, $C9E5E5, $C4E5E5, $BEE5E5, $BAE5E5, $BBE5E5, $BEE3E5, $A0BDDF
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $7792BC, $9DB8E0, $A0BADF
Data $A4BDE3, $A6BFE5, $92B8E5, $61A0E5, $69A7E5, $70ADE5, $7AB3E5, $84B7E5
Data $92BBE5, $A1BFE5, $B3C4E5, $C0CAE5, $CDD2E5, $D6D9E5, $DAE0E5, $DBE4E5
Data $DBE5E5, $D8E5E5, $D4E5E5, $CEE5E5, $CAE5E5, $C4E5E5, $BEE5E5, $B5D6E5
Data $7993BA, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $88A5CE, $9DBBE4, $A1BDE5, $9DBDE5, $66A2E5, $65A5E5, $70ACE5
Data $79B1E5, $84B6E5, $92BAE5, $A1BFE5, $B1C4E5, $C0CBE5, $CCD2E5, $D6D8E5
Data $DBE0E5, $DFE5E5, $DFE5E5, $DCE5E5, $D9E5E5, $D0E5E5, $C4E5E5, $B5D9E5
Data $8FADD0, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $82A0CB, $9BBAE5, $7CAEE5
Data $69A6E5, $6CAAE5, $75AFE5, $82B6E5, $90BAE5, $A1BFE5, $B3C4E5, $C2CBE5
Data $CED3E5, $D9DAE5, $E0E2E5, $E1E5E5, $D9E5E5, $CDE5E5, $C0E2E5, $ACD2E5
Data $87A7C9, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $7EA0CE, $86ADDA, $8BB9E5, $90BAE3, $99BEE3, $99BEE3
Data $A6C5E4, $B0CBE4, $BAD1E3, $BDD5E3, $BDD5E3, $BDDAE5, $9FC4DA, $87AACC
Data $5B779A, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $5D79A1, $7798C5
Data $88A8D1, $88A8D1, $92B0D3, $92B1D3, $87A9D1, $7498C4, $7498C4, $57759E
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000


.BCF_FileRequesterIconRE
Data 50
Data 50
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $676669, $BAB7BE
Data $C8C7D0, $C2C1CB, $9B95A3, $66626C, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $B3B0BB
Data $BCC9C6, $68907B, $447E5C, $40895E, $60A47E, $91B5A8, $ACABBA, $59545F
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $D6D5DC, $ABBBB4, $114A25, $004413, $00541F, $015F24, $006F28, $098C39
Data $39AA65, $93B3AC, $4F4A56, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $A6A6C0, $B3B3CE, $B8B8D5, $A1A1B7
Data $7C7B8C, $9A99AD, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $9BB8A7, $B2BDB9, $073617, $003F17, $084F22, $095927, $0A622B
Data $0B6E30, $0A7733, $048A35, $17AD50, $88A8A4, $413B47, $000000, $000000
Data $000000, $000000, $000000, $000000, $FCFBFE, $E8E8EA, $FAFAFD, $FFFFFF
Data $FEFDFF, $BFBFC3, $414148, $818388, $8E9593, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $C8CECC, $173D26, $003010, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8138, $088F3A, $26B45F, $7D9C9B
Data $332F39, $000000, $000000, $000000, $000000, $FCFBFE, $FCFBFE, $F5F4F7
Data $F3F2F5, $F2F1F4, $F4F3F6, $F2F0F4, $4B6156, $09481F, $167B3D, $0F7C38
Data $0F7C38, $0F7C38, $0F7C38, $0E7C38, $0D7B37, $0D7B36, $0C7A36, $0B7A35
Data $0A7A35, $0A7A35, $0A7B35, $0A7C35, $0B7C36, $0B7D36, $0C7E37, $0C7F37
Data $0C7F37, $0C7F37, $0C7F37, $156F37, $7CAA8F, $819089, $002005, $053718
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0D8B3C
Data $08A643, $35BD71, $85859A, $000000, $000000, $000000, $FCFBFE, $F6F6FA
Data $EFEEF1, $EFEEF1, $EFEFF2, $EFEFF2, $EEEEF1, $F6F3F9, $C8D0CE, $1C5C34
Data $006823, $078035, $078035, $078035, $078035, $078136, $088336, $088437
Data $098538, $098739, $0A883A, $0A893A, $0A8A3B, $0A8A3B, $0A8A3A, $098A3A
Data $098A3A, $098A3A, $098A3A, $098A3A, $098A3A, $D9DCDE, $E5E4E8, $5F7468
Data $002106, $053718, $06441D, $084F22, $095927, $0A622B, $0B7030, $0C7B35
Data $0C8439, $0E8E3D, $0E9941, $11BF56, $6CA093, $36323F, $000000, $D9D8DF
Data $D9D8DF, $EBEBEF, $ECECF0, $ECECF1, $ECECF1, $ECECF1, $ECECF0, $EBEBEF
Data $F7F3FA, $BDCAC6, $3B7C55, $157339, $157238, $157138, $157038, $147237
Data $147338, $147538, $137739, $13793A, $147B3A, $147C3B, $157E3D, $167F3E
Data $17803E, $17803F, $188140, $198241, $198241, $198341, $E2E1E7, $E1DFE5
Data $E6E3E9, $607469, $002207, $053718, $06441D, $084F22, $095927, $0A622B
Data $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $574F65
Data $000000, $D9D8DF, $D9D8DF, $E9E8EE, $E8E9EE, $E9E9EE, $E9E9EE, $E9E9EE
Data $E9E9EE, $E9E8ED, $E7E7ED, $EEEBF2, $E2E1E7, $CFD4D5, $C4CECD, $C9CFD1
Data $CFD1D5, $D1D1D7, $D7D3DA, $DED7E1, $DFD8E2, $DCD7E0, $DAD6DE, $D7D4DB
Data $D5D3D9, $D5D3D9, $D4D3D9, $D3D2D8, $D2D2D7, $D3D3D8, $D5D5D9, $D7D6DB
Data $D9D8DE, $D4D3D9, $DEDCE1, $5E7368, $002106, $053718, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $545773, $A6A5AB, $E2E2EA, $E3E2E8, $E4E4EA, $E5E5EB, $E6E6EB
Data $E6E6EB, $E6E6EB, $E6E6EB, $E6E6EB, $E4E4E9, $E1E1E6, $E0DEE5, $DAD8DF
Data $D4D1D9, $CCCAD0, $C5C4CA, $C0BFC4, $BDBCC2, $BCBBC0, $BBBBBF, $BCBBC0
Data $BCBBC0, $BCBBC0, $BCBBC0, $BCBBC0, $BCBBC0, $BCBCC0, $BCBCC0, $BDBDC1
Data $C0BFC4, $C3C3C8, $C9C8CD, $C7C6CC, $D5D4D8, $5C7165, $002106, $053718
Data $06441D, $084F22, $011602, $001302, $000C00, $000800, $426D4D, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $515773, $B2B1B9, $E3E2EB, $E0DFE6, $E2E2E7
Data $E4E3E8, $E4E4E9, $E4E4EA, $E4E4EA, $E4E4EA, $E4E4EA, $E3E3E8, $DDDDE3
Data $D6D6DB, $535471, $555773, $555671, $54546F, $53546E, $52536D, $51526B
Data $515169, $4F5069, $575770, $5B5C75, $575771, $52536D, $53536E, $53546F
Data $5B5D75, $494B6A, $313156, $ACACB1, $B4B4B9, $B7B8BE, $CAC9CF, $5A6D63
Data $002006, $053718, $06441D, $084F22, $01200F, $001B10, $000F02, $000600
Data $42694D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $525873, $C2C1C9, $DEDDE6
Data $DEDDE4, $DFE0E6, $E1E1E7, $E1E2E8, $E2E2E8, $E2E2E8, $E2E2E8, $E2E2E8
Data $DFDFE5, $D9D9DF, $2B2B3F, $8D8D93, $B7B7BA, $B0B1B6, $AFAFB6, $ADADB6
Data $ABACB7, $A9AAB7, $AAABBA, $989AAB, $454557, $363649, $505062, $6F6F7F
Data $6F6F81, $727384, $757587, $7D7D90, $74758C, $4E4C69, $9C9CA1, $A6A5AC
Data $BEBDC2, $586A60, $002006, $053718, $06441D, $084F22, $233831, $212D32
Data $04131B, $000008, $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $525873
Data $C6C5CF, $D9D8E2, $DAD9E1, $DCDCE3, $DDDDE5, $DEDEE5, $DEDEE5, $DEDEE5
Data $DEDEE4, $DEDEE4, $DBDBE0, $D1D1D7, $7D7D86, $FFFFFF, $FFFFFF, $FFFFFF
Data $FFFFFF, $FEFFFF, $FBFDFF, $F7F9FF, $F3F6FF, $F8FBFF, $AAACC0, $313247
Data $B2B2BB, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $F2F3F9, $5A576D
Data $868689, $96959A, $B2B1B7, $54675D, $001F07, $053618, $06441D, $084F22
Data $2C3D39, $282E38, $0A101F, $00000A, $42604D, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $505772, $BFBEC9, $D5D4DF, $D6D6DF, $D8D8E1, $DBDBE2, $DBDBE1
Data $DBDBE1, $DBDBE1, $DBDBE1, $DBDBE1, $D5D5DC, $CBCBD1, $A5A5AC, $FFFFFF
Data $FAFBFF, $F7F8FF, $F4F5FF, $F1F2FF, $EEEFFF, $EAECFF, $E6E9FF, $E9ECFF
Data $C4C8DE, $3C3D54, $B8B8C3, $F8F8FF, $C7C7D4, $C2C3D2, $C1C1D1, $BFBFD1
Data $C4C4D5, $545168, $76767A, $89898E, $A9A8AE, $53655A, $001F06, $053618
Data $06441D, $084F22, $11291F, $0D1C1D, $00070B, $000000, $42604D, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $505772, $BDBBC7, $D2D2DD, $D3D3DC, $D6D5DE
Data $D8D8DF, $D8D8DF, $D8D8E0, $D8D8E0, $D8D8E0, $D8D8E0, $D2D2DA, $C6C6CE
Data $A1A1AA, $FFFFFF, $F6F7FF, $F3F4FF, $F0F1FF, $EDEFFF, $EAECFF, $E6E9FF
Data $E2E5FF, $E4E9FF, $BEC2DE, $404057, $BFBFCA, $BCBCCB, $3D3D59, $494A66
Data $4C4D6A, $505170, $52536F, $434058, $6B6B6F, $7F7F84, $A3A1A7, $506259
Data $001F06, $053618, $06441D, $084F22, $0B2519, $061816, $000405, $000000
Data $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515773, $B8B7C4, $CFCEDB
Data $D0CFDB, $D4D3DD, $D5D5DE, $D5D5DE, $D5D5DE, $D5D5DE, $D5D5DE, $D5D5DE
Data $CFCFD8, $C3C3CA, $A0A0AA, $FFFFFF, $F3F5FF, $EFF1FF, $EDEFFF, $EAEBFF
Data $E7E9FF, $E3E5FF, $DFE3FF, $E1E5FF, $BDC0DE, $43435C, $BCBCC8, $CECEDC
Data $6E6F85, $76778D, $797991, $7C7D95, $818297, $47445A, $646468, $7A7A80
Data $9F9CA3, $506158, $001F06, $053618, $06441D, $084F22, $1B3029, $172226
Data $000A12, $000000, $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $525873
Data $B4B3C0, $CBCAD8, $CDCCD8, $D0D0DA, $D2D2DC, $D2D2DC, $D2D2DB, $D2D2DB
Data $D2D2DB, $D2D2DB, $CCCCD5, $BFBFC7, $9D9EAA, $FDFFFF, $EFF1FF, $ECEEFF
Data $E9EBFF, $E6E9FF, $E3E5FF, $DFE2FF, $DBDFFF, $DDE2FF, $BABEDF, $464760
Data $B5B6C2, $F4F4FE, $EEEEF7, $ECECF5, $E9E9F3, $E8E8F2, $E3E3EE, $4D4A60
Data $626166, $76767C, $9C9AA1, $4F6058, $001F06, $053618, $06441D, $084F22
Data $20342E, $1E262C, $000C16, $000003, $42604D, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $515772, $B0AEBC, $C7C6D4, $C9C9D4, $CCCCD7, $CECED8, $CECED8
Data $CECED8, $CECED8, $CECED7, $CECED7, $C8C8D1, $BBBBC5, $9B9CAA, $FAFCFF
Data $ECEFFF, $E9ECFF, $E6E9FF, $E3E6FF, $E0E3FF, $DCE0FF, $D8DCFF, $DADFFF
Data $B8BDE0, $4A4B64, $B5B6C3, $ECECF8, $DFDFEE, $DADAEA, $D5D5E7, $D3D3E6
Data $CBCBDE, $49465D, $606065, $74747A, $99989F, $4E6057, $002006, $053618
Data $06441D, $084F22, $192F27, $182227, $000A11, $000000, $42604D, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $505671, $ACABBB, $C3C2D0, $C5C5D2, $C9C9D4
Data $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $CBCBD5, $C5C5CF, $B9B9C2
Data $999AAA, $F6F8FF, $E8EBFF, $E5E8FF, $E2E5FF, $DFE2FF, $DCE0FF, $D8DCFF
Data $D4D9FF, $D5DBFF, $B6BBE1, $4D4F6A, $B5B6C4, $E6E6F3, $DADAE9, $D5D5E6
Data $D2D2E3, $CFCFE2, $C7C7DB, $48455D, $5F5F64, $737179, $98969E, $4E6057
Data $001F06, $053618, $06441D, $084F22, $112920, $111E20, $00080C, $000000
Data $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515772, $A9A7B8, $C0BFCE
Data $C2C2D0, $C6C6D2, $C9C9D4, $C9C9D4, $C9C9D4, $C9C9D4, $C9C9D4, $C9C9D4
Data $C3C3CE, $B6B6C1, $9899AB, $F3F5FF, $E5E8FF, $E2E5FF, $DFE2FF, $DCDFFF
Data $D9DDFF, $D5DAFF, $D1D6FF, $D2D8FF, $B4B9E2, $51526E, $B5B6C4, $E0E0EF
Data $D5D5E6, $D0D0E2, $CCCCE0, $CACADE, $C2C2D7, $48455D, $5E5E62, $707078
Data $96959D, $4E5F57, $002007, $053618, $06441D, $084F22, $0F271D, $0C1B1B
Data $000609, $000000, $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $525773
Data $A4A3B3, $BCBBCB, $BFBECD, $C3C3CF, $C5C5D1, $C5C5D1, $C5C5D2, $C5C5D2
Data $C5C5D1, $C5C5D1, $C0C0CB, $B3B3BE, $9799AD, $EFF2FF, $E2E6FF, $DFE2FF
Data $DCDFFF, $D9DDFF, $D6DAFF, $D2D7FF, $CED3FF, $CFD5FF, $B2B7E2, $545572
Data $B5B5C5, $DCDCEC, $D0D0E2, $CCCCDF, $C8C8DC, $C6C6DA, $BDBDD3, $46445C
Data $5C5C61, $6E6E77, $95939C, $4E5F57, $002006, $053618, $06441D, $084F22
Data $152D23, $121F21, $00090E, $000000, $42604D, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $525773, $9F9FB1, $B7B7C8, $BBBAC9, $BFBFCD, $C2C2CF, $C2C2CF
Data $C2C2CE, $C2C2CE, $C2C2CE, $C1C1CD, $BCBCC7, $B0B0BB, $9698AE, $EBEFFF
Data $DEE2FF, $DBDFFF, $D8DCFF, $D5D9FF, $D2D7FF, $CED3FF, $CAD0FF, $CBD2FF
Data $B0B5E3, $575876, $BBBBCB, $DDDDEF, $D1D1E4, $CCCCE0, $C8C8DD, $C4C5DB
Data $BFBFD6, $47445D, $5A5A60, $6B6B74, $939199, $4D5F56, $002107, $053618
Data $06441D, $084F22, $223730, $212A30, $030F19, $000006, $42604D, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $505571, $9C9AAD, $B5B3C5, $B7B7C7, $BCBBCA
Data $BFBFCC, $BFBFCC, $BFBFCB, $BFBFCB, $BFBFCB, $BFBFCB, $B9B9C5, $ADADB9
Data $9698B1, $E6EBFF, $DADFFF, $D7DCFF, $D4D8FF, $D1D6FF, $CED3FF, $CAD0FF
Data $C6CDFF, $C6CEFF, $AEB3E5, $5D5D7E, $88899B, $A8A8B9, $A3A3B8, $A2A2B7
Data $A0A0B7, $A3A3BB, $9595AC, $3E3C53, $58585F, $6A6A73, $918F99, $4D5E56
Data $002107, $053618, $06441D, $084F22, $293B36, $272E36, $08111E, $000009
Data $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $505572, $9997AA, $B1AFC3
Data $B5B4C5, $B9B9C7, $BCBCCA, $BCBCCA, $BCBCCA, $BCBCCA, $BCBCCA, $BCBCCA
Data $B7B7C4, $ACACB9, $9699B3, $E4E8FF, $D7DCFF, $D4D9FF, $D1D6FF, $CED3FF
Data $CBD1FF, $C7CDFF, $C3CAFF, $C4CBFF, $AEB4E6, $666788, $44455B, $383849
Data $414257, $47485F, $4E4F68, $585976, $4B4B64, $37334B, $58585F, $6A6973
Data $918F98, $4D5F56, $002107, $053618, $06441D, $084F22, $243731, $212A30
Data $040E1A, $000006, $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515672
Data $9593A7, $ADACC0, $B1B0C1, $B6B5C5, $B9B9C8, $B9B9C8, $B9B9C8, $B9B9C8
Data $B9B9C8, $B9B9C7, $B4B4C2, $AAAAB7, $747691, $E3E8FF, $DCE1FF, $D8DDFF
Data $D4D9FF, $D1D7FF, $CDD4FF, $C9D0FF, $C5CCFF, $C8CFFF, $9CA2CF, $656687
Data $4C4D64, $3E3E50, $47485D, $4D4E66, $545570, $5E5F7D, $50506A, $39364D
Data $5B5B63, $6A6974, $918F99, $4E6056, $002107, $053618, $06441D, $084F22
Data $293C36, $272F36, $08121F, $00000A, $42604D, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $515772, $918EA3, $A9A7BC, $ADACBF, $B2B1C2, $B5B5C4, $B5B5C4
Data $B5B5C4, $B5B5C4, $B5B5C4, $B5B5C4, $B1B1BF, $A8A8B5, $3E3F56, $878AA7
Data $A4A8CB, $A1A4CA, $A0A4CB, $9FA3CC, $9EA2CE, $9DA2D0, $9FA3D4, $959AC7
Data $6C6E91, $6A6B8E, $606180, $595A76, $60617F, $646585, $696B8D, $74759B
Data $585874, $3B374F, $61616A, $6F6E79, $94939D, $4E6158, $002108, $053618
Data $06441D, $084F22, $354642, $343A44, $121A29, $000013, $42604D, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $515772, $8C8AA0, $A5A3B9, $AAA9BC, $AFAEBF
Data $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1, $B2B2C1, $AFAFBE, $A8A8B6
Data $9C9CAA, $4B4C63, $4E4F67, $51526B, $54546F, $565772, $595A76, $5C5D7A
Data $5F607D, $616280, $676888, $6B6D8E, $6F7193, $727498, $74759B, $77789E
Data $7B7CA3, $747599, $414155, $5E5E66, $6B6B74, $757480, $9896A2, $50635A
Data $002108, $053618, $06441D, $084F22, $2F423D, $2F353E, $0E1725, $00000F
Data $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515772, $89879D, $A2A0B7
Data $A6A5BA, $ABACBC, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0, $AFAFC0
Data $ADADBE, $A8A8B8, $9F9FAF, $9494A2, $858592, $777783, $6C6C76, $66666F
Data $61616A, $606069, $606069, $606068, $606068, $606068, $606069, $606069
Data $606069, $606069, $606069, $62626B, $666670, $6F6F79, $797985, $7E7D8C
Data $9D9CA9, $52655C, $002208, $053718, $06441D, $084F22, $1A3028, $182327
Data $000B12, $000001, $42604D, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515772
Data $86839A, $9E9CB5, $A3A2B7, $A9A8BB, $ADADBE, $ADADBE, $ADADBE, $ADADBE
Data $ADADBE, $ADADBE, $ACACBD, $A7A7B9, $A2A2B3, $9B9BAB, $91919F, $888896
Data $81818E, $7C7C88, $797985, $797985, $797985, $797985, $797985, $797985
Data $797985, $797985, $797985, $797985, $797985, $797985, $7D7D89, $838390
Data $888796, $878696, $A6A4B1, $54675E, $002208, $053718, $06441D, $084F22
Data $172D24, $131F23, $00080E, $000000, $42604D, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $565C79, $817E97, $9A98B1, $9F9EB4, $A5A4B7, $A9A8BA, $A9A9BA
Data $A9A9BA, $A9A9BA, $A9A9BA, $A9A9BA, $A8A8B9, $A5A5B7, $A3A3B4, $9E9EAF
Data $9999A9, $9494A3, $90909F, $8C8C9B, $8A8A99, $8A8A98, $8A8A98, $8A8A98
Data $8A8A98, $8A8A98, $8A8A98, $8A8A98, $8A8A98, $8A8A98, $8A8A98, $8A8A98
Data $8D8D9B, $90909E, $9292A2, $8D8C9E, $AAA8B7, $566A60, $002308, $053718
Data $06441D, $084F22, $273A34, $242B33, $060F1C, $000008, $42604D, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $585E7C, $7D7A94, $9593AD, $9B9AB1, $A1A1B4
Data $A5A4B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A5A5B7, $A4A4B6
Data $A2A2B4, $A0A0B2, $9F9FB0, $9B9BAC, $9999AA, $9797A8, $9797A7, $9696A7
Data $9696A7, $9595A6, $9595A6, $9595A6, $9595A6, $9595A6, $9595A6, $9595A6
Data $9595A6, $9696A6, $9797A8, $9898A9, $9A99AB, $918FA3, $ABAABB, $576B61
Data $002308, $053718, $06441D, $084F22, $263933, $242C33, $06101C, $000008
Data $42604D, $0E8D3D, $0F9A43, $0EAB49, $23B766, $575E7B, $797691, $928FAB
Data $9796AE, $9F9DB3, $A3A2B6, $A3A2B6, $A2A2B6, $A2A2B6, $A2A2B6, $A2A2B6
Data $A2A2B6, $A2A2B6, $A1A1B5, $A1A1B5, $A0A0B4, $9F9FB3, $9E9EB2, $9E9EB0
Data $9E9EB0, $9E9EB0, $9E9EB0, $9E9EB0, $9E9EB0, $9E9EAF, $9E9EAF, $9E9EAF
Data $9E9EB0, $9E9EB0, $9E9EB0, $9E9EB0, $9E9EB0, $9D9DB1, $9D9DB1, $9290A6
Data $ACABBD, $576C62, $002308, $053718, $06441D, $084F22, $152D24, $132023
Data $00090F, $000000, $42604D, $0E8D3D, $0F9A43, $0EAB49, $23B766, $575D7B
Data $77738E, $8F8CA8, $9594AC, $9B9BB1, $9F9FB4, $A0A0B4, $A0A0B4, $A0A0B4
Data $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3, $A0A0B3
Data $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3
Data $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3, $9F9FB3
Data $9C9CB1, $908FA6, $ACAABC, $576B62, $002308, $053718, $06441D, $084F22
Data $10291F, $0E1E1E, $00080C, $000000, $42604D, $0E8D3D, $0F9A43, $0EAB49
Data $23B766, $565C7A, $716E8A, $8A88A5, $9190A8, $9796AD, $9B9BB0, $9C9CB0
Data $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0
Data $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9C9CB0, $9B9BB0
Data $9B9BB0, $9B9BB0, $9B9BB0, $9B9BB0, $9B9BB0, $9B9BB0, $9B9BB0, $9B9BAF
Data $9B9BAF, $9B9BAF, $9898AE, $8C8BA2, $A9A7B9, $566B61, $002308, $053718
Data $06441D, $084F22, $1A3128, $172627, $000E13, $000002, $42604D, $0E8D3D
Data $0F9A43, $0EAB49, $23B766, $555B79, $6D6988, $8685A2, $8D8CA5, $9392AA
Data $9898AD, $9999AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD
Data $9898AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD, $9898AD
Data $9898AD, $9898AE, $9898AE, $9898AD, $9898AD, $9898AD, $9898AC, $9898AC
Data $9898AC, $9898AC, $9898AC, $9797AC, $9595AB, $88889F, $A6A4B7, $566A61
Data $002308, $053718, $06441D, $084F22, $6C837A, $6F7D7F, $54656A, $545459
Data $42604D, $0E8D3D, $0F9A43, $0EAB49, $23B766, $565B7A, $696885, $8382A0
Data $8A89A4, $9090A8, $9595AB, $9696AC, $9696AC, $9696AC, $9696AC, $9696AC
Data $9696AC, $9696AB, $9696AB, $9696AB, $9696AB, $9696AB, $9595AB, $9595AB
Data $9595AB, $9595AB, $9595AB, $9595AB, $9595AB, $9595AB, $9595AA, $9595AA
Data $9595AA, $9595AB, $9595AB, $9595AB, $9595AB, $9595AB, $9292A9, $85859D
Data $A4A3B5, $566A61, $002308, $053718, $06451D, $085123, $095B28, $0A652C
Data $0B7231, $0C7D36, $0C8539, $0E8D3D, $0F9A43, $0EAB49, $23B766, $565B7A
Data $666581, $7F7E9C, $8686A0, $8D8CA5, $9292A8, $9393A9, $9393A9, $9393A9
Data $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9
Data $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9, $9393A9
Data $9393A9, $9393A9, $9292A9, $9292A9, $9292A9, $9292A9, $9292A9, $9292A9
Data $8F8FA6, $82829B, $A2A1B3, $566B61, $002308, $053818, $06481F, $0D5929
Data $166A35, $1B753C, $1B7E41, $168541, $118A3F, $0F8F3F, $0F9A43, $0EAB49
Data $23B766, $565B7A, $62627E, $7A7A98, $82829C, $8888A1, $8E8EA5, $8F8FA6
Data $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6
Data $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6
Data $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6, $8F8FA6
Data $8F8FA6, $8E8EA5, $8B8BA3, $7D7E97, $9E9DB0, $566B61, $002408, $053B1A
Data $0F5228, $1F683C, $217041, $207243, $1E7644, $167F40, $138740, $129042
Data $0F9B43, $0EAB49, $23B766, $575C7B, $5F5F7A, $767694, $7D7D98, $83839D
Data $8989A2, $8B8BA4, $8C8CA4, $8C8CA4, $8C8CA4, $8C8CA4, $8C8CA3, $8B8BA3
Data $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA4
Data $8B8BA4, $8B8BA4, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3, $8B8BA3
Data $8B8BA3, $8B8BA2, $8B8BA2, $8A8AA2, $86869F, $797994, $9B9AAD, $576B62
Data $002508, $0A411F, $1F5E38, $256943, $2F5F4F, $395164, $3C506E, $365D63
Data $1D7648, $0E8A40, $0E9743, $0CAA48, $23B766, $575C7B, $54546D, $737390
Data $797994, $7F7F9A, $85859E, $8888A0, $8989A1, $8989A1, $8989A1, $8888A1
Data $8888A0, $8787A0, $86869F, $86869F, $86869E, $86869E, $86869F, $86869F
Data $87879F, $8787A0, $8787A0, $8787A0, $8787A0, $8787A0, $8888A0, $8888A0
Data $8888A0, $8888A0, $8888A0, $8888A0, $8787A0, $86869E, $82829C, $767690
Data $9997AB, $586C63, $002609, $124A27, $26603F, $38535B, $30548D, $1271C0
Data $0F79C9, $1F73C0, $42618D, $257451, $09943D, $0AA744, $23B766, $585D7C
Data $000000, $6E6E8C, $747490, $7B7B96, $81819A, $83839C, $84849D, $85859E
Data $84849D, $84849D, $83839C, $82829B, $80809A, $7F7F98, $7F7F98, $7F7F98
Data $7F7F99, $80809A, $80809A, $81819B, $81819B, $82829B, $82829B, $82829B
Data $83839B, $83839C, $83839C, $83839C, $83839C, $83839C, $83839C, $81819A
Data $7E7E98, $72728C, $9694A9, $576D64, $002709, $1A4E2E, $2A5C44, $3E4772
Data $0778C9, $018ADF, $36A2E4, $3EABEC, $3D84C8, $41646D, $0A8E3E, $07A342
Data $23B766, $585D7C, $000000, $686885, $6F6F8B, $74748F, $7A7A95, $7D7D97
Data $7F7F99, $7F7F99, $7E7E98, $7C7C97, $7B7B95, $787893, $777792, $767692
Data $767592, $767591, $777692, $777792, $787892, $787792, $787893, $797994
Data $797994, $7A7A95, $7A7A95, $7B7B95, $7B7B96, $7C7C96, $7C7C96, $7C7C96
Data $7B7B96, $7A7A95, $787892, $6C6C86, $9392A6, $586C65, $002709, $1E5132
Data $2B5A43, $3A4D7D, $0080D5, $158FDC, $7DC4EE, $94D1F5, $56A0DA, $426375
Data $0B8B3F, $06A13F, $23B766, $575C7B, $000000, $000000, $6A6A86, $6D6D88
Data $73738E, $757590, $777792, $767691, $757590, $72728E, $70708B, $6E6D8B
Data $656580, $5D5F78, $595C73, $62627C, $656580, $686783, $6B6A87, $6F6C8B
Data $6F6C8B, $6F6C8B, $706E8B, $6F6E8B, $6F6E8A, $6F6E8A, $70708B, $70708B
Data $71718C, $71718C, $70708C, $70708B, $6F6F89, $6C6C86, $8E8DA2, $556B62
Data $002709, $1A4E2E, $285D42, $424E72, $0D75C7, $0E92E3, $78C5F1, $8ED4FB
Data $618EC9, $366464, $08903D, $07A342, $23B766, $575B7A, $000000, $000000
Data $5D5D76, $686884, $6C6C87, $6F6F89, $70708A, $70708A, $6E6E88, $6A6A85
Data $6A6987, $464B5C, $13261F, $072212, $062613, $062613, $062613, $072815
Data $082916, $092B18, $0B2D1B, $0D2F1D, $0F3120, $113221, $123223, $143325
Data $163428, $19362A, $1A372C, $1C382E, $1D3930, $1E3A31, $1E3A31, $64637F
Data $8C899F, $60766A, $002307, $124827, $25603D, $345A54, $3A5E8A, $2377BF
Data $4590D1, $548DC1, $44697D, $197947, $0B943F, $0BAF4B, $6CA093, $514862
Data $000000, $000000, $000000, $61617D, $666682, $686883, $696984, $696984
Data $676782, $666682, $3C414F, $001505, $001F06, $012C11, $033215, $033215
Data $033215, $033215, $033315, $033315, $033415, $033415, $033415, $033415
Data $023514, $023514, $023514, $023614, $013614, $013614, $013714, $013714
Data $013714, $013714, $87859A, $82918A, $002105, $0A401F, $1F5D37, $256941
Data $286644, $326157, $326262, $21694E, $137D3F, $108C41, $0C9A42, $2AB867
Data $85859A, $000000, $000000, $000000, $000000, $000000, $595973, $62627D
Data $63637E, $62627D, $61617C, $525168, $1B2324, $22342D, $2D493C, $0C2918
Data $042711, $042711, $042711, $042D14, $053015, $053216, $063617, $063919
Data $063A1A, $063B1A, $063C1A, $063D1B, $063E1B, $063E1C, $063F1C, $06401C
Data $06411C, $06431D, $06431D, $06421D, $4F8169, $C8CECC, $173E27, $003311
Data $0F5127, $1F663B, $237041, $1F7440, $197A3E, $168240, $158842, $109041
Data $1EAA55, $7D9C9B, $332F39, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $4C4C62, $595972, $5E5E79, $49495D, $454454, $605F71
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $9BB8A7
Data $B2BDB9, $073717, $004218, $0D5729, $156935, $1B743D, $1C7F42, $168540
Data $0D8D3E, $16A74D, $88A8A4, $413B47, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $D6D5DC, $ABBBB4, $114B25, $004513, $005620, $016125
Data $007129, $098E3A, $39AA66, $93B3AC, $4F4A56, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $B3B0BB, $BCC9C6, $68907B
Data $447F5C, $40895E, $60A47F, $91B5A8, $ACABBA, $59545F, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $676669, $BAB7BE, $C8C7D0, $C2C1CB, $9B95A3, $66626C, $000000, $000000
Data $000000, $000000, $000000, $000000

.BCF_FileRequesterIconNONE
Data 50
Data 50
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $676669, $BAB7BE
Data $C8C7D0, $C2C1CB, $9B95A3, $66626C, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $B3B0BB
Data $BCC9C6, $68907B, $447E5C, $40895E, $60A47E, $91B5A8, $ACABBA, $59545F
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $D6D5DC, $ABBBB4, $114A25, $004413, $00541F, $015F24, $006F28, $098C39
Data $39AA65, $93B3AC, $4F4A56, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $A6A6C0, $B3B3CE, $B8B8D5, $A1A1B7
Data $7C7B8C, $9A99AD, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $9BB8A7, $B2BDB9, $073617, $003F17, $084F22, $095927, $0A622B
Data $0B6E30, $0A7733, $048A35, $17AD50, $88A8A4, $413B47, $000000, $000000
Data $000000, $000000, $000000, $000000, $FCFBFE, $E8E8EA, $FAFAFD, $FFFFFF
Data $FEFDFF, $BFBFC3, $414148, $818388, $8E9593, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $C8CECC, $173D26, $003010, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8138, $088F3A, $26B45F, $7D9C9B
Data $332F39, $000000, $000000, $000000, $000000, $FCFBFE, $FCFBFE, $F5F4F7
Data $F3F2F5, $F2F1F4, $F4F3F6, $F2F0F4, $4B6156, $09481F, $167B3D, $0F7C38
Data $0F7C38, $0F7C38, $0F7C38, $0E7C38, $0D7B37, $0D7B36, $0C7A36, $0B7A35
Data $0A7A35, $0A7A35, $0A7B35, $0A7C35, $0B7C36, $0B7D36, $0C7E37, $0C7F37
Data $0C7F37, $0C7F37, $0C7F37, $156F37, $7CAA8F, $819089, $002005, $053718
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0D8B3C
Data $08A643, $35BD71, $85859A, $000000, $000000, $000000, $FCFBFE, $F6F6FA
Data $EEEDF0, $EEEDF0, $EEEEF1, $EEEEF1, $EDEDF0, $F5F2F8, $C7CFCD, $1C5C34
Data $006823, $078035, $078035, $078035, $078035, $078136, $088336, $088437
Data $098538, $098739, $0A883A, $0A893A, $0A8A3B, $0A8A3B, $0A8A3A, $098A3A
Data $098A3A, $098A3A, $098A3A, $098A3A, $098A3A, $D9DCDE, $E5E4E8, $5F7468
Data $002106, $053718, $323818, $084F22, $095827, $0A612A, $0B6E2F, $0C7A34
Data $0C8339, $0E8D3D, $0E9841, $11BF56, $6CA093, $36323F, $000000, $D9D8DF
Data $D9D8DF, $F55B5C, $F3787A, $E8E8ED, $E7E7EC, $E6E6EA, $E6E6E9, $E6E6EA
Data $F3EFF6, $BCC8C4, $3B7C55, $157339, $157238, $157138, $157038, $147237
Data $147338, $147538, $137739, $13793A, $147B3A, $147C3B, $157E3D, $167F3E
Data $17803E, $17803F, $188140, $198241, $198241, $198341, $E2E1E7, $E1DFE5
Data $E6E3E9, $607469, $002207, $D90803, $F80100, $433A19, $095626, $0A5E29
Data $0B6B2E, $0C7633, $0C8138, $0E8B3C, $0F9943, $0EAB49, $24B766, $574F65
Data $000000, $D9D8DF, $E87E82, $FC0000, $FC0000, $EE7476, $DDDDE2, $DADADF
Data $DADADF, $DCDBE0, $DEDEE4, $E7E5EB, $DFDEE4, $CED3D4, $C4CECD, $C9CFD1
Data $CFD1D5, $D1D1D7, $D7D3DA, $DED7E1, $DFD8E2, $DCD7E0, $DAD6DE, $D7D4DB
Data $D5D3D9, $D5D3D9, $D4D3D9, $D3D2D8, $D2D2D7, $D3D3D8, $D5D5D9, $D7D6DB
Data $D9D8DE, $D4D3D9, $DEDCE1, $5E7368, $D80501, $FC0000, $FC0000, $7A2811
Data $085224, $095A27, $0A662C, $0B7231, $0B7E36, $0E893B, $0F9842, $0EAA49
Data $24B766, $545773, $A6A5AB, $E2E2EA, $E2E1E7, $F82021, $FC0000, $FC0000
Data $E76C6F, $CDCDD1, $CCCCD0, $CFCFD3, $D1D1D6, $D5D5D9, $DAD8DF, $D7D5DC
Data $D3D0D8, $CCCAD0, $C5C4CA, $C0BFC4, $BDBCC2, $BCBBC0, $BBBBBF, $BCBBC0
Data $BCBBC0, $BCBBC0, $BCBBC0, $BCBBC0, $BCBBC0, $BCBCC0, $BCBCC0, $BDBDC1
Data $C0BFC4, $C3C3C8, $C9C8CD, $C7C6CC, $D5D4D8, $E5100E, $FC0000, $FC0000
Data $7E200E, $07471F, $084D22, $095425, $0A602A, $0B6D2F, $0B7B35, $0D873B
Data $0F9842, $0EAA49, $24B766, $515773, $B2B1B9, $E3E2EB, $DFDEE5, $DEDEE3
Data $F71F1F, $FC0000, $FC0000, $DD6265, $BBBBC0, $BEBEC3, $C3C3C7, $C6C6CC
Data $C9C9CD, $51526E, $545672, $555671, $54546F, $53546E, $52536D, $51526B
Data $515169, $4F5069, $575770, $5B5C75, $575771, $52536D, $53536E, $53546F
Data $5B5D75, $494B6A, $313156, $ACACB1, $B4B4B9, $B7B8BE, $F51C1D, $FC0000
Data $FC0000, $7D1A0B, $053C19, $07421C, $07481F, $084E22, $095A27, $0A682D
Data $0B7834, $0D863A, $0F9742, $0EAA49, $24B766, $525873, $C2C1C9, $DEDDE6
Data $DDDCE3, $DCDCE2, $D6D6DB, $F51D1E, $FC0000, $FC0000, $D3595B, $ADADB1
Data $B2B2B6, $B6B6BB, $262638, $84848A, $B2B2B5, $AEAFB4, $AEAEB5, $ADADB6
Data $ABACB7, $A9AAB7, $AAABBA, $989AAB, $454557, $363649, $505062, $6F6F7F
Data $6F6F81, $727384, $757587, $7D7D90, $74758C, $4E4C69, $9C9CA1, $F01718
Data $FC0000, $FC0000, $7B0F03, $043015, $053818, $063D1A, $07421D, $074920
Data $095625, $0A662C, $0B7633, $0D853A, $0F9742, $0EAA49, $24B766, $525873
Data $C6C5CF, $D9D8E2, $D9D8E0, $D9D9DF, $D3D3DA, $C9C9CF, $F31A1B, $FC0000
Data $FC0000, $CC5254, $A1A1A4, $A2A2A7, $686870, $E4E4E4, $EFEFEF, $F8F8F8
Data $FCFCFC, $FDFEFE, $FBFDFF, $F7F9FF, $F3F6FF, $F8FBFF, $AAACC0, $313247
Data $B2B2BB, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $FFFFFF, $F2F3F9, $5A576D
Data $EB1313, $FC0000, $FC0000, $A3312C, $001B06, $042C14, $053316, $063818
Data $063E1B, $07471F, $085625, $0A672D, $0B7733, $0D863A, $0F9842, $0EAA49
Data $24B766, $505772, $BFBEC9, $D5D4DF, $D5D5DE, $D5D5DE, $D2D2D9, $CACACF
Data $BDBDC2, $F11919, $FC0000, $FC0000, $C74C4F, $929297, $7F7F85, $D5D5D5
Data $E0E0E4, $E8E8EF, $EDEEF8, $EEEFFC, $EDEEFE, $EAECFF, $E6E9FF, $E9ECFF
Data $C4C8DE, $3C3D54, $B8B8C3, $F8F8FF, $C7C7D4, $C2C3D2, $C1C1D1, $BFBFD1
Data $C4C4D5, $E40B0F, $FC0000, $FC0000, $CB5053, $49584F, $001905, $042912
Data $043014, $053617, $063E1B, $074820, $095826, $0A6A2E, $0B7A35, $0D873B
Data $0F9842, $0EAA49, $24B766, $505772, $BDBBC7, $D2D2DD, $D3D3DC, $D4D3DC
Data $D2D2D9, $CBCBD2, $C0C0C7, $B4B4BA, $F01718, $FC0000, $FC0000, $C04648
Data $74747B, $C5C5C5, $CDCED5, $D9DAE4, $E1E2EF, $E6E8F8, $E7E9FC, $E5E8FE
Data $E2E5FF, $E4E9FF, $BEC2DE, $404057, $BFBFCA, $BCBCCB, $3D3D59, $494A66
Data $4C4D6A, $505170, $E40C10, $FC0000, $FC0000, $B73D3F, $8F8D92, $415049
Data $001705, $042611, $042E14, $053617, $06401C, $084C21, $095E28, $0B6E30
Data $0B7D36, $0E8A3C, $0F9942, $0EAB49, $24B766, $515773, $B8B7C4, $CFCEDB
Data $D0CFDB, $D3D2DC, $D2D2DB, $CDCDD6, $C6C6CE, $BBBBC3, $AEAEB5, $EF1718
Data $FC0000, $FC0000, $B3393C, $B8B8B8, $BCBDC5, $C8C9D5, $D4D6E4, $DBDCEF
Data $E1E3F8, $E0E2FC, $DEE2FE, $E1E5FF, $BDC0DE, $43435C, $BCBCC8, $CECEDC
Data $6E6F85, $76778D, $797991, $EA1215, $FC0000, $FC0000, $AA3031, $6B6B70
Data $827F85, $3C4942, $001604, $032510, $042F14, $063919, $07451E, $085224
Data $0A632B, $0B7232, $0C8037, $0E8B3C, $0F9943, $0EAB49, $24B766, $525873
Data $B4B3C0, $CBCAD8, $CDCCD8, $D0D0DA, $D1D1DB, $CFCFD9, $C9C9D1, $C1C1CA
Data $B6B6BE, $A9A9B0, $EE1516, $FC0000, $FC0000, $D15757, $A7A9B3, $B2B2C0
Data $BEBFCF, $C9CCE0, $D1D3EB, $D6D9F5, $D7DBFB, $DBE0FD, $BABEDF, $464760
Data $B5B6C2, $F4F4FE, $EEEEF7, $ECECF5, $F92122, $FC0000, $FC0000, $9F232E
Data $565559, $606065, $757479, $38443E, $001504, $032510, $043115, $063D1A
Data $084A21, $095826, $0A682D, $0C7734, $0C8238, $0E8C3D, $0F9A43, $0EAB49
Data $24B766, $515772, $B0AEBC, $C7C6D4, $C9C9D4, $CCCCD7, $CDCDD7, $CCCCD6
Data $C9C9D2, $C1C1CB, $B8B8C0, $ABABB2, $9999A0, $EB1213, $FC0000, $FC0000
Data $C74D52, $9A9CA8, $A4A6B6, $B0B3C6, $BDBFD7, $C6C9E5, $CBCFF0, $D4D9F8
Data $B6BBDD, $4A4B64, $B5B6C3, $ECECF8, $DFDFEE, $F71F21, $FC0000, $FC0000
Data $DB6169, $403D51, $4E4E52, $57575C, $6C6B70, $35413B, $001604, $042711
Data $053516, $07421C, $085023, $095C28, $0B6C2F, $0C7934, $0C8339, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $505671, $ACABBB, $C3C2D0, $C5C5D2, $C8C8D3
Data $C9C9D3, $C7C7D1, $C2C2CC, $BBBBC5, $B2B2BB, $A7A7AF, $95959D, $7F7F86
Data $E60E0F, $FC0000, $FC0000, $BD444A, $888A9A, $9294A7, $A0A2B9, $ADB0CC
Data $B8BCDD, $C4CAEB, $AFB4D8, $4C4E68, $B4B5C3, $E5E5F2, $F71F21, $FC0000
Data $FC0000, $DD636B, $AEAEC0, $3B384C, $48484B, $515055, $67666B, $36423C
Data $001604, $042A13, $053918, $07471E, $085325, $0A5F2A, $0B6E2F, $0C7A35
Data $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515772, $A9A7B8, $C0BFCE
Data $C1C1CF, $C4C4D0, $C3C3CE, $BFBFC9, $B3B6C6, $A0AFCC, $97AED3, $95ABCE
Data $8FA3C2, $8397B4, $5E7599, $E40F14, $FC0000, $FC0000, $A6323D, $666E85
Data $818397, $9093AC, $9FA3C2, $AFB4D5, $A2A7CC, $4D4E69, $B0B1BF, $F81F21
Data $FC0000, $FC0000, $DC616A, $B1B1C2, $9E9EAF, $363446, $424245, $4C4C51
Data $67666C, $38453F, $001905, $042D14, $053D1A, $074A20, $095726, $0A612A
Data $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $525773
Data $A4A3B3, $BBBACA, $BDBCCB, $BEBEC9, $BABAC6, $9FAECB, $99B4DC, $AABDD9
Data $A7B8D1, $9DB1CE, $95ABC9, $8EA3C3, $6481AB, $58759E, $E51015, $FC0000
Data $FC0000, $AF3E4D, $55637C, $686C83, $8184A0, $959AB8, $9095B8, $4B4C66
Data $F0181A, $FC0000, $FC0000, $DB6169, $AFAFC0, $A2A2B2, $8E8E9F, $313041
Data $3E3E42, $4B4B52, $6C6A71, $3C4943, $001B05, $043015, $06401B, $084D21
Data $095827, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $525773, $9E9EB0, $B6B6C6, $B6B5C3, $B5B5C2, $96ACD1, $B1C3DF
Data $B9C6D9, $B0C1D9, $A9BCDA, $A2B8D9, $9DB5D8, $97AFD3, $6E90C1, $6788B9
Data $6985AF, $E71217, $FC0000, $FC0000, $B34250, $637490, $585F79, $777C96
Data $7B7E9E, $E20A0D, $FC0000, $FC0000, $DD626A, $B2B2C3, $A3A3B4, $9494A5
Data $878797, $302E3F, $3E3E42, $4D4D54, $727076, $404F48, $001E06, $053316
Data $06421C, $084E22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $505571, $9B99AC, $B1AFC1, $AEAEBD, $94A9CF
Data $BACAE0, $C1CCDF, $B8C8DF, $B1C4DF, $ACC0DF, $A7BDE0, $A3BCE0, $9AB5DE
Data $7399D2, $7598CE, $7696C7, $7592BC, $E91419, $FC0000, $FC0000, $B74654
Data $6A7E9D, $545C75, $E70F12, $FC0000, $FC0000, $C2474F, $87879A, $818192
Data $787889, $737384, $656575, $2B2939, $3F3F45, $525259, $797780, $45544D
Data $001F07, $053517, $06431D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35
Data $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $505572, $9795A8, $AAA8BB
Data $9CA8C6, $B7C8E3, $C9D3E2, $BFCDE3, $BACAE3, $B4C7E3, $AEC4E4, $A9C1E5
Data $A7C0E8, $97B7E7, $77A1E1, $7DA5E2, $81A7DD, $83A4D5, $819DC9, $EA151A
Data $FC0000, $FC0000, $BB4957, $E61013, $FC0000, $FC0000, $92181F, $282834
Data $303141, $333445, $363748, $3C3C50, $333345, $282536, $444449, $595860
Data $828088, $485951, $002007, $053518, $06441D, $084F22, $095927, $0A622B
Data $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515672
Data $9190A3, $A0A1B7, $A2B8DC, $CED6E4, $C6D3E5, $C1CFE5, $BBCDE6, $B6C9E7
Data $AFC6E9, $B0C8EB, $B5CDF0, $A0BFEE, $8CB3EC, $97B9ED, $98BAED, $90B4EA
Data $8EAEDF, $8BA7D0, $EB161B, $FC0000, $FC0000, $FC0000, $FC0000, $91171E
Data $292935, $262631, $2E2E3C, $333444, $38394B, $414156, $39394C, $2C2A3B
Data $4C4C53, $5F5E68, $88868F, $4C5D54, $002107, $053618, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $515772, $8C899D, $91A2C7, $C4D1E5, $CFD8E8, $C6D4E8, $C2D2E9
Data $BDCFEA, $B7CCEB, $BBD0EF, $BBD2F3, $BBD3F7, $9EC3F8, $70A5F3, $74A5F0
Data $8AB1EC, $A3C1EC, $A0C1EB, $99B9DF, $95AFCF, $FA0304, $FC0000, $FC0000
Data $D41F25, $272936, $282936, $2C2D3A, $353647, $3D3D51, $45465C, $53546E
Data $44445A, $312E42, $57575F, $686771, $908F99, $4D6057, $002108, $053618
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $515772, $858398, $A0B4D7, $D2DBE8, $CDD8EA
Data $C8D6EA, $C3D4EB, $BED0EC, $C1D4F0, $C0D6F6, $C7DDFD, $A5C8FA, $608DD2
Data $5281C8, $5E94E4, $73A6F3, $82ABEC, $A8C5EB, $AACCEC, $EF1B1F, $FC0000
Data $FC0000, $FC0000, $FC0000, $8E171D, $242530, $2E2E3D, $38384B, $44445A
Data $51526C, $575772, $363646, $54545B, $64646D, $72717C, $9694A0, $50635A
Data $002108, $053618, $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35
Data $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515772, $807F93, $B5C8E3
Data $D6DEEA, $CDD9EB, $C9D7EC, $C4D5ED, $C2D5F0, $C6D9F6, $CFE2FE, $89AEE6
Data $32425E, $40414A, $45464F, $404758, $4E77B6, $7BA9F4, $8EB1ED, $F21E22
Data $FC0000, $FC0000, $CA5B64, $EC1718, $FC0000, $FC0000, $880D0F, $202023
Data $29292D, $35353A, $404046, $4B4B52, $585861, $676770, $757581, $7D7C8A
Data $9C9BA8, $52655C, $002208, $053718, $06441D, $084F22, $095927, $0A622B
Data $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49, $24B766, $515772
Data $7C798F, $C6D4E8, $D5DEEB, $CEDAEC, $CBD8EE, $C5D6F0, $C8DAF3, $C5DAF9
Data $A8C8FA, $33496D, $424249, $4D4D56, $56565F, $595963, $505768, $5F8CDB
Data $EB1822, $FC0000, $FC0000, $D46770, $A3B8C5, $93A4AD, $EB1515, $FC0000
Data $FC0000, $8E1415, $323237, $404047, $515159, $5F5F69, $6E6E78, $7B7B88
Data $858492, $868595, $A6A4B1, $54675E, $002208, $053718, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49
Data $24B766, $565C79, $76748B, $CDD8E9, $D4DEEC, $CFDBED, $CAD9EF, $C6D8F1
Data $CADBF5, $C8DEFE, $7CA1D9, $33353E, $48484F, $575760, $656570, $6B6B77
Data $696974, $E41018, $FC0000, $FC0000, $DC6B76, $B3C8D7, $A7B7C2, $96A5AC
Data $879397, $E61012, $FC0000, $FC0000, $971D1F, $484850, $5A5A63, $6A6A75
Data $7A7A86, $858592, $8D8D9D, $8B8A9C, $A9A7B6, $566A60, $002308, $053718
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D
Data $0F9A43, $0EAB49, $24B766, $585E7C, $726F87, $D0DAEA, $D4DEED, $CFDBEE
Data $CBDAF0, $C7D9F3, $CADCF6, $CEE2FF, $7699CD, $35353D, $4B4B53, $5D5D67
Data $6D6D79, $757583, $E91112, $FC0000, $FC0000, $C54D75, $B4C8DC, $AAC1CC
Data $A2B2BA, $98A5AA, $8E9A9B, $6F7F87, $DE0506, $FC0000, $FC0000, $A3282D
Data $5E5E69, $6E6E7A, $7C7C8A, $878796, $908FA0, $8D8B9F, $A9A8B9, $576B61
Data $002308, $053718, $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35
Data $0C8439, $0E8D3D, $0F9A43, $0EAB49, $23B766, $575E7B, $6F6C84, $CBD8E9
Data $D5DFED, $CFDCEF, $CCDBF1, $C8D9F4, $CADCF7, $CADDFB, $8EB5F0, $2B3549
Data $4A4A53, $5D5D68, $6D6D7B, $E91113, $FC0000, $FC0000, $AA4775, $7E93D9
Data $9EC2CE, $99B9BF, $97AFB2, $95A9AA, $97A5A5, $738592, $2E2E33, $E10809
Data $FC0000, $FC0000, $AD3238, $6E6E7A, $7A7A88, $838394, $8C8C9E, $89879C
Data $A7A6B8, $566B61, $002308, $053718, $06441D, $084F22, $095927, $0A622B
Data $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49, $23B766, $575D7B
Data $6D6982, $C2D1E8, $D6E0ED, $CFDCEF, $CCDBF2, $C8DAF5, $CBDDF9, $C6DAF8
Data $88B6FB, $3B6AB0, $373942, $565660, $E70E10, $FC0000, $FC0000, $9F5373
Data $4D9AD8, $75A8CC, $88BEC0, $86B2B3, $8AADAD, $92ADAD, $9FB3B3, $687989
Data $35353C, $45454D, $E40C0D, $FC0000, $FC0000, $B1363E, $727280, $7B7B8A
Data $828294, $818094, $A19FB0, $55685F, $002308, $053718, $06441D, $084F22
Data $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D, $0F9A43, $0EAB49
Data $23B766, $565C7A, $68657F, $A4B6D5, $D9E2F0, $CFDCEF, $CCDBF2, $C9DBF6
Data $C8DDFB, $BED5F7, $75A5EE, $7DADF9, $5384D6, $E20E15, $FC0000, $FC0000
Data $A55B6F, $45B8D2, $52AAC7, $78B9BE, $79B4B4, $7EADAD, $88AFAF, $95B7B7
Data $A8C2C2, $495464, $3D3D46, $4D4D57, $5B5B67, $E60E10, $FC0000, $FC0000
Data $B1363E, $70707E, $757586, $757487, $9795A5, $51645B, $002208, $053618
Data $06441D, $084F22, $095927, $0A622B, $0B6F30, $0C7A35, $0C8439, $0E8D3D
Data $0F9A43, $0EAB49, $23B766, $555B79, $65627E, $7E90B3, $D6E0EF, $D0DDEF
Data $CCDCF3, $C9DCF7, $C8DDFC, $B3D3FE, $84B1F0, $86ACEE, $ED1922, $FC0000
Data $FC0000, $B75A6C, $60BBC9, $5BB6C0, $72B8BB, $74B4B4, $76ADAD, $80AFAF
Data $90B8B8, $A2C5C5, $A9C4CD, $3A3F4E, $45454E, $565662, $646472, $6B6B79
Data $E80F11, $FC0000, $FC0000, $B0353D, $6C6C7B, $69697B, $8B8999, $4D5F57
Data $002107, $053517, $06431D, $084F22, $095927, $0A622B, $0B7030, $0C7A35
Data $0C8439, $0E8D3D, $0F9A43, $0EAB49, $23B766, $565B7A, $63627D, $727C9E
Data $BCCEE8, $D4DFEF, $CCDBF2, $C9DCF7, $CBDEFC, $A5CCFF, $83BEFE, $ED1B22
Data $FC0000, $FC0000, $C8506C, $96ABC7, $92BBBF, $88BCBB, $79B4B4, $74ADAD
Data $7CAFAF, $8BB8B8, $9DC5C5, $B8D5D5, $7B8EA3, $3D3E47, $4E4E59, $60606D
Data $6E6E7D, $747485, $747485, $E81012, $FC0000, $FC0000, $AE333C, $606071
Data $7F7E8C, $485951, $001F07, $053416, $06431C, $085023, $095B28, $0A652C
Data $0B7231, $0C7D36, $0C8539, $0E8D3D, $0F9A43, $0EAB49, $23B766, $565B7A
Data $62617B, $72718B, $7588A8, $D2DFF2, $CDDBF1, $C9DBF6, $CADEFC, $ACD0FF
Data $EA1A24, $FC0000, $FC0000, $D76577, $C2C2D9, $BEC2CD, $A7BDC0, $8CB4B4
Data $7DADAD, $7DAFAF, $88B8B8, $9BC5C5, $B4D5D5, $B6D0D8, $3A4150, $464651
Data $585864, $696979, $767688, $7B7B8F, $7B7B8F, $767689, $E81012, $FC0000
Data $FC0000, $A82E36, $757481, $42534B, $001D07, $043215, $06431D, $0D5728
Data $166934, $1B753C, $1B7E41, $168541, $118A3F, $0F8F3F, $0F9A43, $0EAB49
Data $23B766, $565B7A, $5F5F7A, $70708C, $6C7089, $94A9C9, $D2DFF4, $C9DAF5
Data $C8DDFB, $F21E24, $FC0000, $FC0000, $C76379, $A6BEDF, $B4BAD0, $B2B5C0
Data $A4B1B4, $92ADAD, $89AFAF, $8DB8B8, $99C5C5, $AFD5D5, $C5E1E4, $525E72
Data $3F3F4A, $4F4F5B, $606070, $707081, $7C7C90, $828296, $828297, $7C7C90
Data $757587, $E80F12, $FC0000, $FC0000, $B2373E, $3E4D46, $001C06, $043116
Data $0D4924, $1D6138, $206D3F, $207142, $1E7644, $167F40, $138740, $129042
Data $0F9B43, $0EAB49, $23B766, $575C7B, $5E5E78, $70708C, $6F6F87, $636A87
Data $9FB5D7, $CEE0F9, $F41F23, $FC0000, $FC0000, $BD5F79, $8EB8DF, $9BB2D0
Data $A6ACC0, $A9ABB4, $A4ACAD, $9DAFAF, $9BB8B8, $A0C5C5, $B1D5D5, $C4E3E4
Data $607088, $3B3C48, $494956, $595968, $68687A, $757589, $7F7F94, $84849B
Data $84849B, $808095, $7A7A8E, $717184, $E70E11, $FC0000, $FC0000, $992622
Data $001B06, $083218, $1A4F2F, $215E3C, $2C594A, $374F61, $3B4F6D, $365D63
Data $1D7648, $0E8A40, $0E9743, $0CAA48, $23B766, $575C7B, $53536C, $70708C
Data $70708A, $6E6E85, $5D6177, $EB161A, $FC0000, $FC0000, $C56179, $79ADDF
Data $84ACD0, $8FA5C0, $9BA2B4, $A4A6AD, $A9AEAF, $AEB8B8, $B4C5C5, $BED5D5
Data $B6D4DD, $4D586B, $393A46, $474754, $555565, $626274, $6F6F83, $7A7A8F
Data $818198, $84849C, $85859D, $83839A, $7D7D94, $75758A, $6A6A7F, $E50D0F
Data $FC0000, $FC0000, $7B0D03, $0D351C, $1D4A31, $2F454C, $2B4B7E, $116AB4
Data $0F76C3, $1F72BE, $42618C, $257451, $09943D, $0AA744, $23B766, $585D7C
Data $000000, $6C6C8A, $6F6F8A, $71718A, $E81012, $FC0000, $FC0000, $C75768
Data $98BBDF, $78A9D0, $7BA1C0, $869BB4, $979DAD, $AAABAF, $B8B8B8, $C0C5C5
Data $B3C9D1, $758B9E, $333745, $3D3D4A, $474755, $535363, $5E5E70, $6A6A7E
Data $747489, $7B7B92, $7F7F98, $82829B, $81819A, $81819A, $7E7E96, $77778F
Data $6E6E85, $5D5D72, $E81012, $FC0000, $FC0000, $841C10, $1E4231, $303758
Data $0664A8, $017BC7, $3398D6, $3CA6E6, $3C82C6, $41646D, $0A8E3E, $07A342
Data $23B766, $585D7C, $000000, $686884, $6D6D88, $E81013, $FC0000, $FC0000
Data $AB303A, $4A4C5C, $3C4151, $4B5A70, $617993, $71869E, $8090A3, $8192A4
Data $6E7F90, $45505F, $2E323F, $373744, $40404E, $474757, $515163, $5B5B6F
Data $636379, $6C6C84, $72728C, $777790, $7A7A94, $7C7C95, $7C7C96, $7C7C95
Data $797994, $75758F, $6F6F87, $5E5E75, $787787, $E20B0B, $FC0000, $FC0000
Data $8A2018, $2A385A, $0063A5, $1277B8, $70AFD5, $8BC4E6, $549CD4, $416274
Data $0B8A3F, $06A13F, $23B766, $575C7B, $000000, $000000, $A63D4E, $FC0000
Data $FC0000, $AF3440, $5D5D72, $515163, $444454, $393947, $32323F, $2F2F3B
Data $2B2B37, $2A2A35, $2B2C37, $333340, $393948, $403F51, $48475B, $514F65
Data $57556D, $5E5B75, $64627C, $686782, $6C6B86, $6D6C88, $70708A, $70708B
Data $71718C, $71718C, $70708B, $6E6E89, $6B6B84, $64647C, $7C7B8E, $455750
Data $D80401, $FC0000, $FC0000, $8E1D2A, $095490, $0B71B0, $65A6CB, $80BFE2
Data $5C87BF, $356262, $088F3D, $07A342, $23B766, $575B7A, $000000, $000000
Data $5D5D76, $C22832, $AF3442, $63637A, $5B5B6F, $505063, $464656, $3D3D4C
Data $3A394A, $262933, $0B1612, $04150B, $04180D, $041A0D, $041B0E, $051F10
Data $062112, $082414, $0A2818, $0C2B1A, $0E2F1E, $113120, $123123, $143325
Data $163428, $19362A, $1A372C, $1C382E, $1D3930, $1E3A31, $1E3930, $605F7A
Data $827F93, $54675D, $001D06, $DA0804, $F80101, $592F2C, $284260, $1A588D
Data $3773A6, $497AA7, $3F6174, $187444, $0B923E, $0BAE4B, $6CA093, $514862
Data $000000, $000000, $000000, $5F5F7B, $61617B, $5C5C75, $56566C, $4E4E62
Data $464659, $424255, $272A33, $000E03, $001604, $01210D, $032711, $032912
Data $032A12, $032B12, $032D13, $032F13, $033114, $033214, $033315, $033415
Data $023514, $023514, $023514, $023614, $013614, $013614, $013714, $013714
Data $013714, $013614, $828094, $788680, $001D04, $083419, $403922, $1A4B2E
Data $1C4830, $24463F, $274C4C, $1C5942, $117139, $0F853E, $0C9841, $2AB767
Data $85859A, $000000, $000000, $000000, $000000, $000000, $54546D, $595971
Data $53536A, $4C4C62, $48485D, $3C3C4C, $151A1B, $1B2923, $263D32, $0A2415
Data $042310, $042410, $042410, $042A13, $052E14, $053015, $063517, $063819
Data $063A1A, $063B1A, $063C1A, $063D1B, $063E1B, $063E1C, $063F1C, $06401C
Data $06411C, $06431D, $06431D, $06421D, $4E7F67, $C0C6C4, $153924, $002D0F
Data $0C4220, $184E2D, $1A5330, $17562F, $135F30, $126D35, $137A3B, $0F883D
Data $1DA753, $7D9B9A, $332F39, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $434356, $4B4B60, $4D4D63, $3C3C4C, $3A3A47, $545464
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $99B5A4
Data $ABB6B2, $063315, $003A15, $0B4822, $11542B, $155C30, $176736, $137237
Data $0C8038, $159E49, $85A5A1, $413B47, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $D3D2D9, $A4B4AD, $104622, $003E11, $004B1C, $015320
Data $006224, $087F34, $359E5F, $8DACA5, $4E4955, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $B0ADB8, $B5C2BF, $628874
Data $3F7655, $3A7D56, $589675, $87A99D, $A4A3B1, $57525C, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $000000, $000000, $000000, $000000, $000000, $000000, $000000, $000000
Data $656467, $B6B3BA, $C2C1C9, $BAB9C3, $958F9D, $625F68, $000000, $000000
Data $000000, $000000, $000000, $000000

